import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

import java.util.Random;

class TestCanvas extends Canvas {
	Image im;
	Random r = new Random();
	TestCanvas() {
		ShortTimer t = ShortTimer.getShortTimer(this, 0, 100, true);
		t.start();
		
		MediaImage mi = MediaManager.getImage("resource:///test.gif");
		try {
			mi.use();
		} catch (ConnectionException e) {
		}
		im = mi.getImage();
	}
	int time = 0;
	public void processEvent(int type, int param) {
		if (type == Display.TIMER_EXPIRED_EVENT) {
			time++;
			repaint();
		} else if (type == Display.KEY_PRESSED_EVENT || type == Display.KEY_RELEASED_EVENT) {
			repaint();
		}
	}
	int bgcol = 0;
	int ix, iy;
	public void paint(Graphics g) {
		if (time % 20 == 0)
			bgcol++;
		setBackground(g.getColorOfName(bgcol % 16));
		g.clearRect(0, 0, getWidth(), getHeight());
		g.setColor(g.getColorOfName(time % 16));
		g.drawLine(10, 10, getWidth() - 10, getHeight() - 10);
		Font f = Font.getDefaultFont();
		String s = "time: " + time;
		g.setColor(g.getColorOfName(g.RED));
		g.drawString(s, getWidth() - f.stringWidth(s) - 10, getHeight() - 10 - (time % 10));
		
		String key = "0123456789*#    LURDSAB";
		int state = getKeypadState();
		StringBuffer sb = new StringBuffer();
		for (int i = 0; i < key.length(); i++) {
			boolean b = (state & (1 << i)) != 0;
			sb.append(b ? "1" : "0");
		}
		
		f = Font.getFont(Font.FACE_MONOSPACE | Font.STYLE_PLAIN | Font.SIZE_SMALL);
		int w = f.stringWidth(key);
		int h = f.getHeight();
		
		g.setColor(g.getColorOfName(g.BLACK));
		g.fillRect(5, 5, w + 10, h * 2 + 2 + 10);
		
		g.setFont(f);
		g.setColor(g.getColorOfName(g.WHITE));
		g.drawString(sb.toString(), 10, h + 10);

		char[] chars = new char[key.length()];
		key.getChars(0, chars.length, chars, 0);
		g.drawChars(chars, 10, h * 2 + 10 + 2, 0, chars.length);
		
		if ((time + 5) % 10 == 0) {
			ix = r.nextInt() & 0x3f;
			iy = r.nextInt() & 0x3f;
		}
		g.drawImage(im, 40 + ix, 40 + iy);
	}
}

public class CanvasTest extends IApplication {
	public void start() {
		Canvas c = new TestCanvas();
		Display.setCurrent(c);
	}
}
