import java.io.*;
import java.util.Random;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.rms.*;

public class RMSTest extends MIDlet
   implements CommandListener, RecordFilter, RecordComparator {

   // (,  ̵) ڵ带 ϱ  ڵ 
   private RecordStore recordStore = null;
   final static String RECORD_STORE="RandomPlayer";

   //  ϰ ϱ  Random ü 
   private Random random;

   //  ̽ ϱ  پ Ʈ 
   private Display display;
   private Command exit, ok, sel, play, back, del;

   // " ޴"  ũ  List Ʈ
   private List menuList;

   // "α" ũ ϱ  Form Ʈ
   private Form loginScreen;
   private TextField nameField;

   // "ϱ" ũ ϱ  Form Ʈ
   private Form playScreen;
   private StringItem nameItem, highScoreItem, scoreItem;
   private int score, highScore;

   // "ڱ  ", "ü  " ũ Form Ʈ
   private Form showScreen;

   /* " ޴" List Ʈ  ׸ */
   private static final String[] menuTitles = {
      "ϱ",
      "ڱ  ",
      "ü  ",
      "ڱ  ",
      "ü  "
   };

   /*
    * RecordFilter ̽  ޼ҵμ,
    * "ڱ  " Ǵ "ڱ  " 
    * RecordEnumeration ü  
    * ڱ ̸ شϴ ڵ常 ͸ϱ  ȴ.
    */
   public boolean matches(byte[] candidate)
      throws IllegalArgumentException {

      // , α   ̸ ´.
      String playerNameFilter = nameField.getString();
      if (playerNameFilter == null) {
         return false;
      }

      // ־ byte 迭 candidate ڵ ͸
      //  о  ByteArrayInputStream ü
      // DataInputStream ü Ѵ.
      ByteArrayInputStream bais = new ByteArrayInputStream(candidate);
      DataInputStream inputStream = new DataInputStream(bais);
      String name = null;

      try {
         int score = inputStream.readInt();  //  о´.
         name = inputStream.readUTF();  //  ̵ о´.
      } catch(EOFException eofe) {
         System.out.println(eofe);
         eofe.printStackTrace();
      } catch(IOException eofe) {
         System.out.println(eofe);
         eofe.printStackTrace();
      }
      //  α  ̵
      // ڵ忡 о  ̵ Ѵ.
      return(playerNameFilter.equals(name));
   }

   /*
    * RecordComparator ̽  ޼ҵμ,
    * "ڱ  " Ǵ "ü  " 
    * RecordEnumeration ü  
    * ش ڵ    ȴ.
    */
   public int compare(byte[] rec1, byte[] rec2) {
      // byte 迭 Ǿ ִ   ڵ忡
      //   о̱ 
      // ByteArrayInputStream ü DataInputStream ü Ѵ.
      ByteArrayInputStream bais1 = new ByteArrayInputStream(rec1);
      DataInputStream inputStream1 = new DataInputStream(bais1);
      ByteArrayInputStream bais2 = new ByteArrayInputStream(rec2);
      DataInputStream inputStream2 = new DataInputStream(bais2);
      int score1 = 0;
      int score2 = 0;

      try {
         //  byte 迭 Է½Ʈ  о´.
         score1 = inputStream1.readInt();
         score2 = inputStream2.readInt();

System.out.println("compare-rec1: ["+score1+"], ["+new String(rec1)+"]");
System.out.println("compare-rec2: ["+score2+"], ["+new String(rec2)+"]");
      } catch(EOFException eofe) {
         System.out.println(eofe);
         eofe.printStackTrace();
      } catch(IOException eofe) {
         System.out.println(eofe);
         eofe.printStackTrace();
      }

      //    Ͽ    ش.
      if (score1 > score2) {
         return RecordComparator.PRECEDES;
      } else if (score1 > score2) {
         return RecordComparator.FOLLOWS;
      } else {
         return RecordComparator.EQUIVALENT;
      }
   }

   /*
    *    ϰ Ͽ   ̴.,
    *   , ڽ ϴ  ڵ ҿ   ִ.
    *  ,    ϰ Ѵ.
    */
   public void randomPlay() {
      score = random.nextInt();
      if(score < 0) {
         //   ̸  ȯ ش.
         score = -score;
      }
      //   0~999   .
      score = score % 1000;   // 1000  
      if(score > highScore) {
         //   ְ  ũ ְ  
         highScore = score;
      }
      //   ְ  playScreen  ش Ʈ ǥ
      scoreItem.setText(""+score);
      highScoreItem.setText(""+highScore);

      // , ӿ   Alert â  ش.
      showAlert("Play...", "Random Player:\n\nSocre: "+score);
   }

   /*
    * , ӿ  ְ  ڵ ҿ Ѵ.
    */
   public void addScore() {
      if(highScore <= 0) {
         // ӿ    ׳ Ѵ.
         return;
      }

      // (,  ̵) byte 迭 ȯϱ 
      // ByteArrayOutputStream ü DataOutputStream ü 
      ByteArrayOutputStream baos = new ByteArrayOutputStream();
      DataOutputStream outputStream = new DataOutputStream(baos);

      try {
         // Ʈ 迭  ü ְ  Ѵ.
         outputStream.writeInt(highScore);
         // Ʈ 迭  ü  ̵ Ѵ.
         outputStream.writeUTF(nameField.getString());
      } catch(IOException ioe) {
         System.out.println(ioe);
         ioe.printStackTrace();
      }

      // Ʈ 迭  ü  ͸ byte 迭 ȯѴ.
      byte[] b = baos.toByteArray();
      try {
         // ȯ byte 迭   ڵ ҿ Ѵ.
         recordStore.addRecord(b, 0, b.length);
      } catch(RecordStoreException rse) {
         System.out.println(rse);
         rse.printStackTrace();
      }
   }

   /*
    * ڵ    ڵ带  ڵ Ҹ Ѵ.
    */
   public void resetScore() {
      // ڵ    ڵ带 ϱ    Ѵ.
      //    1. ִ ڵ Ҹ ݴ´.
      //    2. ִ ڵ Ҹ Ѵ.
      //    3. ڵ Ҹ 鼭 Ӱ ϵ Ѵ.
      try {
         recordStore.closeRecordStore();
         recordStore.deleteRecordStore(RECORD_STORE);
         recordStore = RecordStore.openRecordStore(RECORD_STORE, true);
      } catch(RecordStoreException rse) {
         System.out.println(rse);
         rse.printStackTrace();
      }
   }

   /*
    * , ڽ   ڵ ҷκ Ѵ.
    */
   public void deleteScore() {
      try {
         // Ϳ ڸ ̿Ͽ RecordEnumeration ü Ѵ.
         // Ϳ ڽ ̵ شϴ ڵ常  Ѵ.
         RecordEnumeration re = recordStore.enumerateRecords(this, this, true);

         while(re.hasNextElement()) {
            // ڽ ̵   ڵ带 ϳ Ѵ.
            int recordId = re.nextRecordId();
            recordStore.deleteRecord(recordId);
         }
      } catch(RecordStoreException rse) {
         System.out.println(rse);
         rse.printStackTrace();
      }
   }

   /*
    *  ֱ ũ   .
    */
   public void clearShowScreen() {
      //  ֱ ũ Form Ʈ
      // ϵǾ ִ  Ʈ Ѵ.
      while(true) {
         if(showScreen.size() == 0) break;
         showScreen.delete(0);
      }
   }

   /*
    * "ڱ  ", "ü  "  
    * RecordEnumeration ü Ű ޾ 
    * RecordEnumeration ü  ִ  ڵ带
    * showScreen ũ Form Ʈ ߰Ѵ.
    */
   public void showScoreHelper(RecordEnumeration re) {
      try {
         // , showScreen ũ Form Ʈ .
         clearShowScreen();
         while(re.hasNextElement()) {
            // re ü  ִ  ڵ带 ϳ ´.
            int id = re.nextRecordId();

            // (,  ̵) byte 迭 ȯϱ 
            // ByteArrayOutputStream ü DataOutputStream ü 
            ByteArrayInputStream bais = new ByteArrayInputStream(recordStore.getRecord(id));
            DataInputStream inputStream = new DataInputStream(bais);
            try {
               int score = inputStream.readInt();  //  о´.
               String playerName = inputStream.readUTF();   //  ̵ о´.

               // showScreen ũ Form Ʈ ߰Ѵ.
               showScreen.append(new StringItem(""+score, "..."+playerName));

               //   ǥ ġ Ѵ.
               System.out.println(playerName + " = " + score);
            } catch(EOFException eofe) {
               System.out.println(eofe);
               eofe.printStackTrace();
            }
         }
         // , showScreen ũ  ũ Ѵ.
         // showScreen ũ Form Ʈ ̰ ȴ.
         display.setCurrent(showScreen);
      } catch(RecordStoreException rse) {
         System.out.println(rse);
         rse.printStackTrace();
      } catch(IOException ioe) {
         System.out.println(ioe);
         ioe.printStackTrace();
      }
   }

   /*
    * ڽ  ش.
    */
   public void showScore() {
      try {
         // ڽ ̵ شϴ ڵ常 
         // RecordEnumeration ü ϱ  ͸ Ѵ.
         RecordEnumeration re = recordStore.enumerateRecords(this, this, true);

         // RecordEnumeration ü   ڵ带 ũ ش.
         showScoreHelper(re);
      } catch(RecordStoreException rse) {
         System.out.println(rse);
         rse.printStackTrace();
      }
   }

   /*
    * ü  ش.
    */
   public void showScoreAll() {
      try {
         // ڵ ҿ   ڵ带  ,
         // RecordEnumeration ü   ͸  ʴ´.
         RecordEnumeration re = recordStore.enumerateRecords(null, this, true);

         // RecordEnumeration ü   ڵ带 ũ ش.
         showScoreHelper(re);
      } catch(RecordStoreException rse) {
         System.out.println(rse);
         rse.printStackTrace();
      }
   }

   /*
    * ü 
    *
    */
   public RMSTest() {
      try {
         // RECORD_STORE ڵ Ҹ .
         //, ڵ Ұ ٸ  Ѵ.
         recordStore = RecordStore.openRecordStore(RECORD_STORE, true);
      } catch(RecordStoreException rse) {
         System.out.println(rse);
         rse.printStackTrace();
      }

      //   ϰ ϱ  Random ü 
      random = new Random(System.currentTimeMillis());

      //  ÷̸ ´.
      display = Display.getDisplay(this);

      // "α" ũ   Ѵ.
      ok = new Command("OK", Command.OK, 0);

      // " ޴" ũ   Ѵ.
      sel = new Command("OK", Command.OK, 0);
      exit = new Command("Exit", Command.EXIT, 0);

      // "ϱ" ũ   Ѵ.
      play = new Command("Play", Command.SCREEN, 0);

      // "ڱ  ", "ڱ  ", "ü  ", "ü  " 
      // ũ   Ѵ.
      back = new Command("Back", Command.BACK, 0);
      del = new Command("Del", Command.SCREEN, 0);
   }

   /* startApp() : JAM MIDlet   ȣѴ. */
   public void startApp() {
      // " ޴" Ʈ ִ List Ʈ Ѵ.
      // List Choice ϹǷ, List.IMPLICIT Choice.IMPLICIT .
      // List(String title, int listType, String[] stringElements, Image[] imageElements)
      menuList = new List("Random Player:", List.IMPLICIT, menuTitles, null);

      // List Ʈ ɰ ̺Ʈ ڵ鷯 Ѵ.
      menuList.addCommand(exit);
      menuList.addCommand(sel);
      menuList.setCommandListener(this);

      // "α" UI ũ 
      loginScreen = new Form("Login...");
      nameField = new TextField("ID: ", "", 10, TextField.ANY);
      loginScreen.append(nameField);

      loginScreen.addCommand(exit);
      loginScreen.addCommand(ok);
      loginScreen.setCommandListener(this);

      // "ϱ" UI ũ 
      playScreen = new Form("Let's Play");

      nameItem = new StringItem("ID: ", "");
      scoreItem = new StringItem("Score: ", "0");
      highScoreItem = new StringItem("Hi-Score: ", "0");

      playScreen.append(nameItem);
      playScreen.append(scoreItem);
      playScreen.append(highScoreItem);

      playScreen.addCommand(back);
      playScreen.addCommand(play);
      playScreen.setCommandListener(this);

      // "ڱ  "  "ü  " UI ũ 
      showScreen = new Form("Rank...");

      showScreen.addCommand(back);
      showScreen.setCommandListener(this);

      // "α" UI ũ ̵ Ѵ
      display.setCurrent(loginScreen);
   }

   /*
    * MIDlet Ͻ ų   ȣѴ.
    */
   public void pauseApp() {
   }

   /*
    * MIDlet  ų  ȣѴ.
    */
   public void destroyApp (boolean unconditional) {
      try {
         // ִ ڵ Ҹ ݾ ش.
         recordStore.closeRecordStore();
      } catch(RecordStoreException rse) {
         System.out.println(rse);
         rse.printStackTrace();
      }
   }

   /*
    * ޽ â  ޽ ش.
    */
   public void showAlert(String title, String msg) {
      Alert alert = new Alert(title, msg, null, AlertType.INFO);
      alert.setTimeout(5000);
      display.setCurrent(alert);
   }

   /*
    * CommandListener ̽ commandAction(...) ޼ҵ带 Ѵ.
    * Ŀ ̺Ʈ  ׼ óϴ κμ
    * "Exit"  õǾ , destroyApp() ޼ҵ带 ȣѴ.
   */
   public void commandAction(Command cmd, Displayable disp) {
      if(cmd == exit) {
         destroyApp(false);
         notifyDestroyed();
      } else if(cmd == ok) {
         // 'OK'  "α" ũο ϵ ̴.
         // , "α" UI ϵ  ̵
         // ԷµǾ 쿡 " ޴" ũ ȯѴ.
         String name = nameField.getString();
         if(name.length() > 0) {
            nameItem.setText(name);
            menuList.setTitle(name);

            //  ̵ ԷµǾ " ޴" ũ ȯ
            display.setCurrent(menuList);
         } else {
            //  ̵ Էµ ʾ 
            // Alert â   ޽ ش.
            showAlert("Empty ID", "Please,\n Insert your ID");
         }
      } else if(cmd == play) {
         // 'Play'  'ϱ' ũο ϵ ̴.
         // 'ϱ' ũο 'Play'  ϸ  . 
         // ⼭, ̶ ϰ  ϴ  Ѵ.
         randomPlay();
      } else if(cmd == back) {
         // , "ϱ" ũ 'Back' ɸ  ,
         //    ߿    ڵ ҿ 
         if((disp == playScreen)&&(highScore > 0)) {
            addScore();
         }

         // "ϱ", "ڱ  ", "ü  " Form ũ
         // 'Back'   , " ޴" ũ ̵
         display.setCurrent(menuList);
      } else if(cmd == del) {
         deleteScore();
      } else if((cmd == sel)||(disp == menuList)) {
         // List Ʈ õ ׸ Alert  شϴ
         // Alert Ʈ  ũ Ѵ.
         int index = menuList.getSelectedIndex();
System.out.println("index: "+index);
//         display.setCurrent(alerts[index]);
         switch(index) {
            case 0: //  "ϱ"
               // ,     ְ ʱȭ
               score = 0;
               highScore = 0;

               // "ϱ" ũ UI  ʱȭ Ѵ.
               scoreItem.setText(""+score);
               highScoreItem.setText(""+highScore);

               // "ϱ" ũ  ũ ȯ
               display.setCurrent(playScreen);
            break;
            case 1: //  "ڱ  "
               showScore();
            break;
            case 2: //  "ü  "
               showScoreAll();
            break;
            case 3: //  "ڱ  "
               deleteScore();
               //  Ȳ ֱ  Alert â 
               showAlert("Delete", "Clear\n\nyour scores...");
            break;
            case 4: //  "ü  "
               resetScore();
               //  Ȳ ֱ  Alert â 
               showAlert("Delete All", "Clear\n\nall scores...");
            break;
         }
      }
   }
}
