/**
 * DatagramConnection(UDP) 
 * Server reverse String     ϴ 
 */

import java.io.*;
import javax.microedition.io.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class DatagramConnectionMIDlet extends MIDlet implements CommandListener, Runnable
{
 private Display display;        // ÷ ü
 private Form waitForm;          // wait Form
 private TextBox textBox;        // TextBox ü
 private Command connectCommand; // connect Command
 private Command exitCommand;    // exit Command

 private DatagramConnection dc = null; // DatagramConnection ü
 private Datagram dgram = null;        // Datagram ü
 
 //  Server URL
 private String sendUrl = "datagram://127.0.0.1:9000";
 
 public void startApp() 
 {
  // ÷ ü 
  display = Display.getDisplay(this);

  // textBox, wait Form ʱȭ
  textBox = new TextBox("Datagram Connection MIDlet", "Reverse String", 100, TextField.ANY);
  waitForm = new Form("Waiting...");

  // Command 
  connectCommand = new Command("Connect", Command.SCREEN, 0);
  exitCommand = new Command("Exit", Command.EXIT, 0);

  // Command 
  textBox.addCommand(connectCommand);
  textBox.addCommand(exitCommand);
  
  // Listener, Current 
  textBox.setCommandListener(this);
  display.setCurrent(textBox);
 }

 public void commandAction(Command c, Displayable s)
 {
  if (c == exitCommand)
  {
   notifyDestroyed();
  }
  // Server  ϶!!!
  else if(c == connectCommand)
  {
    display.setCurrent(waitForm);

    Thread t = new Thread( this );
    t.start();
  }
 }
 
 public void run()
 {
   connect();
 }

 private void connect() 
 {
  try 
  {
   // Server  reverse String 
   String reverseString = textBox.getString();
   
   // DatagramConnection 
   dc = (DatagramConnection)Connector.open(sendUrl);
   // Server  Datagram 
   dgram= dc.newDatagram(reverseString.getBytes(),reverseString.getBytes().length,sendUrl);
   // Server Datagram 
   dc.send(dgram);
   
   // Server   Datagram 
   dgram = dc.newDatagram(128);
   dc.receive(dgram);

   //  ȭ鿡 
   String input = new String(dgram.getData(), 0,dgram.getLength());
   Alert alert = new Alert("Server Response", input, null, null);
   alert.setTimeout(Alert.FOREVER);
   display.setCurrent(alert, textBox);
  }
  catch (IOException e) 
  {
   Alert alert = new Alert("Exception", e.toString(), null, null);
   alert.setTimeout(Alert.FOREVER);
   display.setCurrent(alert, textBox);
  }
  finally
  {
   try { 
    if(dgram != null) dgram = null;
    if(dc != null) dc.close();
   } catch (IOException ioe) {}
  }
 }

 public void pauseApp() {}

 public void destroyApp(boolean unconditional) {}
}
