/**
 * HTTP Session  
 *
 *    ϱ  Cookie ϴ .
 */
import java.io.*;
import javax.microedition.io.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class SessionMIDlet extends MIDlet implements CommandListener, Runnable
{
 private Display display;        // ÷ ü
 private Form mainForm;          //  Form 
 private Form waitForm;          // wait Form
 private Command connectCommand; // connect Command
 private Command exitCommand;    // exit Command

 private String sessionID;       // Session ID
 //  Servlet URL
 private String url = "http://feelmobile.net/feelmobile/servlet/SessionServlet";
  
 public void startApp() 
 {
  // ÷ ü 
  display = Display.getDisplay(this);

  // main, wait Form ʱȭ
  mainForm = new Form("Session MIDlet");
  waitForm = new Form("Waiting...");

  // Command 
  connectCommand = new Command("Connect", Command.SCREEN, 0);
  exitCommand = new Command("Exit", Command.EXIT, 0);

  // Command 
  mainForm.addCommand(connectCommand);
  mainForm.addCommand(exitCommand);
  
  // Listener, Current 
  mainForm.setCommandListener(this);
  display.setCurrent(mainForm);
 }

 public void commandAction(Command c, Displayable s)
 {
  if (c == exitCommand)
  {
   notifyDestroyed();
  }
  // Servlet  ϶!!!
  else if(c == connectCommand)
  {
   display.setCurrent(waitForm);
   Thread t = new Thread( this );
   t.start();
  }
 }
 
 public void run()
 {
   connect();
 }

 private void connect() 
 {
  try 
  {
   // HTTP Connection 
   HttpConnection hc = (HttpConnection)Connector.open(url);

   // ó  ƴ .
   if (sessionID != null)
   {
    hc.setRequestProperty("Cookie", sessionID);
   }
   
   // InputStream 
   InputStream in = hc.openInputStream();
   // Cookie 
   String cookie = hc.getHeaderField("Set-Cookie");
   // cookie : JSESSIONID=wg68hrtii1;Path=/midp
   
   // cookie JSESSIONID ´.
   if (cookie != null)
   {
    int index = cookie.indexOf(';');
    sessionID = cookie.substring(0, index);
   }
   
   //   Ÿ 
   int length = (int)hc.getLength();
   byte[] raw = new byte[length];
   in.read(raw);

   //  Ÿ 
   String s = new String(raw);
   Alert alert = new Alert("Server Response", s, null, null);
   alert.setTimeout(Alert.FOREVER);
   display.setCurrent(alert, mainForm);

   // Connection 
   in.close();
   hc.close();
  }
  catch (IOException e) 
  {
   Alert alert = new Alert("Exception", e.toString(), null, null);
   alert.setTimeout(Alert.FOREVER);
   display.setCurrent(alert, mainForm);
  }
 }

 public void pauseApp() {}

 public void destroyApp(boolean unconditional) {}
}
