import java.io.*;

import javax.microedition.io.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class SessionMIDlet extends MIDlet {
  private Display mDisplay;
  private Form mMainForm, mWaitForm;
  
  private String mSessionIDCookie;
  
 public void startApp() {
    mDisplay = Display.getDisplay(this);
    
    // Create a simple waiting screen.
    if (mWaitForm == null) {
      mWaitForm = new Form("Waiting...");
    }
    
    // Create the main screen.
    if (mMainForm == null) {
      mMainForm = new Form("SessionMIDlet");
  
      mMainForm.addCommand(new Command("Exit", Command.EXIT, 0));
      mMainForm.addCommand(new Command("Connect", Command.SCREEN, 0));
      
      mMainForm.setCommandListener(new CommandListener() {
        public void commandAction(Command c, Displayable s) {
          if (c.getCommandType() == Command.EXIT)
            notifyDestroyed();
          else {
            mDisplay.setCurrent(mWaitForm);
            
            // Create a new thread for networking.
            Thread t = new Thread() {
              public void run() { connect(); }
            };
            t.start();
          }
        }
      });
    }

    mDisplay.setCurrent(mMainForm);
  }
  
  private void connect() {
    String url = getAppProperty("SessionMIDlet.URL");

    try {
      // Query the server and retrieve the response.
      HttpConnection hc = (HttpConnection)Connector.open(url);
      if (mSessionIDCookie != null)
        hc.setRequestProperty("Cookie", mSessionIDCookie);
      InputStream in = hc.openInputStream();
      
      String cookie = hc.getHeaderField("Set-Cookie");
      if (cookie != null) {
        int semicolon = cookie.indexOf(';');
        mSessionIDCookie = cookie.substring(0, semicolon);
      }
      
      int length = (int)hc.getLength();
      byte[] raw = new byte[length];
      in.read(raw);

      String s = new String(raw);
      Alert a = new Alert("Response", s, null, null);
      a.setTimeout(Alert.FOREVER);
      mDisplay.setCurrent(a, mMainForm);

      in.close();
      hc.close();
    }
    catch (IOException ioe) {
      Alert a = new Alert("Exception", ioe.toString(), null, null);
      a.setTimeout(Alert.FOREVER);
      mDisplay.setCurrent(a, mMainForm);
    }
  }

  public void pauseApp() {}

  public void destroyApp(boolean unconditional) {}
}
