/**
 * StreamConnection(Socket) 
 * Server reverse String     ϴ 
 */

import java.io.*;
import javax.microedition.io.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;

public class StreamConnectionMIDlet extends MIDlet implements CommandListener, Runnable
{
 private Display display;        // ÷ ü
 private Form waitForm;          // wait Form
 private TextBox textBox;        // TextBox ü
 private Command connectCommand; // connect Command
 private Command exitCommand;    // exit Command

 private StreamConnection sc = null;  // StreamConnection ü
 private DataOutputStream out = null; // DataOutputStream ü
 private DataInputStream in = null;   // InputStream ü 

 //  Server URL
 private String url = "socket://127.0.0.1:9000";
  
 public void startApp() 
 {
  // ÷ ü 
  display = Display.getDisplay(this);

  // textBox, wait Form ʱȭ
  textBox = new TextBox("Stream Connection MIDlet", "Reverse String", 100, TextField.ANY);
  waitForm = new Form("Waiting...");

  // Command 
  connectCommand = new Command("Connect", Command.SCREEN, 0);
  exitCommand = new Command("Exit", Command.EXIT, 0);

  // Command 
  textBox.addCommand(connectCommand);
  textBox.addCommand(exitCommand);
  
  // Listener, Current 
  textBox.setCommandListener(this);
  display.setCurrent(textBox);
 }

 public void commandAction(Command c, Displayable s)
 {
  if (c == exitCommand)
  {
   notifyDestroyed();
  }
  // Server  ϶!!!
  else if(c == connectCommand)
  {
   display.setCurrent(waitForm);
   Thread t = new Thread( this );
   t.start();
  }
 }
 
 public void run()
 {
   connect();
 }

 private void connect() 
 {
  try 
  {
   // Server  reverse String 
   String reverseString = textBox.getString();

   // Server StreamConnection(Socket) 
   sc = (StreamConnection) Connector.open (url, Connector.READ_WRITE, true);
   // Server reverse  String 
   out = sc.openDataOutputStream();
   out.writeUTF(reverseString);
   out.flush();

   // InputStream 
   in = sc.openDataInputStream();
   // Server  reverse String ޾ ȭ鿡 .
   String input = in.readUTF();
   Alert alert = new Alert("Server Response", input, null, null);
   alert.setTimeout(Alert.FOREVER);
   display.setCurrent(alert, textBox);
  }
  catch (IOException e) 
  {
   Alert alert = new Alert("Exception", e.toString(), null, null);
   alert.setTimeout(Alert.FOREVER);
   display.setCurrent(alert, textBox);
  }
  finally
  {
   try { 
	if(out != null) out.close();
	if(in != null) in.close();
	if(sc != null) sc.close();
   } catch (IOException ioe) {}
  }
 }

 public void pauseApp() {}

 public void destroyApp(boolean unconditional) {}
}
