package org.fukuno.iap.Test;

import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

class TestCanvas extends Canvas {
	Image im;
	TestCanvas() {
		ShortTimer t = ShortTimer.getShortTimer(this, 0, 100, true);
		t.start();
		
		MediaImage mi = MediaManager.getImage("resource:///test.gif");
		try {
			mi.use();
		} catch (ConnectionException e) {
		}
		im = mi.getImage();
	}
	int time = 0;
	public void processEvent(int type, int param) {
		if (type == Display.TIMER_EXPIRED_EVENT) {
			time++;
			repaint();
		} else if (type == Display.KEY_PRESSED_EVENT || type == Display.KEY_RELEASED_EVENT) {
			System.out.println("key event " + type + " " + param + " " + getKeypadState());
			repaint();
		}
	}
	int bgcol = 0;
	public void paint(Graphics g) {
		if (time % 20 == 0)
			bgcol++;
		setBackground(g.getColorOfName(bgcol % 16));
		g.clearRect(0, 0, getWidth(), getHeight());
		g.setColor(g.getColorOfName(time % 16));
		g.drawLine(10, 10, getWidth() - 10, getHeight() - 10);
		g.drawImage(im, 20, 20);
		Font f = Font.getDefaultFont();
		String s = "time: " + time;
		g.setColor(g.getColorOfName(g.RED));
		g.drawString(s, getWidth() - f.stringWidth(s) - 10, getHeight() - 10 - (time % 10));
		
		String key = "0123456789*#    LURDSAB";
		int state = getKeypadState();
		StringBuffer sb = new StringBuffer();
		for (int i = 0; i < key.length(); i++) {
			boolean b = (state & (1 << i)) != 0;
			sb.append(b ? "1" : "0");
		}
		g.setFont(Font.getFont(Font.FACE_MONOSPACE | Font.STYLE_PLAIN | Font.SIZE_SMALL));
		g.setColor(g.getColorOfName(g.WHITE));
		g.drawString(sb.toString(), 10, f.getHeight() + 10);
		char[] chars = new char[key.length()];
		key.getChars(0, chars.length, chars, 0);
		g.drawChars(chars, 0, chars.length, 10, f.getHeight() * 2 + 10 + 2);
	}
}

public class GameTest extends IApplication {
	public void start() {
		Canvas c = new TestCanvas();
		Display.setCurrent(c);
	}
}
