/*
 *  ImageTest.java
 *
 *  Monday, June 19, 2000
 *
 *   Copyright 2000 Motorola, Inc.  All Rights Reserved.
 *  This notice does not imply publication.
 */

package com.mot.j2me.midlets.imagetests;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import java.io.*;

/**
 * ImageTest demonstrates using images in Forms
 */
public class ImageTest extends MIDlet {

    /**
     * The main screen
     */
    private Form mainScreen;

    /**
     * Reference to the Display
     */
    private Display myDisplay;

    /**
     * Byte array containing image data
     */
    private byte[] imgData = {-119, 80, 78, 71, 13, 10, 26, 10, 0, 0, 0,
            13, 73, 72, 68, 82, 0, 0, 0, 4, 0, 0, 0, 4, 8, 2, 0, 0, 0,
            38, -109, 9, 41, 0, 0, 0, 4, 103, 65, 77, 65, 0, 0, -39, 3,
            66, -42, 79, -95, 0, 0, 0, 32, 99, 72, 82, 77, 0, 0, 122,
            37, 0, 0, -128, -125, 0, 0, -12, 36, 0, 0, -124, -49, 0, 0,
            109, 95, 0, 0, -24, 106, 0, 0, 60, -117, 0, 0, 27, 87, -87,
            -19, -127, 22, 0, 0, 0, 38, 73, 68, 65, 84, 120, -100, 98, -
            8, -56, -35, -56, 125, -8, 35, 16, 1, 25, 0, 1, -60, 0, -95,
            32, 66, 0, 1, -124, -62, 1, 8, 32, 6, 100, 101, 0, 1, 6, 0,
            -99, 98, 25, -31, 101, 39, 47, -71, 0, 0, 0, 0, 73, 69, 78,
            68, -82, 66, 96, -126};

    /**
     * Create an ImageTest
     */
    ImageTest() {

        myDisplay = Display.getDisplay(this);
        mainScreen = new Form("Image Test");
        Font font = Font.getFont(Font.FACE_MONOSPACE,
                                 Font.STYLE_PLAIN, Font.SIZE_SMALL);

        try {
        
            ImageItem i1 = new 
                ImageItem("Left", Image.createImage("basn0g01.png"),
                          ImageItem.LAYOUT_LEFT, "Image"); 

            mainScreen.append(i1);
        } catch (Exception e) {
            System.out.println("Error: " + e.getMessage());
        }
        try {

            ImageItem i2 = new 
                ImageItem("Right", 
                          Image.createImage("test.png"),
                          ImageItem.LAYOUT_RIGHT, "Image"); 
            mainScreen.append(i2);
        } catch (Exception e) {
            System.out.println("Error: " + e.getMessage());
        }
        try {
        
            ImageItem i3 = new 
                ImageItem("NL after",
                          Image.createImage("basn2c16.png"),
                          ImageItem.LAYOUT_NEWLINE_AFTER, "Image"); 
            mainScreen.append(i3);
        } catch (Exception e) {
            System.out.println("Error: " + e.getMessage());
        }
        try {

        
            ImageItem i4 = new 
                ImageItem("Default",
                          Image.createImage("basn3p04.png"),
                          ImageItem.LAYOUT_DEFAULT, "Image"); 
            mainScreen.append(i4);
        } catch (Exception e) {
            System.out.println("Error: " + e.getMessage());
        }
        try {

            ImageItem i5 = new 
                ImageItem("Center", Image.createImage("basn4a08.png"),
                          ImageItem.LAYOUT_CENTER, "Image"); 
            mainScreen.append(i5);
        } catch (Exception e) {
            System.out.println("Error: " + e.getMessage());
        }
        try {

            ImageItem i6 = new 
                ImageItem("NL before",
                          Image.createImage("basn6a16.png"),
                          ImageItem.LAYOUT_NEWLINE_BEFORE, "Image"); 
            mainScreen.append(i6);
        } catch (Exception e) {
            System.out.println("Error: " + e.getMessage());
        }
        try {

            System.out.println("Trying the imagebuffer stuff");

            Image img7 = Image.createImage(64,64);
                
            Graphics g = img7.getGraphics();

            g.setFont(font);
                
            
            g.setClip(0,0,img7.getWidth()-1, img7.getHeight()-1);
            /*
             * Draw a line in the center of the canvas
             */
            g.setGrayScale(0);
            g.drawString("dL", img7.getWidth() / 2, 0,
                         Graphics.HCENTER | Graphics.TOP);
            g.drawLine(img7.getWidth() / 4,
                       img7.getHeight() - 1,
                       img7.getWidth() - (img7.getWidth() / 4), 30);
                
            ImageItem ii7 = new ImageItem("Buffered",
                                          Image.createImage(img7),
                                          ImageItem.LAYOUT_LEFT, 
                                          "Image"); 
                
            mainScreen.append(ii7);

        } catch (Exception e) {
            System.out.println("Error: " + e.getMessage());
        }
        try {


            Image img8 = Image.createImage(64,64);
                
            Graphics g = img8.getGraphics();
                
            g.setClip(0,0,img8.getWidth()-1, img8.getHeight()-1);
            for (int i=0; i<32; i++) {
                for (int j=0; j<32; j++) {
                    g.setColor((i+j)%256, (2*i+j)%256, (i+2*j)%256);
                    g.drawLine(i, j, i*2, j*2);
                }
            }
                
            ImageItem ii8 = new ImageItem("Buffered - 2",
                                          Image.createImage(img8),
                                          ImageItem.LAYOUT_CENTER, 
                                          "Image"); 
                
            mainScreen.append(ii8);

        } catch (Exception e) {
            System.out.println("Error: " + e.getMessage());
        }
        try {

            Image img9 = Image.createImage(128,128);
                
            Graphics g = img9.getGraphics();
            g.setClip(0,0,img9.getWidth()-1, img9.getHeight()-1);

            /*
             * Draw roundRect in the center of the canvas
             */
            g.setColor(0);
            g.drawString("fillRoundRect", img9.getWidth() / 2,
                         0, Graphics.HCENTER | Graphics.TOP);
            g.drawString("drawRoundRect", img9.getWidth() / 2,
                         font.getHeight(),
                         Graphics.HCENTER | Graphics.TOP);
            
            g.fillRoundRect(img9.getWidth() / 6,
                            font.getHeight() * 2,
                            (img9.getWidth() / 3) * 2, 30, 10, 10);
            g.setColor(0, 0, 255);
            g.drawRoundRect(img9.getWidth() / 6,
                            font.getHeight() * 2,
                            img9.getWidth() / 3 * 2, 30, 10, 10);

            ImageItem ii9 = new ImageItem("Buffered - 3",
                                          Image.createImage(img9),
                                          ImageItem.LAYOUT_RIGHT, 
                                          "Image"); 
                
            mainScreen.append(ii9);



        } catch (Exception e) {
            System.out.println("Error: " + e.getMessage());
        }
    }

    /**
     * Starts the MIDlet
     */
    public void startApp() throws MIDletStateChangeException {

        myDisplay.setCurrent(mainScreen);
    }

    /**
     * Stop the MIDlet
     */
    public void pauseApp() {
    }

    /**
     * Called by the framework before the application is unloaded
     */
    public void destroyApp(boolean unconditional) {
    }
}
