/*
 *  ChoiceGroupTest.java
 *
 *  Monday, June 19, 2000
 *
 *   Copyright 2000 Motorola, Inc.  All Rights Reserved.
 *  This notice does not imply publication.
 */

package com.mot.j2me.midlets.tests;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

/**
 * ChoiceGroupTest demonstrates use of radio buttons and checkboxes.
 *
 * @see MIDlet
 */
public class ChoiceGroupTest extends MIDlet {

    /**
     * Main midlet screen
     */
    private Form mainScreen;

    /**
     * Radio buttons
     */
    private ChoiceGroup radioGroup;

    /**
     * Checkboxes
     */
    private ChoiceGroup checkboxGroup;

    /**
     * Reference to the Display
     */
    private Display myDisplay;

    /**
     * Create the ChoiceGroupTest
     */
    ChoiceGroupTest() {

        myDisplay = Display.getDisplay(this);
        mainScreen = new Form("ChoiceGroup Test");

        testRadioButtons();
    }

    /**
     * Starts the shell
     */
    public void startApp() throws MIDletStateChangeException {

        myDisplay.setCurrent(mainScreen);
    }

    /**
     * Stop the shell
     */
    public void pauseApp() {
    }

    /**
     * Called by the framework before the application is unloaded
     */
    public void destroyApp(boolean unconditional) {
    }

    /**
     * Create and draw the radio buttons
     */
    private void testRadioButtons() {

        String str[] = {"Red", "Green", "Blue", "Yellow", "Orange"};
        Image img[] = {null, null, null, null, null};

        ChoiceGroup radioGroup = new ChoiceGroup("Radio Buttons:",
            ChoiceGroup.EXCLUSIVE, str, img);

        mainScreen.append(radioGroup);

        boolean selectArray[] = {false, false, false, true, true};

        radioGroup.setSelectedFlags(selectArray);

        String valString = radioGroup.getString(3);
        Image valImage = radioGroup.getImage(3);

        radioGroup.append("new item", null);

        /**
         * do checkboxes test here to ensure ChoiceGroup height
         * is being grown and shrunk correctly.
         */
        testCheckBoxes();

        radioGroup.set(4, "changed four", null);

        if (radioGroup.isSelected(3)) {
            radioGroup.setSelectedIndex(2, true);
            int sel = radioGroup.getSelectedIndex();
        }

        radioGroup.set(3, valString, valImage);
        radioGroup.delete(2);
        radioGroup.insert(2, "new two", valImage);
        radioGroup.delete(5);
        radioGroup.insert(radioGroup.size(), "HI!!", null);
    }

    /**
     * Create and draw the checkboxes
     */
    private void testCheckBoxes() {

        String str[] = {"zero", "one", "two", "three", "four"};
        Image img[] = {null, null, null, null, null};

        ChoiceGroup checkboxGroup = new ChoiceGroup("Checkboxes:",
            ChoiceGroup.MULTIPLE, str, img);

        mainScreen.append(checkboxGroup);

        boolean selectArray[] = {true, false, false, true, false};
        checkboxGroup.setSelectedFlags(selectArray);

        String valString = checkboxGroup.getString(3);

        Image valImage = checkboxGroup.getImage(3);

        checkboxGroup.delete(3);

        checkboxGroup.insert(3, "new three", valImage);

        checkboxGroup.set(4, "changed four", null);

        if (checkboxGroup.isSelected(0)) {
            checkboxGroup.setSelectedIndex(2, true);
        }
    }
}
