/*
 *  FormTest.java
 *
 *  Monday, June 19, 2000
 *
 *   Copyright 2000 Motorola, Inc.  All Rights Reserved.
 *  This notice does not imply publication.
 */

package com.mot.j2me.midlets.tests;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

/**
 * FormTest demonstrates use of Forms with different Items
 *
 * @see MIDlet
 */
public class FormTest extends MIDlet {

    /**
     * The main application screen
     */
    private Form mainScreen;

    /**
     * A reference to the Display
     */
    private Display myDisplay;

    /**
     * Create the FormTest
     */
    FormTest() {

        myDisplay = Display.getDisplay(this);
        mainScreen = new Form("Recipes");

        /*
         * Create a string item
         */
        StringItem si = new StringItem("Chocolate Cake",
                "Stir ingredients and bake 20 minutes. Eat and enjoy!");
        mainScreen.append(si);

        /*
         * Create a couple gauges
         */
        Gauge ag = new Gauge("Volume", true, 10, 5);
        mainScreen.append(ag);
        Gauge bg = new Gauge("Balance", true, 10, 5);
        mainScreen.append(bg);

        /*
         * Add some more string items
         */
        StringItem ai = new StringItem("Potatoes", "Bake them.");
        mainScreen.append(ai);
        StringItem bi = new StringItem("Chicken",
                "Fry for 10 minutes.");
        mainScreen.append(bi);

        /*
         * Add a radio button group
         */
        String str2[] = {"Red", "Green", "Blue", "Yellow", "Orange"};
        Image img2[] = {null, null, null, null, null};
        ChoiceGroup cgi2 = new ChoiceGroup("Next Item List:",
        ChoiceGroup.EXCLUSIVE, str2, img2);
        mainScreen.append(cgi2);

        /*
         * Add some more string items
         */
        StringItem di = new StringItem("Soup", "Add water, stir.");
        mainScreen.append(di);
        StringItem hi = new StringItem("Cookies", "Drop, bake.");
        mainScreen.append(hi);

        /*
         * Add a gauge
         */
        Gauge cg = new Gauge("Fade", true, 10, 5);
        mainScreen.append(cg);

        /*
         * Add a checkbox group
         */
        Image img[] = {null, null, null, null, null};
        String str[] = {"zero", "one", "two", "three", "four"};
        ChoiceGroup cgi = new ChoiceGroup("Item List:",
                ChoiceGroup.MULTIPLE, str, img);
        boolean selectArray[] = {true, false, false, true, false};
        cgi.setSelectedFlags(selectArray);
        mainScreen.append(cgi);
    }

    /**
     * Starts the midlet
     */
    public void startApp() throws MIDletStateChangeException {

        myDisplay.setCurrent(mainScreen);
    }

    /**
     * Stop the midlet
     */
    public void pauseApp() {
    }

    /**
     * Called by the framework before the application is unloaded
     */
    public void destroyApp(boolean unconditional) {
    }
}