/*
 *  GaugeTest.java
 *
 *  Monday, June 19, 2000
 *
 *   Copyright 2000 Motorola, Inc.  All Rights Reserved.
 *  This notice does not imply publication.
 */

package com.mot.j2me.midlets.tests;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

/**
 * GaugeTest demonstrates using the Gauge component
 *
 * @see MIDlet
 */
public class GaugeTest extends MIDlet {

    /**
     * The main screen
     */
    private Form mainScreen;

    /**
     * Reference to the Display
     */
    private Display myDisplay;

    /**
     * Create the GaugeTest
     */
    GaugeTest() {

        myDisplay = Display.getDisplay(this);
        mainScreen = new Form("Gauge Test");

        /*
         * Create a new interactable gauge
         * Max value = 10, initial value = 5
         */
        Gauge g = new Gauge("Volume", true, 10, 5);

        mainScreen.append(g);
    }

    /**
     * Starts the MIDlet
     */
    public void startApp() throws MIDletStateChangeException {

        myDisplay.setCurrent(mainScreen);
    }

    /**
     * Stop the MIDlet
     */
    public void pauseApp() {
    }

    /**
     * Called by the framework before the application is unloaded
     */
    public void destroyApp(boolean unconditional) {
    }
}