/*
 *  TextBoxTest.java
 *
 *  Monday, June 19, 2000
 *
 *   Copyright 2000 Motorola, Inc.  All Rights Reserved.
 *  This notice does not imply publication.
 */

package com.mot.j2me.midlets.tests;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

/**
 * TextBoxTest demonstrates use of the textbox screen
 *
 * @see MIDlet
 */
public class TextBoxTest extends MIDlet implements CommandListener {

    /**
     * The main textbox screen
     */
    private TextBox mainScreen;

    /**
     * Reference to the Display
     */
    private Display myDisplay = null;

    /**
     * A large string to fill the text box with
     */
    String bigString = "The TextBox is a screen that allows the user to enter and edit text. The textBox has a title that is shown at the top of the display. It can be given a piece of text that is used as the initial value. The TextBox has a maximum capacity in terms of the number of characters that can be set by the application. When the textbox reaches this maximum capacity, the user is not allowed to enter additional characters unless some are deleted first.";

    /**
     * Command to add - just to make sure it appears correctly
     */
    Command okCommand = new Command("OK", Command.OK, 1);

    TextBoxTest() {

        myDisplay = Display.getDisplay(this);
        mainScreen = new TextBox("Text Box Test", bigString,
             512, TextField.ANY);
        mainScreen.addCommand(okCommand);
        mainScreen.setCommandListener(this);
    }

    /**
     * Starts the midlet
     */
    public void startApp() throws MIDletStateChangeException {

        myDisplay.setCurrent(mainScreen);
    }

    /**
     * Stop the midlet
     */
    public void pauseApp() {
    }

    /**
     * Called by the framework before the application is unloaded
     */
    public void destroyApp(boolean unconditional) {
    }

    /**
     * A command has been fired
     */
    public void commandAction(Command c, Displayable s) {
    }
}