/*
 *  TextFieldTest.java
 *
 *  Monday, June 19, 2000
 *
 *   Copyright 2000 Motorola, Inc.  All Rights Reserved.
 *  This notice does not imply publication.
 */

package com.mot.j2me.midlets.tests;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

/**
 * TextFieldTest demonstrates use of text fields in Forms
 *
 * @see MIDlet
 */
public class TextFieldTest extends MIDlet {

    /**
     * Main application screen
     */
    private Form mainScreen;

    /**
     * Reference to the display
     */
    private Display myDisplay;

    TextFieldTest() {

        myDisplay = Display.getDisplay(this);
        mainScreen = new Form("Text Field Test");

        /*
         * Create some text fields
         */
        TextField anyField = new TextField("Any:", "My Name", 20,
                TextField.ANY);
        TextField emailField = new TextField("Email:",
                "myname@something.com", 20,
                                      TextField.EMAILADDR);
        TextField passwordField = new TextField("Password:", "", 24,
                TextField.PASSWORD);
        TextField phoneField = new TextField("Phone:", "", 7,
                TextField.PHONENUMBER);
        TextField urlField = new TextField("URL:", "www.something.com",
                20, TextField.URL);
        TextField numberField = new TextField("Numeric:", "", 4,
                TextField.NUMERIC);

        /*
         * Add them to the main screen
         */
        mainScreen.append(anyField);
        mainScreen.append(emailField);
        mainScreen.append(passwordField);
        mainScreen.append(phoneField);
        mainScreen.append(urlField);
        mainScreen.append(numberField);
    }

    /**
     * Starts the midlet
     */
    public void startApp() throws MIDletStateChangeException {

        myDisplay.setCurrent(mainScreen);
    }

    /**
     * Stop the midlet
     */
    public void pauseApp() {
    }

    /**
     * Called by the framework before the application is unloaded
     */
    public void destroyApp(boolean unconditional) {
    }
}