import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

public class PanelTest extends IApplication implements SoftKeyListener, KeyListener, ComponentListener {
	public void start() {
		String[] args;
		TextBox label;
		String text;
	
		Panel panel = new Panel();
		
		panel.add(new Label("xł"));
		panel.add(new Button("{^ł"));
		
		ListBox[] lb = new ListBox[6];
		for (int i = 0; i < lb.length; i++) {
			ListBox l;
			panel.add(l = new ListBox(i, 3));
			for (int j = 0; j < 5; j++)
				l.append("item" + j);
		}
		
		panel.add(new TextBox("s", 10, 1, TextBox.DISPLAY_ANY));
		panel.add(new TextBox("password", 10, 1, TextBox.DISPLAY_PASSWORD));
		panel.add(new TextBox("s", 10, 3, TextBox.DISPLAY_ANY));
		
		MediaImage mi = MediaManager.getImage("resource:///test.gif");
		try {
			mi.use();
		} catch (ConnectionException e) {
		}
		Image im = mi.getImage();
		panel.add(new ImageLabel(im));
		VisualPresenter vp;
		panel.add(vp = new VisualPresenter());
		vp.setImage(mi);
		
		
		panel.add(new Ticker("Tickerł"));
		panel.add(new Ticker("鑬x͋@ˑł"));
		panel.add(new Ticker("iEmulator release 2 ӊJI"));
		
		panel.setComponentListener(this);
		panel.setKeyListener(this);
		panel.setSoftKeyListener(this);
		
		Display.setCurrent(panel);
	}
	
	// SoftKeyListener
	public void softKeyPressed(int key) {
		System.out.println("soft key pressed " + key);
	}
	public void softKeyReleased(int key) {
		System.out.println("soft key released " + key);
	}
	
	// KeyListener
	public void keyPressed(Panel p, int key) {
		System.out.println("key pressed " + p + " " + key);
	}
	public void keyReleased(Panel p, int key) {
		System.out.println("key released " + p + " " + key);
	}

	// ComponentListener
	public void componentAction(Component source, int type, int param) {
		System.out.println("component action " + source + " " + type + " " + param);
	}
}
