import java.io.*;

import com.nttdocomo.ui.*;
import com.nttdocomo.io.*;

import javax.microedition.io.*;

public class ScratchPadTest extends IApplication implements ComponentListener {
	TextBox pos, body, url, sp;
	Button btn;
	public void start() {
		Panel panel = new Panel();
		
		panel.add(new Label("ʒu"));
		panel.add(pos = new TextBox("0", 16, 1, TextBox.DISPLAY_ANY));
		panel.add(new Label("e"));
		panel.add(body = new TextBox("", 16, 3, TextBox.DISPLAY_ANY));
		panel.add(new Label("URL"));
		panel.add(url = new TextBox("", 20, 1, TextBox.DISPLAY_ANY));
		url.setEditable(false);

		panel.add(btn = new Button("ScratchPadɏ"));

		panel.add(new Label("ScratchPad"));
		panel.add(sp = new TextBox("", 16, 3, TextBox.DISPLAY_ANY));
		sp.setEditable(false);
		
		panel.setComponentListener(this);
		
		Display.setCurrent(panel);
		
		sp.setText(read());
	}
	//
	public void componentAction(Component source, int type, int param) {
		if (source == btn) {
			int n = 0;
			try {
				n = Integer.parseInt(pos.getText());
			} catch (NumberFormatException e) {
			}
			n *= 2;
			url.setText("scratchpad:///0;pos=" + n);
			write(n, body.getText());
			
			sp.setText(read());
		}
	}
	void write(int pos, String s) {
		try {
			DataOutputStream out = Connector.openDataOutputStream("scratchpad:///0;pos=" + pos);
			for (int i = 0; i < s.length(); i++)
				out.writeChar(s.charAt(i));
			out.close();
		} catch (IOException e) {
			System.out.println("write exception: " + e);
		}
	}
	String read() {
		String res = null;
		try {
			DataInputStream in = Connector.openDataInputStream("scratchpad:///0");
			StringBuffer sb = new StringBuffer();
			try {
				for (;;)
					sb.append(in.readChar());
			} catch (EOFException e) {
			}
			res = sb.toString();
			in.close();
		} catch (IOException e) {
			System.out.println("read exception: " + e);
		}
		return res;
	}
}
