<?xml version="1.0" encoding="euc-kr"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/TR/WD-xsl">

	<xsl:template match="/">
		<HTML>
			<HEAD>
				<TITLE> Phone Device Information </TITLE>
			</HEAD>
			<BODY>
				<CENTER> 
				<H1> Phone Device Information </H1>
				</CENTER> 
				<BR/>
				<xsl:apply-templates select="phone/java_property"/> <BR/>
				<xsl:apply-templates select="phone/bitmap"/> <BR/>

				<CENTER>
				<TABLE BORDER="1" BGCOLOR="#FFFFF0" WIDTH="600">
					<TR>
						<TD colspan="2" BGCOLOR="#FFFFE0"> Other settings </TD>
					</TR>
					<xsl:apply-templates select="phone/sound"/> 
					<xsl:apply-templates select="phone/text_component_handler"/> 
					<xsl:apply-templates select="phone/sound_type"/> 
					<xsl:apply-templates select="phone/socket_num"/> 
					<xsl:apply-templates select="phone/graphic_dll"/>
					<xsl:apply-templates select="phone/image_directory"/>	
				</TABLE>
				</CENTER>
			</BODY>
		</HTML>
	</xsl:template>
	
	<xsl:template match="java_property">
		<CENTER>
			<TABLE BORDER="1" BGCOLOR="#FFFFF0" WIDTH="600">
				<TR>
					<TD colspan="2" BGCOLOR="#FFFFE0"> Java System Property &#x00A0;&#x00A0; (get via java.lang.System.getProperty()) </TD>
				</TR>
   				<TR>
   					<TD WIDTH="50%"> m.CARRIER </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@CARRIER"/> &#x00A0;</TD>
   				</TR>
   				<TR>
   					<TD> m.TYPE </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@TYPE"/> &#x00A0;</TD>
   				</TR>
   				<TR>
   					<TD> m.VENDER </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@VENDER"/> &#x00A0;</TD>
   				</TR>
   				<TR>
   					<TD> m.MODEL </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@MODEL"/> &#x00A0;</TD>
   				</TR>
   				<TR>
   					<TD> m.CONF_PROFILE </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@CONF_PROFILE"/> &#x00A0;</TD>
   				</TR>
   				<TR>
   					<TD> m.SK_VM </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@SK_VM"/> &#x00A0;</TD>
   				</TR>
   				<TR>
   					<TD> m.EXT_SW </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@EXT_SW"/> &#x00A0;</TD>
   				</TR>
   				<TR>
   					<TD> m.LCD_PIXEL </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@LCD_PIXEL"/> &#x00A0;</TD>
   				</TR>
   				<TR>
   					<TD> m.LCD_FONT </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@LCD_FONT"/> &#x00A0;</TD>
   				</TR>
   				<TR>
   					<TD> m.SOUND_POLY </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@SOUND_POLY"/> &#x00A0;</TD>
   				</TR>
   				<TR>
   					<TD> m.COLOR </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@COLOR"/> &#x00A0;</TD>
   				</TR>
   				<TR>
   					<TD> m.MIN </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@MIN"/> &#x00A0;</TD>
   				</TR>
   				<TR>
   					<TD> m.SID </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@SID"/> &#x00A0;</TD>
   				</TR>
   				<TR>
   					<TD> m.BASE_ID </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@BASE_ID"/> &#x00A0;</TD>
   				</TR>
   				<TR>
   					<TD> m.REG_ZONE </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@REG_ZONE"/> &#x00A0;</TD>
   				</TR>
   				<TR>
   					<TD> m.PILOT_PN </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@PILOT_PN"/> &#x00A0;</TD>
   				</TR>
   				<TR>
   					<TD> m.GVM_VER </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@GVM_VER"/> &#x00A0;</TD>
   				</TR>
			</TABLE>
		</CENTER>
	</xsl:template>

	<xsl:template match="bitmap">
		<CENTER>
			<TABLE BORDER="1" BGCOLOR="#FFFFF0" WIDTH="600">
				<TR>
					<TD colspan="2" BGCOLOR="#FFFFE0"> Emulator Skin Bitmap Image </TD>
				</TR>
   				<TR>
   					<TD WIDTH="50%"> Image file name </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@src"/> &#x00A0;</TD>
   				</TR>
   				<TR>
   					<TD> Image width </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@width"/> &#x00A0;</TD>
   				</TR>
   				<TR>
   					<TD> Image height </TD>
   					<TD BGCOLOR="#FEDCA3"><xsl:value-of select="@height"/> &#x00A0;</TD>
   				</TR>
   			</TABLE>
		</CENTER>   			
	</xsl:template>

	<xsl:template match="sound">
		<TR>
			<TD WIDTH="50%"> Supported sound formats </TD>
			<TD BGCOLOR="#FEDCA3">
				<xsl:apply-templates select="./format"/> &#x00A0;
			</TD>
		</TR>
	</xsl:template>

	<xsl:template match="format">
		<xsl:value-of select="./@type"/> 
	</xsl:template>
	

	<xsl:template match="text_component_handler">
		<TR>
			<TD> Text component handler class </TD>
			<TD BGCOLOR="#FEDCA3">
				<xsl:value-of/> &#x00A0;
			</TD>
		</TR>
	</xsl:template>

	<xsl:template match="sound_type">
		<TR>
			<TD> Sound type </TD>
			<TD BGCOLOR="#FEDCA3">
				<xsl:value-of/> &#x00A0;
			</TD>
		</TR>
	</xsl:template>
	
	<xsl:template match="socket_num">
		<TR>
			<TD> Concurrently available socket number </TD>
			<TD BGCOLOR="#FEDCA3">
				<xsl:value-of/> &#x00A0;
			</TD>
		</TR>
	</xsl:template>

	<xsl:template match="graphic_dll">
		<TR>
			<TD> Graphics DLL name </TD>
			<TD BGCOLOR="#FEDCA3">
				<xsl:value-of/> &#x00A0;
			</TD>
		</TR>
	</xsl:template>

	<xsl:template match="image_directory">
		<TR>
			<TD> Image folder name </TD>
			<TD BGCOLOR="#FEDCA3">
				<xsl:value-of/> &#x00A0;
			</TD>
		</TR>
	</xsl:template>

	
</xsl:stylesheet>
