
package graphic;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import com.xce.lcdui.*;
import com.skt.m.*;
import java.io.*;

public class DrawTest extends MIDlet implements CommandListener, Runnable
{
    private Display display;
	private TestCanvas testCanvas;

	private Command exitComm = new Command("Exit", Command.EXIT, 0);
	
	int drawIndex = 0;
	int drawStep = 0;
	final static int MAXINDEX = 3;
	final static int MAXSTEP = 20;
	
    public DrawTest()
    {
		testCanvas = new TestCanvas();
    }

    public void startApp()
    {
		testCanvas.addCommand(exitComm);
		testCanvas.setCommandListener(this);
    	
    	display = Display.getDisplay(this);
        display.setCurrent(testCanvas);
        display.callSerially(this);
    }

    public void destroyApp(boolean uncond)
    {
    }

    public void pauseApp()
    {
    }

    class TestCanvas extends Canvas {
		int color1 = (Integer.parseInt(System.getProperty("m.COLOR"), 10) < 4)? 0x00FFFF00: Toolkit.lt_gray;
		int color2 = (Integer.parseInt(System.getProperty("m.COLOR"), 10) < 4)? 0x00FF0000: Toolkit.black;
		int color3 = (Integer.parseInt(System.getProperty("m.COLOR"), 10) < 4)? 0x000000FF: Toolkit.black;
		
		int width = getWidth();
		int height = getHeight();
		int drawWidth = width-20;
		int drawHeight = height-20;
		int x = 10;
		int y = 10;

        public void paint(Graphics g) {
        	g.setColor(Toolkit.white);
        	g.fillRect(0,0,getWidth(),getHeight());
        	switch(drawIndex){
        		case 0:
        			int arc = 360 / MAXSTEP * drawStep;
		        	g.setColor(color1);
					g.fillArc(x, y, drawWidth, drawHeight, 0, arc);
					g.setColor(color2);
					g.drawArc(x, y, drawWidth, drawHeight, 0, arc);
					g.setColor(color3);
					g.drawString("fillArc", width/2, height/2-Toolkit.FONT_HEIGHT, Graphics.TOP | Graphics.HCENTER);
					g.drawString("drawArc", width/2, height/2, Graphics.TOP | Graphics.HCENTER);
					break;
				case 1:
					int arcWidth = drawWidth / 2 / MAXSTEP * (MAXSTEP-drawStep);
					int arcHeight = drawHeight / 2 / MAXSTEP * (MAXSTEP-drawStep);
					g.setColor(color1);
					g.fillRoundRect(x, y, drawWidth, drawHeight, arcWidth, arcHeight);
					g.setColor(color2);
					g.drawRoundRect(x, y, drawWidth, drawHeight, arcWidth, arcHeight);
					g.setColor(color3);
					g.drawString("fillRoundRect", width/2, height/2-Toolkit.FONT_HEIGHT, Graphics.TOP | Graphics.HCENTER);
					g.drawString("drawRoundRect", width/2, height/2, Graphics.TOP | Graphics.HCENTER);
					break;
				case 2:
					int w = drawWidth / MAXSTEP * (MAXSTEP-drawStep);
					int h = drawHeight / MAXSTEP * (MAXSTEP-drawStep);
					g.setColor(color1);
					g.fillRect(x, y, w, h);
					g.setColor(color2);
					g.drawRect(x, y, w, h);
					g.setColor(color3);
					g.drawString("fillRect", width/2, height/2-Toolkit.FONT_HEIGHT, Graphics.TOP | Graphics.HCENTER);
					g.drawString("drawRect", width/2, height/2, Graphics.TOP | Graphics.HCENTER);
					break;
				case 3:
					int lineY = drawHeight / MAXSTEP * drawStep;
					g.setColor(color2);
					g.drawLine(x, y + lineY, x + drawWidth, y + lineY);
					g.setColor(color3);
					g.drawString("drawLine", width/2, height/2, Graphics.TOP | Graphics.HCENTER);
					break;
			}
        }
    }

	public void commandAction(Command c, Displayable d) {
		if (c == exitComm) {
			destroyApp(true);
			notifyDestroyed();
		}
	}
	
	public void run(){
	
		drawStep++;
		if( drawStep > MAXSTEP ){
			drawStep = 0;
			drawIndex++;
			if( drawIndex > MAXINDEX ){
				drawIndex = 0;
			}
		}
		//try{ Thread.sleep(50); } catch( Exception e ){}
		display.callSerially(this);
		testCanvas.repaint();		
	}
}
