package graphic;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import com.xce.lcdui.*;
import com.skt.m.*;

public class GrayLbmTest extends MIDlet implements CommandListener
{
    Display display;
	Canvas testCanvas;

	Command exitComm = new Command("Exit", Command.EXIT, 0);
	
    public GrayLbmTest()
    {
		testCanvas = new TestCanvas();
    }

    public void startApp()
    {
		if (System.getProperty("m.SKT_API") == null){
			Device.setColorMode(Device.COLOR_MODE_4G);
		}
		
		testCanvas.addCommand(exitComm);
		testCanvas.setCommandListener(this);
    	
    	display = Display.getDisplay(this);
        display.setCurrent(testCanvas);
    }

    public void destroyApp(boolean uncond)
    {
    }

    public void pauseApp()
    {
    }

    class TestCanvas extends Canvas {
        Image image;
		Graphics2D g2d;

        public TestCanvas() {
        }

        public void paint(Graphics g) {
			g.setColor(Toolkit.white);
			g.fillRect(0, 0, this.getWidth(), this.getHeight());
            try {
				image = Image.createImage("/graphic/gray.lbm");
            } catch (java.io.IOException ex) {}
            
			int x = (image.getWidth() - getWidth())/2;
			int y = (image.getHeight() - getHeight() - 16)/2;

			if( g2d == null ){
	            g2d = Graphics2D.getGraphics2D(g);
	        }
            g2d.drawImage(0, 0, image, x, y, getWidth(), getHeight()+16, Graphics2D.DRAW_COPY);
        }
    }

	public void commandAction(Command c, Displayable d) {
		if (c == exitComm) {
			destroyApp(true);
			notifyDestroyed();
		}
	}
}
