package perf;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;
import java.util.*;
import java.io.*;
import com.xce.io.*;

public class XVMFilePerf extends MIDlet implements CommandListener {

private Display display;

private Command startCmd 
					= new Command(" ", Command.SCREEN, 3);
private Command exitCmd = new Command("", Command.EXIT, 2);
private TextBox msgBox = 
			new TextBox("  ", "", 100, TextField.ANY);
private Form form = new Form("  ");
private TextField writeField = 
					new TextField(" ", "", 20, TextField.ANY);
private TextField readField = 
					new TextField(" б", "", 20, TextField.ANY);
	
public XVMFilePerf() {
	display = Display.getDisplay(this);

	form.append(writeField);
	form.append(readField);
	
	form.addCommand(exitCmd);
	form.setCommandListener(this);

	msgBox.setString(
		"      ð " + 
		"ɸǷ  ٷ ֽʽÿ");
	msgBox.addCommand(startCmd);
	msgBox.addCommand(exitCmd);
	msgBox.setCommandListener(this);

}

public void startApp() {
	display.setCurrent(msgBox);
}

public void pauseApp() {
}

public void destroyApp(boolean unconditional) {
}	

public void commandAction(Command c, Displayable s) {
	if ( c == exitCmd ) {
		destroyApp(false);
		notifyDestroyed();
	} else if ( c == startCmd ) {
		startFilePerf();
	}
}


private void startFilePerf() {
	byte[] data = new byte[1024];
	String testFileName = "test_file_perf";
	int repeat = 10;

	FileOutputStream fos = null;
	FileInputStream fis = null;
	
	// make data
	display.setCurrent(form);
	for (int i = 0; i < data.length; i++) data[i] = (byte)i;
	try {
		long startTime, endTime;

		// write data
		startTime = System.currentTimeMillis();
		fos = new FileOutputStream(testFileName);
		for (int i = 0; i < repeat ; i++)
			fos.write(data, 0, data.length);
		
		endTime = System.currentTimeMillis();

		writeField.setString((endTime - startTime) 
			+ " msec/ "
			+ (data.length * repeat / 1024)
			+ " KB");

		// read data
		startTime = System.currentTimeMillis();
		fis = new FileInputStream(testFileName);
		
		//for (int i = 0; i < repeat ; i++)
		data = new byte[fis.available()];
		fis.read(data, 0, fis.available());
		endTime = System.currentTimeMillis();

		readField.setString((endTime - startTime) 
			+ " msec/ "
			+ (data.length/ 1024)
			+ " KB");
	} catch (Exception e) {
		System.out.println(e);
	} finally {
		if( fos != null ){
			try{ fos.close(); } catch ( Exception e ){}
		}
		if( fis != null ){
			try{ fis.close(); } catch ( Exception e ){}
		}
		try{
			XFile.unlink(testFileName);
		} catch ( Exception e ){}
	}
}


}
