package perf;

import javax.microedition.lcdui.Display;
import javax.microedition.midlet.MIDlet;
import com.xce.util.Debug;
import com.xce.lcdui.*;
import java.io.IOException;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.MIDlet;

public class XVMGraphicTest extends MIDlet {
	Display display;	
	AniCanvas canvas;
	WaitCanvas waitCanvas;	

	public XVMGraphicTest() {		
        display = Display.getDisplay(this);		
		waitCanvas = new WaitCanvas();
		canvas = new AniCanvas(this);
    }

	public void startApp() {		
		display.setCurrent(waitCanvas);
		canvas.init();
    }

	public void pauseApp() {
		display.setCurrent(null);
    }

	public void destroyApp(boolean flag) {
    }    


class WaitCanvas extends Canvas {
	public void paint(Graphics g) {
		g.drawString("̹ ε", getWidth() / 2, 50, Graphics.TOP | Graphics.HCENTER);
	}
}


class AniCanvas extends Canvas implements Runnable, CommandListener {
	public static final int MAX_IMG = 6;
	
    Display display;
    XVMGraphicTest midlet;	
	
	Command exitCmd = new Command("", Command.EXIT, 1);

	long oldTime;
	String time = "0";
	boolean visible;
    Image imgs[] = new Image[14];
    int index;
	boolean loaded = false;
	
    public AniCanvas(XVMGraphicTest midlet1)
    {	
		this.addCommand(exitCmd);
		this.setCommandListener(this);
		
        midlet = midlet1;        
    }
	
	void init() {
		if (!loaded) {
			for(int i = 0; i < MAX_IMG; i++) {
				try {
					imgs[i] = Image.createImage("/perf/img/120149" + "-" + (i + 1) + ".png");
				} catch (Exception e) {
				}
				
				// FIXME : if Image class is updated, this will be removed.
				if (imgs[i].getWidth() == 10) {
					try {
						imgs[i] = Image.createImage("/perf/img/" + (i + 1) + ".png");
					} catch (Exception ef) {
					}					
				}
			}			
			loaded = true;
		}
		display = Display.getDisplay(midlet);
		display.setCurrent(this);
		display.callSerially(this);					
	}

	/*
    String twoDigitOf(int i)
    {
        if(i < 10)
            return "0" + i;
        else
            return String.valueOf(i);
    }
	*/

    public void paint(Graphics g)
    {        
        g.drawImage(imgs[index], 0, 0, Graphics.LEFT | Graphics.TOP);
		g.setGrayScale(Toolkit.WHITE);
		g.fillRect(0, 0, 70, 14);
		g.setGrayScale(Toolkit.BLACK);		
		g.drawString(time, 0, 0, Graphics.LEFT | Graphics.TOP);		
    }
	
	public void commandAction(Command c, Displayable d) {
		if (c == exitCmd) {			
			midlet.notifyDestroyed();			
		}
	}

    public void run()
    {	
		index++;
		if(index == MAX_IMG) {
		    index = 0;
			long l = System.currentTimeMillis();
			time = String.valueOf(MAX_IMG * 1000 / (l - oldTime)) + " frame/sec";
			oldTime = l;
		}
		display.callSerially(this);
		repaint();
    }

}

}
