/******************************************************************************
	BLTest.java
		 : Vibration, Backlight  ׽Ʈ
		 : Vibration Test ޴ -  ð   
			   Backlight On ޴ -    ʷ  ð ѱ
			   Backlight Off ޴ -  
			   All Test with Sound ޴ - , ,  Ѳ 
*******************************************************************************/

package skvm;

import com.skt.m.*;
import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.io.*;
import java.io.*;
import com.xce.util.*;

public class BLTest extends MIDlet
			implements CommandListener, Runnable {
    Display display;	
	Command exitComm = new Command("Exit", Command.EXIT, 0);	
	List testList = new List("BLTest", List.IMPLICIT);
	
	AudioClip clip = null;	
	
	public BLTest() {
		testList.addCommand(exitComm);
		testList.setCommandListener(this);
		
		testList.append("Vibration Test", null);
		testList.append("Backlight On 3 sec", null);
		testList.append("Backlight On Forever", null);
		testList.append("Backlight Off", null);
		testList.append("All Test with Sound", null);
		
		display = Display.getDisplay(this);
	}
	
    public void startApp () {
        display.setCurrent(testList);
	}
	
    public void destroyApp (boolean unconditional) {
    	// ׽Ʈ α׷ ɶ  , 带  Ŵ
		BackLight.off();
		Vibration.stop();
		if (clip != null) {
			try {
				clip.close();
			} catch (Exception e) {
			}		
			clip = null;
		}
    }

    public void pauseApp () {
    }
	
	public void commandAction(Command c, Displayable d) {
		if (c == exitComm) {
			destroyApp(true);
			notifyDestroyed();
		} else if (c == List.SELECT_COMMAND){
			run(testList.getSelectedIndex());
		}
	}
	
	private void run(int testnum){
		// List ׸ ý õ ε   ׽Ʈ 
		switch(testnum){
			case 0:					// Vibration Test ޴
				vibration();
				break;
			case 1:					// Backlight On ޴
				backlight();
				break;
			case 2:
				BackLight.on(0);
				break;
			case 3:					// Backlight Off ޴
				BackLight.off();
				break;
			case 4:					// All Test with Sound ޴
				play();
				vibration();
				backlight();				
				break;
		}
	}
	
	public void run() {
		try {
			String fileName;
			// mmf  带   ִ clip 
			try{ 
				clip = AudioSystem.getAudioClip("mmf");
				fileName = "/skvm/snd0.mmf";
			} catch (Exception e){
				clip = AudioSystem.getAudioClip("buzzer");
				fileName = "/skvm/snd4.buz";
			}
			// snd.mmf buffer о  ̸  mmf clip Ͽ 
			InputStream is = getClass().getResourceAsStream(fileName);
			byte[] buffer = new byte[is.available()];
			is.read(buffer);
			clip.open(buffer, 0, buffer.length);
			clip.play();
		} catch (Exception e) {			
		} finally {
			if (clip != null) {
				try {
					clip.close();
				} catch (Exception e) {}
				clip = null;
			}
		}
	}
	
	private void play() {
		Thread thread = new Thread(this);
		thread.start();
	}
	
	private void vibration(){
		//  ѱ : void start(int level, int timeout) 
		Vibration.start(0, 3000);
	}
	
	private void backlight(){
		//    : int[] getColor() 
		int colors[] = BackLight.getColors();
		for(int i=0; i<colors.length; i++){
			//    : void setColor(int index) 
			BackLight.setColor(i);
			BackLight.on(3000);
			//try {
			//	Thread.sleep(3000);
			//} catch (Exception e) {
			//}
		}
	}
}
