/******************************************************************************
	PhonebookTest.java
*******************************************************************************/

package skvm;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import com.skt.m.*;

/**
 * SK-VM 1.1  ߰ Ŭ PhoneBook ϴ 
 * /SK-VM/bin/pbook.dat  ͸ о´.
 */

public class PhonebookTest extends MIDlet implements CommandListener {
    Display display;
	
	//main list
	List lstPhoneBook = new List("PhoneBook", List.IMPLICIT);

	Command cmdExit = new Command("Exit", Command.EXIT, 0);
	Command cmdView = new Command("View", Command.SCREEN, 1);
	Command cmdAllList = new Command("AllList", Command.SCREEN, 2);
	Command cmdFindList = new Command("FindList", Command.SCREEN, 3);
	Command cmdGroupList = new Command("GroupList", Command.SCREEN, 4);
	

	//find form
	Form frmFind = new Form("Find");
	ChoiceGroup cgField = new ChoiceGroup("Field", Choice.EXCLUSIVE);
	TextField tfPattern = new TextField("Pattern", "", 50, TextField.ANY);
	
	Command cmdCancel = new Command("Cancel", Command.CANCEL, 0);
	Command cmdFind = new Command("Find", Command.OK, 1);
	
	
	public PhonebookTest() {
		lstPhoneBook.addCommand(cmdExit);

		if(	System.getProperty("m.SK_VM") != null ){
			lstPhoneBook.addCommand(cmdView);
			lstPhoneBook.addCommand(cmdAllList);
			lstPhoneBook.addCommand(cmdFindList);
			lstPhoneBook.addCommand(cmdGroupList);

			cgField.append("NAME",null);
			cgField.append("GROUP",null);
			cgField.append("HANDPHONE",null);
			cgField.append("HOME",null);
			cgField.append("OFFICE",null);
			cgField.append("EMAIL",null);

			frmFind.append(cgField);
			frmFind.append(tfPattern);
			frmFind.addCommand(cmdCancel);
			frmFind.addCommand(cmdFind);		
			frmFind.setCommandListener(this);
		}

		lstPhoneBook.setCommandListener(this);		
																		
		display = Display.getDisplay(this);
	}
	
    public void startApp () {
		if(	System.getProperty("m.SK_VM") == null ){
			display.setCurrent(lstPhoneBook);
			alert("PhoneBook", " ʴ SK-VM Դϴ.");
		} else {
			loadAllList();
			display.setCurrent(lstPhoneBook);
		}
	}
	
    public void destroyApp (boolean unconditional) {
    }

    public void pauseApp () {
    }
	
	public void commandAction(Command c, Displayable d) {
		if (c == cmdExit) {
			destroyApp(true);
			notifyDestroyed();
		} else if (c == cmdView || c == List.SELECT_COMMAND) {
			viewInfo();			
		} else if (c == cmdAllList) {
			loadAllList();
		} else if (c == cmdFindList) {
			display.setCurrent(frmFind);			
		} else if (c == cmdGroupList) {
			loadGroupList();
		} else if (c == cmdCancel){
			loadAllList();
		} else if (c == cmdFind){
			loadFindList();
			display.setCurrent(lstPhoneBook);
		}
	}

	private void loadAllList(){
		lstPhoneBook.deleteAll();
		lstPhoneBook.setTitle("PhoneBook-All");
		PhoneBook.first();
		int id;
		while((id=PhoneBook.next())!=-1){
			lstPhoneBook.append(id + "." + PhoneBook.getField(id,PhoneBook.NAME),null);
		}			
	}
	
	private void loadFindList(){
		lstPhoneBook.deleteAll();
		lstPhoneBook.setTitle("PhoneBook-Find");
		PhoneBook.findRecord(cgField.getSelectedIndex()+1,tfPattern.getString());
		int id;
		while((id=PhoneBook.next())!=-1){
			lstPhoneBook.append(id + "." + PhoneBook.getField(id,PhoneBook.NAME),null);
		}			
	}
	
	private void loadGroupList(){
		lstPhoneBook.deleteAll();
		lstPhoneBook.setTitle("PhoneBook-Group"); 
		String group[] = PhoneBook.getGroupNames();
		if( group != null ){
			for(int i=0; i<group.length; i++ ){
				if( group[i] != null ){
					lstPhoneBook.append(group[i], null);
				}
			}
		}
	}
	
	private void viewInfo(){
		String name = lstPhoneBook.getString(lstPhoneBook.getSelectedIndex());
		int id = Integer.parseInt(name.substring(0,name.indexOf('.')));
		String info = "Name:" + PhoneBook.getField(id, PhoneBook.NAME) + "\n";
		info += "GROUP:" + PhoneBook.getField(id, PhoneBook.GROUP) + "\n";
		info += "HANDPHONE:" + PhoneBook.getField(id, PhoneBook.HANDPHONE) + "\n";
		info += "HOMEPHONE:" + PhoneBook.getField(id, PhoneBook.HOME) + "\n";
		info += "OFFICEPHONE:" + PhoneBook.getField(id, PhoneBook.OFFICE) + "\n";
		info += "EMAIL:" + PhoneBook.getField(id, PhoneBook.EMAIL) + "\n";
		info += "MEMO:" + PhoneBook.getField(id, PhoneBook.MEMO) + "\n";
		alert("PhoneBook", info);	
	}

	private void alert(String name, String msg){
		Alert alert = new Alert(name);
		alert.setString(msg);
		alert.setTimeout(Alert.FOREVER);
		display.setCurrent(alert);
	}

}
