package skvm;

import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;
import com.xce.io.*;
import javax.microedition.io.*;
import java.io.*;
import com.skt.m.*;

/**
 * SK-VM 1.1  ߰ Ŭ com.skt.m.SISImage 
 * Device.setSISImage() ϴ 
 */

public class SISTest extends MIDlet implements CommandListener {
	private static Command okCmd = new Command("Ȯ", Command.OK, 2);
	private static Command exitCmd = new Command("Exit", Command.EXIT, 1);	
	List list = new List("SIS ̹ ׽Ʈ", List.IMPLICIT);
	String[] fname = {"/skvm/sis_bw.sis", "/skvm/sis_4g.sis",
					  "/skvm/sis_256c.sis"};	
	byte[][] buf = new byte[fname.length][];
	SISImage[] sisImage = new SISImage[fname.length];
	
	
	private static Command setCmd = new Command("Set", Command.OK, 2);	
	private static Command backCmd = new Command("Back", Command.BACK, 1);
	SISTestCanvas canvas;	
	
	Display display;
	int currIndex;
	

	SISTest() {
		/**
		 * ҴǴ   ũ 64kb + 20kb * 2 = 104kb ̴.
		 * ϴ SIS ̹ ũ⿡   ũ⸦ Ҵ
		 * ϸ ȴ.
		 */
		SISImage.createBuffer(64 * 1024, 20*1024);
		for (int i = 0; i < fname.length; i++) {
			list.append(fname[i], null);
		}
		list.addCommand(okCmd);
		list.addCommand(exitCmd);
		list.setCommandListener(this);
		
		canvas = new SISTestCanvas(this);	
		canvas.addCommand(setCmd);
		canvas.addCommand(backCmd);
		canvas.setCommandListener(this);
		
		loadSISData();
	}
	
	void loadSISData() {
		for (int i = 0; i < fname.length; i++) {
			InputStream in = null;
			try {
				in = this.getClass().getResourceAsStream(fname[i]);
				buf[i] = new byte[in.available()];
				in.read(buf[i]);
				
				/**
				 * ÿ  SISImage    ۴
				 * ϳ̱   ۿ ִ ̹ ڽ
				 * ̹ ƴ϶  ޼ҵ带 ȣ  SIS
				 * ̹ ٽ ڵѴ.
				 * 
				 * ׷ SIS ڴ  ϱ   ̴
				 *     ̴.
				 */
				sisImage[i] = SISImage.createSISImage(buf[i], 0, buf[i].length);
			} catch (Exception e) {
			} finally {
				if (in != null) {
					try {
						in.close();
					} catch (Exception e) { }
				}
			}
		}
	} 	
	
	public void startApp() {
		display = Display.getDisplay(this);
		display.setCurrent(list);
	}	
	
	public void pauseApp() {
    }
	
    public void destroyApp(boolean unconditional){
    } 
	
	public void commandAction(Command c, Displayable d) {
		if (d == list) {
			currIndex = list.getSelectedIndex();
			if (c == okCmd || c == List.SELECT_COMMAND) {
				canvas.setSIS(sisImage[currIndex]);
				display.setCurrent(canvas);			
			} else if (c == exitCmd) {
				notifyDestroyed();
			}
		} else if (d == canvas) {
			if (c == backCmd) {
				display.setCurrent(list);
			} else if (c == setCmd) {
				boolean ret = Device.setSISImage(Device.SIS_NORMAL, 
						fname[currIndex], buf[currIndex]);
				Alert alert = new Alert("׸ ģ ");
				alert.setString(ret ? "" : "");
				display.setCurrent(alert);
			}			
		}
	}
}

class SISTestCanvas extends Canvas implements Runnable {
	private SISTest midlet;
	private Display display;
	
	private SISImage sisImage;
	private int imgLen;
	private int imgCount;
	
	SISTestCanvas(SISTest midlet) {
		this.midlet = midlet;
		this.display = Display.getDisplay(midlet);
	}
	
	public void setSIS(SISImage img) {
		sisImage = img;
		imgLen = sisImage.getMaxFrameID();
		imgCount = 0;
	}
	
	public void showNotify() {
		display.callSerially(this);
	}
	
	public void run() {
		if (++imgCount > imgLen) {
			imgCount = 0;
		}
		this.repaint();
		display.callSerially(this);
	}
	
	public void paint(Graphics g) {
		sisImage.paintFrame(g, imgCount, 0, 0);
	}		
}
