/******************************************************************************
	SoundTest.java
		 : Sound ׽Ʈ
		 : Play/Stop ޴ - Sound /
			   SupportFormat ޴ -   ϴ Sound  Ȯ
			   ALARM Beep ޴ - ALARM beep 
			   CONFIRMATION Beep ޴ - CONFIRMATION beep 
			   ERROR Beep ޴ - ERROR beep 
			   INFO Beep ޴ - INFO beep 
			   WARNING Beep ޴ - WARNING beep 
			   / Ű  
*******************************************************************************/

package skvm;

import com.skt.m.*;
import com.xce.util.*;
import java.io.*;
import javax.microedition.lcdui.*;
import javax.microedition.midlet.*;

public class SoundTest extends MIDlet implements CommandListener, Runnable, ItemStateListener {
	
	static final String STR_MMF = "mmf";
	static final String STR_EVRC = "evrc";
	static final String STR_MA2 = "ma2";
	static final String STR_BUZZER = "buzzer";
	static final String STR_MIDI = "midi";
	String[] soundList = {STR_MMF, STR_EVRC, STR_MA2+"FM", STR_MA2+"PCM", STR_BUZZER, STR_MIDI};
	
	Form form = new Form("Sound Test");
	Ticker ticker;
	Command playComm = new Command("Play/Stop", Command.SCREEN, 0);
	Command repeatComm = new Command("Repeat", Command.SCREEN, 2);
	Command resumeComm = new Command("Resume/Pause", Command.SCREEN, 2);
	Command formatComm = new Command("SupportFormat",Command.SCREEN, 3);
	Command beepComm = new Command("Beep Test", Command.SCREEN,  3);
	Command beepComm1 = new Command("ALARM Beep", Command.SCREEN, 4);
	Command beepComm2 = new Command("CONFIRMATION Beep", Command.SCREEN, 5);
	Command beepComm3 = new Command("ERROR Beep", Command.SCREEN, 6);
	Command beepComm4 = new Command("INFO Beep", Command.SCREEN, 7);
	Command beepComm5 = new Command("WARNING Beep", Command.SCREEN, 8);
	Command exitComm = new Command("Exit", Command.EXIT, 1);	
	
	Gauge gauge;
	ChoiceGroup cg;
	Thread thread;
	AudioClip clip;
	String soundType = STR_MMF;
	
	int selectedIndex = 0;
	boolean repeatFlag = false;	
	Display display;
	
	static final int STOP = 0;
	static final int PAUSE = 1;	
	static final int PLAY = 2;

	int state;
	
	SoundTest() {
		ticker = new Ticker("带 ÷ Ű");
		
		form.setTicker(ticker);
		form.addCommand(exitComm);
		form.addCommand(playComm);
		form.addCommand(resumeComm);
		form.addCommand(repeatComm);
		form.addCommand(formatComm);
		form.addCommand(beepComm);
		form.addCommand(beepComm1);
		form.addCommand(beepComm2);
		form.addCommand(beepComm3);
		form.addCommand(beepComm4);
		form.addCommand(beepComm5);
		form.setCommandListener(this);
		form.setItemStateListener(this);		
		
		cg = new ChoiceGroup(" Ÿ", ChoiceGroup.EXCLUSIVE, soundList, null);		
		form.append(cg);
		
		try {
			clip = AudioSystem.getAudioClip(soundType);
		} catch (Exception e) {
			clip = null;
		}
		
		try {
			//   gauge 
			// maxValue AudioSystem.getMaxVolume(String format)  ִ  ϰ,
			// initialValue AudioSystem.getVolume(String format)    
			gauge = new Gauge("Volume", true, 10, 0);
			form.append(gauge);
			gauge.setMaxValue(AudioSystem.getMaxVolume(soundType));
			gauge.setValue(AudioSystem.getVolume(soundType));			
		} catch (Exception e) { ticker.setString(" ʴ Դϴ"); }		
		
	}
		
	public void startApp() {		
		display = Display.getDisplay(this);
		display.setCurrent(form);
	}
	
	public void pauseApp() {
	}
	
	public void destroyApp(boolean unconditional) {
		
		state = STOP;
		if (clip != null) {
			try {
				clip.close();
			} catch (Exception e) {
			}
		}
		//clip = null;
	}
	
	public void itemStateChanged(Item item) {
		if (item == gauge) {
			try {
				// /  Ű gauge ϴ   ݿŴ
				AudioSystem.setVolume(soundType, gauge.getValue());
			} catch (Exception e) {
			}
		} else if (item == cg) {
			selectedIndex = cg.getSelectedIndex();
			switch (selectedIndex) {
				case 0:					
					soundType = STR_MMF;					
					break;
				case 1:
					soundType = STR_EVRC;
					break;
				case 2:
					soundType = STR_MA2;
					break;
				case 3:
					soundType = STR_MA2;
					break;
				case 4:
					soundType = STR_BUZZER;
					break;
				case 5:
					soundType = STR_MIDI;
					break;
			}
			
			try {
				clip = AudioSystem.getAudioClip(soundType);
			} catch (Exception e) {
				ticker.setString(" ʴ Դϴ");
				clip = null;
			}			
			
			try {
				gauge.setMaxValue(AudioSystem.getMaxVolume(soundType));
				gauge.setValue(AudioSystem.getVolume(soundType));
			} catch (Exception e) {
			}
		}
	}
	
	public void commandAction(Command c, Displayable d) {
		if (c == exitComm) {
			destroyApp(true);
			notifyDestroyed();
		} else if (c == playComm) {
			// Play/Stop Ű   带 / Ŵ
			if (clip == null) {
				return;
			}
			
			switch (state) {
				case STOP:
					state = PLAY;
					//     带 Ű thread 
					ticker.setString(" ");
					thread = new Thread(this);
					thread.start();					
					break;
				case PAUSE:
					state = PLAY;
					try {
						ticker.setString(" ÷̰ Resume Ǿϴ");
						clip.resume();
					} catch (Exception e) {
					}
					break;
				case PLAY:
					state = STOP;
					ticker.setString("带 ÷ Ű");
					try {
						clip.stop();
					} catch (Exception e) {
					}
					thread = null;
					break;
			}
		} else if (c == resumeComm) {
			if (clip == null) {
				return;
			}
			
			switch (state) {
				case PLAY:					
					if (thread != null) {
						state = PAUSE;
						ticker.setString(" ÷̰ Pause Ǿϴ");
						try {
							clip.pause();
						} catch (Exception e) {
						}				
					} else {
						ticker.setString(" ÷̸ Ű  Ŀ Pause ϼ");
					}				
					break;
				case PAUSE:
					ticker.setString(" ÷̰ Resume Ǿϴ");
					if (thread != null) {
						state = PLAY;
						try {
							clip.resume();
						} catch (Exception e) {}											
					} else {
						ticker.setString(" ÷̸ Ű  Ŀ Resume ϼ");
					}					
					break;
			}
		} else if (c == formatComm) {
			// SupportFormat ޴ ϴ  Ǵ   
			String[] list = AudioSystem.getClipFormats();
			String allformat = "";
			if( list.length == 0 ){
				allformat = "Ǵ  ϴ.";
			}
			else{
				for(int i=0; i<list.length; i++){
					allformat += list[i] + "\n";
				}
			}
		
		    Alert alert = new Alert("Sound Format List");
		    alert.setString(allformat);
		    alert.setTimeout(Alert.FOREVER);
		    display.setCurrent(alert);
		} else if (c== beepComm) {
			/*
			Alert alert = new Alert("Beep Test");
			alert.setString("Test Frequency :\n523 hertz\n587 hertz\n659 hertz\n698 hertz\n784 hertz\n880 hertz\n988 hertz");
			alert.setTimeout(4000);
			display.setCurrent(alert);
			*/
			Device.beep(523,500);
			try {
				Thread.sleep(500);
			} catch (Exception e) {
			}
			Device.beep(587,500);
			try {
				Thread.sleep(500);
			} catch (Exception e) {
			}		
			Device.beep(659,500);
			try {
				Thread.sleep(500);
			} catch (Exception e) {
			}
			
			Device.beep(698,500);
			try {
				Thread.sleep(500);
			} catch (Exception e) {
			}
			
			Device.beep(784,500);
			try {
				Thread.sleep(500);
			} catch (Exception e) {
			}
			
			Device.beep(880,500);
			try {
				Thread.sleep(500);
			} catch (Exception e) {
			}
			
			Device.beep(988,500);
			try {
				Thread.sleep(500);
			} catch (Exception e) {
			}
			
			Device.beep(1046,500);
			try {
				Thread.sleep(500);
			} catch (Exception e) {
			}
		} else if (c == beepComm1) {
			// ALARM Beep ޴ ý ALARM beep 
			AlertType.ALARM.playSound(display);
		} else if (c == beepComm2) {
			// CONFIRMATION Beep ޴ ý CONFIRMATION beep 
			AlertType.CONFIRMATION.playSound(display);
		} else if (c == beepComm3) {
			// ERROR Beep ޴ ý ERROR beep 
			AlertType.ERROR.playSound(display);
		} else if (c == beepComm4) {
			// INFO Beep ޴ ý INFO beep 
			AlertType.INFO.playSound(display);
		} else if (c == beepComm5) {
			// WARNING Beep ޴ ý WARNING beep 
			AlertType.WARNING.playSound(display);
		} else if (c == repeatComm){
			if( repeatFlag ){
				repeatFlag = false;
			} else {
				repeatFlag = true;
			}
			if( state != STOP ){
				state = STOP;
				ticker.setString("带 ÷ Ű");
				try {
					clip.stop();
				} catch (Exception e) {
				}
				thread = null;
			}
			commandAction(playComm, d);
		}
	}
			   
	public void run() {
		//   Ű    thread 
		// snd.mmf buffer о  ̸  mmf clip Ͽ 
		try {
			InputStream is = getClass().getResourceAsStream("/skvm/snd" + selectedIndex + "." + getExt(soundType));
			System.out.println("avail : " + is.available());
			byte[] buffer = new byte[is.available()];
			is.read(buffer);
			clip.open(buffer, 0, buffer.length);
			if( repeatFlag ){
				clip.loop();
			} else {
				clip.play();			
			}			
			ticker.setString("÷̰  ");
		} catch (Exception e) {			
			ticker.setString("÷  ߻߰ų ڰ ߴܽ׽ϴ.");
		} finally {
			try {
				clip.close();
			} catch (Exception e) {}
			thread = null;
		}
	}
	
	String getExt(String type) {
		if (type.equals(STR_MMF)) {
			return "mmf";
		} else if (type.equals(STR_EVRC)) {
			return "ssd";
		} else if (type.equals(STR_MA2)) {
			return "ma2";
		} else if (type.equals(STR_BUZZER)) {
			return "buz";
		} else if (type.equals(STR_MIDI) ){
			return "mid";
		}
		return null;
	}
}
