/*
 * @(#)GainChangeListener.java	1.13 98/03/28
 *
 * Copyright 1996-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 *
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package javax.media;

/**
 * <CODE>GainChangeListener</CODE> is an interface for handling
 * <code>GainChangeEvents</code> generated by 
 * <code>GainControls</code>.
 *
 * <h2>Java Beans support</h2>
 * It is required that any implementation of this object is
 * sub-classed either from java.util.EventListener, or
 * sunw.util.EventListener.
 *
 *
 * @see GainControl
 * @see GainChangeEvent
 * 
 * @version 1.13, 98/03/28.
*/
public interface GainChangeListener {

    /**
     * This method is called to deliver a <code>GainChangeEvent</code>
     * when the state of a <code>GainControl</code> changes.
     *
     * @param event The event generated.
     */
    void gainChange(GainChangeEvent event);
}
