#!/bin/ksh
# @(#)rmdoctimes.ksh	1.2	00/10/19
#
# Remove the "Generated by javadoc" timestamps from a javadoc HTML
# hierarchy, copying it in the process.  This is useful for comparing
# javadoc hierarchies, since the timestamp lines generate spurious
# differences.

export PATH=/usr/bin

function usage {
    print -r "usage: ${0##*/} fromdir todir" 1>&2
    exit 1
}

if [ $# -ne 2 ] ; then
    usage
fi

SRCDIR=$1
DESTDIR=$2

mkdir -p $DESTDIR

# Copy the source hierarchy to the destination hierarchy, running sed
# over each HTML file, creating directories as necessary and simply
# copying the non-HTML files.

(cd $SRCDIR ; find . -print) |
    sed -e 1d -e 's,^\./,,' |
	while read name ; do
	    if [ -d $SRCDIR/$name ] ; then
		mkdir -p $DESTDIR/$name
	    elif [[ "$name" = *.html ]] ; then
		sed '/^<!-- Generated by javadoc/d' \
		    < $SRCDIR/$name > $DESTDIR/$name
	    else
		cp $SRCDIR/$name $DESTDIR/$name
	    fi
	done
