/**
 *
 * @(#)CommandState.java	1.3 01/03/30
 *
 * Copyright 2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 */

package com.sun.midp;

/** Holds the state for MIDlet Suite management commands. */
class CommandState {
    /** status of the last command */
    int status;
    /** the initial command so we can loop (autotest) */
    int initialCommand;
    /** the next command to after the initial command, set by the processor */
    int nextCommand;
    /** overwrite the existing version of the MIDlet suite when installing */
    boolean forceOverwrite;
    /** location of the MIDlet suite to install */
    String suiteURL;
    /** the storage name given to a suite when installed */
    String suiteStorageName;
    /** remove the suite after running it */
    boolean runOnce;
    /** repeat the install-run-remove process until the suite is not found */
    boolean autotest;
    /** filename of local descriptor, for development systems */
    String descriptorName;
    /** what midlet to run in the suite */
    String midletName;
    /** class name of MIDlet, for development systems */
    String midletClassName;
    /** did we display the Java logo yet */
    boolean logoDisplayed;
}
