/*
 * @(#)CommandAccess.java	1.7 01/08/12
 * Copyright (c) 1999-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
/* This is an interface that allows Java code to get at the private    */
/* data fields of a Command.  It's only temporary, because (I believe) */
/* the access problems were fixed in a later version of the MIDP spec. */
package com.sun.midp.lcdui;

import javax.microedition.lcdui.Command;

/**
 * Special class to handle access to Command objects.
 */
public interface CommandAccess {
    /**
     * Get the label of the given Command.
     *
     * @param c The Command to retrieve the label of
     * @return String The label of the Command
     */
    String getLabel(Command c);
    /**
     * Get the type of the given Command.
     *
     * @param c The Command to retrieve the type of
     * @return int The type of the Command
     */
    int    getType(Command c);
    /**
     * Get the priority of the given Command.
     *
     * @param c The Command to retrieve the priority of
     * @return int The priority of the Command
     */
    int    getPriority(Command c);
}
