/*
 *  @(#)Events.java	1.3 01/08/21
 *
 *  Copyright (c) 2001 Sun Microsystems, Inc., 901 San Antonio Road,
 *  Palo Alto, CA 94303, U.S.A.  All Rights Reserved.
 *
 *  Sun Microsystems, Inc. has intellectual property rights relating
 *  to the technology embodied in this software.  In particular, and
 *  without limitation, these intellectual property rights may include
 *  one or more U.S. patents, foreign patents, or pending
 *  applications.  Sun, Sun Microsystems, the Sun logo, Java, KJava,
 *  and all Sun-based and Java-based marks are trademarks or
 *  registered trademarks of Sun Microsystems, Inc.  in the United
 *  States and other countries.
 *
 *  This software is distributed under licenses restricting its use,
 *  copying, distribution, and decompilation.  No part of this
 *  software may be reproduced in any form by any means without prior
 *  written authorization of Sun and its licensors, if any.
 *
 *  FEDERAL ACQUISITIONS:  Commercial Software -- Government Users
 *  Subject to Standard License Terms and Conditions
 */

package com.sun.midp.lcdui;

import java.io.IOException;

/**
 * This class establishes the connection to the event queue in the virtual
 * machime, and allows the Java code to read the event data from the queue.
 */
public class Events {

    /**
     * Open the connection to the native event queue.
     *
     * @throws IOException if an I/O error occurs.
     */
    public native void open() throws IOException;

    /**
     * Reads the next 4 bytes from the event queue, and return as 
     * an integer.
     *
     * @return     the next four bytes of the event queue,
     *             interpreted as an <code>int</code>.
     * @exception  IOException   if an I/O error occurs.
     */
    public native int readInt() throws IOException;

    /**
     * Reads from the event queue a String object.
     *
     * @return     a string
     * @exception  IOException   if an I/O error occurs.
     */
    public native String readUTF() throws IOException;
}
