/**
 *
 * @(#)InstallState.java	1.2 01/08/16
 *
 * Copyright 2001 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 */

package com.sun.midp.midletsuite;

/**
 * Holds the state of an installation, so it can restarted after it has
 * been stopped.
 */
public interface InstallState {
    /**
     * Get the last recoverable exception that stopped the install.
     * Non-recoverable exceptions are thrown and not saved in the state.
     *
     * @return last exception that stopped the install
     */
    public InvalidJadException getLastException();

    /**
     * Get the unique name that the installed suite was stored with.
     *
     * @return storage name that can be used to load the suite
     */
    public String getStorageName();

    /**
     * Set the username to be used for HTTP authentication.
     *
     * @param username 8 bit username, cannot contain a ":"
     */
    public void setUsername(String username);

    /**
     * Set the password to be used for HTTP authentication.
     *
     * @param password 8 bit password
     */
    public void setPassword(String password);
}
