/*
 *  @(#)Actions.java	1.5 01/08/08
 * 
 *  Copyright (c) 2001 Sun Microsystems, Inc., 901 San Antonio Road,
 *  Palo Alto, CA 94303, U.S.A.  All Rights Reserved.
 *
 *  Sun Microsystems, Inc. has intellectual property rights relating
 *  to the technology embodied in this software.  In particular, and
 *  without limitation, these intellectual property rights may include
 *  one or more U.S. patents, foreign patents, or pending
 *  applications.  Sun, Sun Microsystems, the Sun logo, Java, KJava,
 *  and all Sun-based and Java-based marks are trademarks or
 *  registered trademarks of Sun Microsystems, Inc.  in the United
 *  States and other countries.
 *
 *  This software is distributed under licenses restricting its use,
 *  copying, distribution, and decompilation.  No part of this
 *  software may be reproduced in any form by any means without prior
 *  written authorization of Sun and its licensors, if any.
 *
 *  FEDERAL ACQUISITIONS:  Commercial Software -- Government Users
 *  Subject to Standard License Terms and Conditions
 */
package com.sun.midp.security;

/**
 * This class is a standard list of action groups that go
 * beyond what an "untrusted" suite can do and is used by all internal security
 * features. This class also builds a list of action groups for each
 * security domain. This only class that would need to be updated in order to
 * add a new security domain.
 * <p>
 * From MExE specification GSM 03.57-700 section 8.2.
 */
public final class Actions {

    /** Number of actions. */
    public static final int NUMBER_OF_ACTIONS = 11;

    /** User private data access actions. */
    public static final int USER_PRIVATE_DATA_ACCESS = 1;

    /** Network access actions. */
    public static final int NETWORK_ACCESS = 2;

    /** Lifecycle management actions. */
    public static final int LIFECYCLE_MANAGEMENT = 3;

    /** Miscellaneous function actions. */
    public static final int MISCELLANEOUS_FUNCTION = 4;

    /** Certificate management actions. */
    public static final int CERTIFICATE_MANAGEMENT = 5;

    /** Audio access actions. */
    public static final int AUDIO_ACCESS = 6;

    /** Power management actions. */
    public static final int POWER_MANAGEMENT = 7;

    /** Network selection/operator data access actions. */
    public static final int OPERATOR_DATA_ACCESS = 8;

    /** 
     * Device core function access actions.
     * For MIDP this group is for internal system API actions.
     */
    public static final int DEVICE_CORE_FUNCTION = 9;

    /** User profile management actions. */
    public static final int USER_PROFILE_MANAGEMENT = 10;

    /** User preference management actions. */
    public static final int USER_PREFERENCE_MANAGEMENT = 11;

    /** List of actions for the "untrusted" domain. */
    private static final int[] untrustedActions = {};

    /**
     * Create a list of action groups a domain is permitted to perform.
     *
     * @param name name of domain
     * @return a int array containing the action group ID's
     */
    static int[] forDomain(String name) {
        return untrustedActions;
    }
}
