/*
 * @(#)PassNumericPolicy.java	1.16 01/08/21 
 * Copyright (c) 1999-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */


package javax.microedition.lcdui;

/**
 * A special policy class to handle password numerics
 */
class PassNumericPolicy extends PassTextPolicy {

    /**
     * Construct a new PassNumericPolicy
     *
     * @param f The Font to use for this policy
     */
    PassNumericPolicy(Font f) {
        super(f, '0');
    }

    /**
     * Validate the content of this policy
     *
     * @param buffer The buffer containing this policy's data
     * @param offset The start offset of the data buffer
     * @param length The length of this policy's data in the buffer
     * @return boolean A boolean result of the validity of this policy's data
     */
    boolean validateContent(char[] buffer, int offset, int length) {
        for (int i = offset; i < (offset + length); i++) {
            char c = buffer[i];
            if (((c < '0') || (c > '9')) && (c != '-'  || i != 0)) {
                return false;
            }
        }
        return true;
    }	
}
