/*
 * @(#)commandState.h	1.8 01/08/30
 * Copyright (c) 1999,2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
#ifndef _COMMAND_STATE_H
#define _COMMAND_STATE_H

/* MUST MATCH the values in Command.java */
#define MAIN_EXIT (2001)

typedef enum {
    EXIT        = 1,                                                /* exit */
    MANAGE      = 2,                      /* Manage MIDlet suites Graphicly */
    INSTALL     = 3,                             /* Install an MIDlet suite */
    INSTALL_RUN = 4,                      /* Install and run a MIDlet suite */
    RUN         = 5,                                    /* Run MIDlet suite */
    REMOVE      = 6,                                 /* Remove MIDlet suite */
    LIST        = 7,                        /* List installed MIDlet suites */
    RUN_CLASS   = 8,                       /* run midlet from the classpath */
    STORAGE_NAMES = 9,         /* Only list the storage names of the suites */
} jam_state;

typedef struct _COMMAND_STATE {
    int status;
    int initialCommand;
    int nextCommand;
    int /*boolean*/ forceOverwrite;
    char* suiteURL;
    char* suiteStorageName;
    int /*boolean*/ runOnce;
    int /*boolean*/ autotest;
    char* descriptorName;
    char* midletName;
    char* midletClassName;
    int /*boolean*/ logoDisplayed;
} COMMAND_STATE;

extern COMMAND_STATE MidpCommandState;

#endif /* _COMMAND_STATE_H */
