/*
 * @(#)crc32.c	1.3 01/07/16
 * Copyright (c)1998-2001 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

#include <crc32.h>

unsigned long
CRC32_init(unsigned char *data, int length){
    return (CRC32_update(data, length, 0xFFFFFFFF));
}

unsigned long
CRC32_update(unsigned char *data, int length, unsigned long iv) { 
    unsigned long crc = iv;
    unsigned int j;
    for ( ; length > 0; length--, data++) { 
        crc ^= *data;
        for (j = 8; j > 0; --j) { 
            crc = (crc & 1) ? ((crc >> 1) ^ 0xedb88320) : (crc >> 1);
        }
    }
    return crc;
}

unsigned long
CRC32_finalize(unsigned long crc) {
    return ~crc;
}
