/*
 * @(#)conv.h	1.12 01/08/21
 * Copyright (c) 1999-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

#ifndef _CONV_H_INCLUDED
#define _CONV_H_INCLUDED

#include <defaultLCDUI.h>

typedef struct _LcConvMethodsRec {
    char *encoding;
    int (*byteMaxLen)(void);
    int (*byteLen)(const unsigned char *b, int len);
    int (*unicodeToNative)(const unicode *ustr, int ulen, 
                           unsigned char *bstr, int blen);
    int (*nativeToUnicode)(const unsigned char *bstr, int blen,
                           unicode *ustr, int ulen);
    int (*sizeOfByteInUnicode)(const unsigned char *str, int offset, int len);
    int (*sizeOfUnicodeInByte)(const unicode *str, int offset, int len);
} LcConvMethodsRec, *LcConvMethods;

extern LcConvMethods getLcConvMethods(char *encoding);

#endif
