/*
 * @(#)localeMethod.h	1.8 01/05/02 @(#)
 * Copyright (c) 1999-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

#ifndef _LOCALEMETHOD_H_INCLUDED
#define _LOCALEMETHOD_H_INCLUDED

/*
 * Initialize the locale system.
 */
extern void initLocaleMethod();

/*
 * Finalize the locale system.
 */
extern void finalizeLocaleMethod();

/*
 * Get the locale encoding name.
 */
extern char *getLocaleEncoding();

/*
 * Get the locale name.
 */
extern char *getLocaleName();

/*
 * Convert the Unicode string into the current locale native string.
 */
extern int unicodeToNative(const unicode *ustr, int ulen, 
                           unsigned char *bstr, int blen);

/*
 * Convert the current locale native string into the Unicode string.
 */
extern int nativeToUnicode(const unsigned char *bstr, int blen, 
                           unicode *ustr, int ulen);

#endif /* _LOCALEMETHOD_H_INCLUDED */
