/*
 * @(#)kvmUtil.c	1.41 01/04/02
 * Copyright (c) 1999,2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

#include <global.h>

#include "kvmUtil.h"


/*
 * Do a strdup using jam_malloc instead of malloc
 */
char * jam_strdup(const char * str){
    int len = strlen(str);
    char * p = (char*)jam_malloc(len + 1);
    if(p){
	strncpy(p, str, len);
	p[len] = '\0';
    }
    return p; /* null if p could not be allocated */
}

void raiseExceptionWithString(char* pszClassName, char* pszMessage) {
    STRING_INSTANCE pStringInstance = NULL;

    pStringInstance = instantiateString(pszMessage, strlen(pszMessage));
    if (NULL == pStringInstance) {
	/* Roll back to KVM 1.0 exception without message */
       raiseException(pszClassName);
       return;
    }

    raiseExceptionMsg(pszClassName, pStringInstance);
}

BYTEARRAY allocByteArray(int length) {
    /* instantiateArray automatically throws an out of memory error */
    return (BYTEARRAY)instantiateArray(PrimitiveArrayClasses[T_BYTE], length);
}

