/*
 * @(#)perfmon.c	1.2 01/07/18
 * Copyright (c) 2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 */

#include <global.h>  
#include <profiling.h>

/** 
 * The system performance measurement count type's 
 */
#define INSTRUCTION_COUNTER        0
#define THREAD_SWITCH_COUNTER      1
#define DYNAMIC_OBJECT_COUNTER     2
#define DYNAMIC_ALLOC_COUNTER      3
#define DYNAMIC_DEALLOC_COUNTER    4
#define GARBAGE_COLLECTION_COUNTER 5
#define TOTAL_GC_DEFERRALS         6
#define MAX_GC_DEFERRALS           7
#define GARBAGE_COLLECTION_RESCANS 8

/**
 * @name:        Java_com_sun_midp_perfmon_PerfMon_sysGetCounter
 *
 * @description: Generic method that takes one parameter that idenifies 
 *               the particula rsystem performance measurement to return.
 *
 * @param:       count  - system performance measurement count type
 *
 * @return:      the appropriate performance measurement counter.
 */
void Java_com_sun_midp_perfmon_PerfMon_sysGetCounter() {

    int count = popStack();

    switch (count) 
    {
    case INSTRUCTION_COUNTER:        
        pushStack((int)InstructionCounter); 
        break;
    case THREAD_SWITCH_COUNTER:
        pushStack((int)ThreadSwitchCounter);
        break;
    case DYNAMIC_OBJECT_COUNTER:
        pushStack((int)DynamicObjectCounter);
        break;
    case DYNAMIC_ALLOC_COUNTER:
        pushStack((int)DynamicAllocationCounter);
        break;
    case DYNAMIC_DEALLOC_COUNTER:
        pushStack((int)DynamicDeallocationCounter);
        break;
    case GARBAGE_COLLECTION_COUNTER:
        pushStack((int)GarbageCollectionCounter);
        break;
    case TOTAL_GC_DEFERRALS:
        pushStack((int)TotalGCDeferrals);
        break;
    case MAX_GC_DEFERRALS:
        pushStack((int)MaximumGCDeferrals);
        break;
    case GARBAGE_COLLECTION_RESCANS:
        pushStack((int)GarbageCollectionRescans);
        break;
    default :
        pushStack((int)0);
        break;
    }

}


