/*
 * @(#)property.c	1.23 01/08/21 
 *
 * Copyright (c) 1998-2001 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 */

/*=========================================================================
 * MIDP Reference implementation
 *=========================================================================
 * SYSTEM:    MIDP RI
 * SUBSYSTEM: System dependent property lookup
 * FILE:      property.c
 * OVERVIEW:  Return MID Profile specific properties
 * AUTHOR:    Roger Riggs
 *=======================================================================*/

/*=========================================================================
 * Include files
 *=======================================================================*/

#include <global.h>
#include "configuration.h"

/*=========================================================================
 * FUNCTION:      getSystemProperty()
 * TYPE:          public operation
 * OVERVIEW:      Return a value of a property key
 * INTERFACE:
 *   parameters:  char *key
 *   returns:     char *result
 *=======================================================================*/

char *getSystemProperty(char *key) {
    /*
     * System properties are now found in the configuration files.
     * The $MIDP_HOME/lib/appl.config file contains the application visible
     * parameters an $MIDP_HOME/lib/impl.config contains the properties
     * supporting the reference implementation itself.
     */
    return getSystemProp(key) ;
}

