/*
 * @(#)nativeGUI.h	1.15 01/07/23
 * Copyright (c)1999-2001 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#ifndef NATIVEGUI_H_INCLUDED
#define NATIVEGUI_H_INCLUDED

#include <X11/Xlib.h>

/*
 * Defines screen size
 */
#define DISPLAY_WIDTH           96
#define DISPLAY_HEIGHT          128

/*
 * This (x,y) coordinate pair refers to the offset of the upper 
 * left corner of the display screen within the MIDP phone handset
 * graphic window 
 */
#define X_SCREEN_OFFSET 50
#define Y_SCREEN_OFFSET 70

/* The max number of characters in a command menu item */
#define MAX_COMMAND_LENGTH 127

extern Display     *display;
extern Screen      *screen;
extern GC           gc;
extern GC           gcErase;
extern Drawable     paintDrawable;
extern bool_t       doubleBuffer;
extern int          visualDepth;
extern int          numColors;

/* a greenish pixel that looks kind of like a typical LCD screen */
extern XColor       lightPixel;
extern Window       paintWindow;
extern XColor       grayTable[16];
extern XColor       rgbTable[256];

extern Window       outerWindow;
extern Colormap     colormap;

extern XFontStruct *fonts[];

/*  Atoms used for fetching underline parameters */
extern Atom          underlinePositionAtom;
extern Atom          underlineThicknessAtom;
extern Atom          rawPositionAtom;
extern Atom          rawThicknessAtom;

extern XFontStruct *findFontStruct(Font font);
extern Drawable setupGC(GC gc, int pixel, short *clip, void* dst, int dotted);
extern void refreshPaintWindow(int x1, int y1, int x2, int y2);


#ifdef SLOW_DRAWING
extern drawingInterval;

#ifndef SLEEP
  #define SLEEP(x) usleep(x)
#endif

#endif


#endif
