/*
 * @(#)nativeGUI.h	1.15 01/07/23
 * Copyright (c)1999-2001 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#ifndef NATIVEGUI_H_INCLUDED
#define NATIVEGUI_H_INCLUDED

#include <defaultLCDUI.h>
#include <windows.h>
#include <ctype.h>

/*
 * Defines screen size
 */
#define DISPLAY_WIDTH    96
#define DISPLAY_HEIGHT   128

/*
 * This (x,y) coordinate pair refers to the offset of the upper 
 * left corner of the display screen within the MIDP phone handset
 * graphic window 
 */
#define X_SCREEN_OFFSET 50
#define Y_SCREEN_OFFSET 70

/* The max number of characters in a command menu item */
#define MAX_COMMAND_LENGTH 127

#define GRAPHICS_SETUP(filled)                                            \
    HDC hdc;                                                              \
    HPEN hPen     = NULL;                                                 \
    HBRUSH hBrush = NULL;                                                 \
                                                                          \
    hdc = getBitmapDC(dst);                                               \
    setupClip(hdc, dst, clip);                                            \
    if (filled) {                                                         \
        hBrush = setBrush(hdc, pixel);                                    \
        hPen   = setPen(hdc, pixel, 0);                                   \
    } else {                                                              \
        hPen   = setPen(hdc, pixel, dotted);                              \
        SelectObject(hdc, GetStockObject(HOLLOW_BRUSH));                  \
    }

#define GRAPHICS_CLEANUP()                                        \
    if (hPen != NULL) DeleteObject(SelectObject(hdc, hPen));      \
    if (hBrush != NULL) DeleteObject(SelectObject(hdc, hBrush));  \
    releaseBitmapDC(hdc);


extern HWND          hMainWindow;
extern HBRUSH        BACKGROUND_BRUSH;
extern HPEN          BACKGROUND_PEN;
extern int           numColors;
extern bool_t        doubleBuffer;
extern int           backgroundColor;

extern HBRUSH setBrush(HDC hdc, int pixel);
extern HPEN setPen(HDC hdc, int pixel, int dotted);
extern HDC getBitmapDC(void *imageData);
extern void releaseBitmapDC(HDC hdcMem);

extern void setupFont(HDC hdc, FONTPARAMS_PROTO);
extern void setupClip(HDC hdc, void *imageData, short *clip);
extern void refreshWholePaintWindow();

extern void DrawBitmap(HDC hdc, HBITMAP hBitmap, int x, int y, int rop);
extern void refreshPaintWindow(int x1, int y1, int x2, int y2);
extern void setupClip(HDC hdc, void *imageData, short *clip);

#ifdef SLOW_DRAWING
extern drawingInterval;

#ifndef SLEEP
  #define SLEEP(x) Sleep(x/1000)
#endif

#endif



#endif
