# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)builddlls.mk	1.8 99/11/15
#
# makefile for building shared libraries.

##############################
# The javai shared library
##############################

LIBJAVAI = $(DLLBIN)/$(DLLPREFIX)javai$G.$(DLLPOSTFIX)

PJAVADLLS += $(LIBJAVAI)

LIBJAVIOBJS = JAVAIclassstubs.o $(JAVAISHAREOBJECTS) $(JAVAIPLATFORMOBJECTS)

LIBJAVAIOFILES = \
	$(sort $(patsubst %.o,$(OBJ)/%.o,$(LIBJAVIOBJS)))

ifdef LIBJAVAIIMPORT
$(LIBJAVAIIMPORT) : $(LIBJAVAI)
endif

$(LIBJAVAI):: $(DLLBIN)
$(LIBJAVAI):: $(LIBJAVAIOFILES)
	@echo ... $@
	@$(LINKDLL) $(LINKOUT)$@ $^ $(LINKDLLFLAGS) $(JAVAILINKLIBS) \
		$(JAVAIEXPORTS)


##############################
# The awt shared library
##############################

ifeq ($(USETRUFFLE), true)
LIBAWT = $(DLLBIN)/$(DLLPREFIX)pswsgs$G.$(DLLPOSTFIX)
else
LIBAWT = $(DLLBIN)/$(DLLPREFIX)awt$G.$(DLLPOSTFIX)
endif

PJAVADLLS += $(LIBAWT)

LIBAWTOBJS = AWTclassstubs.o $(AWTSHAREOBJECTS) $(AWTPLATFORMOBJECTS)

LIBAWTOFILES = \
	$(sort $(patsubst %.o,$(OBJ)/%.o,$(patsubst %.res,$(OBJ)/%.res,$(LIBAWTOBJS))))


$(LIBAWT):: $(DLLBIN)
$(LIBAWT):: $(LIBAWTOFILES) $(LIBJAVAIIMPORT)
	@echo ... $@
	@$(LINKDLL) $(LINKOUT)$@ $^ $(LINKDLLFLAGS) $(AWTLINKLIBS) \
		$(AWTEXPORTS)


##############################
# The net shared library
##############################

LIBNET = $(DLLBIN)/$(DLLPREFIX)net$G.$(DLLPOSTFIX)

PJAVADLLS += $(LIBNET)

LIBNETOBJS = NETclassstubs.o $(NETSHAREOBJECTS) $(NETPLATFORMOBJECTS)

LIBNETOFILES = \
	$(sort $(patsubst %.o,$(OBJ)/%.o,$(LIBNETOBJS)))


$(LIBNET):: $(DLLBIN)
$(LIBNET):: $(LIBNETOFILES) $(LIBJAVAIIMPORT)
	@echo ... $@
	@$(LINKDLL) $(LINKOUT)$@ $^ $(LINKDLLFLAGS) $(NETLINKLIBS) 


##############################
# The math shared library
##############################

ifeq ($(INCLUDEMATH), true)

LIBMATH = $(DLLBIN)/$(DLLPREFIX)math$G.$(DLLPOSTFIX)

PJAVADLLS += $(LIBMATH)

LIBMATHOBJS = MATHclassstubs.o $(MATHSHAREOBJECTS)

LIBMATHOFILES = \
	$(sort $(patsubst %.o,$(OBJ)/%.o,$(LIBMATHOBJS)))


$(LIBMATH):: $(DLLBIN)
$(LIBMATH):: $(LIBMATHOFILES) $(LIBJAVAIIMPORT)
	@echo ... $@
	@$(LINKDLL) $(LINKOUT)$@ $^ $(LINKDLLFLAGS)

endif


##############################
# The file shared library
##############################

LIBJAVAFILE = $(DLLBIN)/$(DLLPREFIX)javafile$G.$(DLLPOSTFIX)

PJAVADLLS += $(LIBJAVAFILE)

LIBJAVAFILEOBJS = JAVAFILEclassstubs.o $(JAVAFILESHAREOBJECTS)

LIBJAVAFILEOFILES = \
	$(sort $(patsubst %.o,$(OBJ)/%.o,$(LIBJAVAFILEOBJS)))


$(LIBJAVAFILE):: $(DLLBIN)
$(LIBJAVAFILE):: $(LIBJAVAFILEOFILES) $(LIBJAVAIIMPORT)
	@echo ... $@
	@$(LINKDLL) $(LINKOUT)$@ $^ $(LINKDLLFLAGS)


##############################
# The zip shared library
##############################

LIBZIP = $(DLLBIN)/$(DLLPREFIX)zip$G.$(DLLPOSTFIX)

PJAVADLLS += $(LIBZIP)

LIBZIPOBJS = ZIPclassstubs.o $(ZIPSHAREOBJECTS)

LIBZIPOFILES = \
	$(sort $(patsubst %.o,$(OBJ)/%.o,$(LIBZIPOBJS)))


$(LIBZIP):: $(DLLBIN)
$(LIBZIP):: $(LIBZIPOFILES) $(LIBJAVAIIMPORT)
	@echo ... $@
	@$(LINKDLL) $(LINKOUT)$@ $^ $(LINKDLLFLAGS)


##############################
# The agent shared library
##############################

ifeq ($(DEBUGAGENT), true)

LIBAGENT = $(DLLBIN)/$(DLLPREFIX)agent$G.$(DLLPOSTFIX)

PJAVADLLS += $(LIBAGENT)

LIBAGENTOBJS = $(AGENTSHAREOBJECTS)

LIBAGENTOFILES = \
	$(sort $(patsubst %.o,$(OBJ)/%.o,$(LIBAGENTOBJS)))


$(LIBAGENT):: $(DLLBIN)
$(LIBAGENT):: $(LIBAGENTOFILES) $(LIBJAVAIIMPORT)
	@echo ... $@
	@$(LINKDLL) $(LINKOUT)$@ $^ $(LINKDLLFLAGS)

endif

##############################
# The hprof shared library
##############################

ifeq ($(HPROF), true)

LIBHPROF = $(DLLBIN)/$(DLLPREFIX)hprof$G.$(DLLPOSTFIX)

PJAVADLLS += $(LIBHPROF)

LIBHPROFOBJS = $(HPROFSHAREOBJECTS) $(HPROFPLATFORMOBJECTS)

LIBHPROFOFILES = \
	$(sort $(patsubst %.o,$(OBJ)/%.o,$(LIBHPROFOBJS)))


$(LIBHPROF):: $(DLLBIN)
$(LIBHPROF):: $(LIBHPROFOFILES) $(LIBJAVAIIMPORT)
	@echo ... $@
	@$(LINKDLL) $(LINKOUT)$@ $^ $(LINKDLLFLAGS) $(HPROFLINKLIBS) \
		$(HPROFEXPORTS)

endif
