# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)buildjavadoc.mk	1.4 99/03/18
#
# Runs javadoc to produce the html documentation for all classes.
#
JAVADIRS=$(patsubst classes/%,%,$(shell find $(CLASSESDIR)/java/* -type d -print))
JAVAPKGS=$(subst /,.,$(JAVADIRS))
JAVADOC_DIR=$(TOP)/build/docs

JAVASRCDIRS=\
    $(TOP)/src/share/java \
    $(TOP)/src/share/sun  \
    $(TOP)/src/share/com

ifeq ($(USETRUFFLE), true)
SUNPKGS=\
    sun.porting.utils \
    sun.porting.graphicssystem \
    sun.porting.windowsystem \
    sun.porting.toolkit \
    sun.awt \
    sun.awt.aw \
    sun.awt.im \
    sun.awt.image \
    sun.awt.otk

JAVASRCDIRS += \
    $(TOP)/src/share/classes \
    $(TOP)/src/reference/classes
endif

# Convert list of directories above to colon-separated path
empty:=
space:= $(empty) $(empty)
JAVASRCPATH=$(subst $(space),:,$(strip $(JAVASRCDIRS)))

JAVADOC_IMAGES= \
    GridBagEx.gif \
    OpenBookIcon.gif \
    blue-ball-small.gif \
    blue-ball.gif \
    class-index.gif \
    constructor-index.gif \
    constructors.gif \
    cyan-ball-small.gif \
    cyan-ball.gif \
    error-index.gif \
    exception-index.gif \
    green-ball-small.gif \
    green-ball.gif \
    interface-index.gif \
    magenta-ball-small.gif \
    magenta-ball.gif \
    method-index.gif \
    methods.gif \
    package-index.gif \
    red-ball-small.gif \
    red-ball.gif \
    variables.gif \
    yellow-ball-small.gif \
    yellow-ball.gif

SOURCEPATH=$(CLASSESDIR):$(JAVASRCPATH)

javadoc: javadoc_images
	$(JAVADOC) -d $(JAVADOC_DIR) -sourcepath $(SOURCEPATH) $(JAVAPKGS) $(SUNPKGS)

javadoc_images: $(JAVADOC_DIR)/images $(addprefix $(JAVADOC_DIR)/,$(JAVADOC_IMAGES))

$(JAVADOC_DIR)/images:
	[ -d $(JAVADOC_DIR) ] || mkdir -p $(JAVADOC_DIR)/images

$(addprefix $(JAVADOC_DIR)/,$(JAVADOC_IMAGES)): $(TOP)/src/share/javadoc_images/$(@F)
	rm -f $@
	cp $(TOP)/src/share/javadoc_images/$(@F) $@
