# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)install.mk	1.7 98/10/28
#
# Makefile for building the pjee directory and self extracting archive

include install_$(PLATFORM).mk

####################
# Exported variables
####################

# set this on the make command line if you don't like the default
INSTALLDIR	= $(TOP)/install


################
# pjee target
################

DOCINSTALL=\
	COPYRIGHT \
	CHANGES \
	LICENSE \
	README

# set PJEEDIRNAME to something like:
#   pjee3.0alpha-x-bin-win-ja-Oct_26

PJEEDIRNAME	:= $(PRODUCT)
ifeq ($(ROMIZE), true)
PJEEDIRNAME	:= $(PJEEDIRNAME)_rom
endif
PJEEDIRNAME	:= $(PJEEDIRNAME)$(VERSION)$(STATUS)-$(BUILD)-bin-$(PLATFORMNAME)
ifneq ($(BUILDLOCALE), en_US)
PJEEDIRNAME	:= $(PJEEDIRNAME)-$(BUILDLOCALE)
endif
PJEEDIRNAME	:= $(PJEEDIRNAME)-$(shell date +%h_%d)

PJEEDIR=$(INSTALLDIR)/$(PJEEDIRNAME)

pjee: all pjee_only

# the pjee_only rule is in install.<platform>.mk


################
# release target
################

release: pjee release_only

# the release_only rule is in install.<platform>.mk
