# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)javai.mk	1.28 99/09/07
#
# makefile for the shared part of javai. As a shared library, it contains
# everything that isn't already in another shared library.

include  javai_$(PLATFORM).mk

####################
# exported variables
####################

CLASSES		+= $(JAVAISHARECLASSES) $(JAVAIPLATFORMCLASSES)
HEADERCLASSES	+= $(JAVAIHEADERCLASSES)
JNIHEADERCLASSES+= $(JAVAIJNIHEADERCLASSES)

ifeq ($(STATICLIBRARIES), true)
SHAREOBJECTS	+= $(JAVAISHAREOBJECTS)
PLATFORMOBJECTS	+= $(JAVAIPLATFORMOBJECTS)
CLASSSTUBFILES	+= classstubs.c
STUBCLASSES	+= $(JAVAISTUBCLASSES)
else
CLASSSTUBFILES	+= JAVAIclassstubs.c
PJAVADLLS	+= $(LIBJAVAI)
JAVAISHAREOBJECTS	+= $(SHAREOBJECTS)
ifeq ($(ROMIZE), true)
JAVAISHAREOBJECTS	+= $(ROMJAVA)
endif
JAVAIPLATFORMOBJECTS	+= $(PLATFORMOBJECTS)
endif

#################
# classes
#################

JAVAIJNIHEADERCLASSES += \
	java.lang.SecurityManager \
	java.lang.Thread

JAVAIHEADERCLASSES += \
	$(JAVAISTUBCLASSES) \
	java.lang.Thread

JAVAISTUBCLASSES += \
	java.lang.Class \
	java.lang.Boolean \
	java.lang.Byte \
	java.lang.Short \
	java.lang.Character \
	java.lang.ClassLoader \
	java.lang.Compiler \
	java.lang.Float \
	java.lang.Double \
	java.lang.Integer \
	java.lang.Long \
	java.lang.Math \
	java.lang.Number \
	java.lang.NoClassDefFoundError \
	java.lang.Object \
	java.lang.OutOfMemoryError \
	java.lang.Process \
	java.lang.Runtime \
	java.lang.StackOverflowError \
	java.lang.String \
	java.lang.System \
	java.lang.ThreadGroup \
	java.lang.Throwable \
	java.lang.reflect.Array \
	java.lang.reflect.Constructor \
	java.lang.reflect.Field \
	java.lang.reflect.Method \
	java.lang.reflect.InvocationTargetException \
	java.io.FileDescriptor \
	java.io.InputStream \
	java.io.ObjectInputStream \
	java.io.ObjectOutputStream \
	java.io.ObjectStreamClass \
	java.util.ResourceBundle \
	sun.io.ByteToCharConverter \
	sun.io.CharToByteConverter \
	sun.misc.VM

JAVAISHARECLASSES = \
	java.lang.Class \
	java.lang.AbstractMethodError \
	java.lang.ArithmeticException \
	java.lang.ArrayIndexOutOfBoundsException \
	java.lang.ArrayStoreException \
	java.lang.Boolean \
	java.lang.Byte \
	java.lang.Character \
	java.lang.ClassCastException \
	java.lang.ClassCircularityError \
	java.lang.ClassFormatError \
	java.lang.ClassLoader \
	java.lang.ClassNotFoundException \
	java.lang.CloneNotSupportedException \
	java.lang.Cloneable \
	java.lang.Compiler \
	java.lang.Double \
	java.lang.Error \
	java.lang.Exception \
	java.lang.ExceptionInInitializerError \
	java.lang.Float \
	java.lang.FloatingDecimal \
	java.lang.IllegalAccessError \
	java.lang.IllegalAccessException \
	java.lang.IllegalArgumentException \
	java.lang.IllegalMonitorStateException \
	java.lang.IllegalStateException \
	java.lang.IllegalThreadStateException \
	java.lang.IncompatibleClassChangeError \
	java.lang.IndexOutOfBoundsException \
	java.lang.InstantiationError \
	java.lang.InstantiationException \
	java.lang.Integer \
	java.lang.InternalError \
	java.lang.InterruptedException \
	java.lang.LinkageError \
	java.lang.Long \
	java.lang.Math \
	java.lang.NegativeArraySizeException \
	java.lang.NoClassDefFoundError \
	java.lang.NoSuchFieldError \
	java.lang.NoSuchFieldException \
	java.lang.NoSuchMethodError \
	java.lang.NoSuchMethodException \
	java.lang.NullPointerException \
	java.lang.Number \
	java.lang.NumberFormatException \
	java.lang.Object \
	java.lang.OutOfMemoryError \
	java.lang.Process \
	java.lang.Runnable \
	java.lang.Runtime \
	java.lang.RuntimeException \
	java.lang.SecurityException \
	java.lang.SecurityManager \
	java.lang.Short \
	java.lang.StackOverflowError \
	java.lang.String \
	java.lang.StringBuffer \
	java.lang.StringIndexOutOfBoundsException \
	java.lang.System \
	java.lang.Thread \
	java.lang.ThreadDeath \
	java.lang.ThreadGroup \
	java.lang.Throwable \
	java.lang.UnknownError \
	java.lang.UnsatisfiedLinkError \
	java.lang.UnsupportedOperationException \
	java.lang.VerifyError \
	java.lang.VirtualMachineError \
	java.lang.Void \
	\
	java.lang.reflect.Array \
	java.lang.reflect.Constructor \
	java.lang.reflect.Field \
	java.lang.reflect.InvocationTargetException \
	java.lang.reflect.Member \
	java.lang.reflect.Method \
	java.lang.reflect.Modifier \
	\
	java.text.BreakIterator \
	java.text.CharacterBreakData \
	java.text.CharacterIterator \
	java.text.ChoiceFormat \
	java.text.CollationElementIterator \
	java.text.CollationKey \
	java.text.CollationRules \
	java.text.Collator \
	java.text.CompactByteArray \
	java.text.CompactIntArray \
	java.text.CompactShortArray \
	java.text.DateFormat \
	java.text.DateFormatSymbols \
	java.text.DecimalFormat \
	java.text.DecimalFormatSymbols \
	java.text.DecompositionIterator \
	java.text.DigitList \
	java.text.EntryPair \
	java.text.FieldPosition \
	java.text.Format \
	java.text.LineBreakData \
	java.text.MergeCollation \
	java.text.MessageFormat \
	java.text.NumberFormat \
	java.text.ParseException \
	java.text.ParsePosition \
	java.text.PatternEntry \
	java.text.RuleBasedCollator \
	java.text.SentenceBreakData \
	java.text.SimpleDateFormat \
	java.text.SimpleTextBoundary \
	java.text.SpecialMapping \
	java.text.StringCharacterIterator \
	java.text.TextBoundaryData \
	java.text.UnicodeClassMapping \
	java.text.Utility \
	java.text.WordBreakData \
	java.text.WordBreakTable \
	\
	java.util.BitSet \
	java.util.Calendar \
	java.util.Date \
	java.util.Dictionary \
	java.util.EmptyStackException \
	java.util.Enumeration \
	java.util.EventListener \
	java.util.EventObject \
	java.util.GregorianCalendar \
	java.util.Hashtable \
	java.util.ListResourceBundle \
	java.util.Locale \
	java.util.MissingResourceException \
	java.util.NoSuchElementException \
	java.util.Observable \
	java.util.Observer \
	java.util.Properties \
	java.util.PropertyResourceBundle \
	java.util.ResourceBundle \
	java.util.Random \
	java.util.SimpleTimeZone \
	java.util.Stack \
	java.util.StringTokenizer \
	java.util.TimeZone \
	java.util.TooManyListenersException \
	java.util.Vector \
	\
	java.io.BufferedInputStream \
	java.io.BufferedOutputStream \
	java.io.BufferedReader \
	java.io.BufferedWriter \
	java.io.ByteArrayInputStream \
	java.io.ByteArrayOutputStream \
	java.io.CharArrayReader \
	java.io.CharArrayWriter \
	java.io.CharConversionException \
	java.io.DataInput \
	java.io.DataInputStream \
	java.io.DataOutput \
	java.io.DataOutputStream \
	java.io.EOFException \
	java.io.Externalizable \
	java.io.FileDescriptor \
	java.io.FilterInputStream \
	java.io.FilterOutputStream \
	java.io.FilterReader \
	java.io.FilterWriter \
	java.io.IOException \
	java.io.InputStream \
	java.io.InputStreamReader \
	java.io.InterruptedIOException \
	java.io.InvalidClassException \
	java.io.InvalidObjectException \
	java.io.LineNumberInputStream \
	java.io.LineNumberReader \
	java.io.NotActiveException \
	java.io.NotSerializableException \
	java.io.ObjectInput \
	java.io.ObjectInputStream \
	java.io.ObjectInputValidation \
	java.io.ObjectOutput \
	java.io.ObjectOutputStream \
	java.io.ObjectStreamClass \
	java.io.ObjectStreamConstants \
	java.io.ObjectStreamException \
	java.io.ObjectStreamField \
	java.io.OptionalDataException \
	java.io.OutputStream \
	java.io.OutputStreamWriter \
	java.io.PipedInputStream \
	java.io.PipedOutputStream \
	java.io.PipedReader \
	java.io.PipedWriter \
	java.io.PrintStream \
	java.io.PrintWriter \
	java.io.PushbackInputStream \
	java.io.PushbackReader \
	java.io.Reader \
	java.io.SequenceInputStream \
	java.io.Serializable \
	java.io.StreamCorruptedException \
	java.io.StreamTokenizer \
	java.io.StringBufferInputStream \
	java.io.StringReader \
	java.io.StringWriter \
	java.io.SyncFailedException \
	java.io.UTFDataFormatException \
	java.io.UnsupportedEncodingException \
	java.io.WriteAbortedException \
	java.io.Writer \
	\
	java.beans.BeanDescriptor \
	java.beans.BeanInfo \
	java.beans.Beans \
	java.beans.Customizer \
	java.beans.EventSetDescriptor \
	java.beans.FeatureDescriptor \
	java.beans.IndexedPropertyDescriptor \
	java.beans.IntrospectionException \
	java.beans.Introspector \
	java.beans.MethodDescriptor \
	java.beans.ParameterDescriptor \
	java.beans.PropertyChangeEvent \
	java.beans.PropertyChangeListener \
	java.beans.PropertyChangeSupport \
	java.beans.PropertyDescriptor \
	java.beans.PropertyEditor \
	java.beans.PropertyEditorManager \
	java.beans.PropertyEditorSupport \
	java.beans.PropertyVetoException \
	java.beans.SimpleBeanInfo \
	java.beans.VetoableChangeListener \
	java.beans.VetoableChangeSupport \
	java.beans.Visibility \
	\
	java.awt.AWTConfig \
	\
	sun.misc.MessageUtils \
	sun.misc.Queue \
	sun.misc.Ref \
        sun.misc.Cache \
	sun.misc.VM \
	sun.misc.VMNotification \
	sun.misc.WeakCache \
	\
	sun.tools.jar.JarVerifierStream \
	sun.tools.jar.JarImageSource \
	\
	com.sun.lang.UnsupportedOperationException \
	\
	com.sun.util.PTimer \
	com.sun.util.PTimerSpec \
	com.sun.util.PTimerWentOffEvent \
	com.sun.util.PTimerWentOffListener \
	com.sun.util.DefaultPTimer \
	\
	sun.applet.AppletResourceLoader \
	sun.applet.AppletSecurity \
	sun.applet.AppletSecurityException \
	\
	sun.audio.AudioData \
	sun.audio.AudioDataStream \
	sun.audio.AudioPlayer \
	sun.audio.AudioStream \
	sun.audio.AudioStreamSequence \
	sun.audio.ContinuousAudioDataStream \
	sun.audio.InvalidAudioFormatException \
	\
	sun.io.ObjectInputStreamDelegate \
	sun.io.ObjectOutputStreamDelegate \
	\
	sun.misc.Regexp \
	sun.misc.RegexpPool \
	sun.misc.RegexpTarget \
	sun.misc.REException \
	\
	sun.beans.editors.BoolEditor \
	sun.beans.editors.ByteEditor \
	sun.beans.editors.ColorEditor \
	sun.beans.editors.DoubleEditor \
	sun.beans.editors.FloatEditor \
	sun.beans.editors.FontEditor \
	sun.beans.editors.IntEditor \
	sun.beans.editors.LongEditor \
	sun.beans.editors.NumberEditor \
	sun.beans.editors.ShortEditor \
	sun.beans.editors.StringEditor \

ifeq ($(REMOTECLASSLOADING), true)
JAVAISHARECLASSES	+= sun.pjava.lang.RemoteClassLoader
JAVAISTUBCLASSES	+= sun.pjava.lang.RemoteClassLoader
endif

#
# Include Applet support for non-filtered apps
#

ifndef FILTERAPP
JAVAISHARECLASSES	+= 	\
	java.applet.Applet \
	java.applet.AppletContext \
	java.applet.AppletStub \
	java.applet.AudioClip \
	sun.applet.AppletAudioClip \
	sun.applet.AppletClassEntry \
	sun.applet.AppletClassLoader \
	sun.applet.AppletCopyright \
	sun.applet.AppletEvent \
	sun.applet.AppletEventMulticaster \
	sun.applet.AppletIOException \
	sun.applet.AppletIllegalArgumentException \
	sun.applet.AppletImageRef \
	sun.applet.AppletListener \
	sun.applet.AppletMessageHandler \
	sun.applet.AppletObjectInputStream \
	sun.applet.AppletPanel \
	sun.applet.AppletProps \
	sun.applet.AppletThreadGroup \
	sun.applet.AppletViewer \
	sun.applet.AppletViewerFactory \
	sun.applet.AppletViewerPanel \
	sun.applet.resources.MsgAppletViewer
endif

#
# Include *NO* Applet support for filtered apps
#

ifdef FILTERAPP
OPTIONALSRCDIRS += $(OPTIONALSHARESRCDIR)/noappletsupport
else
OPTIONALSRCDIRS += $(OPTIONALSHARESRCDIR)/pjae
endif

#
# If security is not included, do not use it.
#

ifneq ($(INCLUDESECURITY), true)
OPTIONALSRCDIRS += $(OPTIONALSHARESRCDIR)/nosecurity
endif


###############
# objects
###############

JAVAISHAREOBJECTS += opcodes.o

ifeq ($(STATICLIBRARIES), true)
JAVAISHAREOBJECTS += classstubs.o
endif

ifeq ($(ROMIZE), true)
JAVAISHAREOBJECTS += preloader.o
else
JAVAISHAREOBJECTS += null_preloader.o
endif

ifeq ($(SUPPORTOLDPROFILER), true)
JAVAISHAREOBJECTS += profiler.o 
endif

ifeq ($(JVMDI), true)
JAVAISHAREOBJECTS += \
	jvmdi.o \
	jvmdi_jni.o \
	bag.o
endif

ifeq ($(JVMPI), true)
JAVAISHAREOBJECTS += jvmpi.o
endif

ifeq ($(CLOOP), true)	
JAVAISHAREOBJECTS += executeJava.o 
else 
JAVAISHAREOBJECTS += \
	executeJava_$(ASMLOOPPROCESSOR).o \
	runtimeHelper_$(ASMLOOPPROCESSOR).o 
endif

JAVAISHAREOBJECTS += \
	array.o \
	check_class.o \
	check_code.o \
	class.o \
	classinitialize.o \
	classloader.o \
	classresolver.o \
	classruntime.o \
	common_exceptions.o \
	compiler.o \
	debug.o \
	exception.o \
	exceptions.o \
	finalize.o \
	gc.o \
	globals.o \
	inline.o \
	interpreter.o \
	jcov.o \
	jni.o \
	method.o \
	monitor.o \
	monitor_cache.o \
	reflect.o \
	remoteClassLoader.o \
	resource.o \
	security.o \
	string.o \
	system.o \
	threadruntime.o \
	threads.o \
	utf.o \
	util.o \
	wrap.o \
	zip.o \
	ObjectInputStream.o

#
# fragmented native methods
#

ifndef FILTERAPP
JAVAISHAREOBJECTS += \
	java_io_FileDescriptor_initSystemFD.o \
	java_io_FileDescriptor_sync.o \
	java_io_FileDescriptor_valid.o \
	java_io_ObjectInputStream_allocateNewArray.o \
	java_io_ObjectInputStream_allocateNewObject.o \
	java_io_ObjectInputStream_inputClassFields.o \
	java_io_ObjectInputStream_invokeObjectReader.o \
	java_io_ObjectInputStream_loadClass0.o \
	java_io_ObjectOutputStream_invokeObjectWriter.o \
	java_io_ObjectOutputStream_invokeObjectWriter.o \
	java_io_ObjectOutputStream_outputClassFields.o \
	java_io_ObjectStreamClass_getClassAccess.o \
	java_io_ObjectStreamClass_getFieldAccess.o \
	java_io_ObjectStreamClass_getFieldSignatures.o \
	java_io_ObjectStreamClass_getFieldSignatures.o \
	java_io_ObjectStreamClass_getFields0.o \
	java_io_ObjectStreamClass_getMethodAccess.o \
	java_io_ObjectStreamClass_getMethodSignatures.o \
	java_io_ObjectStreamClass_getMethodSignatures.o \
	java_io_ObjectStreamClass_getMethodSignatures.o \
	java_io_ObjectStreamClass_getSerialVersionUID.o \
	java_io_ObjectStreamClass_hasWriteObject.o \
	java_lang_Character_getA.o \
	java_lang_Character_getX.o \
	java_lang_Character_getY.o \
	java_lang_Class_forName.o \
	java_lang_Class_getClassLoader.o \
	java_lang_Class_getComponentType.o \
	java_lang_Class_getConstructor0.o \
	java_lang_Class_getConstructors0.o \
	java_lang_Class_getField0.o \
	java_lang_Class_getFields0.o \
	java_lang_Class_getInterfaces.o \
	java_lang_Class_getMethod0.o \
	java_lang_Class_getMethods0.o \
	java_lang_Class_getModifiers.o \
	java_lang_Class_getName.o \
	java_lang_Class_getPrimitiveClass.o \
	java_lang_Class_getSigners.o \
	java_lang_Class_getSuperclass.o \
	java_lang_Class_isArray.o \
	java_lang_Class_isAssignableFrom.o \
	java_lang_Class_isInstance.o \
	java_lang_Class_isInterface.o \
	java_lang_Class_isPrimitive.o \
	java_lang_Class_newInstance.o \
	java_lang_Class_setSigners.o \
	java_lang_ClassLoader_defineClass0.o \
	java_lang_ClassLoader_findSystemClass0.o \
	java_lang_ClassLoader_resolveClass0.o \
	java_lang_ClassLoader_getSystemResourceAsName0.o \
	java_lang_ClassLoader_getSystemResourceAsStream0.o \
	java_lang_ClassLoader_init.o \
	java_lang_Compiler_command.o \
	java_lang_Compiler_compileClass.o \
	java_lang_Compiler_compileClasses.o \
	java_lang_Compiler_compileClasses.o \
	java_lang_Compiler_disable.o \
	java_lang_Compiler_disable.o \
	java_lang_Compiler_enable.o \
	java_lang_Compiler_enable.o \
	java_lang_Compiler_initialize.o \
	java_lang_Compiler_initialize.o \
	java_lang_Double_doubleToLongBits.o \
	java_lang_Double_longBitsToDouble.o \
	java_lang_Float_floatToIntBits.o \
	java_lang_Float_intBitsToFloat.o \
	java_lang_Math_IEEEremainder.o \
	java_lang_Math_acos.o \
	java_lang_Math_asin.o \
	java_lang_Math_atan2.o \
	java_lang_Math_atan.o \
	java_lang_Math_ceil.o \
	java_lang_Math_cos.o \
	java_lang_Math_exp.o \
	java_lang_Math_floor.o \
	java_lang_Math_log.o \
	java_lang_Math_pow.o \
	java_lang_Math_rint.o \
	java_lang_Math_sin.o \
	java_lang_Math_sqrt.o \
	java_lang_Math_tan.o \
	java_lang_Object_clone.o \
	java_lang_Object_getClass.o \
	java_lang_Object_hashCode.o \
	java_lang_Object_notifyAll.o \
	java_lang_Object_notify.o \
	java_lang_Object_wait.o \
	java_lang_Object_getClass.o \
	java_lang_Object_getClass.o \
	java_lang_Runtime_buildLibName.o \
	java_lang_Runtime_exitInternal.o \
	java_lang_Runtime_freeMemory.o \
	java_lang_Runtime_gc.o \
	java_lang_Runtime_initializeLinkerInternal.o \
	java_lang_Runtime_loadFileInternal.o \
	java_lang_Runtime_runFinalization.o \
	java_lang_Runtime_runFinalization.o \
	java_lang_Runtime_runFinalizersOnExit0.o \
	java_lang_Runtime_runFinalizersOnExit0.o \
	java_lang_Runtime_totalMemory.o \
	java_lang_Runtime_totalMemory.o \
	java_lang_Runtime_traceInstructions.o \
	java_lang_Runtime_traceMethodCalls.o \
	java_lang_SecurityManager_classDepth.o \
	java_lang_SecurityManager_classLoaderDepth.o \
	java_lang_SecurityManager_currentClassLoader.o \
	java_lang_SecurityManager_currentLoadedClass0.o \
	java_lang_SecurityManager_getClassContext.o \
	java_lang_String_intern.o \
	java_lang_System_setIn0.o \
	java_lang_System_setOut0.o \
	java_lang_System_setErr0.o \
	java_lang_System_currentTimeMillis.o \
	java_lang_System_arraycopy.o \
	java_lang_System_identityHashCode.o \
	java_lang_Thread_countStackFrames.o \
	java_lang_Thread_currentThread.o \
	java_lang_Thread_interrupt0.o \
	java_lang_Thread_isAlive.o \
	java_lang_Thread_isInterrupted.o \
	java_lang_Thread_resume0.o \
	java_lang_Thread_setPriority0.o \
	java_lang_Thread_sleep.o \
	java_lang_Thread_start.o \
	java_lang_Thread_stop0.o \
	java_lang_Thread_stop0.o \
	java_lang_Thread_suspend0.o \
	java_lang_Thread_suspend0.o \
	java_lang_Thread_suspend0.o \
	java_lang_Thread_yield.o \
	java_lang_Thread_yield.o \
	java_lang_Throwable_fillInStackTrace.o \
	java_lang_Throwable_printStackTrace0.o \
	java_lang_reflect_Array_getBoolean.o \
	java_lang_reflect_Array_getByte.o \
	java_lang_reflect_Array_getChar.o \
	java_lang_reflect_Array_getDouble.o \
	java_lang_reflect_Array_getFloat.o \
	java_lang_reflect_Array_getInt.o \
	java_lang_reflect_Array_getInt.o \
	java_lang_reflect_Array_getLength.o \
	java_lang_reflect_Array_getLong.o \
	java_lang_reflect_Array_getShort.o \
	java_lang_reflect_Array_get.o \
	java_lang_reflect_Array_multiNewArray.o \
	java_lang_reflect_Array_newArray.o \
	java_lang_reflect_Array_setBoolean.o \
	java_lang_reflect_Array_setByte.o \
	java_lang_reflect_Array_setChar.o \
	java_lang_reflect_Array_setDouble.o \
	java_lang_reflect_Array_setFloat.o \
	java_lang_reflect_Array_setInt.o \
	java_lang_reflect_Array_setLong.o \
	java_lang_reflect_Array_setShort.o \
	java_lang_reflect_Array_set.o \
	java_lang_reflect_Constructor_getModifiers.o \
	java_lang_reflect_Constructor_newInstance.o \
	java_lang_reflect_Field_getBoolean.o \
	java_lang_reflect_Field_getByte.o \
	java_lang_reflect_Field_getChar.o \
	java_lang_reflect_Field_getDouble.o \
	java_lang_reflect_Field_getFloat.o \
	java_lang_reflect_Field_getInt.o \
	java_lang_reflect_Field_getInt.o \
	java_lang_reflect_Field_getLong.o \
	java_lang_reflect_Field_getModifiers.o \
	java_lang_reflect_Field_getShort.o \
	java_lang_reflect_Field_get.o \
	java_lang_reflect_Field_setBoolean.o \
	java_lang_reflect_Field_setByte.o \
	java_lang_reflect_Field_setChar.o \
	java_lang_reflect_Field_setDouble.o \
	java_lang_reflect_Field_setFloat.o \
	java_lang_reflect_Field_setInt.o \
	java_lang_reflect_Field_setLong.o \
	java_lang_reflect_Field_setShort.o \
	java_lang_reflect_Field_set.o \
	java_lang_reflect_Method_getModifiers.o \
	java_lang_reflect_Method_invoke.o \
	java_util_ResourceBundle_getClassContext.o \
	java_util_ResourceBundle_getLoaderCache.o
endif
