# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)jcc.mk	1.24 98/11/25
#
# Makefile for building JavaCodeCompact(tm) and romjava.c

####################
# Exported variables
####################

# these are exported for the cleanjcc rule
JCC_CLASSPATH	= $(TOP)/build/classes.jcc
ROMJAVA 	= romjava.o

# don't include the rest of the flie if this is not a romized build
ifeq ($(ROMIZE), true)

BUILDDIRS	+= $(JCC_CLASSPATH)

#################
# Local variables
#################

JCC_SRCPATH	= $(TOP)/src/share/jcc
JCC_DEPEND	= $(JCC_CLASSPATH)/JavaCodeCompact.class

# If we are filtering then include the JavaFilter makefile. Include
# it after the above variables are defined because it relies on
# JCC_CLASSPATH and JCC_SRCPATH in some of its rules.
ifdef FILTERAPP
include jf.mk
endif

JNICLASSESLIST	= $(patsubst %,-jniClass %,$(JNIHEADERCLASSES))

PRELOADER_OPTIONS = \
	$(JNICLASSESLIST)

ifdef FILTERAPP
NMITIMESTAMP	= $(CCH)/nmi/.time.stamp$G
NMISTUBS	= build/classstubs$G.c
ROMJAVAECHO	= , nmi class headers, and classstubs$G.c
PRELOADER_INPUT = \
	-classpath $(ZIPPEDCLASSES) \
	-f $(SHARE_MDIR)/Description_$(FILTERAPP).classpath \
	-memberlist $(JFILTER_LIST) \
	-stubs $(NMISTUBS) -headers $(CCH)/nmi
else
PRELOADER_INPUT += $(ZIPPEDCLASSES)
endif

ifeq ($(DEBUGCLASSES), true)
PRELOADER_OPTIONS += -g
endif
# Allow breakpoints in ROMized code
ifeq ($(JVMDI), true)
PRELOADER_OPTIONS += -imageAttribute noPureCode
endif

###########
# romjava.c
###########

romjava$G.c $(NMISTUBS) $(NMITIMESTAMP): $(ZIPPEDCLASSES) $(JCC_DEPEND) $(JFILTER_LIST)
	@echo "... romjava$G.c$(ROMJAVAECHO)"
	@export CLASSPATH; \
	CLASSPATH=$(JCC_CLASSPATH); \
	rm -f $(JCC_CLASSPATH)/JCCMessage.properties; \
	cp $(TOP)/src/share/lib/JCCMessage.properties $(JCC_CLASSPATH); \
	$(JAVA) -mx64m JavaCodeCompact $(PRELOADER_OPTIONS) -q -o \
		romjava$G.c $(PRELOADER_INPUT)
	@touch romjava$G.c $(NMISTUBS) $(NMITIMESTAMP)

#################
# JavaCodeCompact
#################

$(JCC_DEPEND) :: $(JCC_CLASSPATH)
$(JCC_DEPEND) :: $(JCC_SRCPATH)/*.java \
		 $(JCC_SRCPATH)/components/*.java \
		 $(JCC_SRCPATH)/runtime/*.java \
		 $(JCC_SRCPATH)/text/*.java \
		 $(JCC_SRCPATH)/util/*.java \
		 $(JCC_SRCPATH)/vm/*.java
	@echo "... $@"
	@CLASSPATH=$(JCC_SRCPATH); export CLASSPATH; \
	$(JAVAC) -d $(JCC_CLASSPATH) \
	    $(subst /,$(FILESEP),$(JCC_SRCPATH)/JavaCodeCompact.java); \
	$(JAVAC) -d $(JCC_CLASSPATH) \
	    $(subst /,$(FILESEP),$(JCC_SRCPATH)/Strip.java)

endif   # if romized
