# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)jdc.mk	1.9 98/12/17
#
# Makefile for building JavaDataCompact(tm) and romfiles.c

####################
# Exported variables
####################

ifeq ($(ROMIZEFILES), true)
BUILDDIRS	+= $(ROMFILESOBJ) $(JDC_CLASSPATH)
SHAREOBJECTS	+= $(JDCOBJECTS)
CLASSES		+= sun.io.RandomAccessROMFile  
HEADERCLASSES	+= sun.io.RandomAccessROMFile
JAVAISTUBCLASSES+= sun.io.RandomAccessROMFile
endif            

# these are exported for the cleanjdc rule
JDC_CLASSPATH   = $(TOP)/build/classes.jdc
ROMFILESOBJ	= $(OBJ)/romfiles
ROMFILES	= romfiles.o

#################
# Local variables
#################

JDC_SRCPATH	= $(TOP)/src/share/sun/jdc
JDC_DEPEND	= $(JDC_CLASSPATH)/JavaDataCompact.class
STUFFER_DEPEND	= $(JDC_CLASSPATH)/Stuffer.class
ROMFILES_FILES	= $(ALLPROPERTIESDEST)

########################################
# Objects needed for the ROM file system
########################################

JDCOBJECTS = $(ROMFILES) romfile.o

ifndef FILTERAPP
JDCOBJECTS += \
	sun_io_RandomAccessROMFile_close.o \
	sun_io_RandomAccessROMFile_getFilePointer.o \
	sun_io_RandomAccessROMFile_length.o \
	sun_io_RandomAccessROMFile_open.o \
	sun_io_RandomAccessROMFile_read.o \
	sun_io_RandomAccessROMFile_readBytes.o \
	sun_io_RandomAccessROMFile_seek.o
endif

#############################
# JavaDataCompact and STUFFER
#############################

$(JDC_DEPEND) $(STUFFER_DEPEND) :: $(JDC_CLASSPATH)

$(JDC_DEPEND) :: $(JDC_SRCPATH)/JavaDataCompact.java
	@echo "... $@"
	@CLASSPATH=$(JDC_SRCPATH); export CLASSPATH; \
	$(JAVAC) -d $(JDC_CLASSPATH) $^

$(STUFFER_DEPEND) :: $(JDC_SRCPATH)/Stuffer.java
	@echo "... $@"
	@CLASSPATH=$(JDC_SRCPATH); export CLASSPATH; \
	$(JAVAC) -d $(JDC_CLASSPATH) $^

#############
# romfiles.o
#############

JDC_CONVERSIONS = -convert_prefix lib /javahome/lib

ifneq ($(USESTUFFER), true)

# The Easy way. Everything goes into one .c file.

$(OBJ)/$(ROMFILES) : $(ROMFILESOBJ)/romfiles.data.o
	@echo "... $@"
	@cp $< $@

$(ROMFILESOBJ)/romfiles.data.o: $(ROMFILESOBJ)/romfiles.data.c
	@echo "... $@"
	@$(CC) $(CFLAGS) $(ROMJAVACFLAGS) $(COUT)$@ $<

$(ROMFILESOBJ)/romfiles.data.c :: $(ROMFILESOBJ)
$(ROMFILESOBJ)/romfiles.data.c :: $(ROMFILES_FILES) $(JDC_DEPEND)
	@echo "... $@"
	@CLASSPATH=$(JDC_CLASSPATH); export CLASSPATH; \
	rm -f $(JDC_CLASSPATH)/JDCMessage.properties; \
	cp $(TOP)/src/share/lib/JDCMessage.properties $(JDC_CLASSPATH); \
	$(JAVA) JavaDataCompact -big -verbose -o $@ \
		$(JDC_CONVERSIONS) \
		$(ROMFILES_FILES)

else

# The somewhat hard and not so portable way. The .c file has no data for files
# and gets stuffed.

$(OBJ)/$(ROMFILES) : $(ROMFILESOBJ)/romfiles.nodata.o $(STUFFER_DEPEND)
	@echo "... $@"
	@cp $< $@
	@cat $(ROMFILES_FILES) > $(ROMFILESOBJ)/romfiles.data
	@CLASSPATH=$(JDC_CLASSPATH); export CLASSPATH; \
	$(JAVA) Stuffer `dump -h $(ROMFILESOBJ)/romfiles.nodata.o | nawk '$$7==".rodata"{print $$5}'` $(ROMFILESOBJ)/romfiles.data $@
	@rm $(ROMFILESOBJ)/romfiles.data

$(ROMFILESOBJ)/romfiles.nodata.o: $(ROMFILESOBJ)/romfiles.nodata.c
	@echo "... $@"
	@$(CC) $(CFLAGS) $(COUT)$@ $<

$(ROMFILESOBJ)/romfiles.nodata.c:: $(ROMFILESOBJ)
$(ROMFILESOBJ)/romfiles.nodata.c:: $(ROMFILES_FILES) $(JDC_DEPEND)
	@echo "... $@"
	@CLASSPATH=$(JDC_CLASSPATH); export CLASSPATH; \
	rm -f $(JDC_CLASSPATH)/JDCMessage.properties ;\
	cp $(TOP)/src/share/lib/JDCMessage.properties $(JDC_CLASSPATH); \
	$(JAVA) JavaDataCompact -verbose -o $@ \
		$(JDC_CONVERSIONS) \
		$(ROMFILES_FILES)

endif
