# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)locale.mk	1.5 99/07/01
#
# List of shared local related classes.

include locale_$(PLATFORM).mk

# dynamically add the names of the character converter classes
CLASSES	+= $(CHARCONVERTERLIST_base)
CLASSES += $(CHARCONVERTERLIST_$(BUILDLOCALE))

# dynamically add the names of the text resource classes
CLASSES += $(TEXTRESOURCECLASSLIST_base)
CLASSES += $(TEXTRESOURCECLASSLIST_$(BUILDLOCALE))

# dynamically add dependencies on the text resource classes
MUSTLOAD += $(DEPENDENCYLIST_base)
MUSTLOAD += $(DEPENDENCYLIST_$(BUILDLOCALE))

# shared character converter classes

CHARCONVERTERLIST_base = \
	sun.io.ByteToCharISO8859_1 \
	sun.io.ByteToCharConverter \
	sun.io.ByteToCharUTF8 \
	sun.io.ByteToCharUnicode \
	sun.io.ByteToCharUnicodeBig \
	sun.io.ByteToCharUnicodeLittle \
	sun.io.CharToByteISO8859_1 \
	sun.io.CharToByteConverter \
	sun.io.CharToByteUTF8 \
	sun.io.CharToByteUnicode \
	sun.io.CharToByteUnicodeBig \
	sun.io.CharToByteUnicodeBigUnmarked \
	sun.io.CharToByteUnicodeLittle \
	sun.io.CharToByteUnicodeLittleUnmarked \
	sun.io.CharacterEncoding \
	sun.io.ConversionBufferFullException \
	sun.io.MalformedInputException \
	sun.io.UnknownCharacterException

CHARCONVERTERLIST_en_US = \
	sun.io.ByteToCharISO8859_1 \
	sun.io.CharToByteISO8859_1

CHARCONVERTERLIST_ja = \
	sun.io.ByteToCharDoubleByte \
	sun.io.ByteToCharJIS0208 \
	sun.io.ByteToCharJIS0212 \
	sun.io.ByteToCharEUC_JP \
	sun.io.ByteToCharISO2022JP \
	sun.io.ByteToCharSJIS \
	sun.io.ByteToCharMS932 \
	\
	sun.io.ByteToCharSingleByte \
	sun.io.ByteToCharJIS0201 \
	\
	sun.io.ByteToCharJISAutoDetect \
	\
	sun.io.CharToByteDoubleByte \
	sun.io.CharToByteJIS0208 \
	sun.io.CharToByteJIS0212 \
	sun.io.CharToByteEUC_JP \
	sun.io.CharToByteISO2022JP \
	sun.io.CharToByteSJIS \
	sun.io.CharToByteMS932 \
	\
	sun.io.CharToByteSingleByte \
	sun.io.CharToByteJIS0201

# All Character Converter Classes
CHARCONVERTERLIST_ALL = \
	sun.io.ByteToCharASCII \
	sun.io.ByteToCharBig5 \
	sun.io.ByteToCharConverter \
	sun.io.ByteToCharCp037 \
	sun.io.ByteToCharCp1006 \
	sun.io.ByteToCharCp1025 \
	sun.io.ByteToCharCp1026 \
	sun.io.ByteToCharCp1046 \
	sun.io.ByteToCharCp1097 \
	sun.io.ByteToCharCp1098 \
	sun.io.ByteToCharCp1112 \
	sun.io.ByteToCharCp1122 \
	sun.io.ByteToCharCp1123 \
	sun.io.ByteToCharCp1124 \
	sun.io.ByteToCharCp1140 \
	sun.io.ByteToCharCp1141 \
	sun.io.ByteToCharCp1142 \
	sun.io.ByteToCharCp1143 \
	sun.io.ByteToCharCp1144 \
	sun.io.ByteToCharCp1145 \
	sun.io.ByteToCharCp1146 \
	sun.io.ByteToCharCp1147 \
	sun.io.ByteToCharCp1148 \
	sun.io.ByteToCharCp1149 \
	sun.io.ByteToCharCp1250 \
	sun.io.ByteToCharCp1251 \
	sun.io.ByteToCharCp1252 \
	sun.io.ByteToCharCp1253 \
	sun.io.ByteToCharCp1254 \
	sun.io.ByteToCharCp1255 \
	sun.io.ByteToCharCp1256 \
	sun.io.ByteToCharCp1257 \
	sun.io.ByteToCharCp1258 \
	sun.io.ByteToCharCp1381 \
	sun.io.ByteToCharCp1383 \
	sun.io.ByteToCharCp273 \
	sun.io.ByteToCharCp277 \
	sun.io.ByteToCharCp278 \
	sun.io.ByteToCharCp280 \
	sun.io.ByteToCharCp284 \
	sun.io.ByteToCharCp285 \
	sun.io.ByteToCharCp297 \
	sun.io.ByteToCharCp33722 \
	sun.io.ByteToCharCp420 \
	sun.io.ByteToCharCp424 \
	sun.io.ByteToCharCp437 \
	sun.io.ByteToCharCp500 \
	sun.io.ByteToCharCp737 \
	sun.io.ByteToCharCp775 \
	sun.io.ByteToCharCp838 \
	sun.io.ByteToCharCp850 \
	sun.io.ByteToCharCp852 \
	sun.io.ByteToCharCp855 \
	sun.io.ByteToCharCp856 \
	sun.io.ByteToCharCp857 \
	sun.io.ByteToCharCp858 \
	sun.io.ByteToCharCp860 \
	sun.io.ByteToCharCp861 \
	sun.io.ByteToCharCp862 \
	sun.io.ByteToCharCp863 \
	sun.io.ByteToCharCp864 \
	sun.io.ByteToCharCp865 \
	sun.io.ByteToCharCp866 \
	sun.io.ByteToCharCp868 \
	sun.io.ByteToCharCp869 \
	sun.io.ByteToCharCp870 \
	sun.io.ByteToCharCp871 \
	sun.io.ByteToCharCp874 \
	sun.io.ByteToCharCp875 \
	sun.io.ByteToCharCp918 \
	sun.io.ByteToCharCp921 \
	sun.io.ByteToCharCp922 \
	sun.io.ByteToCharCp923 \
	sun.io.ByteToCharCp930 \
	sun.io.ByteToCharCp933 \
	sun.io.ByteToCharCp935 \
	sun.io.ByteToCharCp937 \
	sun.io.ByteToCharCp939 \
	sun.io.ByteToCharCp942 \
	sun.io.ByteToCharCp942C \
	sun.io.ByteToCharCp943 \
	sun.io.ByteToCharCp943C \
	sun.io.ByteToCharCp948 \
	sun.io.ByteToCharCp949 \
	sun.io.ByteToCharCp949C \
	sun.io.ByteToCharCp950 \
	sun.io.ByteToCharCp964 \
	sun.io.ByteToCharCp970 \
	sun.io.ByteToCharDBCS_ASCII \
	sun.io.ByteToCharDBCS_EBCDIC \
	sun.io.ByteToCharDoubleByte \
	sun.io.ByteToCharEUC \
	sun.io.ByteToCharEUC_CN \
	sun.io.ByteToCharEUC_JP \
	sun.io.ByteToCharEUC_KR \
	sun.io.ByteToCharEUC_TW \
	sun.io.ByteToCharGBK \
	sun.io.ByteToCharISO2022 \
	sun.io.ByteToCharISO2022CN \
	sun.io.ByteToCharISO2022JP \
	sun.io.ByteToCharISO2022KR \
	sun.io.ByteToCharISO8859_1 \
	sun.io.ByteToCharISO8859_15_FDIS \
	sun.io.ByteToCharISO8859_2 \
	sun.io.ByteToCharISO8859_3 \
	sun.io.ByteToCharISO8859_4 \
	sun.io.ByteToCharISO8859_5 \
	sun.io.ByteToCharISO8859_6 \
	sun.io.ByteToCharISO8859_7 \
	sun.io.ByteToCharISO8859_8 \
	sun.io.ByteToCharISO8859_9 \
	sun.io.ByteToCharJIS0201 \
	sun.io.ByteToCharJIS0208 \
	sun.io.ByteToCharJIS0212 \
	sun.io.ByteToCharJISAutoDetect \
	sun.io.ByteToCharJohab \
	sun.io.ByteToCharKOI8_R \
	sun.io.ByteToCharMS874 \
	sun.io.ByteToCharMS932 \
	sun.io.ByteToCharMS936 \
	sun.io.ByteToCharMS950 \
	sun.io.ByteToCharMacArabic \
	sun.io.ByteToCharMacCentralEurope \
	sun.io.ByteToCharMacCroatian \
	sun.io.ByteToCharMacCyrillic \
	sun.io.ByteToCharMacDingbat \
	sun.io.ByteToCharMacGreek \
	sun.io.ByteToCharMacHebrew \
	sun.io.ByteToCharMacIceland \
	sun.io.ByteToCharMacRoman \
	sun.io.ByteToCharMacRomania \
	sun.io.ByteToCharMacSymbol \
	sun.io.ByteToCharMacThai \
	sun.io.ByteToCharMacTurkish \
	sun.io.ByteToCharMacUkraine \
	sun.io.ByteToCharSJIS \
	sun.io.ByteToCharSingleByte \
	sun.io.ByteToCharTIS620 \
	sun.io.ByteToCharUTF8 \
	sun.io.ByteToCharUnicode \
	sun.io.ByteToCharUnicodeBig \
	sun.io.ByteToCharUnicodeLittle \
	sun.io.CharToByteASCII \
	sun.io.CharToByteBig5 \
	sun.io.CharToByteConverter \
	sun.io.CharToByteCp037 \
	sun.io.CharToByteCp1006 \
	sun.io.CharToByteCp1025 \
	sun.io.CharToByteCp1026 \
	sun.io.CharToByteCp1046 \
	sun.io.CharToByteCp1097 \
	sun.io.CharToByteCp1098 \
	sun.io.CharToByteCp1112 \
	sun.io.CharToByteCp1122 \
	sun.io.CharToByteCp1123 \
	sun.io.CharToByteCp1124 \
	sun.io.CharToByteCp1140 \
	sun.io.CharToByteCp1141 \
	sun.io.CharToByteCp1142 \
	sun.io.CharToByteCp1143 \
	sun.io.CharToByteCp1144 \
	sun.io.CharToByteCp1145 \
	sun.io.CharToByteCp1146 \
	sun.io.CharToByteCp1147 \
	sun.io.CharToByteCp1148 \
	sun.io.CharToByteCp1149 \
	sun.io.CharToByteCp1250 \
	sun.io.CharToByteCp1251 \
	sun.io.CharToByteCp1252 \
	sun.io.CharToByteCp1253 \
	sun.io.CharToByteCp1254 \
	sun.io.CharToByteCp1255 \
	sun.io.CharToByteCp1256 \
	sun.io.CharToByteCp1257 \
	sun.io.CharToByteCp1258 \
	sun.io.CharToByteCp1381 \
	sun.io.CharToByteCp1383 \
	sun.io.CharToByteCp273 \
	sun.io.CharToByteCp277 \
	sun.io.CharToByteCp278 \
	sun.io.CharToByteCp280 \
	sun.io.CharToByteCp284 \
	sun.io.CharToByteCp285 \
	sun.io.CharToByteCp297 \
	sun.io.CharToByteCp33722 \
	sun.io.CharToByteCp420 \
	sun.io.CharToByteCp424 \
	sun.io.CharToByteCp437 \
	sun.io.CharToByteCp500 \
	sun.io.CharToByteCp737 \
	sun.io.CharToByteCp775 \
	sun.io.CharToByteCp838 \
	sun.io.CharToByteCp850 \
	sun.io.CharToByteCp852 \
	sun.io.CharToByteCp855 \
	sun.io.CharToByteCp856 \
	sun.io.CharToByteCp857 \
	sun.io.CharToByteCp858 \
	sun.io.CharToByteCp860 \
	sun.io.CharToByteCp861 \
	sun.io.CharToByteCp862 \
	sun.io.CharToByteCp863 \
	sun.io.CharToByteCp864 \
	sun.io.CharToByteCp865 \
	sun.io.CharToByteCp866 \
	sun.io.CharToByteCp868 \
	sun.io.CharToByteCp869 \
	sun.io.CharToByteCp870 \
	sun.io.CharToByteCp871 \
	sun.io.CharToByteCp874 \
	sun.io.CharToByteCp875 \
	sun.io.CharToByteCp918 \
	sun.io.CharToByteCp921 \
	sun.io.CharToByteCp922 \
	sun.io.CharToByteCp923 \
	sun.io.CharToByteCp930 \
	sun.io.CharToByteCp933 \
	sun.io.CharToByteCp935 \
	sun.io.CharToByteCp937 \
	sun.io.CharToByteCp939 \
	sun.io.CharToByteCp942 \
	sun.io.CharToByteCp942C \
	sun.io.CharToByteCp943 \
	sun.io.CharToByteCp943C \
	sun.io.CharToByteCp948 \
	sun.io.CharToByteCp949 \
	sun.io.CharToByteCp949C \
	sun.io.CharToByteCp950 \
	sun.io.CharToByteCp964 \
	sun.io.CharToByteCp970 \
	sun.io.CharToByteDBCS_ASCII \
	sun.io.CharToByteDBCS_EBCDIC \
	sun.io.CharToByteDoubleByte \
	sun.io.CharToByteEUC \
	sun.io.CharToByteEUC_CN \
	sun.io.CharToByteEUC_JP \
	sun.io.CharToByteEUC_KR \
	sun.io.CharToByteEUC_TW \
	sun.io.CharToByteGBK \
	sun.io.CharToByteISO2022 \
	sun.io.CharToByteISO2022CN_CNS \
	sun.io.CharToByteISO2022CN_GB \
	sun.io.CharToByteISO2022JP \
	sun.io.CharToByteISO2022KR \
	sun.io.CharToByteISO8859_1 \
	sun.io.CharToByteISO8859_15_FDIS \
	sun.io.CharToByteISO8859_2 \
	sun.io.CharToByteISO8859_3 \
	sun.io.CharToByteISO8859_4 \
	sun.io.CharToByteISO8859_5 \
	sun.io.CharToByteISO8859_6 \
	sun.io.CharToByteISO8859_7 \
	sun.io.CharToByteISO8859_8 \
	sun.io.CharToByteISO8859_9 \
	sun.io.CharToByteJIS0201 \
	sun.io.CharToByteJIS0208 \
	sun.io.CharToByteJIS0212 \
	sun.io.CharToByteJohab \
	sun.io.CharToByteKOI8_R \
	sun.io.CharToByteMS874 \
	sun.io.CharToByteMS932 \
	sun.io.CharToByteMS936 \
	sun.io.CharToByteMS950 \
	sun.io.CharToByteMacArabic \
	sun.io.CharToByteMacCentralEurope \
	sun.io.CharToByteMacCroatian \
	sun.io.CharToByteMacCyrillic \
	sun.io.CharToByteMacDingbat \
	sun.io.CharToByteMacGreek \
	sun.io.CharToByteMacHebrew \
	sun.io.CharToByteMacIceland \
	sun.io.CharToByteMacRoman \
	sun.io.CharToByteMacRomania \
	sun.io.CharToByteMacSymbol \
	sun.io.CharToByteMacThai \
	sun.io.CharToByteMacTurkish \
	sun.io.CharToByteMacUkraine \
	sun.io.CharToByteSJIS \
	sun.io.CharToByteSingleByte \
	sun.io.CharToByteTIS620 \
	sun.io.CharToByteUTF8 \
	sun.io.CharToByteUnicode \
	sun.io.CharToByteUnicodeBig \
	sun.io.CharToByteUnicodeBigUnmarked \
	sun.io.CharToByteUnicodeLittle \
	sun.io.CharToByteUnicodeLittleUnmarked

# shared text resources classes

TEXTRESOURCECLASSLIST_base = \
	java.text.resources.DateFormatZoneData \
	java.text.resources.LocaleData \
	java.text.resources.LocaleElements

TEXTRESOURCECLASSLIST_en_US = \
	java.text.resources.DateFormatZoneData_en \
	java.text.resources.LocaleElements_en

TEXTRESOURCECLASSLIST_ja = \
	java.text.resources.DateFormatZoneData_ja \
	java.text.resources.LocaleElements_ja

TEXTRESOURCECLASSLIST_ALL = \
	java.text.resources.DateFormatZoneData_ar \
	java.text.resources.DateFormatZoneData_be \
	java.text.resources.DateFormatZoneData_bg \
	java.text.resources.DateFormatZoneData_ca \
	java.text.resources.DateFormatZoneData_cs \
	java.text.resources.DateFormatZoneData_da \
	java.text.resources.DateFormatZoneData_de \
	java.text.resources.DateFormatZoneData_de_AT \
	java.text.resources.DateFormatZoneData_de_CH \
	java.text.resources.DateFormatZoneData_el \
	java.text.resources.DateFormatZoneData_en \
	java.text.resources.DateFormatZoneData_en_CA \
	java.text.resources.DateFormatZoneData_en_GB \
	java.text.resources.DateFormatZoneData_en_IE \
	java.text.resources.DateFormatZoneData_es \
	java.text.resources.DateFormatZoneData_et \
	java.text.resources.DateFormatZoneData_fi \
	java.text.resources.DateFormatZoneData_fr \
	java.text.resources.DateFormatZoneData_fr_BE \
	java.text.resources.DateFormatZoneData_fr_CA \
	java.text.resources.DateFormatZoneData_fr_CH \
	java.text.resources.DateFormatZoneData_hr \
	java.text.resources.DateFormatZoneData_hu \
	java.text.resources.DateFormatZoneData_is \
	java.text.resources.DateFormatZoneData_it \
	java.text.resources.DateFormatZoneData_it_CH \
	java.text.resources.DateFormatZoneData_iw \
	java.text.resources.DateFormatZoneData_ja \
	java.text.resources.DateFormatZoneData_ko \
	java.text.resources.DateFormatZoneData_lt \
	java.text.resources.DateFormatZoneData_lv \
	java.text.resources.DateFormatZoneData_mk \
	java.text.resources.DateFormatZoneData_nl \
	java.text.resources.DateFormatZoneData_nl_BE \
	java.text.resources.DateFormatZoneData_no \
	java.text.resources.DateFormatZoneData_no_NO_NY \
	java.text.resources.DateFormatZoneData_pl \
	java.text.resources.DateFormatZoneData_pt \
	java.text.resources.DateFormatZoneData_ro \
	java.text.resources.DateFormatZoneData_ru \
	java.text.resources.DateFormatZoneData_sh \
	java.text.resources.DateFormatZoneData_sk \
	java.text.resources.DateFormatZoneData_sl \
	java.text.resources.DateFormatZoneData_sq \
	java.text.resources.DateFormatZoneData_sr \
	java.text.resources.DateFormatZoneData_sv \
	java.text.resources.DateFormatZoneData_tr \
        java.text.resources.DateFormatZoneData_th \
	java.text.resources.DateFormatZoneData_uk \
	java.text.resources.DateFormatZoneData_zh \
	java.text.resources.DateFormatZoneData_zh_TW \
	java.text.resources.LocaleElements_ar \
	java.text.resources.LocaleElements_be \
	java.text.resources.LocaleElements_bg \
	java.text.resources.LocaleElements_ca \
	java.text.resources.LocaleElements_cs \
	java.text.resources.LocaleElements_da \
	java.text.resources.LocaleElements_de \
	java.text.resources.LocaleElements_de_AT \
	java.text.resources.LocaleElements_de_AT_EURO \
	java.text.resources.LocaleElements_de_CH \
	java.text.resources.LocaleElements_de_DE_EURO \
	java.text.resources.LocaleElements_de_LU \
	java.text.resources.LocaleElements_de_LU_EURO \
	java.text.resources.LocaleElements_el \
	java.text.resources.LocaleElements_en \
	java.text.resources.LocaleElements_en_CA \
	java.text.resources.LocaleElements_es_ES_EURO \
	java.text.resources.LocaleElements_en_GB \
	java.text.resources.LocaleElements_en_IE \
	java.text.resources.LocaleElements_en_IE_EURO \
        java.text.resources.LocaleElements_en_AU \
        java.text.resources.LocaleElements_en_NZ \
        java.text.resources.LocaleElements_en_ZA \
	java.text.resources.LocaleElements_es \
        java.text.resources.LocaleElements_es_AR \
        java.text.resources.LocaleElements_es_BO \
        java.text.resources.LocaleElements_es_CL \
        java.text.resources.LocaleElements_es_CO \
        java.text.resources.LocaleElements_es_CR \
        java.text.resources.LocaleElements_es_DO \
        java.text.resources.LocaleElements_es_EC \
        java.text.resources.LocaleElements_es_GT \
        java.text.resources.LocaleElements_es_HN \
        java.text.resources.LocaleElements_es_MX \
        java.text.resources.LocaleElements_es_NI \
        java.text.resources.LocaleElements_es_PA \
        java.text.resources.LocaleElements_es_PE \
        java.text.resources.LocaleElements_es_PR \
        java.text.resources.LocaleElements_es_PY \
        java.text.resources.LocaleElements_es_SV \
        java.text.resources.LocaleElements_es_UY \
        java.text.resources.LocaleElements_es_VE \
	java.text.resources.LocaleElements_et \
	java.text.resources.LocaleElements_fi \
	java.text.resources.LocaleElements_fi_FI_EURO \
	java.text.resources.LocaleElements_fr \
	java.text.resources.LocaleElements_fr_BE \
	java.text.resources.LocaleElements_fr_BE_EURO \
	java.text.resources.LocaleElements_fr_CA \
	java.text.resources.LocaleElements_fr_CH \
	java.text.resources.LocaleElements_fr_FR_EURO \
	java.text.resources.LocaleElements_fr_LU \
	java.text.resources.LocaleElements_fr_LU_EURO \
	java.text.resources.LocaleElements_hr \
	java.text.resources.LocaleElements_hu \
	java.text.resources.LocaleElements_is \
	java.text.resources.LocaleElements_it \
	java.text.resources.LocaleElements_it_CH \
	java.text.resources.LocaleElements_it_IT_EURO \
	java.text.resources.LocaleElements_iw \
	java.text.resources.LocaleElements_ja \
	java.text.resources.LocaleElements_ko \
	java.text.resources.LocaleElements_lt \
	java.text.resources.LocaleElements_lv \
	java.text.resources.LocaleElements_mk \
	java.text.resources.LocaleElements_nl \
	java.text.resources.LocaleElements_nl_BE \
	java.text.resources.LocaleElements_nl_BE_EURO \
	java.text.resources.LocaleElements_nl_NL_EURO \
	java.text.resources.LocaleElements_no \
	java.text.resources.LocaleElements_no_NO_NY \
	java.text.resources.LocaleElements_pl \
	java.text.resources.LocaleElements_pt \
        java.text.resources.LocaleElements_pt_BR \
	java.text.resources.LocaleElements_pt_PT_EURO \
	java.text.resources.LocaleElements_ro \
	java.text.resources.LocaleElements_ru \
	java.text.resources.LocaleElements_sh \
	java.text.resources.LocaleElements_sk \
	java.text.resources.LocaleElements_sl \
	java.text.resources.LocaleElements_sq \
	java.text.resources.LocaleElements_sr \
	java.text.resources.LocaleElements_sv \
        java.text.resources.LocaleElements_th \
	java.text.resources.LocaleElements_tr \
	java.text.resources.LocaleElements_uk \
	java.text.resources.LocaleElements_zh \
	java.text.resources.LocaleElements_zh_TW  

# shared text resource dependencies

DEPENDENCYLIST_base = \
	-loadClass java.text.resources.DateFormatZoneData \
	-loadClass java.text.resources.LocaleElements

DEPENDENCYLIST_en_US = $(patsubst %,-loadClass %,$(TEXTRESOURCECLASSLIST_en_US))

DEPENDENCYLIST_ja = $(patsubst %,-loadClass %,$(TEXTRESOURCECLASSLIST_ja))

DEPENDENCYLIST_ALL = $(patsubst %,-loadClass %,$(TEXTRESOURCECLASSLIST_ALL))
