# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)pkgawt.mk	1.42 99/06/24
#
# Makefile for the shared part of awt.

include pkgawt_$(PLATFORM).mk

####################
# exported variables
####################

ifeq ($(USETRUFFLE), true)
DEFINES += -DIMG_USE_JNI -DUSETRUFFLE
endif

CLASSES		+= $(AWTSHARECLASSES) $(AWTPLATFORMCLASSES) 
HEADERCLASSES	+= $(AWTSTUBCLASSES)
JNIHEADERCLASSES+= $(AWTJNIHEADERCLASSES)
MUSTLOAD        += -load 'sun.awt.image.JPEGImageDecoder.<clinit>()V'

#
# If native peers are being used, a dependence upon the native toolkit will be
# generated in the pkgawt_<platform>.mk makefile.
#
ifeq ($(USETRUFFLE), true)
MUSTLOAD += -dependence 'java.awt.Toolkit.getDefaultToolkit()Ljava/awt/Toolkit;' calls 'sun.awt.touchable.TouchableToolkit.<init>()V'
endif

ifeq ($(PLATFORM), solaris)
MUSTLOAD        += -dependence 'sun.porting.graphicssystem.GraphicsSystem.getDefaultGraphicsSystem()Lsun/porting/graphicssystem/GraphicsSystem;' calls 'sun.awt.gfX.GraphicsSystem.<init>()V'
endif
ifeq ($(PLATFORM), win32)
MUSTLOAD        += -dependence 'sun.porting.graphicssystem.GraphicsSystem.getDefaultGraphicsSystem()Lsun/porting/graphicssystem/GraphicsSystem;' calls 'sun.awt.gfW.GraphicsSystem.<init>()V'
endif

ifeq ($(STATICLIBRARIES), true)
SHAREOBJECTS	+= $(AWTSHAREOBJECTS)
PLATFORMOBJECTS	+= $(AWTPLATFORMOBJECTS)
STUBCLASSES	+= $(AWTSTUBCLASSES)
else
CLASSSTUBFILES	+= AWTclassstubs.c
endif


#################
# classes
#################


ifeq ($(USETRUFFLE), true)
AWTJNIHEADERCLASSES += \
	java.awt.image.ColorModel \
	sun.awt.EmbeddedFrame \
	sun.awt.aw.Window \
	sun.awt.image.GifImageDecoder \
	sun.awt.image.ImageRepresentation \
	sun.awt.image.OffScreenImageSource \
	sun.awt.otk.ComponentModel

else

AWTSTUBCLASSES += \
	java.awt.image.ColorModel \
	sun.awt.EmbeddedFrame \
	sun.awt.image.GifImageDecoder \
	sun.awt.image.ImageRepresentation \
	sun.awt.image.OffScreenImageSource
endif

AWTSTUBCLASSES += \
	java.awt.AWTEvent \
	java.awt.Adjustable \
	java.awt.Button \
	java.awt.Canvas \
	java.awt.Checkbox \
	java.awt.CheckboxGroup \
	java.awt.CheckboxMenuItem \
	java.awt.Choice \
	java.awt.Color \
	java.awt.Component \
	java.awt.Container \
	java.awt.Cursor \
	java.awt.Dialog \
	java.awt.Dimension \
	java.awt.Event \
	java.awt.Font \
	java.awt.FontMetrics \
	java.awt.Frame \
	java.awt.Graphics \
	java.awt.Image \
	java.awt.Insets \
	java.awt.Label \
	java.awt.List \
	java.awt.Menu \
	java.awt.MenuBar \
	java.awt.MenuComponent \
	java.awt.MenuItem \
	java.awt.Point \
	java.awt.PopupMenu \
	java.awt.Rectangle \
	java.awt.Scrollbar \
	java.awt.ScrollPane \
	java.awt.ScrollPaneAdjustable \
	java.awt.SystemColor \
	java.awt.TextArea \
	java.awt.TextComponent \
	java.awt.TextField \
	java.awt.Toolkit \
	java.awt.Window \
	\
	java.awt.datatransfer.DataFlavor \
	java.awt.datatransfer.StringSelection \
	java.awt.datatransfer.Transferable \
	\
	java.awt.event.AdjustmentEvent \
	java.awt.event.ComponentEvent \
	java.awt.event.FocusEvent \
	java.awt.event.InputEvent \
	java.awt.event.KeyEvent \
	java.awt.event.MouseEvent \
	java.awt.event.WindowEvent \
	\
	java.awt.image.DirectColorModel \
	java.awt.image.ImageConsumer \
	java.awt.image.ImageObserver \
	java.awt.image.IndexColorModel \
	\
	java.awt.peer.ComponentPeer \
	java.awt.peer.MenuComponentPeer \
	\
	sun.awt.ArrowKeyFocusManager \
	sun.awt.AWTFinalizeable \
	sun.awt.AWTFinalizer \
	sun.awt.CharsetString \
	sun.awt.FocusManagement \
	sun.awt.FontDescriptor \
	sun.awt.PlatformFont \
	sun.awt.SunToolkit \
	sun.awt.TabFocusManager \
	sun.awt.im.InputContext \
	sun.awt.im.InputMethod \
	sun.awt.im.InputMethodAdapter \
	sun.awt.im.InputMethodContext \
	sun.awt.image.ByteArrayImageSource \
	sun.awt.image.FileImageSource \
	sun.awt.image.Image \
	sun.awt.image.ImageConsumerQueue \
	sun.awt.image.ImageDecoder \
	sun.awt.image.ImageFetchable \
	sun.awt.image.ImageFetcher \
	sun.awt.image.ImageFormatException \
	sun.awt.image.ImageWatched \
	sun.awt.image.InputStreamImageSource \
	sun.awt.image.JPEGImageDecoder \
	sun.awt.image.PixelStore \
	sun.awt.image.PixelStore8 \
	sun.awt.image.PixelStore32 \
	sun.awt.image.URLImageSource \
	sun.awt.image.XbmImageDecoder

ifeq ($(INCLUDEJAVAFILE), true)
AWTSTUBCLASSES += \
	java.awt.FileDialog
endif

AWTSHARECLASSES = \
	java.awt.AWTError \
	java.awt.AWTEvent \
	java.awt.AWTEventMulticaster \
	java.awt.AWTException \
	java.awt.Adjustable \
	java.awt.BorderLayout \
	java.awt.Button \
	java.awt.Canvas \
	java.awt.CardLayout \
	java.awt.Checkbox \
	java.awt.CheckboxGroup \
	java.awt.CheckboxMenuItem \
	java.awt.Choice \
	java.awt.Color \
	java.awt.Component \
	java.awt.Container \
	java.awt.Cursor \
	java.awt.Dialog \
	java.awt.Dimension \
	java.awt.Event \
	java.awt.EventDispatchThread \
	java.awt.EventQueue \
	java.awt.EventQueueListener \
	java.awt.FileDialog \
	java.awt.FlowLayout \
	java.awt.Font \
	java.awt.FontMetrics \
	java.awt.Frame \
	java.awt.Graphics \
	java.awt.GridBagConstraints \
	java.awt.GridBagLayout \
	java.awt.GridLayout \
	java.awt.IllegalComponentStateException \
	java.awt.Image \
	java.awt.Insets \
	java.awt.ItemSelectable \
	java.awt.Label \
	java.awt.LayoutManager \
	java.awt.LayoutManager2 \
	java.awt.List \
	java.awt.MediaTracker \
	java.awt.Menu \
	java.awt.MenuBar \
	java.awt.MenuComponent \
	java.awt.MenuContainer \
	java.awt.MenuItem \
	java.awt.MenuShortcut \
	java.awt.Panel \
	java.awt.Point \
	java.awt.Polygon \
	java.awt.PopupMenu \
	java.awt.PrintGraphics \
	java.awt.PrintJob \
	java.awt.Rectangle \
	java.awt.ScrollPane \
	java.awt.Scrollbar \
	java.awt.Shape \
	java.awt.SystemColor \
	java.awt.TextArea \
	java.awt.TextComponent \
	java.awt.TextField \
	java.awt.Toolkit \
	java.awt.Window \
	\
	java.awt.datatransfer.Clipboard \
	java.awt.datatransfer.ClipboardOwner \
	java.awt.datatransfer.DataFlavor \
	java.awt.datatransfer.StringSelection \
	java.awt.datatransfer.Transferable \
	java.awt.datatransfer.UnsupportedFlavorException \
	\
	java.awt.event.ActionEvent \
	java.awt.event.ActionListener \
	java.awt.event.AdjustmentEvent \
	java.awt.event.AdjustmentListener \
	java.awt.event.ComponentAdapter \
	java.awt.event.ComponentEvent \
	java.awt.event.ComponentListener \
	java.awt.event.ContainerAdapter \
	java.awt.event.ContainerEvent \
	java.awt.event.ContainerListener \
	java.awt.event.FocusAdapter \
	java.awt.event.FocusEvent \
	java.awt.event.FocusListener \
	java.awt.event.InputEvent \
	java.awt.event.ItemEvent \
	java.awt.event.ItemListener \
	java.awt.event.KeyAdapter \
	java.awt.event.KeyEvent \
	java.awt.event.KeyListener \
	java.awt.event.MouseAdapter \
	java.awt.event.MouseEvent \
	java.awt.event.MouseListener \
	java.awt.event.MouseMotionAdapter \
	java.awt.event.MouseMotionListener \
	java.awt.event.PaintEvent \
	java.awt.event.TextEvent \
	java.awt.event.TextListener \
	java.awt.event.WindowAdapter \
	java.awt.event.WindowEvent \
	java.awt.event.WindowListener \
	\
	java.awt.image.AreaAveragingScaleFilter \
	java.awt.image.CropImageFilter \
	java.awt.image.DirectColorModel \
	java.awt.image.FilteredImageSource \
	java.awt.image.ImageConsumer \
	java.awt.image.ImageFilter \
	java.awt.image.ImageObserver \
	java.awt.image.ImageProducer \
	java.awt.image.IndexColorModel \
	java.awt.image.MemoryImageSource \
	java.awt.image.PixelGrabber \
	java.awt.image.RGBImageFilter \
	java.awt.image.ReplicateScaleFilter \
	\
	java.awt.peer.ActiveEvent \
	java.awt.peer.ButtonPeer \
	java.awt.peer.CanvasPeer \
	java.awt.peer.CheckboxMenuItemPeer \
	java.awt.peer.CheckboxPeer \
	java.awt.peer.ChoicePeer \
	java.awt.peer.ComponentPeer \
	java.awt.peer.ContainerPeer \
	java.awt.peer.DialogPeer \
	java.awt.peer.FileDialogPeer \
	java.awt.peer.FontPeer \
	java.awt.peer.FramePeer \
	java.awt.peer.LabelPeer \
	java.awt.peer.LightweightPeer \
	java.awt.peer.ListPeer \
	java.awt.peer.MenuBarPeer \
	java.awt.peer.MenuComponentPeer \
	java.awt.peer.MenuItemPeer \
	java.awt.peer.MenuPeer \
	java.awt.peer.PanelPeer \
	java.awt.peer.PopupMenuPeer \
	java.awt.peer.ScrollPanePeer \
	java.awt.peer.ScrollbarPeer \
	java.awt.peer.TextAreaPeer \
	java.awt.peer.TextComponentPeer \
	java.awt.peer.TextFieldPeer \
	java.awt.peer.WindowPeer \
	\
	sun.awt.ArrowKeyFocusManager \
	sun.awt.AWTFinalizeable \
	sun.awt.AWTFinalizer \
	sun.awt.CharsetString \
	sun.awt.DrawingSurface \
	sun.awt.DrawingSurfaceInfo \
	sun.awt.EmbeddedFrame \
	sun.awt.FocusManagement \
	sun.awt.FontDescriptor \
	sun.awt.PhysicalDrawingSurface \
	sun.awt.PlatformFont \
	sun.awt.ScreenUpdater \
	sun.awt.SunToolkit \
	sun.awt.TabFocusManager \
	sun.awt.UpdateClient \
        sun.awt.im.InputContext \
        sun.awt.im.InputMethod \
        sun.awt.im.InputMethodAdapter \
        sun.awt.im.InputMethodContext \
	sun.awt.image.ByteArrayImageSource \
	sun.awt.image.FileImageSource \
	sun.awt.image.GifImageDecoder \
	sun.awt.image.Image \
	sun.awt.image.ImageConsumerQueue \
	sun.awt.image.ImageDecoder \
	sun.awt.image.ImageFetchable \
	sun.awt.image.ImageFetcher \
	sun.awt.image.ImageFormatException \
	sun.awt.image.ImageRepresentation \
	sun.awt.image.ImageWatched \
	sun.awt.image.ImageProductionMonitor \
	sun.awt.image.InputStreamImageSource \
	sun.awt.image.JPEGImageDecoder \
	sun.awt.image.OffScreenImageSource \
	sun.awt.image.PixelStore \
	sun.awt.image.PixelStore8 \
	sun.awt.image.PixelStore32 \
	sun.awt.image.URLImageSource \
	sun.awt.image.XbmImageDecoder \
	\
	com.sun.awt.ActionInputPreferred \
	com.sun.awt.KeyboardInputPreferred \
	com.sun.awt.NoInputPreferred \
	com.sun.awt.PositionalInputPreferred

ifeq ($(USETRUFFLE), true)
AWTSHARECLASSES += \
	sun.awt.aw.WindowSystem \
	sun.awt.aw.Window \
	sun.awt.aw.WindowSystemEventQueue \
	sun.awt.otk.AdjustableObject \
	sun.awt.otk.Armable \
	sun.awt.otk.ArmableMouseController \
	sun.awt.otk.ArmOnPress \
	sun.awt.otk.Backspace \
	sun.awt.otk.BasicView \
	sun.awt.otk.BufferedKeyEvent \
	sun.awt.otk.CheckboxModel \
	sun.awt.otk.ChoiceModel \
	sun.awt.otk.ColorPalette \
	sun.awt.otk.ColorPolicy \
	sun.awt.otk.ComponentModel \
	sun.awt.otk.ComponentView \
	sun.awt.otk.ContainerModel \
	sun.awt.otk.ContainerView \
	sun.awt.otk.ContainerViewImpl \
	sun.awt.otk.Controller \
	sun.awt.otk.CutAndPaste \
	sun.awt.otk.CvtVirtual \
	sun.awt.otk.Dependent \
	sun.awt.otk.DialogModel \
	sun.awt.otk.DragMenu \
	sun.awt.otk.DragMenuMouseController \
	sun.awt.otk.FrameModel \
	sun.awt.otk.GenericInputHandler \
	sun.awt.otk.HorizArrows \
	sun.awt.otk.HorizPage \
	sun.awt.otk.InputController \
	sun.awt.otk.InputMethodAdapter \
	sun.awt.otk.InputMethodListener \
	sun.awt.otk.ItemSelectable \
	sun.awt.otk.LabelledComponentModel \
	sun.awt.otk.LabelMenuItem \
	sun.awt.otk.ListItem \
	sun.awt.otk.ListModel \
	sun.awt.otk.ListMouseController \
	sun.awt.otk.LWActionListener \
	sun.awt.otk.MenuComponentModel \
	sun.awt.otk.MenuItemModel \
	sun.awt.otk.MenuItemOwner \
	sun.awt.otk.MenuItemOperations \
	sun.awt.otk.MenuModel \
	sun.awt.otk.MenuShowEvent \
	sun.awt.otk.ModalContainerViewImpl \
	sun.awt.otk.Model \
	sun.awt.otk.MouseGobbler \
	sun.awt.otk.MultiLineTextPane \
	sun.awt.otk.ObjectToolkit \
	sun.awt.otk.ObservableModel \
	sun.awt.otk.OrderedList \
	sun.awt.otk.OrderedListImpl \
	sun.awt.otk.PopupMenuModel \
	sun.awt.otk.RandomSelectionTextPane \
	sun.awt.otk.RepaintEvent \
	sun.awt.otk.SampleInputMethod \
	sun.awt.otk.SimpleController \
	sun.awt.otk.Scroll \
	sun.awt.otk.Scrollable \
	sun.awt.otk.ScrollPaneModel \
	sun.awt.otk.SimpleStackActivationPolicy \
	sun.awt.otk.SingleLineTextPane \
	sun.awt.otk.StateChangeNotification \
	sun.awt.otk.StatelessController \
	sun.awt.otk.Subject \
	sun.awt.otk.SubjectImpl \
	sun.awt.otk.TextAreaModel \
	sun.awt.otk.TextCatchall \
	sun.awt.otk.TextComponentController \
	sun.awt.otk.TextComponentModel \
	sun.awt.otk.TextComponentPeerModel \
	sun.awt.otk.TextComponentView \
	sun.awt.otk.TextCharData \
	sun.awt.otk.TextDataInterface \
	sun.awt.otk.TextData \
	sun.awt.otk.TextFieldModel \
	sun.awt.otk.TextFilter \
	sun.awt.otk.TextPane \
	sun.awt.otk.TextPaneImpl \
	sun.awt.otk.TextPaneScroller \
	sun.awt.otk.TextPassThru \
	sun.awt.otk.TextScroll \
	sun.awt.otk.TopLevelWindowModel \
	sun.awt.otk.TriggerOnEnterKey \
	sun.awt.otk.TriggerOnRelease \
	sun.awt.otk.VertArrows \
	sun.awt.otk.VertPage \
	sun.awt.otk.View \
	sun.awt.otk.ViewEvent \
	sun.awt.otk.VirtualKeyEvent \
	sun.awt.otk.VirtualComponentEvent \
	sun.awt.otk.VirtualComponentMessage \
	sun.awt.otk.VirtualComponentSelInfo \
	sun.awt.otk.VirtualKeyboardActivator \
	sun.awt.otk.VirtualKeyboardInputMethod \
	sun.awt.otk.VirtualKeyboardModel \
	sun.awt.otk.VirtualKeyboardViewIntf \
	sun.awt.otk.VirtualKey \
	sun.awt.otk.VirtualKeySet \
	sun.awt.otk.WindowActivationPolicy \
	sun.awt.otk.WindowActivationVetoException \
	sun.awt.otk.WindowModel \
	\
	sun.awt.touchable.ArmableView \
	sun.awt.touchable.BasicColorPolicy \
	sun.awt.touchable.ButtonView \
	sun.awt.touchable.CheckboxView \
	sun.awt.touchable.CheckboxRadioButtonModel \
	sun.awt.touchable.ChoiceOwner \
	sun.awt.touchable.ChoiceView \
	sun.awt.touchable.DialogView \
	sun.awt.touchable.DrawUtils \
	sun.awt.touchable.FingerPrint \
	sun.awt.touchable.FrameView \
	sun.awt.touchable.GroupingColorPolicy \
	sun.awt.touchable.HorizListView \
	sun.awt.touchable.KeyboardActivator \
	sun.awt.touchable.LabelView \
	sun.awt.touchable.LabelColorPolicy \
	sun.awt.touchable.ListView \
	sun.awt.touchable.ListMultiViewModel \
	sun.awt.touchable.MenuController \
	sun.awt.touchable.MenuSoundController \
	sun.awt.touchable.MenuView \
	sun.awt.touchable.OutlinedColorPolicy \
	sun.awt.touchable.RadioButtonView \
	sun.awt.touchable.Palette \
	sun.awt.touchable.ScrollableTextView \
	sun.awt.touchable.ScrollableTextAreaView \
	sun.awt.touchable.ScrollbarView \
	sun.awt.touchable.ScrollButton \
	sun.awt.touchable.ScrollerView \
	sun.awt.touchable.ScrollPaneView \
	sun.awt.touchable.Sounds \
	sun.awt.touchable.TextAreaView \
	sun.awt.touchable.TextComponentViewImpl \
	sun.awt.touchable.TextFieldView \
	sun.awt.touchable.TextPaneColorPolicy \
	sun.awt.touchable.TextPopupView \
	sun.awt.touchable.TouchableContainerView \
	sun.awt.touchable.TouchableMultiLinePane \
	sun.awt.touchable.TouchableSingleLinePane \
	sun.awt.touchable.TouchableToolkit  \
	sun.awt.touchable.TouchableView \
	sun.awt.touchable.TouchableVirtualKey \
	sun.awt.touchable.TouchableVirtualKanaKey \
	sun.awt.touchable.TouchableVirtualKeySet \
	sun.awt.touchable.TouchableVirtualKanaKeySet \
	sun.awt.touchable.TouchableVirtualArrowKey \
	sun.awt.touchable.TouchableVirtualToggleKey \
	sun.awt.touchable.TwoForegroundColorPolicy \
	sun.awt.touchable.TouchableVirtualStickyKey \
	sun.awt.touchable.VertListView \
	sun.awt.touchable.VirtualKeyboardPopupView \
	sun.awt.touchable.VirtualKeyboard_en_US_QWERTY_1 \
	sun.awt.touchable.VirtualKeyboard_ja_JP_GOJUUON \
	sun.awt.touchable.VKControlAreaView \
	sun.awt.touchable.VKMultiKeySetControlAreaView \
	\
	sun.porting.graphicssystem.Region \
	sun.porting.graphicssystem.GeometryProvider \
	sun.porting.graphicssystem.Drawable \
	sun.porting.graphicssystem.CursorImage \
	sun.porting.graphicssystem.GraphicsSystem \
	\
	sun.porting.toolkit.ToolkitEventHandler \
	sun.porting.toolkit.SettableCursor \
	\
	sun.porting.utils.BitmapImageSource \
	sun.porting.utils.Rectangle \
	sun.porting.utils.RegionImpl \
	sun.porting.utils.XSpan \
	sun.porting.utils.YXBand \
	sun.porting.utils.YXBandList \
	\
	sun.porting.windowsystem.EventHandler \
	sun.porting.windowsystem.WindowFactory \
	sun.porting.windowsystem.WindowSystem \
	sun.porting.windowsystem.WindowManagementFeedback \
	sun.porting.windowsystem.Window
endif 

############
# Objects
############

AWTSHAREOBJECTS += \
	jcomapi.o \
	jdapimin.o \
	jdapistd.o \
	jdcoefct.o \
	jdcolor.o \
	jddctmgr.o \
	jdhuff.o \
	jdinput.o \
	jdmainct.o \
	jdmarker.o \
	jdmaster.o \
	jdmerge.o \
	jdphuff.o \
	jdpostct.o \
	jdsample.o \
	jerror.o \
	jidctflt.o \
	jidctfst.o \
	jidctint.o \
	jidctred.o \
	jmemmgr.o \
	jmemnobs.o \
	jpegdecoder.o \
	jquant1.o \
	jquant2.o \
	jutils.o

ifeq ($(USETRUFFLE), true)

AWTSHAREOBJECTS += \
	aw.o \
	awt_access.o \
	gifdecoder.o \
	img_globals.o

endif
