# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)pkgfile.mk	1.5 98/12/01
#
# Makefile for the shared part of java.io.File*.

####################
# exported variables
####################

OPTIONALSRCDIRS	+= $(OPTIONALSHARESRCDIR)/fileio/$(FILEIOPKG)

#
# If java.io.File* classes are needed, include the non-stub
# version of FileDialog, as well as the rest of the File classes
# from the right place.
#
ifeq ($(INCLUDEJAVAFILE), true)
OPTIONALSRCDIRS	+= $(OPTIONALSHARESRCDIR)/filedialog
OPTIONALSRCDIRS	+= $(OPTIONALPLATFORMSRCDIR)/filedialog
OPTIONALSRCDIRS	+= $(OPTIONALSHARESRCDIR)/javafile
endif

CLASSES		+= $(JAVAFILECLASSES)
HEADERCLASSES	+= $(JAVAFILESTUBCLASSES)

ifeq ($(STATICLIBRARIES), true)
SHAREOBJECTS	+= $(JAVAFILESHAREOBJECTS)
STUBCLASSES	+= $(JAVAFILESTUBCLASSES)
else
CLASSSTUBFILES	+= JAVAFILEclassstubs.c
endif

#################
# classes
#################


file_CLASSES = \
	sun.io.FileFileIO
null_CLASSES = \
	sun.io.NullFileIO
rom_CLASSES = \
	sun.io.RomFileIO \
	sun.io.RomInputStream
url_CLASSES = \
	sun.io.URLFileIO

JAVAFILECLASSES = \
	sun.io.FileIO \
	sun.io.FDInputStream \
	sun.io.FDOutputStream \
	sun.io.FileIOFactory \
	$($(FILEIOPKG)_CLASSES)

JAVAFILESTUBCLASSES = \
	sun.io.FDInputStream \
	sun.io.FDOutputStream

ifeq ($(INCLUDEJAVAFILE), true)
JAVAFILECLASSES += \
	java.io.File \
	java.io.FileInputStream \
	java.io.FileOutputStream \
	java.io.FileReader \
	java.io.FileWriter \
	\
	java.io.FilenameFilter \
	java.io.FileNotFoundException \
	\
	java.io.RandomAccessFile \


JAVAFILESTUBCLASSES += \
	java.io.File \
	java.io.FileInputStream \
	java.io.FileOutputStream \
	java.io.InputStream \
	java.io.RandomAccessFile
endif


###############
# objects
###############

ifndef FILTERAPP
JAVAFILESHAREOBJECTS = \
	sun_io_FDInputStream_available.o \
	sun_io_FDInputStream_close.o \
	sun_io_FDInputStream_open.o \
	sun_io_FDInputStream_readBytes.o \
	sun_io_FDInputStream_read.o \
	sun_io_FDInputStream_skip.o \
	sun_io_FDOutputStream_close.o \
	sun_io_FDOutputStream_openAppend.o \
	sun_io_FDOutputStream_open.o \
	sun_io_FDOutputStream_writeBytes.o \
	sun_io_FDOutputStream_write.o


ifeq ($(INCLUDEJAVAFILE), true)
JAVAFILESHAREOBJECTS += \
	java_io_RandomAccessFile_close.o \
	java_io_RandomAccessFile_getFilePointer.o \
	java_io_RandomAccessFile_length.o \
	java_io_RandomAccessFile_open.o \
	java_io_RandomAccessFile_readBytes.o \
	java_io_RandomAccessFile_read.o \
	java_io_RandomAccessFile_seek.o \
	java_io_RandomAccessFile_writeBytes.o \
	java_io_RandomAccessFile_write.o \
	java_io_File_canRead0.o \
	java_io_File_canWrite0.o \
	java_io_File_canWrite0.o \
	java_io_File_canonPath.o \
	java_io_File_delete0.o \
	java_io_File_exists0.o \
	java_io_File_isAbsolute.o \
	java_io_File_isDirectory0.o \
	java_io_File_isFile0.o \
	java_io_File_lastModified0.o \
	java_io_File_length0.o \
	java_io_File_list0.o \
	java_io_File_mkdir0.o \
	java_io_File_renameTo0.o \
	java_io_File_rmdir0.o
endif
endif
