# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)pkgnet.mk	1.8 99/09/15
#
# Makefile for the shared part of net.

include pkgnet_$(PLATFORM).mk

####################
# exported variables
####################

CLASSES		+= $(NETSHARECLASSES) $(NETPLATFORMCLASSES)
HEADERCLASSES	+= $(NETSTUBCLASSES)

ifeq ($(STATICLIBRARIES), true)
PLATFORMOBJECTS	+= $(NETPLATFORMOBJECTS)
SHAREOBJECTS	+= $(NETSHAREOBJECTS)
STUBCLASSES	+= $(NETSTUBCLASSES)
else
CLASSSTUBFILES	+= NETclassstubs.c
endif


#################
# classes
#################

NETSTUBCLASSES += \
	sun.net.www.protocol.systemresource.SystemResourceManager \
	java.net.DatagramPacket \
	java.net.DatagramSocket \
	java.net.InetAddress \
	java.net.InetAddressImpl \
	java.net.PlainDatagramSocketImpl \
	java.net.PlainSocketImpl \
	java.net.ServerSocket \
	java.net.Socket \
	java.net.SocketInputStream \
	java.net.SocketOutputStream \
	java.net.SocketImpl

NETSHARECLASSES = \
	\
	java.net.BindException \
	java.net.ConnectException \
	java.net.ContentHandler \
	java.net.ContentHandlerFactory \
	java.net.DatagramPacket \
	java.net.DatagramSocket \
	java.net.DatagramSocketImpl \
	java.net.FileNameMap \
	java.net.HttpURLConnection \
	java.net.InetAddress \
	java.net.MalformedURLException \
	java.net.MulticastSocket \
	java.net.NoRouteToHostException \
	java.net.PlainDatagramSocketImpl \
	java.net.PlainSocketImpl \
	java.net.ProtocolException \
	java.net.ServerSocket \
	java.net.Socket \
	java.net.SocketException \
	java.net.SocketImpl \
	java.net.SocketImplFactory \
	java.net.SocketInputStream \
	java.net.SocketOptions \
	java.net.SocketOutputStream \
	java.net.URL \
	java.net.URLConnection \
	java.net.URLEncoder \
	java.net.URLStreamHandler \
	java.net.URLStreamHandlerFactory \
	java.net.UnknownHostException \
	java.net.UnknownServiceException \
	\
	sun.net.NetworkClient \
	sun.net.ProgressData \
	sun.net.ProgressEntry \
	sun.net.TelnetInputStream \
	sun.net.TelnetOutputStream \
	sun.net.TelnetProtocolException \
	sun.net.TransferProtocolClient \
	\
	sun.net.ftp.FtpClient \
	sun.net.ftp.FtpInputStream \
	sun.net.ftp.FtpLoginException \
	sun.net.ftp.FtpProtocolException \
	\
	sun.net.www.ApplicationLaunchException \
	sun.net.www.HeaderParser \
	sun.net.www.MessageHeader \
	sun.net.www.MeteredStream \
	sun.net.www.MimeEntry \
	sun.net.www.MimeLauncher \
	sun.net.www.MimeTable \
	sun.net.www.URLConnection \
	\
	sun.net.www.http.HttpClient \
	sun.net.www.http.KeepAliveCache \
	sun.net.www.http.KeepAliveStream \
	\
	sun.net.www.protocol.http.AuthenticationInfo \
	sun.net.www.protocol.http.BasicAuthentication \
	sun.net.www.protocol.http.HttpAuthenticator \
	sun.net.www.protocol.http.HttpURLConnection \
	sun.net.www.protocol.http.Handler \
	\
	sun.net.www.protocol.appletresource.AppletResourceConnection \
	sun.net.www.protocol.appletresource.Handler \
	\
	sun.net.www.protocol.systemresource.Handler \
	sun.net.www.protocol.systemresource.ParseSystemURL \
	sun.net.www.protocol.systemresource.SystemResourceConnection \
	sun.net.www.protocol.systemresource.SystemResourceManager

ifeq ($(INCLUDEURLPROTOCOLEXTRAS), true)
NETSHARECLASSES += \
	sun.net.www.protocol.file.Handler \
	sun.net.www.protocol.file.FileURLConnection \
	\
	sun.net.www.protocol.ftp.FtpURLConnection \
	sun.net.www.protocol.ftp.Handler \
	\
	sun.net.www.protocol.mailto.MailToURLConnection \
	sun.net.www.protocol.mailto.Handler \
	sun.net.smtp.SmtpClient \
	sun.net.smtp.SmtpProtocolException \
	\
	sun.net.www.protocol.gopher.GopherClient \
	sun.net.www.protocol.gopher.Handler
endif


############
# Objects
############

ifndef FILTERAPP
NETSHAREOBJECTS = \
	sun_net_www_protocol_systemresource_SystemResourceManager_getEntryFromKey.o \
	sun_net_www_protocol_systemresource_SystemResourceManager_getZipResourceByteArray.o \
	sun_net_www_protocol_systemresource_SystemResourceManager_validateSystemResource.o
endif
