# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)pkgrmi.mk	1.2 98/12/18
#
# Makefile for the shared part of rmi.

####################
# exported variables
####################

CLASSES		+= $(RMICLASSES)


#################
# rmistubs target
#################

REMOTE_impls = \
	sun.rmi.registry.RegistryImpl \
	sun.rmi.transport.DGCImpl

REMOTE_files = $(subst .,/,$(REMOTE_impls))
FILES_stubs =  $(REMOTE_files:%=$(CLASSESDIR)/%_Stub.class)
FILES_skels =  $(REMOTE_files:%=$(CLASSESDIR)/%_Skel.class)

rmistubs: $(FILES_stubs) $(FILES_skels)

$(CLASSESDIR)/%_Skel.class $(CLASSESDIR)/%_Stub.class: $(CLASSESDIR)/%.class
	@echo "... $@"
	@$(RMIC) -classpath $(CLASSESDIR) \
		-d $(CLASSESDIR) $(REMOTE_impls)

.PRECIOUS: $(patsubst %,$(CLASSESDIR)/%.class,$(REMOTE_files))


#################
# classes
#################

RMICLASSES = $(JAVARMICLASSES) $(SUNRMICLASSES)

JAVARMICLASSES = \
	java.rmi.AccessException \
	java.rmi.AlreadyBoundException \
	java.rmi.ConnectException \
	java.rmi.ConnectIOException \
	java.rmi.MarshalException \
	java.rmi.Naming \
	java.rmi.NoSuchObjectException \
	java.rmi.NotBoundException \
	java.rmi.RMISecurityException \
	java.rmi.RMISecurityManager \
	java.rmi.Remote \
	java.rmi.RemoteException \
	java.rmi.ServerError \
	java.rmi.ServerException \
	java.rmi.ServerRuntimeException \
	java.rmi.StubNotFoundException \
	java.rmi.UnexpectedException \
	java.rmi.UnknownHostException \
	java.rmi.UnmarshalException \
	java.rmi.dgc.DGC \
	java.rmi.dgc.Lease \
	java.rmi.dgc.VMID \
	java.rmi.registry.LocateRegistry \
	java.rmi.registry.Registry \
	java.rmi.registry.RegistryHandler \
	java.rmi.server.ExportException \
	java.rmi.server.LoaderHandler \
	java.rmi.server.LogStream \
	java.rmi.server.ObjID \
	java.rmi.server.Operation \
	java.rmi.server.RMIClassLoader \
	java.rmi.server.RMIFailureHandler \
	java.rmi.server.RMISocketFactory \
	java.rmi.server.RemoteCall \
	java.rmi.server.RemoteObject \
	java.rmi.server.RemoteRef \
	java.rmi.server.RemoteServer \
	java.rmi.server.RemoteStub \
	java.rmi.server.ServerCloneException \
	java.rmi.server.ServerNotActiveException \
	java.rmi.server.ServerRef \
	java.rmi.server.Skeleton \
	java.rmi.server.SkeletonMismatchException \
	java.rmi.server.SkeletonNotFoundException \
	java.rmi.server.SocketSecurityException \
	java.rmi.server.UID \
	java.rmi.server.UnicastRemoteObject \
	java.rmi.server.Unreferenced

SUNRMICLASSES = \
	sun.rmi.registry.RegistryHandler \
	sun.rmi.registry.RegistryImpl \
	sun.rmi.server.Dispatcher \
	sun.rmi.server.LoaderHandler \
	sun.rmi.server.MarshalInputStream \
	sun.rmi.server.MarshalOutputStream \
	sun.rmi.server.RMIClassLoader \
	sun.rmi.server.RemoteProxy \
	sun.rmi.server.UnicastRef \
	sun.rmi.server.UnicastServerRef \
	sun.rmi.transport.Channel \
	sun.rmi.transport.Connection \
	sun.rmi.transport.ConnectionInputStream \
	sun.rmi.transport.ConnectionOutputStream \
	sun.rmi.transport.DGCAckHandler \
	sun.rmi.transport.DGCClient \
	sun.rmi.transport.DGCImpl \
	sun.rmi.transport.Endpoint \
	sun.rmi.transport.LiveRef \
	sun.rmi.transport.LocateDGC \
	sun.rmi.transport.Notifiable \
	sun.rmi.transport.Notifier \
	sun.rmi.transport.ObjectTable \
	sun.rmi.transport.RMIThread \
	sun.rmi.transport.StreamRemoteCall \
	sun.rmi.transport.Target \
	sun.rmi.transport.Transport \
	sun.rmi.transport.TransportConstants \
	sun.rmi.transport.Utils \
	sun.rmi.transport.WeakRef \
	sun.rmi.transport.proxy.CGIHandler \
	sun.rmi.transport.proxy.HttpAwareServerSocket \
	sun.rmi.transport.proxy.HttpInputStream \
	sun.rmi.transport.proxy.HttpOutputStream \
	sun.rmi.transport.proxy.HttpReceiveSocket \
	sun.rmi.transport.proxy.HttpSendInputStream \
	sun.rmi.transport.proxy.HttpSendOutputStream \
	sun.rmi.transport.proxy.HttpSendSocket \
	sun.rmi.transport.proxy.RMIDirectSocketFactory \
	sun.rmi.transport.proxy.RMIHttpToCGISocketFactory \
	sun.rmi.transport.proxy.RMIHttpToPortSocketFactory \
	sun.rmi.transport.proxy.RMIMasterSocketFactory \
	sun.rmi.transport.proxy.RMISocketInfo \
	sun.rmi.transport.proxy.WrappedSocket \
	sun.rmi.transport.tcp.ConnectionMultiplexer \
	sun.rmi.transport.tcp.MultiplexConnectionInfo \
	sun.rmi.transport.tcp.MultiplexInputStream \
	sun.rmi.transport.tcp.MultiplexOutputStream \
	sun.rmi.transport.tcp.TCPChannel \
	sun.rmi.transport.tcp.TCPConnection \
	sun.rmi.transport.tcp.TCPEndpoint \
	sun.rmi.transport.tcp.TCPTransport 
