# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)pkgsecurity.mk	1.5 99/10/26
#
# Makefile for the shared part of security.

####################
# exported variables
####################

CLASSES		+= $(SECURITYCLASSES)

#################
# classes
#################

SECURITYCLASSES = \
        java.security.Certificate \
        java.security.DigestException \
        java.security.DigestInputStream \
	java.security.DigestOutputStream \
        java.security.Identity \
        java.security.IdentityScope \
        java.security.InvalidKeyException \
        java.security.InvalidParameterException \
        java.security.Key \
        java.security.KeyException \
        java.security.KeyManagementException \
        java.security.KeyPair \
        java.security.KeyPairGenerator \
	java.security.MessageDigest \
        java.security.NoSuchAlgorithmException \
        java.security.NoSuchProviderException \
        java.security.Principal \
        java.security.PrivateKey \
        java.security.Provider \
        java.security.ProviderException \
        java.security.PublicKey \
        java.security.SecureRandom \
        java.security.Security \
        java.security.SeedGenerator \
        java.security.Signature \
        java.security.SignatureException \
        java.security.Signer \
        java.security.interfaces.DSAKey \
        java.security.interfaces.DSAKeyPairGenerator \
        java.security.interfaces.DSAParams \
        java.security.interfaces.DSAPrivateKey \
        java.security.interfaces.DSAPublicKey \
        sun.security.pkcs.PKCS7 \
        sun.security.pkcs.PKCS8Key \
        sun.security.pkcs.PKCS10 \
        sun.security.pkcs.ContentInfo \
        sun.security.pkcs.EncodingException \
        sun.security.pkcs.SignerInfo \
        sun.security.provider.DSA \
        sun.security.provider.DSAKeyPairGenerator \
        sun.security.provider.DSAPrivateKey \
        sun.security.provider.DSAPublicKey \
        sun.security.provider.IdentityDatabase \
        sun.security.provider.MD5 \
        sun.security.provider.SHA \
        sun.security.provider.Sun \
        sun.security.provider.SystemIdentity \
        sun.security.provider.SystemSigner \
        sun.security.util.BigInt \
        sun.security.util.DerInputBuffer \
        sun.security.util.DerInputStream \
        sun.security.util.DerOutputStream \
        sun.security.util.DerValue \
        sun.security.util.ObjectIdentifier \
        sun.security.x509.AVA \
        sun.security.x509.AlgIdDSA \
        sun.security.x509.AlgorithmId \
        sun.security.x509.CertAndKeyGen \
        sun.security.x509.CertException \
        sun.security.x509.CertParseError \
        sun.security.x509.X500Name \
        sun.security.x509.X500Signer \
        sun.security.x509.X509Cert \
        sun.security.x509.X509Key \
	\
        sun.misc.BASE64Decoder \
        sun.misc.BASE64Encoder \
        sun.misc.CharacterDecoder \
        sun.misc.CharacterEncoder \
        sun.misc.HexDumpEncoder \
        sun.misc.CEStreamExhausted \
        sun.misc.CEFormatException \
	\
	sun.security.provider.Main \
	sun.tools.jar.Manifest \
	sun.tools.jar.SignatureFile

#
# security.acl is unsupported package for PJAVA.
# It is configurable package for EJAVA
#
ifdef FILTERAPP
SECURITYCLASSES += \
        java.security.acl.Acl \
        java.security.acl.AclEntry \
        java.security.acl.Owner \
        java.security.acl.Group \
        java.security.acl.AclNotFoundException \
        java.security.acl.NotOwnerException \
        java.security.acl.Permission \
        java.security.acl.LastOwnerException \
        \
        sun.security.acl.AclEntryImpl \
        sun.security.acl.AclImpl \
        sun.security.acl.AllPermissionsImpl \
        sun.security.acl.GroupImpl \
        sun.security.acl.OwnerImpl \
        sun.security.acl.PermissionImpl \
        sun.security.acl.PrincipalImpl \
        sun.security.acl.WorldGroupImpl 
endif
