# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)pkgzip.mk	1.10 99/09/21
#
# Makefile for the shared part of zip.

####################
# exported variables
####################

ifeq ($(INCLUDEZIPEXTRAS), true)
OPTIONALSRCDIRS	+= $(OPTIONALSHARESRCDIR)/zip
DEFINES		+= -DZIPEXTRAS
endif

CLASSES		+= $(ZIPCLASSES)
HEADERCLASSES	+= $(ZIPSTUBCLASSES)

ifeq ($(STATICLIBRARIES), true)
SHAREOBJECTS	+= $(ZIPSHAREOBJECTS)
STUBCLASSES	+= $(ZIPSTUBCLASSES)
else
CLASSSTUBFILES	+= ZIPclassstubs.c
endif

#################
# classes
#################

ZIPCLASSES = \
	java.util.zip.CRC32 \
	java.util.zip.CheckedInputStream \
	java.util.zip.CheckedOutputStream \
	java.util.zip.Checksum \
	java.util.zip.DataFormatException \
	java.util.zip.GZIPInputStream \
	java.util.zip.Inflater \
	java.util.zip.InflaterInputStream \
	java.util.zip.ZipConstants \
	java.util.zip.ZipEntry \
	java.util.zip.ZipException \
	java.util.zip.ZipInputStream \
	\
	java.util.zip.Adler32 \
	java.util.zip.Deflater \
	java.util.zip.DeflaterOutputStream \
	java.util.zip.GZIPOutputStream \
	java.util.zip.ZipFile \
	java.util.zip.ZipOutputStream

ZIPSTUBCLASSES = \
	java.util.zip.CRC32 \
	java.util.zip.Inflater

ifeq ($(INCLUDEZIPEXTRAS), true)
ZIPSTUBCLASSES += \
	java.util.zip.Adler32 \
	java.util.zip.Deflater
endif

###############
# objects
###############

ZIPSHAREOBJECTS = \
	zipglue.o \
	\
	crc32.o \
	infblock.o \
	infcodes.o \
	inffast.o \
	inflate.o \
	inftrees.o \
	infutil.o \
	zutil.o

ifndef FILTERAPP
ZIPSHAREOBJECTS += \
	java_util_zip_CRC32_update1.o \
	java_util_zip_CRC32_update.o \
	java_util_zip_Inflater_end.o \
	java_util_zip_Inflater_getAdler.o \
	java_util_zip_Inflater_getTotalIn.o \
	java_util_zip_Inflater_getTotalOut.o \
	java_util_zip_Inflater_inflate.o \
	java_util_zip_Inflater_init.o \
	java_util_zip_Inflater_reset.o \
	java_util_zip_Inflater_setDictionary.o
endif

ifeq ($(INCLUDEZIPEXTRAS), true)
ZIPSHAREOBJECTS += \
	adler32.o \
	deflate.o \
	trees.o 

ifndef FILTERAPP
ZIPSHAREOBJECTS += \
	java_util_zip_Adler32_update1.o \
	java_util_zip_Adler32_update.o \
	java_util_zip_Deflater_deflate.o \
	java_util_zip_Deflater_end.o \
	java_util_zip_Deflater_getAdler.o \
	java_util_zip_Deflater_getAdler.o \
	java_util_zip_Deflater_getTotalIn.o \
	java_util_zip_Deflater_getTotalOut.o \
	java_util_zip_Deflater_init.o \
	java_util_zip_Deflater_reset.o \
	java_util_zip_Deflater_setDictionary.o
endif
endif
