# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)properties.mk	1.14 99/03/18
#
# Makefile for copying all of the properties files.

####################
# exported variables
####################

# used by jdc as list of files to romize
ALLPROPERTIESDEST = \
	$(FONTPROPERTIESDEST) $(SHAREDPROPERTIESDEST) $(PLATFORMPROPERTIESDEST) $(PALETTEPROPERTIESDEST)


########################################
# properties that are platform specific
########################################

PLATFORMPROPERTIESDIR	= ../../src/$(PLATFORM)/lib

PLATFORMPROPERTIESDEST	= $(addprefix lib/, $(PLATFORMPROPERTIES))
PLATFORMPROPERTIESSRC	= \
	$(addprefix $(PLATFORMPROPERTIESDIR)/, $(PLATFORMPROPERTIES))


########################################
# properties that are shared
########################################

SHAREDPROPERTIESDIR	= ../../src/share/lib
SHAREDPROPERTIES	= \
	appletviewer.properties \
	awt.properties

ifeq ($(REMOTECLASSLOADING), true)
SHAREDPROPERTIES += remote-classes.properties
endif

ifeq ($(HPROF), true)
SHAREDPROPERTIES += jvm.hprof.txt
endif

SHAREDPROPERTIESDEST	= $(addprefix lib/, $(SHAREDPROPERTIES))

SHAREDPROPERTIESSRC 	= \
	$(addprefix $(SHAREDPROPERTIESDIR)/, $(SHAREDPROPERTIES))

ifeq ($(USETRUFFLE), true)
PALETTEPROPERTIES	= touchable.palettes
PALETTEPROPERTIESDIR	= ../../src/reference/lib
PALETTEPROPERTIESSRC	= \
	$(addprefix $(PALETTEPROPERTIESDIR)/, $(PALETTEPROPERTIES))
PALETTEPROPERTIESDEST	= $(addprefix lib/, $(PALETTEPROPERTIES))
endif

########################################
# special case java.security property
########################################

lib/security/java.security:: lib/security


###############################################
# font properties for the specified language(s)
###############################################

FONTPROPERTIESDIR = ../../src/$(PLATFORM)/sun/sun/awt/$(GUI)

FONTPROPERTIES_en_US = \
	font.properties

FONTPROPERTIES_ja=  \
	font.properties.ja

FONTPROPERTIES_ALL = \
	font.properties \
	font.properties.ja

FONTPROPERTIES = $(FONTPROPERTIES_$(BUILDLOCALE))

FONTPROPERTIESDEST = $(addprefix lib/, $(FONTPROPERTIES))
FONTPROPERTIESSRC = $(addprefix $(FONTPROPERTIESDIR)/, $(FONTPROPERTIES))


########################################
# Build properties files
########################################

#
# Note, this rule must come after all of the variable definitions above
# since the rule contains a variable in it's dependency list. Also,
# the include must be just before it, since it contains both rules and
# variables.

include properties_$(PLATFORM).mk

properties :: lib $(ALLPROPERTIESDEST)
