# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)defs_win32.mk	1.25 98/10/28
#
# Common variable definitions used throughout the makefiles.

# The win32 file and path separator characters.
FILESEP	:= \\
PATHSEP	:= \;

# The host CPU type and target CPU type
HOST_CPU	= x86
TARGET_CPU	= x86

# Locate the proper jdk
ifndef JAVATOP
JAVATOP = C:/JDK1.1.5
endif

# pass -e to sh like make does.
SHELL += -e

# used when creating the full name of the pjee
PLATFORMNAME = win

# location of pjava binary and dll binaries
PJAVABIN	= bin
DLLBIN		= bin

# prefix and postfix for dll file names
DLLPREFIX	=
DLLPOSTFIX	= dll

# the import library for javai that some other dll's need to link with
LIBJAVAIIMPORT	= $(DLLBIN)/javai$G.lib

# MAXCOMMANDLINE is the maximum size of a shell command line. Platforms 
# with lower limits (like win32) should lower this limit.
MAXCOMMANDLINE = 32000

# some common source directories
SHARE_JAVA = $(TOP)/src/share/java
SHARE_SUN  = $(TOP)/src/share/sun
WIN32_JAVA = $(TOP)/src/win32/java
WIN32_SUN  = $(TOP)/src/win32/sun
WIN32_SRC  = $(TOP)/src/win32

# file name extensions
BAT = .bat
EXE = .exe

# Development tools we use

ifeq ($(DEBUG), true)
D=d
endif

CC	= cl
CFLAGS	= -nologo -MD$D -DWIN32 -DIAL -D_X86_ -Dx86 -DWIN32_LEAN_AND_MEAN -c
CFLAGS  += $(EXTRA_CFLAGS)
ifeq ($(DEBUG), true)
CFLAGS	+= -Zi -Od
else
CFLAGS	+= -Ox -G5 
endif
ROMJAVACFLAGS = /Zm2000

COUT	= -Fo
ASMOUT	= -out:
LIBOUT	= -out:
LINKOUT	= -out:

RC  	= rc

AS.s	= $(CC) $(ARCH_OPT) -c
AS.S	= $(CC) $(ARCH_OPT) -traditional -D_ASM -c

LINK		= link $(LINKFLAGS)
LINKFLAGS	= -nologo -map -debug
LINKPJAVA	= $(LINK)
LINKPJAVAFLAGS	= setargv.obj
#ifeq ($(STATICLIBRARIES), true)
PJAVALINKLIBS	= advapi32.lib winmm.lib
PJAVALINKLIBS	+= wsock32.lib kernel32.lib user32.lib gdi32.lib \
	    	   winspool.lib comdlg32.lib
#endif

LINKDLL		= $(LINK)
LINKDLLFLAGS	= -dll
LIBTOOL		= lib
LIBFLAGS	= -nologo

ZIP	= zip

DEL	= del/f/q
DELTREE	= rmdir/s/q

# tools for building tools that run on the host
CC_HOST		= $(CC)
CFLAGS_HOST	= $(CFLAGS)
COUT_HOST	= $(COUT)
LINK_HOST	= $(LINK)
LINKFLAGS_HOST	= $(LINKFLAGS)
LINKOUT_HOST	= $(LINKOUT)
