# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)install_win32.mk	1.13 99/09/21
#
# Makefile for building the pjee directory and self extracting archive

U2D = flip -dbc

pjee_only:
	rm -rf $(PJEEDIR)
	mkdir -p $(PJEEDIR)
	mkdir -p $(PJEEDIR)/lib
	mkdir -p $(PJEEDIR)/bin
	cp -r redist $(PJEEDIR)/redist
	rm -rf $(PJEEDIR)/redist/SCCS
ifneq ($(STATICLIBRARIES), true)
	mkdir -p $(PJEEDIR)/$(DLLBIN)
	cp $(DLLBIN)/*.$(DLLPOSTFIX) $(PJEEDIR)/$(DLLBIN)
endif
	cp $(PJAVABIN)/pjava.exe $(PJEEDIR)/$(PJAVABIN)
	cp $(PJAVABIN)/pjava_g.exe $(PJEEDIR)/$(PJAVABIN)
	cp $(PJAVABIN)/pjavaw.exe $(PJEEDIR)/$(PJAVABIN)
	cp $(PJAVABIN)/pjavaw_g.exe $(PJEEDIR)/$(PJAVABIN)
	cp $(PJAVABIN)/pappletviewer.exe  $(PJEEDIR)/$(PJAVABIN)
	cp $(PJAVABIN)/pappletviewer_g.exe $(PJEEDIR)/$(PJAVABIN)
ifneq ($(ROMIZE), true)
	cp  $(ZIPPEDCLASSES) $(PJEEDIR)/lib
	cp  $(ZIPPEDCLASSES2) $(PJEEDIR)/lib
endif
	@for i in $(DOCINSTALL) ; do \
		echo $(U2D) $(TOP)/src/share/doc/release-notes/$$i.PJEE >$(PJEEDIR)/$$i; \
		$(U2D) $(TOP)/src/share/doc/release-notes/$$i.PJEE >$(PJEEDIR)/$$i; \
	done
	@for i in $(SHAREDPROPERTIES) $(PLATFORMPROPERTIES) $(PALETTEPROPERTIES) $(FONTPROPERTIES);\
	do \
		echo cp lib/$$i $(PJEEDIR)/lib; \
		cp lib/$$i $(PJEEDIR)/lib; \
	done
	@if [ -f lib/jvm.hprof.txt ]; then \
		echo cp lib/jvm.hprof.txt $(PJEEDIR)/lib; \
		cp lib/jvm.hprof.txt $(PJEEDIR)/lib; \
	fi


ifeq ($(INCLUDECODESIGNING),true) 
	@mkdir -p $(PJEEDIR)/lib/security
	@mkdir -p $(PJEEDIR)/tools
	cp lib/security/java.security $(PJEEDIR)/lib/security
	cp $(TOP)/src/win32/tools/pjavakey.bat $(PJEEDIR)/tools
	cp tools/pjavakey.jar $(PJEEDIR)/tools
endif


#####################
# release_only target
#####################


release_only:
	@echo ... Creating self extracting archive \"$(INSTALLDIR)/$(PJEEDIRNAME).exe\"
	ABSPATH=`cd $(INSTALLDIR); pwd`; \
	cd ishield; buildpjee $$ABSPATH/$(PJEEDIRNAME); \
	cp -f pjee3.exe $$ABSPATH/$(PJEEDIRNAME).exe
