# Copyright (c) 1997, 1998 SunMicrosystems, Inc. All rights reserved.
#
# @(#)pkgawt_win32.mk	1.17 99/11/15
#
# Makefile for the win32 part of awt.

BUILDDIRS += build/sun/awt/windows

####################
# exported variables
####################

ifeq ($(USETRUFFLE), true)
DEFINES += -DUSE_CRT_FPRINTF
else
AWTEXPORTS	= @exports_awt.lcf
MUSTLOAD 	+= -f $(PLAT_MDIR)/Mustload_$(PLATFORM)_awt
endif
AWTLINKLIBS 	= advapi32.lib gdi32.lib comdlg32.lib user32.lib
MUSTLOAD 	+= -load 'sun.awt.PlatformFont.<clinit>()V'

ifeq ($(USETRUFFLE), true)

###########
# Classes
###########

AWTJNIHEADERCLASSES += \
	sun.awt.gfW.CursorImageImpl \
	sun.awt.gfW.DefaultFontCharset \
	sun.awt.gfW.DrawableImageImpl \
	sun.awt.gfW.FontImpl \
	sun.awt.gfW.FontMetricsImpl \
	sun.awt.gfW.GraphicsImpl \
	sun.awt.gfW.GraphicsSystem \
	sun.awt.gfW.ScreenImpl \

AWTSTUBCLASSES += \

AWTPLATFORMCLASSES += \
	sun.awt.gfW.CursorImageImpl \
	sun.awt.gfW.DefaultFontCharset \
	sun.awt.gfW.DrawableImageImpl \
	sun.awt.gfW.FontImpl \
	sun.awt.gfW.FontMetricsImpl \
	sun.awt.gfW.GraphicsImpl \
	sun.awt.gfW.GraphicsSystem \
	sun.awt.gfW.ImageImpl \
	sun.awt.gfW.ScreenImpl \

############
# Objects
############

AWTPLATFORMOBJECTS += \
	CursorImageImpl.o \
	DefaultFontCharset.o \
	DrawableImageImpl.o \
	FontImpl.o \
	FontMetricsImpl.o \
	GraphicsImpl.o \
	GraphicsSystem.o \
	ImageRepresentation.o \
	OffScreenImageSource.o \
	ScreenImpl.o \
	SharedDC.o \
	\
	img_util.o \
	img_cvdirdefault.o \
	img_cvfsdefault.o \
	img_cvorddefault.o

else

########################
# AWTConfig_win32.java
########################
build/sun/awt/windows/AWTConfig_$(PLATFORM).java :: build/sun/awt/windows
	@echo Generate ... $@
	@(echo "/*" `date` " */";                               \
	echo "package sun.awt.windows;";                        \
	echo "class AWTConfig_$(PLATFORM) {";                   \
	echo "static final boolean minawt = $(MINAWT);";      \
	echo "}") > $@

###########
# Classes
###########

AWTSTUBCLASSES += \
	sun.awt.windows.WDefaultFontCharset \
	sun.awt.windows.WDrawingSurfaceInfo \
	sun.awt.windows.WButtonPeer \
	sun.awt.windows.WCanvasPeer \
	sun.awt.windows.WCheckboxPeer \
	sun.awt.windows.WCheckboxMenuItemPeer \
	sun.awt.windows.WChoicePeer \
	sun.awt.windows.WClipboard \
	sun.awt.windows.WColor \
        sun.awt.windows.WComponentPeer \
	sun.awt.windows.WDialogPeer \
	sun.awt.windows.WEmbeddedFrame \
	sun.awt.windows.WEmbeddedFramePeer \
	sun.awt.windows.WFileDialogPeer \
	sun.awt.windows.WFontPeer \
	sun.awt.windows.WFontMetrics \
	sun.awt.windows.WFramePeer \
	sun.awt.windows.WGraphics \
	sun.awt.windows.WImage \
        sun.awt.windows.WLabelPeer \
        sun.awt.windows.WListPeer \
	sun.awt.windows.WMenuBarPeer \
	sun.awt.windows.WMenuItemPeer \
	sun.awt.windows.WMenuPeer \
	sun.awt.windows.WObjectPeer \
	sun.awt.windows.WPopupMenuPeer \
	sun.awt.windows.WPrintJob \
	sun.awt.windows.WPrintGraphics \
        sun.awt.windows.WScrollbarPeer \
        sun.awt.windows.WScrollPanePeer \
        sun.awt.windows.WTextAreaPeer \
        sun.awt.windows.WTextComponentPeer \
        sun.awt.windows.WTextFieldPeer \
	sun.awt.windows.WPanelPeer \
        sun.awt.windows.WToolkit \
        sun.awt.windows.WWindowPeer

AWTPLATFORMCLASSES += \
	sun.awt.windows.AWTConfig_win32 \
	sun.awt.windows.WObjectPeer \
	sun.awt.windows.WComponentPeer \
	sun.awt.windows.WButtonPeer \
	sun.awt.windows.WCanvasPeer \
	sun.awt.windows.WCheckboxMenuItemPeer \
	sun.awt.windows.WCheckboxPeer \
	sun.awt.windows.WChoicePeer \
	sun.awt.windows.WClipboard \
	sun.awt.windows.WColor \
	sun.awt.windows.WDialogPeer \
	sun.awt.windows.WFileDialogPeer \
	sun.awt.windows.WFontMetrics \
	sun.awt.windows.WFramePeer \
	sun.awt.windows.WGraphics \
	sun.awt.windows.WImage \
	sun.awt.windows.WOffScreenImage \
	sun.awt.windows.WLabelPeer \
	sun.awt.windows.WListPeer \
	sun.awt.windows.WMenuBarPeer \
	sun.awt.windows.WMenuItemPeer \
	sun.awt.windows.WMenuPeer \
	sun.awt.windows.WPanelPeer \
	sun.awt.windows.WPopupMenuPeer \
	sun.awt.windows.WPrintJob \
	sun.awt.windows.WPrintGraphics \
	sun.awt.windows.WScrollPanePeer \
	sun.awt.windows.WScrollbarPeer \
	sun.awt.windows.WTextAreaPeer \
	sun.awt.windows.WTextComponentPeer \
	sun.awt.windows.WTextFieldPeer \
	sun.awt.windows.WToolkit \
	sun.awt.windows.WWindowPeer \
	sun.awt.windows.WFontPeer \
	sun.awt.windows.CharToByteWingDings \
	sun.awt.windows.WDefaultFontCharset \
	sun.awt.windows.WEmbeddedFrame \
	sun.awt.windows.WEmbeddedFramePeer \
	sun.awt.windows.WDrawingSurfaceInfo \
	sun.awt.Win32DrawingSurface \


############
# Objects
############

AWTPLATFORMOBJECTS = \
	CmdIDList.o \
	Hashtable.o \
	ObjectList.o \
	awt_Brush.o \
	awt_Button.o \
	awt_Canvas.o \
	awt_Checkbox.o \
	awt_Choice.o \
	awt_Clipboard.o \
	awt_Color.o \
	awt_Component.o \
	awt_Dialog.o \
	awt_DrawingSurface.o \
	awt_Font.o \
	awt_Frame.o \
	awt_Graphics.o \
	awt_Image.o \
	awt_Label.o \
	awt_List.o \
	awt_Menu.o \
	awt_MenuBar.o \
	awt_MenuItem.o \
	awt_Object.o \
	awt_PopupMenu.o \
	awt_Pen.o \
	awt_PrintJob.o \
	awt_Scrollbar.o \
	awt_ScrollPane.o \
	awt_TextArea.o \
	awt_TextComponent.o \
	awt_TextField.o \
	awt_Toolkit.o \
	awt_Unicode.o \
	awt_Window.o \
	awt_cvdirdefault.o \
	awt_cvd24IcmOpqUns.o \
	awt_cvd24DcmOpqUns.o \
	awt_cvd24IcmOpqScl.o \
	awt_cvd24DcmOpqScl.o \
	awt_cvd16IcmOpqUns.o \
	awt_cvd16DcmOpqUns.o \
	awt_cvd16IcmOpqScl.o \
	awt_cvd16DcmOpqScl.o \
	awt_cvorcdefault.o \
	awt_cvorcIcmOpqUns.o \
	awt_cvorcDcmOpqUns.o \
	awt_cvorcIcmOpqScl.o \
	awt_cvorcDcmOpqScl.o \
	awt_cvfscdefault.o \
	awt_cvfscIcmOpqScl.o \
	awt_cvfscDcmOpqScl.o \
	img_globals.o \
	gifdecoder.o \
	embeddedframe.o \
	winawt.res

ifeq ($(INCLUDEJAVAFILE), true)
AWTPLATFORMOBJECTS += \
	awt_FileDialog.o
endif

endif
