/*
 * @(#)CheckboxRadioButtonModel.java	1.1 98/10/22 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
package sun.awt.touchable;

import java.awt.*;
import java.awt.peer.*;
import sun.awt.otk.*;

class CheckboxRadioButtonModel extends CheckboxModel {
    private View alternateViews[];
    
    public CheckboxRadioButtonModel(Checkbox target, ObjectToolkit tk){
	super(target, tk);
    }
    
    public void setViews(View views[]) {
	alternateViews = views;
	setCheckboxGroup(getCheckboxGroup());
    }
    
    public void setDefaultView(View v){
	
	View dv = getDefaultView();
	Rectangle r = null;
	if (dv != null && v != dv){
	    dv.setVisible(false);
	    r = getDefaultView().getBounds(false);
	}
	
	super.setDefaultView(v);
	
	if (r != null){
	    setBounds(r.x, r.y, r.width, r.height);
	}
	
	v.setVisible(true);
    }


    public void setCheckboxGroup(CheckboxGroup g) {
	
	super.setCheckboxGroup(g);
	
	if (g == null) {
	    setDefaultView(alternateViews[0]);
	} else {
	    setDefaultView(alternateViews[1]);
	}
    }
}
