/*
 * @(#)ChoiceOwner.java	1.4 98/11/25 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
package sun.awt.touchable;

import sun.awt.otk.MenuItemOperations;

interface ChoiceOwner {
    /**
     * Called by a controller to initiate a choice action.  Should
     * cause any changes in visible state that are necessary, e.g.
     * popping up a menu.
     */
    void initiateChoice();

    /**
     * Check the state of the ChoiceOwner.  If a selection has been
     * initiated (probably via a call to initiateChoice()) and it has
     * not been completed or cancelled, this will return true.
     * @return true if a selection is in progress, false otherwise
     */
    boolean selectionInProgress();

    /**
     * Set the selection to the specified item.  This is called by a
     * controller as part of the selection operation.  passing null
     * will cause the selection to be aborted and the current choice
     * reverted to whatever it was last set to.
     */
    void selectChoice(MenuItemOperations item);
}
