/*
 * @(#)FrameView.java	1.8 98/08/28 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
package sun.awt.touchable;

import sun.porting.windowsystem.WindowFactory;
import java.awt.Rectangle;
import java.awt.Dimension;
import sun.awt.otk.*;

class FrameView extends TouchableContainerView {

    public FrameView(ComponentModel model,
		     ObjectToolkit toolkit,
		     ColorPolicy colors) {
	this(model, toolkit, colors, NULL_BOUNDS);
    }

    public FrameView(ComponentModel model,
		     ObjectToolkit toolkit,
		     ColorPolicy colors,
		     Rectangle bounds) {
	super(model, toolkit, null, colors, bounds,
	      WindowFactory.TOP_LEVEL_FRAME);

	Dimension screenSize = getToolkit().getScreenSize(); 
	super.setBounds(0, 0, screenSize.width, screenSize.height);
    }

    public void setBounds(int x, int y, int width, int height) {
	// This window's size is hardwired to the size of the screen
    }
}
