/*
 * @(#)KeyboardActivator.java	1.1 98/11/06 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 */
package sun.awt.touchable;

import sun.porting.toolkit.ToolkitEventHandler;
import sun.awt.otk.*;
import java.awt.*;
import java.awt.image.*;

public class KeyboardActivator extends VirtualKeyboardActivator implements ImageObserver {
    private Image image;

    public KeyboardActivator(ObjectToolkit tk, Image icon) {
	super(tk, null, new Rectangle(0, 0, 1, 1), new Insets(0, 0, 0, 0),
	      sun.porting.windowsystem.WindowFactory.TOP_LEVEL_FRAMELESS);

	this.image = icon;
	pack();
    }

    public Dimension getPreferredSize(int r, int c) {
	return new Dimension(image.getWidth(this), image.getHeight(this));
    }

    public Dimension getMinimumSize(int r, int c) {
	return getPreferredSize(r, c);
    }

    public void requestFocus()           { /* DON'T!!! */ }

    public void handleEvent(int id, long when, int modifiers,
			    int x, int y, int arg1, int arg2) {

	if (id == ToolkitEventHandler.WINDOW_DAMAGED) {
	    Graphics g = getGraphics();
	    g.drawImage(image, 0, 0, this);
	    g.dispose();
	} else if (id == ToolkitEventHandler.POINTER_RELEASED) {
	    /* if we see the release, we must have gotten the press also */
	    if (   (x >= 0) && (x < image.getWidth(this))
		&& (y >= 0) && (y < image.getHeight(this))) {
		/* the release was inside the window */
		showKeyboard();
	    }
	}
    }

    public boolean imageUpdate(Image img, int infoflags,
			       int x, int y, int w, int h) {
	return ((infoflags & ImageObserver.ALLBITS) != 0);
    }
}
