/*
 *  @(#)LabelColorPolicy.java	1.3 98/10/22 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package sun.awt.touchable;

import java.awt.*;
import sun.awt.otk.*;

/* This Color policy is basic for all peers but is
 * final for Label, ScrollPane, Canvas, Panel, Window, 
 * TextField, TextArea
 */
class LabelColorPolicy extends BasicColorPolicy{



    LabelColorPolicy(Color bg, Color hiliteBg, Color inactiveBg,
		     Color fg, Color hiliteFg, Color inactiveFg,
		     Color eraseColor, boolean getEraseFromParent){
	super(bg, hiliteBg, inactiveBg, fg, hiliteFg, inactiveFg,
	      eraseColor, getEraseFromParent);
    }

    public Color getBackground(Model m, boolean pressed,
			boolean enabled, boolean unused){
 
	if (pressed){
	    return hiliteBg;
	} else if (!enabled){
	    return inactiveBg;
	} else if (enabled && m instanceof ComponentModel){
	    Color bgColor = ((ComponentModel)m).getRealBackground();
	    if (bgColor != null){
		return bgColor;
	    }
	    if (m instanceof ComponentModel){
		Color erase = ((ComponentModel)m).getParentBackground();
		if (erase != null){
		    return erase;
		}
	    }
	}

	return bg;
    }
}
