/*
 * @(#)MenuSoundController.java	1.2 98/11/18 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
package sun.awt.touchable;
import sun.awt.otk.DragMenu;
import sun.awt.otk.SimpleController;
import sun.awt.otk.View;
import sun.porting.toolkit.ToolkitEventHandler;

public class MenuSoundController extends SimpleController {
    static MenuSoundController instance = null;

    public synchronized static MenuSoundController getController() {
	if (instance == null) {
	    instance = new MenuSoundController();
	}

	return instance;
    }

    public boolean handleEvent(View v,
			       int id, long when, int modifiers,
			       int x, int y, int arg1, int arg2) {

	DragMenu d = (DragMenu) v;
	if ((id == ToolkitEventHandler.POINTER_PRESSED) && (arg1 >= 0)) {
	    if (d.insideMenu(x, y)) {
		Sounds.play(Sounds.MOUSE_PRESS);
	    } else {
		// This is not desirable.  Dismissing may need its own sound.
		// Sounds.play(Sounds.UNSWISH);
	    }
	}

	return false;
    }
}
