/*
 * @(#)OutlinedColorPolicy.java	1.3 98/07/30 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package sun.awt.touchable;

import java.awt.*;
import sun.awt.otk.ComponentModel;

/* This Color policy is used by several peers but is
 * final for Dialog, Choice, Menu, Text pop-up, Button, Ctl buttons
 */
class OutlinedColorPolicy extends BasicColorPolicy{

    Color outline1       = null;
    Color hiliteOutline1 = null;

    Color outline2       = null;
    Color hiliteOutline2 = null;

    OutlinedColorPolicy(Color bg, Color hiliteBg, Color inactiveBg, 
			Color fg, Color hiliteFg, Color inactiveFg,
			Color outline1, Color hiliteOutline1,
			Color outline2, Color hiliteOutline2,
			Color eraseColor, boolean getEraseFromParent){

	super(bg, hiliteBg, inactiveBg, 
	      fg, hiliteFg, inactiveFg,
	      eraseColor, getEraseFromParent);

	this.outline1       = outline1;
	this.hiliteOutline1 = hiliteOutline1;
	this.outline2       = outline2;
	this.hiliteOutline2 = hiliteOutline2;
    }

    Color getOutline1(boolean pressed, boolean enabled){
	if (pressed){
	    return hiliteOutline1;
	}
	return null;
    }


    Color getOutline2(boolean pressed, boolean enabled){
	if (!pressed && enabled){
	    return outline2;
	}
	return null;
    }
}
