/*
 * @(#)Palette.java	1.19 98/12/03 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
package sun.awt.touchable;
import java.awt.Color;
import java.awt.SystemColor;

class Palette {
    //Colors
    protected static final Color  dot_light        = Color.white;
    protected static final Color  dot_dark         = Color.black;

    // Scroll pane
    protected static final BasicColorPolicy SCROLL_PANE_COLORS =
                       new BasicColorPolicy(SystemColor.menu, 
					    SystemColor.menu,
					    SystemColor.menu,
					    SystemColor.menu,
					    SystemColor.menu,
    					    SystemColor.menu,
					    SystemColor.desktop, true); //
    // Horizontal list colors
    protected static final BasicColorPolicy HList_COLORS =
                       new BasicColorPolicy(SystemColor.control, 
					    SystemColor.controlHighlight,
					    SystemColor.controlShadow,
					    SystemColor.controlText,
					    SystemColor.textHighlightText,
    					    SystemColor.textInactiveText,
					    SystemColor.desktop, true); //


    // Virtual Keyboard
    protected static final BasicColorPolicy VK_COLORS =
                    new BasicColorPolicy(SystemColor.control, 
					 SystemColor.controlHighlight,
					 SystemColor.controlShadow,
					 SystemColor.controlText,
					 SystemColor.textHighlightText,
					 SystemColor.textInactiveText,
					 SystemColor.menu,
					 true);


    // used by Canvas, Container, Panel, Window, Frame
    // Label
    protected static final LabelColorPolicy DEF_COLORS =
                       new LabelColorPolicy(SystemColor.desktop, 
					    SystemColor.desktop,
					    SystemColor.desktop,
					    SystemColor.controlText,
					    SystemColor.textHighlightText,
    					    SystemColor.textInactiveText,
					    SystemColor.desktop, false); //

    // Vertical List
    protected static final GroupingColorPolicy VList_COLORS =
                    new GroupingColorPolicy(SystemColor.control, 
					    SystemColor.controlHighlight,
					    SystemColor.controlShadow,
					    SystemColor.controlText,
					    SystemColor.textHighlightText,
    					    SystemColor.textInactiveText,
					    SystemColor.menu,
					    SystemColor.desktop, true); //
   // Choice
    protected static final GroupingColorPolicy CHOICE_COLORS =
                    new GroupingColorPolicy(SystemColor.control, 
					    SystemColor.controlHighlight,
					    SystemColor.controlShadow,
					    SystemColor.controlText,
					    SystemColor.textHighlightText,
    					    SystemColor.textInactiveText,
					    SystemColor.controlHighlight, 
					    SystemColor.desktop, true);  //

   // Menu
    protected static final GroupingColorPolicy MENU_COLORS =
                    new GroupingColorPolicy(SystemColor.menu, 
					    SystemColor.controlHighlight,
					    SystemColor.menu,
					    SystemColor.controlText,
					    SystemColor.textHighlightText,
    					    SystemColor.textInactiveText,
					    SystemColor.textHighlight, 
					    SystemColor.menu, false); //

   // Dialog
    protected static final GroupingColorPolicy DIALOG_COLORS =
                    new GroupingColorPolicy(SystemColor.window, 
					    null,
					    null,
					    SystemColor.controlText,
					    null,
    					    null,
					    SystemColor.textHighlight,
					    SystemColor.window, false);  //

    //Text area
    protected static final BasicColorPolicy TA_COLORS =
                       new BasicColorPolicy(SystemColor.desktop, 
					    SystemColor.desktop,
					    SystemColor.desktop,
					    SystemColor.controlText,
					    SystemColor.textHighlightText,
    					    SystemColor.textInactiveText,
					    SystemColor.desktop, true);

    // Text Pane for Text field and Text area
    protected static final TextPaneColorPolicy TEXT_PANE_COLORS =
                    new TextPaneColorPolicy(SystemColor.menu, 
					    SystemColor.controlHighlight,
					    SystemColor.menu,
					    SystemColor.textText,
					    SystemColor.textHighlightText,
    					    SystemColor.textInactiveText,
					    SystemColor.textHighlight,
					    SystemColor.textHighlight,
					    SystemColor.textInactiveText,
					    SystemColor.control,
					    SystemColor.controlHighlight,
					    SystemColor.textInactiveText,
					    SystemColor.menu, true, true); //

    //Text Pane for Virtual keyboard and text popup
    protected static final TextPaneColorPolicy TEXTPOPUP_TEXTPANE_COLORS =
                    new TextPaneColorPolicy(SystemColor.menu, 
					    SystemColor.controlHighlight,
					    SystemColor.menu,
					    SystemColor.textText,
					    SystemColor.textHighlightText,
    					    SystemColor.textInactiveText,
					    SystemColor.textHighlight,
					    SystemColor.textHighlight,
					    SystemColor.textInactiveText,
					    SystemColor.control,
					    SystemColor.controlHighlight,
					    SystemColor.textInactiveText,
					    SystemColor.menu, false, false);
 
   // Button
    protected static final OutlinedColorPolicy BUTTON_COLORS =
                    new OutlinedColorPolicy(SystemColor.control, 
					    SystemColor.controlHighlight,
					    SystemColor.controlShadow,
					    SystemColor.controlText,
					    SystemColor.textHighlightText,
    					    SystemColor.textInactiveText,
					    null, // control
					    SystemColor.controlLtHighlight,
					    SystemColor.controlDkShadow,
					    null, // controlHighlight
					    SystemColor.desktop, true);  //

   // Ctrl Buttons
    protected static final OutlinedColorPolicy CTRLS_COLORS =
                    new OutlinedColorPolicy(SystemColor.menu, 
					    SystemColor.menu,
					    SystemColor.menu,
					    SystemColor.control,
					    SystemColor.controlHighlight,
    					    SystemColor.controlShadow,
					    null, // control
					    SystemColor.controlLtHighlight,
					    SystemColor.controlDkShadow,
					    null, // controlHighlight
					    SystemColor.desktop, true);  //

   // Menu arrows Buttons
    protected static final OutlinedColorPolicy MENU_ARROW_COLORS =
                    new OutlinedColorPolicy(SystemColor.window, 
					    SystemColor.window,
					    SystemColor.window,
					    SystemColor.control,
					    SystemColor.controlHighlight,
    					    SystemColor.controlShadow,
					    null, // control
					    SystemColor.controlLtHighlight,
					    SystemColor.controlDkShadow,
					    null, // controlHighlight
					    SystemColor.desktop, true);  //

   // Checkbox/Radio button
    protected static final TwoForegroundColorPolicy CHECKBOX_COLORS =
               new TwoForegroundColorPolicy(SystemColor.control, 
					    SystemColor.controlHighlight,
					    SystemColor.controlShadow,
					    SystemColor.controlText,
					    SystemColor.textHighlightText,
    					    SystemColor.textInactiveText,
					    SystemColor.control,
					    SystemColor.controlLtHighlight,
					    SystemColor.controlDkShadow,
					    SystemColor.controlHighlight,
					    SystemColor.controlText,
					    SystemColor.controlText,
    					    SystemColor.textInactiveText, 	
					    SystemColor.desktop, true);  //
}
