/*
 * @(#)RadioButtonView.java	1.17 98/11/25 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
package sun.awt.touchable;

import java.awt.*;
import sun.awt.otk.*;

class RadioButtonView extends CheckboxView {
    public RadioButtonView(ComponentModel model,
			   ObjectToolkit toolkit,
			   ContainerView parent,
			   ColorPolicy colors) {
	this(model, toolkit, parent, colors, NULL_BOUNDS);
    }

    public RadioButtonView(ComponentModel model,
			   ObjectToolkit toolkit,
			   ContainerView parent,
			   ColorPolicy colors,
			   Rectangle bounds) {
	super(model, toolkit, parent, colors, bounds);
    }


    public void performAction() {
	CheckboxModel model  = (CheckboxModel) getModel();
	if (model.getCheckboxGroup() != null && model.getState()){
	    return;
	}
	super.performAction();
    }

    protected void paintCheckboxBackground(Graphics g, int height,
					   ColorPolicy colors, 
					   CheckboxModel cm, 
					   boolean pressed, boolean active) {
	DrawUtils.paintRoundRect(g, DrawUtils.INTER_ELEM_PAD, 
				 (height - DrawUtils.RADIO_BUTTON_SIZE)/2, 
				 DrawUtils.RADIO_BUTTON_SIZE, 
				 DrawUtils.RADIO_BUTTON_SIZE, 
				 DrawUtils.RB_ARC_WIDTH,
				 DrawUtils.RB_ARC_HEIGHT,
				 colors, cm, pressed, active);
    }

    protected void paintCheckboxGraphic(Graphics g, boolean checked, 
					int height, Color fg) {
	if (checked) {
	    g.setColor(fg);
	    int x = DrawUtils.INTER_ELEM_PAD +
		     (DrawUtils.RADIO_BUTTON_SIZE-DrawUtils.RB_BLOB_SIZE)/2;
	    int y = (height - DrawUtils.RB_BLOB_SIZE)/2;
	    g.fillRoundRect(x, y, 
			    DrawUtils.RB_BLOB_SIZE,
			    DrawUtils.RB_BLOB_SIZE,
			    DrawUtils.RB_BLOB_ARC_SIZE,
			    DrawUtils.RB_BLOB_ARC_SIZE);
	}
    }

    protected synchronized void fontChanged(Model m, Font f, FontMetrics fm) {
	/* recalculate the preferred size */
	String label = ((CheckboxModel)m).getLabel();
	minSize = DrawUtils.getCheckboxMinimumSize(label, fm, 
		     			   DrawUtils.RADIO_BUTTON_SIZE);

	repaintAll(m, getBounds());
    }
}

