/*
 * @(#)ScrollerView.java	1.5 98/09/14 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package sun.awt.touchable;

import java.awt.*;
import java.awt.event.AdjustmentListener;
import sun.awt.otk.AdjustableObject;
import sun.awt.otk.BasicView;
import sun.awt.otk.ColorPolicy;

class ScrollerView extends ScrollbarView{

    ScrollerView(BasicView view, ColorPolicy colors,
		 boolean  enabled, int orientation, 
		 int min, int max, int vis, int unitIncr){

	this(view, colors, enabled, orientation, 
	     min, max, vis, unitIncr, DrawUtils.INTER_ELEM_PAD);
    }
    
    ScrollerView(BasicView view, ColorPolicy colors, 
		 boolean  enabled, int orientation, 
		 int min, int max, int vis, int unitIncr,
		 int inter_button_pad){

	super(view, colors,
	      (Adjustable)(new AdjustableObject(orientation,
						min, max, vis)), 
	      enabled, inter_button_pad);
	adj.setUnitIncrement(unitIncr);
	adj.addAdjustmentListener((AdjustmentListener)view);
    }

    void setSpan(int min, int max, int vis){
	adj.setMinimum(min);
	adj.setMaximum(max);
	adj.setVisibleAmount(vis);
	updateEnabled();
    }
    
    int getValue(){
	return adj.getValue();
    }

    void setValue(int value){
	adj.setValue(value);
    }
    
}
