/*
 * @(#)TextPaneColorPolicy.java	1.4 98/12/03 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package sun.awt.touchable;

import java.awt.*;
import sun.awt.otk.Model;

/* This Color policy is used for TextPane
 */
class TextPaneColorPolicy extends BasicColorPolicy{

    Color underline         = null;
    Color hiliteUnderline   = null;
    Color inactiveUnderline = null;
    Color affordance        = null;
    Color hiliteAffordance  = null;
    Color inactiveAffordance = null;
    boolean checkModel       = true;

    TextPaneColorPolicy(Color bg, Color hiliteBg, Color inactiveBg,
			Color fg, Color hiliteFg, Color inactiveFg,
		        Color underline, Color hiliteUnderline, 
			Color inactiveUnderline,
			Color affordance, Color hiliteAffordance,
			Color inactiveAffordance,
			Color eraseColor, 
			boolean checkModel,
			boolean getEraseFromParent){

	super(bg, hiliteBg, inactiveBg, 
	      fg, hiliteFg, inactiveFg,
	      eraseColor, getEraseFromParent);

	this.underline       = underline;
	this.hiliteUnderline = hiliteUnderline;
	this.inactiveUnderline = inactiveUnderline;
	
	this.affordance = affordance;
	this.hiliteAffordance = hiliteAffordance;
	this.inactiveAffordance = inactiveAffordance;

	this.checkModel = checkModel;
    }

    public Color getForeground(Model m, boolean pressed,
			       boolean enabled, boolean unused){
	if (!checkModel){
	    m = null;
	}
	
	return super.getForeground(m, pressed, enabled, unused);
    }

    public Color getBackground(Model m, boolean pressed,
			       boolean enabled, boolean unused){
	if (!checkModel){
	    m = null;
	}
	return super.getBackground(m, pressed, enabled, unused);
    }

    public Color getEraseColor(Model m, boolean pressed,
			       boolean enabled, boolean unused){
	if (!checkModel){
	    m = null;
	}
	return super.getEraseColor(m, pressed, enabled, unused);
    }
    
    public Color getUnderline(boolean selected, boolean enabled){
	if (selected){
	    return hiliteUnderline;
	} else if (!enabled){
	    return inactiveUnderline;
	}

	return underline;
    }

    public Color getAffordance(boolean selected, boolean enabled) {
	if (selected){
	    return hiliteAffordance;
	} else if (!enabled){
	    return inactiveAffordance;
	}

	return affordance;
    }
}
