/*
 * @(#)TouchableVirtualStickyKey.java	1.12 98/11/19 SMI
 * 
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 *
 */

package sun.awt.touchable;

import java.awt.*;
import sun.awt.otk.*;

/**
 *
 * @version 1.12, 11/19/98
 * @author Sun Microsystems, Inc.
 */

public class TouchableVirtualStickyKey extends TouchableVirtualToggleKey {

    public TouchableVirtualStickyKey(String keyCap, char keyChar, int keyCode,
				     int modes, int mask,
				     Rectangle bounds) {
	super(keyCap, keyChar, keyCode, modes, mask, bounds);
    }

    protected boolean getLockValue() {
	return false;
    }

    public void keyPressed() {
	// are my flags already set?
	if (getVKSet().getModifiers(getMask())) {
	    return;  // if yes then don't allow any pressing
	}
	super.keyPressed();
    }

    public void stickyRelease() {
	if (!isPressed()) {
	    return;
	}

	super.reset();

	VirtualKeySet vkSet = getVKSet();
	if (!vkSet.clearModifier(getMask(), getLockValue())) {
	    vkSet.updateDependent(this);
	}
    }
}
