/*
 * @(#)TouchableVirtualToggleKey.java	1.15 98/11/19 SMI
 * 
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 *
 */
package sun.awt.touchable;

import java.awt.*;
import sun.awt.otk.*;

public class TouchableVirtualToggleKey extends TouchableVirtualKey {

    protected int mask;
    protected boolean isToggled;

    public TouchableVirtualToggleKey(String keyCap, char keyChar, int keyCode,
				     int mask, int modes, Rectangle bounds) {
	super(keyCap, keyChar, keyCode, modes, bounds);
	this.mask = mask;
    }

    public int getMask() {
	return mask;
    }

    protected boolean getLockValue() {
	return true;
    }

    public void keyPressed() {
	VirtualKeySet vkSet = getVKSet();
	vkSet.addModifier(getMask(), getLockValue());
	super.keyPressed();
    }

    public void keyReleased() {
	VirtualKeySet vkSet = getVKSet();
	vkSet.clearModifier(getMask(), getLockValue());
	super.keyReleased();
    }

    public void pointerPressed() {
	if (!isPressed()) {
	    super.pointerPressed();
	}
    }

    public void pointerReleased() {
	if (isToggled) {
	    super.pointerReleased();
	    isToggled = false;
	} else {
	    isToggled = true;
	}
    }

    public void reset() {
	super.reset();
	isToggled = false;
    }

    public boolean update() {
	if (super.update()) {
	    return true;
	}
	getVKSet().updateDependent(this);
	return true;
    }
}
