/*
 * @(#)TwoForegroundColorPolicy.java	1.2 98/07/24 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package sun.awt.touchable;

import java.awt.*;
import sun.awt.otk.ComponentModel;

/* This Color policy is used Checkbox and Radio button
 */
class TwoForegroundColorPolicy extends OutlinedColorPolicy{

    Color label         = null;
    Color hiliteLabel   = null;
    Color inactiveLabel = null;

    TwoForegroundColorPolicy(Color bg, Color hiliteBg, Color inactiveBg,
			    Color fg, Color hiliteFg, Color inactiveFg,
			    Color outline1, Color hiliteOutline1,
			    Color outline2, Color hiliteOutline2,
			    Color label, Color hiliteLabel, Color inactiveLabel,
			    Color eraseColor, boolean getEraseFromParent){

	super(bg, hiliteBg, inactiveBg,
	      fg, hiliteFg, inactiveFg,
	      outline1, hiliteOutline1,
	      outline2, hiliteOutline2,
	      eraseColor, getEraseFromParent);

	this.label         = label;
	this.hiliteLabel   = hiliteLabel;
	this.inactiveLabel = inactiveLabel;
    }

    Color getLabelColor(boolean enabled){
	if (!enabled){
	    return inactiveLabel;
	}
	return label;
    }
}
