/*
 * @(#)VirtualKeyboard_en_US_QWERTY_1.java	1.16 98/11/25 SMI
 * 
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 *
 */

package sun.awt.touchable;

import java.util.Locale;
import java.awt.Rectangle;
import java.awt.event.KeyEvent;
import sun.awt.otk.VirtualKey;
import sun.awt.otk.VirtualKeySet;
import java.util.ListResourceBundle;


public class VirtualKeyboard_en_US_QWERTY_1 extends ListResourceBundle {

    private static final int KEY_HEIGHT  = DrawUtils.VKEY_HEIGHT;
    private static final int KEY_WIDTH   = DrawUtils.VKEY_WIDTH;
    private static final int KEY_PAD     = DrawUtils.VKEY_PAD;

    private static final int ROW0 = 0;
    private static final int ROW1 = ROW0 + KEY_HEIGHT + KEY_PAD;
    private static final int ROW2 = ROW0 + 2*(KEY_HEIGHT + KEY_PAD) + KEY_PAD;
    private static final int ROW3 = ROW0 + 3*(KEY_HEIGHT + KEY_PAD) + KEY_PAD;
    private static final int ROW4 = ROW0 + 4*(KEY_HEIGHT + KEY_PAD) + KEY_PAD;
    private static final int ROW5 = ROW0 + 5*(KEY_HEIGHT + KEY_PAD) + 2*KEY_PAD;

    private static final int COLUMN0 = 0;
    private static final int COLUMN1 = COLUMN0 + KEY_WIDTH + KEY_PAD;
    private static final int COLUMN2 = COLUMN0 + 2*(KEY_WIDTH + KEY_PAD);
    private static final int COLUMN3 = COLUMN0 + 3*(KEY_WIDTH + KEY_PAD);
    private static final int COLUMN4 = COLUMN0 + 4*(KEY_WIDTH + KEY_PAD);
    private static final int COLUMN5 = COLUMN0 + 5*(KEY_WIDTH + KEY_PAD);
    private static final int COLUMN6 = COLUMN0 + 6*(KEY_WIDTH + KEY_PAD);
    private static final int COLUMN7 = COLUMN0 + 7*(KEY_WIDTH + KEY_PAD);
    private static final int COLUMN8 = COLUMN0 + 8*(KEY_WIDTH + KEY_PAD);
    private static final int COLUMN9 = COLUMN0 + 9*(KEY_WIDTH + KEY_PAD);
    private static final int COLUMN10 = COLUMN0 + 10*(KEY_WIDTH + KEY_PAD);
    private static final int COLUMN11 = COLUMN0 + 11*(KEY_WIDTH + KEY_PAD);

    private static final int COLUMN12 = COLUMN0 + 12*(KEY_WIDTH + KEY_PAD) + 3*KEY_PAD;
    private static final int COLUMN13 = COLUMN0 + 13*(KEY_WIDTH + KEY_PAD) + 3*KEY_PAD;
    private static final int COLUMN14 = COLUMN0 + 14*(KEY_WIDTH + KEY_PAD) + 3*KEY_PAD;

    public Object[][] getContents() {

	//System.err.println("contents = " + contents);
	//System.err.println("keys = " + keys);
	return contents;
    }

    //private VirtualKeySetSettings settings();

    private VirtualKey keys[] = {
	// ROW 0
	new TouchableVirtualKey("Tab", '\t', KeyEvent.VK_TAB,
				TouchableVirtualKeySet.SHIFT_MODE,
				new Rectangle(COLUMN0, ROW0,
					      2*KEY_WIDTH + KEY_PAD, KEY_HEIGHT)),
	new TouchableVirtualKey("1", '1', KeyEvent.VK_1,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN2, ROW0,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("2", '2', KeyEvent.VK_2,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN3, ROW0, 
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("3", '3', KeyEvent.VK_3,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN4, ROW0,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("4", '4', KeyEvent.VK_4,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN5, ROW0,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("5", '5', KeyEvent.VK_5,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN6, ROW0,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("6", '6', KeyEvent.VK_6,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN7, ROW0,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("7", '7', KeyEvent.VK_7,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN8, ROW0,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("8", '8', KeyEvent.VK_8,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN9, ROW0,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("9", '9', KeyEvent.VK_9,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN10, ROW0,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("0", '0', KeyEvent.VK_0,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN11, ROW0,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("<", '<', KeyEvent.VK_COMMA,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN12, ROW0,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey(">", '>', KeyEvent.VK_PERIOD,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN13, ROW0,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("+", '+', KeyEvent.VK_ADD,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN14, ROW0,
					      KEY_WIDTH, KEY_HEIGHT)),

	// ROW 1
	new TouchableVirtualKey("!", '!', KeyEvent.VK_1,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN0, ROW1,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("@", '@', KeyEvent.VK_UNDEFINED,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN1, ROW1,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("#", '#', KeyEvent.VK_UNDEFINED,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN2, ROW1,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("$", '$', KeyEvent.VK_UNDEFINED,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN3, ROW1,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("%", '%', KeyEvent.VK_UNDEFINED,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN4, ROW1,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("^", '^', KeyEvent.VK_UNDEFINED,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN5, ROW1,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("&", '&', KeyEvent.VK_UNDEFINED,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN6, ROW1,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("*", '*', KeyEvent.VK_UNDEFINED,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN7, ROW1,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("_", '_', KeyEvent.VK_UNDEFINED,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN8, ROW1,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("Backspace", '\u0008', KeyEvent.VK_BACK_SPACE,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN9, ROW1,
					      3*KEY_WIDTH + 2*KEY_PAD, KEY_HEIGHT)),
	new TouchableVirtualKey("[", '[', KeyEvent.VK_OPEN_BRACKET,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN12, ROW1,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("]", ']', KeyEvent.VK_CLOSE_BRACKET,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN13, ROW1,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("\\", '\\', KeyEvent.VK_BACK_SLASH,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN14, ROW1,
					      KEY_WIDTH, KEY_HEIGHT)),

	// ROW 2
	new TouchableVirtualKey("Q", 'q', KeyEvent.VK_Q,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN0, ROW2,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("W", 'w', KeyEvent.VK_W,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN1, ROW2,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("E", 'e', KeyEvent.VK_E,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN2, ROW2,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("R", 'r', KeyEvent.VK_R,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN3, ROW2,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("T", 't', KeyEvent.VK_T,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN4, ROW2,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("Y", 'y', KeyEvent.VK_Y,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN5, ROW2,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("U", 'u', KeyEvent.VK_U,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN6, ROW2,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("I", 'i', KeyEvent.VK_I,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN7, ROW2,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("O", 'o', KeyEvent.VK_O,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN8, ROW2,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("P", 'p', KeyEvent.VK_P,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN9, ROW2,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("\'", '\'', KeyEvent.VK_QUOTE,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN10, ROW2,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("\"", '\"', KeyEvent.VK_QUOTE,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN11, ROW2,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("(", '(', KeyEvent.VK_9,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN12, ROW2 - KEY_PAD,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey(")", ')', KeyEvent.VK_0,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN13, ROW2 - KEY_PAD,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("=", '=', KeyEvent.VK_UNDEFINED,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN14, ROW2 - KEY_PAD,
					      KEY_WIDTH, KEY_HEIGHT)),

	// ROW 3
	new TouchableVirtualKey("A", 'a', KeyEvent.VK_A,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN0, ROW3,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("S", 's', KeyEvent.VK_S,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN1, ROW3,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("D", 'd', KeyEvent.VK_D,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN2, ROW3,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("F", 'f', KeyEvent.VK_F,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN3, ROW3,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("G", 'g', KeyEvent.VK_G,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN4, ROW3,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("H", 'h', KeyEvent.VK_H,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN5, ROW3,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("J", 'j', KeyEvent.VK_J,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN6, ROW3,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("K", 'k', KeyEvent.VK_K,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN7, ROW3,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("L", 'l', KeyEvent.VK_L,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN8, ROW3,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("-", '-', KeyEvent.VK_UNDEFINED,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN9, ROW3,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey(":", ':', KeyEvent.VK_SEMICOLON,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN10, ROW3,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey(";", ';', KeyEvent.VK_SEMICOLON,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN11, ROW3,
					      KEY_WIDTH, KEY_HEIGHT)),

	// ROW 4
	new TouchableVirtualKey("Z", 'z', KeyEvent.VK_Z,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN0, ROW4,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("X", 'x', KeyEvent.VK_X,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN1, ROW4,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("C", 'c', KeyEvent.VK_C,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN2, ROW4,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("V", 'v', KeyEvent.VK_V,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN3, ROW4,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("B", 'b', KeyEvent.VK_B,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN4, ROW4,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("N", 'n', KeyEvent.VK_N,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN5, ROW4,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("M", 'm', KeyEvent.VK_M,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN6, ROW4,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("~", '~', KeyEvent.VK_UNDEFINED,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN7, ROW4,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey(",", ',', KeyEvent.VK_COMMA,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN8, ROW4,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey(".", '.', KeyEvent.VK_PERIOD,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN9, ROW4,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("?", '?', KeyEvent.VK_SLASH,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN10, ROW4,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("/", '/', KeyEvent.VK_SLASH,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN11, ROW4,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualArrowKey(KeyEvent.VK_UP,
				TouchableVirtualKeySet.SHIFT_MODE |
				     TouchableVirtualKeySet.SINGLE_LINE_MODE,
				     new Rectangle(COLUMN13, ROW4 + KEY_PAD, 
					      KEY_WIDTH, KEY_HEIGHT)),

	// ROW 5
	new TouchableVirtualStickyKey("Shift", KeyEvent.CHAR_UNDEFINED,
				      KeyEvent.VK_SHIFT,
				      TouchableVirtualKeySet.SHIFT_MODE,
				      TouchableVirtualKeySet.SHIFT_MODE |
				      TouchableVirtualKeySet.SINGLE_LINE_MODE,
				      new Rectangle(COLUMN0, ROW5,
						    2*KEY_WIDTH + KEY_PAD, KEY_HEIGHT)),
	new TouchableVirtualToggleKey("Caps", KeyEvent.CHAR_UNDEFINED,
				      KeyEvent.VK_CAPS_LOCK,
				      TouchableVirtualKeySet.SHIFT_MODE,
				      TouchableVirtualKeySet.SHIFT_MODE |
				      TouchableVirtualKeySet.SINGLE_LINE_MODE,
				      new Rectangle(COLUMN2, ROW5,
						    2*KEY_WIDTH + KEY_PAD, KEY_HEIGHT)),
	new TouchableVirtualKey("Space", ' ', KeyEvent.VK_SPACE,
				TouchableVirtualKeySet.SHIFT_MODE |
				TouchableVirtualKeySet.SINGLE_LINE_MODE,
				new Rectangle(COLUMN4, ROW5,
					      6*KEY_WIDTH + 5*KEY_PAD, KEY_HEIGHT)),

	new TouchableVirtualKey("Return", '\r', KeyEvent.VK_ENTER,
				TouchableVirtualKeySet.SHIFT_MODE,
				new Rectangle(COLUMN10, ROW5, 
					      2*KEY_WIDTH + KEY_PAD, KEY_HEIGHT)),
	new TouchableVirtualArrowKey(KeyEvent.VK_LEFT,
				TouchableVirtualKeySet.SHIFT_MODE |
				     TouchableVirtualKeySet.SINGLE_LINE_MODE,
				     new Rectangle(COLUMN12, ROW5,
						   KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualArrowKey(KeyEvent.VK_DOWN,
				TouchableVirtualKeySet.SHIFT_MODE |
				     TouchableVirtualKeySet.SINGLE_LINE_MODE,
				     new Rectangle(COLUMN13, ROW5,
						   KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualArrowKey(KeyEvent.VK_RIGHT,
				TouchableVirtualKeySet.SHIFT_MODE |
				     TouchableVirtualKeySet.SINGLE_LINE_MODE,
				     new Rectangle(COLUMN14, ROW5,
						   KEY_WIDTH, KEY_HEIGHT))
    };

    private Object[][] contents = {
	{"settings", "null" /*settings*/},
	{"keys", keys}
    };

}
