/*
 * @(#)VirtualKeyboard_en_US_QWERTY_1.java	1.11 98/10/13 SMI
 * 
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 *
 */

package sun.awt.touchable;

import java.util.Locale;
import java.awt.Rectangle;
import java.awt.event.KeyEvent;
import java.awt.event.InputEvent;
import java.util.ListResourceBundle;
import sun.awt.otk.VirtualKey;


public class VirtualKeyboard_ja_JP_GOJUUON extends ListResourceBundle {

    private static final int KEY_HEIGHT  = DrawUtils.VKEY_HEIGHT;
    private static final int KEY_WIDTH   = DrawUtils.VKEY_WIDTH;
    private static final int KEY_PAD     = DrawUtils.VKEY_PAD;

    private static final int ROW0 = 0;
    private static final int ROW1 = ROW0 + KEY_HEIGHT + KEY_PAD;
    private static final int ROW2 = ROW0 + 2*(KEY_HEIGHT + KEY_PAD);
    private static final int ROW3 = ROW0 + 3*(KEY_HEIGHT + KEY_PAD);
    private static final int ROW4 = ROW0 + 4*(KEY_HEIGHT + KEY_PAD);
    private static final int ROW5 = ROW0 + 5*(KEY_HEIGHT + KEY_PAD) + KEY_PAD;

    private static final int COLUMN0 = 0;
    private static final int COLUMN1 = COLUMN0 + KEY_WIDTH + KEY_PAD;
    private static final int COLUMN2 = COLUMN0 + 2*(KEY_WIDTH + KEY_PAD);
    private static final int COLUMN3 = COLUMN0 + 3*(KEY_WIDTH + KEY_PAD);
    private static final int COLUMN4 = COLUMN0 + 4*(KEY_WIDTH + KEY_PAD);
    private static final int COLUMN5 = COLUMN0 + 5*(KEY_WIDTH + KEY_PAD);
    private static final int COLUMN6 = COLUMN0 + 6*(KEY_WIDTH + KEY_PAD);
    private static final int COLUMN7 = COLUMN0 + 7*(KEY_WIDTH + KEY_PAD);
    private static final int COLUMN8 = COLUMN0 + 8*(KEY_WIDTH + KEY_PAD);
    private static final int COLUMN9 = COLUMN0 + 9*(KEY_WIDTH + KEY_PAD);
    private static final int COLUMN10 = COLUMN0 + 10*(KEY_WIDTH + KEY_PAD);
    private static final int COLUMN11 = COLUMN0 + 11*(KEY_WIDTH + KEY_PAD);

    private static final int COLUMN12 = COLUMN0 + 12*(KEY_WIDTH + KEY_PAD) + 3*KEY_PAD;
    private static final int COLUMN13 = COLUMN0 + 13*(KEY_WIDTH + KEY_PAD) + 3*KEY_PAD;
    private static final int COLUMN14 = COLUMN0 + 14*(KEY_WIDTH + KEY_PAD) + 3*KEY_PAD;

    public Object[][] getContents() {

	//System.err.println("contents = " + contents);
	//System.err.println("keys = " + keys);
	return contents;
    }

    //private VirtualKeySetSettings settings();

    private VirtualKey keys[] = {

	// ROW 0
	new TouchableVirtualKey("(", '(', KeyEvent.VK_9,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN0, ROW0,
					      KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualToggleKey("\u309c", KeyEvent.CHAR_UNDEFINED, KeyEvent.VK_KANA,
				      TouchableVirtualKanaKeySet.HANDAKUTEN_MODE,
				      TouchableVirtualKanaKeySet.HANDAKUTEN_MODE |
				      TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				      TouchableVirtualKanaKeySet.KATAKANA_MODE,
				      new Rectangle(COLUMN1, ROW0,
						    KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u308f", '\u308f',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SHOUJI_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN2, ROW0, 
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3089", '\u3089',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN3, ROW0,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3084", '\u3084',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SHOUJI_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN4, ROW0,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u307e", '\u307e',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN5, ROW0,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u306f", '\u306f',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.HANDAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN6, ROW0,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u306a", '\u306a',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN7, ROW0,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u305f", '\u305f',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN8, ROW0,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3055", '\u3055',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN9, ROW0,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u304b", '\u304b',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN10, ROW0,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3042", '\u3042',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SHOUJI_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN11, ROW0,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("7", '7',
				    KeyEvent.VK_7,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN12, ROW0,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("8", '8',
				    KeyEvent.VK_8,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN13, ROW0,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("9", '9',
				    KeyEvent.VK_9,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN14, ROW0,
						  KEY_WIDTH, KEY_HEIGHT)),

	// ROW 1
	new TouchableVirtualKey(")", ')',
				    KeyEvent.VK_0,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN0, ROW1,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualToggleKey("\u309b", KeyEvent.CHAR_UNDEFINED, KeyEvent.VK_KANA,
				      TouchableVirtualKanaKeySet.DAKUTEN_MODE,
				      TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				      TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				      TouchableVirtualKanaKeySet.KATAKANA_MODE,
				      new Rectangle(COLUMN1, ROW1,
						    KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3092", '\u3092',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN2, ROW1,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u308a", '\u308a',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN3, ROW1,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3086", '\u3086',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SHOUJI_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN4, ROW1,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u307f", '\u307f',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN5, ROW1,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3072", '\u3072',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.HANDAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN6, ROW1,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u306b", '\u306b',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN7, ROW1,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3061", '\u3061',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN8, ROW1,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3057", '\u3057',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN9, ROW1,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u304d", '\u304d',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN10, ROW1,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3044", '\u3044',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SHOUJI_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN11, ROW1,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("4", '4',
				    KeyEvent.VK_4,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN12, ROW1,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("5", '5',
				    KeyEvent.VK_5,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN13, ROW1,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("6", '6',
				    KeyEvent.VK_6,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN14, ROW1,
						  KEY_WIDTH, KEY_HEIGHT)),

	// ROW 2
	new TouchableVirtualKey("\u300c", '\u300c',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN0, ROW2,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("\u30fc", '\u30fc',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN1, ROW2,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3093", '\u3093',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN2, ROW2,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u308b", '\u308b',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN3, ROW2,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3088", '\u3088',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SHOUJI_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN4, ROW2,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3080", '\u3080',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN5, ROW2,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3075", '\u3075',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.HANDAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN6, ROW2,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u306c", '\u306c',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN7, ROW2,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3064", '\u3064',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SHOUJI_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN8, ROW2,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3059", '\u3059',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN9, ROW2,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u304f", '\u304f',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN10, ROW2,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3046", '\u3046',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SHOUJI_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN11, ROW2,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("1", '1',
				    KeyEvent.VK_1,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN12, ROW2,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("2", '2',
				    KeyEvent.VK_2,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN13, ROW2,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("3", '3',
				    KeyEvent.VK_3,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN14, ROW2,
						  KEY_WIDTH, KEY_HEIGHT)),

	// ROW 3
	new TouchableVirtualKey("\u300d", '\u300d',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN0, ROW3,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("\u3001", '\u3001',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN1, ROW3,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u309d", '\u309d',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN2, ROW3,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u308c", '\u308c',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN3, ROW3,
						  KEY_WIDTH, KEY_HEIGHT)),
	// EMPTY SPACE
	new TouchableVirtualKanaKey("\u3081", '\u3081',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN5, ROW3,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3078", '\u3078',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.HANDAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN6, ROW3,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u306d", '\u306d',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN7, ROW3,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3066", '\u3066',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN8, ROW3,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u305b", '\u305b',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN9, ROW3,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3051", '\u3051',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN10, ROW3,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3048", '\u3048',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SHOUJI_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN11, ROW3,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("0", '0',
				    KeyEvent.VK_0,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN12, ROW3,
						  KEY_WIDTH, KEY_HEIGHT)),

	// ROW 4
	new TouchableVirtualKey(/*"\u2022", '\u2022',*/
				    "\u00b7", '\u00b7',
				    KeyEvent.VK_UNDEFINED,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN0, ROW4,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKey("\u3002", '\u3002',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN1, ROW4,
						  KEY_WIDTH, KEY_HEIGHT)),
	// BLANK SPACE
	new TouchableVirtualKanaKey("\u308d", '\u308d',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN3, ROW4,
						  KEY_WIDTH, KEY_HEIGHT)),
	// BLANK SPACE
	new TouchableVirtualKanaKey("\u3082", '\u3082',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN5, ROW4,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u307b", '\u307b',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.HANDAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN6, ROW4,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u306e", '\u306e',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN7, ROW4,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3068", '\u3068',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN8, ROW4,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u305d", '\u305d',
				    KeyEvent.VK_KANA, 
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN9, ROW4,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u3053", '\u3053',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.DAKUTEN_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN10, ROW4,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u304a", '\u304a',
				    KeyEvent.VK_KANA,
				    TouchableVirtualKanaKeySet.SHOUJI_MODE |
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN11, ROW4,
						  KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualArrowKey(KeyEvent.VK_UP,
				     TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				     TouchableVirtualKanaKeySet.KATAKANA_MODE,
				     new Rectangle(COLUMN13, ROW4 + KEY_PAD, 
					      KEY_WIDTH, KEY_HEIGHT)),

	// ROW 5
	new TouchableVirtualToggleKey("\u5c0f\u5b57", 
				      KeyEvent.CHAR_UNDEFINED, KeyEvent.VK_MODECHANGE,
				      TouchableVirtualKanaKeySet.SHOUJI_MODE,
				      TouchableVirtualKanaKeySet.SHOUJI_MODE |
				      TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				      TouchableVirtualKanaKeySet.KATAKANA_MODE,
				      new Rectangle(COLUMN0, ROW5,
						    2*KEY_WIDTH + KEY_PAD, KEY_HEIGHT)),
	new TouchableVirtualKanaKey("\u5f8c\u9000", '\u0008',
				    KeyEvent.VK_BACK_SPACE,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN2, ROW5,
						  2*KEY_WIDTH + KEY_PAD, KEY_HEIGHT)),

	new TouchableVirtualKanaKey("\u30b9\u30da\u30fc\u30b9", ' ',
				    KeyEvent.VK_SPACE,
				    TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN4, ROW5,
						  6*KEY_WIDTH + 5*KEY_PAD, KEY_HEIGHT)),

	new TouchableVirtualKanaKey("\u6539\u884c", '\r', 
				    KeyEvent.VK_ENTER,
				    TouchableVirtualKanaKeySet.KATAKANA_MODE,
				    new Rectangle(COLUMN10, ROW5, 
						  2*KEY_WIDTH + KEY_PAD, KEY_HEIGHT)),
	new TouchableVirtualArrowKey(KeyEvent.VK_LEFT,
				     TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				     TouchableVirtualKanaKeySet.KATAKANA_MODE,
				     new Rectangle(COLUMN12, ROW5,
						   KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualArrowKey(KeyEvent.VK_DOWN,
				     TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				     TouchableVirtualKanaKeySet.KATAKANA_MODE,
				     new Rectangle(COLUMN13, ROW5,
						   KEY_WIDTH, KEY_HEIGHT)),
	new TouchableVirtualArrowKey(KeyEvent.VK_RIGHT,
				     TouchableVirtualKanaKeySet.SINGLE_LINE_MODE |
				     TouchableVirtualKanaKeySet.KATAKANA_MODE,
				     new Rectangle(COLUMN14, ROW5,
						   KEY_WIDTH, KEY_HEIGHT))
    };

    private Object[][] contents = {
	{"settings", "null" /*settings*/},
	{"keys", keys}
    };

}
