/*
 * @(#)Backspace.java	1.1 98/11/19 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
package sun.awt.otk;

import sun.porting.toolkit.ToolkitEventHandler;
import java.awt.AWTEvent;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.Component;

/**
 * A controller that consumes and interprets backspace/delete.
 * For benefit of text components.
 */
public class Backspace extends TextComponentController {
    public static final Backspace controller = new Backspace();

    public boolean handleEvent(View v,
			       int id, long when, int modifiers,
			       int x, int y, int arg1, int arg2) {

	if (textDebugging)
	    System.err.println("backspaceController: id=" + id + " ag1=" + arg1 + " arg2=" + arg2);

	switch(id) {
	case ToolkitEventHandler.KEY_PRESSED:
	    if (arg1 == KeyEvent.VK_BACK_SPACE ||
		arg1 == KeyEvent.VK_DELETE) {
		TextComponentView tv = ((TextComponentView) v);
		TextPane tp = tv.getTextPane();
		if (!tp.backspace()) {
		    tv.playNotAllowedSound();
		}
		return true;
	    }
	    break;

	default:
	    // Unfortunately keyCode is not set on KEY_TYPED,
	    // so we have to check against the keyCode int value.
	    if (arg2 == 0x08 || arg2 == 0x7f)
		return true;
	}

	return false;
    }
}
