/*
 * @(#)BufferedKeyEvent.java	1.2 98/11/25
 * 
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 *
 */

package sun.awt.otk;

import java.awt.Component;
import java.awt.event.KeyEvent;

/**
 * BufferedKeyEvent class is a marker class used to mark key events
 * that have buffered. By a marker class is meant one that does not
 * modify the class it extends but is merely used to tag/identify
 * events.
 * 
 * When off the stop support is provided, there is a need to 
 * buffer key events.  Eventually when these events are delivered
 * to the target component tagging them ensures that they are delivered
 * as is without any inteference from input methods.
 * 
 *
 * @version 1.2, 11/25/98
 * @author Sun Microsystems, Inc.
 */

public class BufferedKeyEvent extends java.awt.event.KeyEvent {

    /**
     * Constructs a BufferedKeyEvent with the specified source component,
     * type, modifiers, and key.
     *
     * @param source the object where the event originated
     * @param id the event type
     * @param when the time the event occurred
     * @param modifiers the modifier keys down during event
     * @param keyCode the integer code representing the key of the event 
     * @param keyChar the Unicode character generated by this event, or NUL
     */
     public BufferedKeyEvent(Component source, int id, long when, int modifiers,
                    int keyCode, char keyChar) {
        super(source, id, when, modifiers, keyCode, keyChar);
    }
}
