/*
 * @(#)MenuShowEvent.java	1.6 98/11/25 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
package sun.awt.otk;

import java.awt.AWTEvent;

/**
 * An event which is posted whenever a menu is shown.  Used for coordination.
 */
public class MenuShowEvent extends ViewEvent {
    private long when;
    private boolean visible;

    /**
     * Create a new MenuShowEvent with the specified target.
     * @param target The menu that is being shown or hidden
     * @param when The time at which the event occurred
     * @param visible whether the menu was made visible or invisible
     */
    public MenuShowEvent(View target, long when, boolean visible) {
	super(target, 0, target);
	this.when = when;
	this.visible = visible;
    }

    /**
     * @return The timestamp for the event
     */
    public long getWhen() {
	return when;
    }

    /**
     * @return The type of state transition: true if the menu was made
     * visible and false if it was made invisible.
     */
    public boolean getVisible() {
	return visible;
    }
}
