/*
 * @(#)Scrollable.java	1.3 98/11/28 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
package sun.awt.otk;

import java.awt.*;

/**
 * The interface for controlling a view that handles scrolling.
 */
public interface Scrollable {
    /**
     * Start scrolling the view.
     * @param x the x coordinate associated with the event
     * @param y the y coordinate associated with the event
     * @param modifiers The modifier key (SHIFT, CONTROL, ALT, META) state
     * @return true if this event is consumed by the view, false otherwise
     */
    boolean startScrolling(int x, int y, int modifiers);

    /**
     * Stop scrolling the view.
     * @return true if this event is consumed by the view, false otherwise
     */
    boolean stopScrolling();
}
