/*
 * @(#)TextComponentController.java	1.4 98/11/30
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package sun.awt.otk;

import java.awt.AWTEvent;

/**
 * Base class for all Text Component controllers. Adds functionality to handle
 * VirtualComponentEvent's.
 */
public abstract class TextComponentController extends InputController {

    /**
     * Empty default constructor
     */
    public TextComponentController() {
    }

    public static boolean textDebugging = false;

    /**
     * We over-ride this method because InputController will only
     * handle InputEvents and VirtualComponentEvent is an instance
     * of ComponentEvent.
     * @param  v view where an event occurred
     * @param  e AWT event that occurred in the view <code> v </code>
     */
    public boolean handleEvent(View v, AWTEvent e) {

        if (e instanceof VirtualComponentEvent) {
	    int id = e.getID();
	    int x = 0;
	    int y = 0;
	    int arg1 = 0;
	    if (id == VirtualComponentEvent.VIRTUAL_COMPONENT_HIDE) {
	        VirtualComponentSelInfo msg = (VirtualComponentSelInfo)
		                      ((VirtualComponentEvent) e).getMessage();
		x = msg.selStart;
		y = msg.selEnd;
		arg1 = msg.caret;
	    }

	    return ((GenericInputHandler) v).handleInputEvent(v, id, 0, 0,
							      x, y, arg1, 0);
	} else {
	    return super.handleEvent(v, e);
	}
    }
}
