/*
 * @(#)TextFilter.java	1.1 98/11/19 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
package sun.awt.otk;

import sun.porting.toolkit.ToolkitEventHandler;
import java.awt.AWTEvent;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.Component;

/**
 * A controller that consumes and interprets enter and tab.
 * For benefit of text components.
 */
public class TextFilter extends TextComponentController {
    public static final TextFilter controller = new TextFilter();

    public boolean handleEvent(View v,
			       int id, long when, int modifiers,
			       int x, int y, int arg1, int arg2) {

	if (textDebugging)
	    System.err.println("preProcessTextFieldKeys: id=" + id + " ag1=" + arg1 + " arg2=" + arg2);

	if (id == ToolkitEventHandler.KEY_TYPED) {

	    TextComponentView tv = ((TextComponentView) v);
	    char d[] = {(char) arg2};

	    switch(d[0]) {

	    case '\n':
	    case '\r':
		((TextComponentModel) tv.getModel()).sendActionEvent();
		return true;

	    default:
	      if (d[0] == 0x09) {    // consume tabs
		  return true;
	      }

	      return false;
	    }
	}

	return false;
    }
}
