/*
 * @(#)VertArrows.java	1.1 98/11/19 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
package sun.awt.otk;

import sun.porting.toolkit.ToolkitEventHandler;
import java.awt.AWTEvent;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.Component;

/**
 * A controller that consumes and interprets up/down arrow keys.
 * For benefit of Text components.
 */
public class VertArrows extends TextComponentController {
    public static final VertArrows controller = new VertArrows();

    public boolean handleEvent(View v,
			       int id, long when, int modifiers,
			       int x, int y, int arg1, int arg2) {

	if (textDebugging)
	    System.err.println("upDownKeyController: id=" + id + " ag1=" + arg1 + " arg2=" + arg2);

	if (id == ToolkitEventHandler.KEY_PRESSED &&
	    ObjectToolkit.isActionKey(arg1)) {

	    TextComponentView tv = ((TextComponentView) v);
	    TextPane tp = tv.getTextPane();

	    switch(arg1) {

	    case KeyEvent.VK_UP:
		if (tp.isComposing()) {
		    tv.playNotAllowedSound();
		}
		if (tp.lineUp(false)) {
		    tp.gotoLine(tp.getFirstVisibleLine());
		}
		return true;

	    case KeyEvent.VK_DOWN:
		if (tp.isComposing()) {
		    tv.playNotAllowedSound();
		}
		if (tp.lineDown(false)) {
		    tp.gotoLine(tp.getFirstVisibleLine());
		}
		return true;

	    default:
		return false;
	    }
	}

	return false;
    }

}
