/*
 * @(#)VertPage.java	1.1 98/11/19 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
package sun.awt.otk;

import sun.porting.toolkit.ToolkitEventHandler;
import java.awt.AWTEvent;
import java.awt.event.KeyEvent;
import java.awt.event.MouseEvent;
import java.awt.Component;

/**
 * A controller that consumes key events and interprets them as page up and
 * page down.  For benefit of Text components. 
 */
public class VertPage extends TextComponentController {
    public static final VertPage controller = new VertPage();

    public boolean handleEvent(View v,
			       int id, long when, int modifiers,
			       int x, int y, int arg1, int arg2) {

	if (textDebugging)
	    System.err.println("verticalPagingController: id=" + id + " ag1=" + arg1 + " arg2=" + arg2);

	if (id == ToolkitEventHandler.KEY_PRESSED &&
	    ObjectToolkit.isActionKey(arg1)) {

	    TextComponentView tv = ((TextComponentView) v);
	    TextPane tp = tv.getTextPane();

	    switch(arg1) {

	    case KeyEvent.VK_PAGE_UP:
		if (tp.isComposing()) {
		    tv.playNotAllowedSound();
		}
		tp.pageUp();
		return true;

	    case KeyEvent.VK_PAGE_DOWN:
		if (tp.isComposing()) {
		    tv.playNotAllowedSound();
		}
		tp.pageDown();
		return true;

	    default:
		return false;
	    }
	}

	return false;
    }
}
