/*
 * @(#)ViewEvent.java	1.3 98/09/15 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
package sun.awt.otk;

import java.awt.*;
import java.awt.peer.ActiveEvent;
import sun.porting.graphicssystem.Region;

public class ViewEvent extends AWTEvent implements ActiveEvent {
    public static final int UPDATE = RESERVED_ID_MAX + 1;

    protected Object arg;

    public ViewEvent(View source, int id, Object arg) {
	super(source, id);

	this.arg    = arg;
    }

    public void dispatch() {
	View v = (View)getSource();

	if (id == UPDATE) {
	    Graphics g = v.getGraphics();

	    if (arg instanceof Region) {
		/* update clip */
	    } else if (arg instanceof Shape) {
		/* update clip */
	    }

	    v.updateDependent(v.getModel(), g);
	    g.dispose();
	} else {
	    v.updateDependent(v.getModel(), this);
	}
    }

    public Object getArg() {
	return arg;
    }
}
