/*
 * @(#)VirtualComponentSelInfo.java	1.2 98/11/25
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package sun.awt.otk;

/**
 * This object is used to pass selection state information between a text
 * component and it's associated virtual component, i.e. text popup or
 * virtual keyboard. Selection state is passed from the componet to the
 * virtual component when a VIRTUAL_COMPONENT_SHOW is posted and is then
 * sent in the reverse direction when VIRTUAL_COMPONENT_HIDDEN is posted by
 * the virtual component.
 */

public class VirtualComponentSelInfo extends Object
    implements VirtualComponentMessage {

    public int selStart;
    public int selEnd;
    public int caret;

    /**
     * Constructs a <code>VirtualComponentSelInfo</code> object
     * with the specified start, end, and caret position.
     * @param start the ordinal number of the character for the start of the selection
     * @param end the ordinal number of the character for the end of the selection
     * @param caret the ordinal number of the character which the caret is placed before
     */
    public VirtualComponentSelInfo(int start, int end, int caret) {
        selStart = start;
	selEnd = end;
	this.caret = caret;
    }
}
