/*
 * @(#)VirtualKeyboardViewIntf.java	1.7 98/11/30 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package sun.awt.otk;

import java.awt.AWTEvent;
import java.awt.Component;

/**
 * This is the interface that a virtual keyboard view or any other virtual
 * component must implement to be able to receive input from the virtual
 * keyboard input method.
 */
public interface VirtualKeyboardViewIntf {

    /**
      * This is the channel through which a virtual component receives AWT events.
      *
      * @param e the event
      * @see java.awt.AWTEvent
      */
    boolean dispatchEvent(AWTEvent e);
    
    /**
      * Is the virtual component visible?
      *
      * @returns true if the component is visible otherwise false
      */
    boolean isVisible();

    /**
      * Show the component.
      *
      * @param e the event which caused the show
      * @see java.awt.AWTEvent
      */
    void show(AWTEvent e);

    /**
      * Hide the component.
      */
    void hide();
    
    /**
      * Dispose of the component.
      */
    void dispose();
}
