/*
 * @(#)WindowActivationVetoException.java	1.3 98/11/28 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
package sun.awt.otk;

/**
 * Signals that the requested window activation is not permitted by the current
 * window activation policy.
 * @see WindowActivationPolicy
 */
public class WindowActivationVetoException extends java.lang.Exception {
    Object w;

    /** 
     * Constructs a WindowActivationVetoException with the given window and 
     * no specified detail message.
     * @param window the window for which this exception has occurred
     */
    public WindowActivationVetoException(Object window) {
	this(window, "");
    }

    /**
     *  Constructs a WindowActivationVetoException with the specified window and 
     * detail message.
     * @param window the window for which this exception has occurred
     * @param s the detail message
     */
    public WindowActivationVetoException(Object window, String s) {
	super(s);
	w = window;
    }

    /**
     * Returns the window for which this exception occurred.
     * @return the window for which the exception occurred
     */
    public Object getWindow() {
	return w;
    }
}
