/*
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

package com.sun.awt;

/**
 * Indicates that a user can click on
 * or otherwise "activate" a component by using the input device.
 * The component should receive a <code>MOUSE_ENTER</code> event
 * when the user navigates to the component,
 * and a <code>MOUSE_EXIT</code> event
 * when the user navigates from the component.
 * It should receive a <code>MOUSE_DOWN</code> event
 * followed by a <code>MOUSE_UP</code> event when the user selects it.
 * The mouse coordinates for all events associated
 * with this component will be the coordinates
 * of the center of the component. 
 *
 * @author      unascribed
 * @since       pJava1.0
 * @version     1.4, 06/15/98
 * @see         com.sun.awt.KeyboardInputPreferred
 * @see         com.sun.awt.NoInputPreferred
 * @see         com.sun.awt.PositionalInputPreferred
 */
public interface ActionInputPreferred {
}
