/*
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

package com.sun.awt;

/**
 * Indicates that the component will be used primarily via keyboard input.
 * Some platforms will respond by popping up an on-screen keyboard
 * when the user navigates to or selects this component.
 * The developer should ensure that <code>Component.isFocusTraversable</code>
 * returns true for this component. 
 *
 * @author      unascribed
 * @since       pJava1.0
 * @version     1.4, 06/15/98
 * @see         com.sun.awt.ActionInputPreferred
 * @see         com.sun.awt.NoInputPreferred
 * @see         com.sun.awt.PositionalInputPreferred
 */
public interface KeyboardInputPreferred {
}
