/*
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

package com.sun.awt;

/**
 * Indicates that the component will be used primarily
 * by the user selecting <i>x</i>,<i>y</i> coordinates within the component.
 * The component should receive <code>MOUSE_ENTER</code>
 * and <code>MOUSE_EXIT</code> events when the user navigates to it.
 * The system should provide some mechanism for selecting specific
 * <i>x</i>,<i>y</i> coordinates within the component's bounds,
 * and provide mouse movement events.
 * The platform should decide if selection of
 * <i>x</i>,<i>y</i> coordinate begins
 * when the user navigates to the component
 * or when the user selects the component.
 * In either case,
 * the component should receive a <code>MOUSE_DOWN</code>
 * and <code>MOUSE_UP</code> event with the selected coordinates.
 *
 * @author      unascribed
 * @since       pJava1.0
 * @version     1.4, 06/15/98
 * @see         com.sun.awt.KeyboardInputPreferred
 * @see         com.sun.awt.NoInputPreferred
 * @see         com.sun.awt.PositionalInputPreferred
 */
public interface PositionalInputPreferred {
}
