/*
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

package com.sun.util;

/**
 * An event indicating that a timer specification has gone off.
 *
 * @author: Alan Bishop
 * @since: PersonalJava1.0
 */
public class PTimerWentOffEvent extends java.util.EventObject {
    
    private PTimerSpec timerSpec;
    
    /**
     * Creates a new PTimerWentOffEvent with the specified timer and
     * timer specification.
     * @param source the timer that sent this event
     * @param spec the timer specification that went off
     */
    public PTimerWentOffEvent(PTimer source, PTimerSpec spec) {
	super(source);
    
	timerSpec = spec;
    }
            
    /**
     * Returns the timer specification for this event.
     */
    public PTimerSpec getTimerSpec() {
	return timerSpec;
    }
}
