/*
 * @(#)filesystem.c     1.48 97/05/06
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/* This is a system-independent level of file system operations. */

#include <sys/types.h>
#include <sys/stat.h>

#include "oobj.h"
#include "typecodes.h"
#include "interpreter.h"
#include "javaString.h"

#include "java_io_File.h"
#include "sys_api.h"
#include "path.h"


HString*
java_io_File_canonPath(Hjava_io_File *this, HString* path) 
{
    char real[MAXPATHLEN];
    char *current = makePlatformCString(path);
    if(sysCanonicalPath(sysNativePath(current), real, MAXPATHLEN) < 0) {
	SignalError(0, "java/io/IOException", "bad path error");
	return 0;
    }
    return makeJavaStringFromPlatformCString(real, strlen(real));
}
