/*
 * @(#)filesystem.c     1.48 97/05/06
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/* This is a system-independent level of file system operations. */

#include <sys/types.h>
#include <sys/stat.h>

#include "oobj.h"
#include "typecodes.h"
#include "interpreter.h"
#include "javaString.h"

#include "java_io_File.h"
#include "sys_api.h"
#include "path.h"


long
java_io_File_renameTo0(Hjava_io_File *this, Hjava_io_File *dest) 
{
    Classjava_io_File *thisptr = unhand(this);
    Classjava_io_File *destptr;
    char *path; 
    char *dpath;

    if ((thisptr->path == 0) || (dest == 0)) {
	SignalError(0, JAVAPKG "NullPointerException", 0);
	return 0;
    }

    path = makePlatformCString(thisptr->path);
    destptr = unhand(dest);
    dpath = makePlatformCString(destptr->path);

    return sysRename(path, dpath) != -1;
}
