/*
 * @(#)java_io_ObjectInputStream_invokeObjectReader.c	1.2 98/09/04
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 */
 
#include "StubPreamble.h"
#include "native.h"
#include "sys_api.h"
 
#include "java_io_ObjectInputStream.h"

#define OBJECT_PACKAGE "java/io/"
#define WRITEOBJECT "writeObject"
#define READOBJECT "readObject"
#define WRITE_SIGNATURE "(L" OBJECT_PACKAGE "ObjectOutputStream;)V"
#define READ_SIGNATURE "(L" OBJECT_PACKAGE "ObjectInputStream;)V"

struct methodblock *findWriteReadObject(ExecEnv *ee,
					ClassClass *cb, int findwrite);

/* Locate the two magic method signatures within the specified class.
 * If both are found invoke the write method
 */
long java_io_ObjectInputStream_invokeObjectReader(struct Hjava_io_ObjectInputStream *this,
				     struct Hjava_lang_Object *obj,
				     struct Hjava_lang_Class *cb)
{
    struct methodblock* method;
    ExecEnv *ee = EE();

    method = findWriteReadObject(ee, cb, 0);
    if (method == NULL || exceptionOccurred(ee))
	return 0;

    do_execute_java_method(ee, 
			   /* object */obj, 
			   /* method name */  READOBJECT, 
			   /* method signature */  READ_SIGNATURE, 
			   /* method block of  */ method,
			   /* isStaticCall */ 0, 
			   /* argument */ this, NULL);

   return (exceptionOccurred(ee))?(0):(1);
}
