/*
 * @(#)java_io_ObjectInputStream_loadClass0.c	1.3 98/09/07
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 */
 
#include "StubPreamble.h"
#include "native.h"
#include "sys_api.h"
 
#include "java_io_ObjectInputStream.h"

#define OBJECT_PACKAGE "java/io/"
#define WRITEOBJECT "writeObject"
#define READOBJECT "readObject"
#define WRITE_SIGNATURE "(L" OBJECT_PACKAGE "ObjectOutputStream;)V"
#define READ_SIGNATURE "(L" OBJECT_PACKAGE "ObjectInputStream;)V"

/*
 * Find the first class loader up the stack and use its class to call
 * FindClassFromClass to resolve the specified class name.  The code
 * is similar to that of java.lang.currentClassLoader
 */
struct Hjava_lang_Class *
java_io_ObjectInputStream_loadClass0(struct Hjava_io_ObjectInputStream * this,
				     struct Hjava_lang_Class *class,
				     struct Hjava_lang_String *classname)
{
    struct javaframe *frame, frame_buf;
    ClassClass	*cb;
    char clname[256], *p;
    int c;

    cb = class;			/* Default to use default system loader */
    if (cb == NULL) {
	for (frame = EE()->current_frame ; frame != 0 ;) {
	    if (!IS_NATIVE_FRAME(frame)) {
		cb = methodclass(frame->current_method);
		if (cb && cbLoader(cb)) {
		    /* Found a class with a non-zero class loader, use it */
		    break;
		}
	    }
	    frame = FRAME_PREV(frame, &frame_buf);
	}
    }
    /* Convert the string so we can call FindClassFromClass with a char * */
    javaString2CString(classname, clname, sizeof(clname));
    for (p = clname ; (c = *p); p++) {
	if (c == '.') {
	    *p = '/';
	}
    }

    if ((cb = FindClassFromClass(EE(), clname, TRUE, cb)) == 0) {
	SignalError(0, JAVAPKG "ClassNotFoundException", clname);
	return NULL;
    }

    return cbHandle(cb);
}
