/*
 * @(#)java_io_ObjectStreamClass_getFieldAccess.c	1.1 98/08/28
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 */
 
#include "StubPreamble.h"
#include "native.h"
#include "sys_api.h"

#include "java_io_ObjectStreamClass.h"

extern struct methodblock *findWriteReadObject(ExecEnv *ee, ClassClass *cb, int findwrite);

/* Look through the fields for the field named,
   return its fieldblock, or null if none
   */
static struct fieldblock * findfield(ClassClass *cb,
				     struct Hjava_lang_String *fieldname) {
    int i;
    struct fieldblock *fields = cbFields(cb);
    char buffer[1024];
    char *p;
    
    javaString2CString(fieldname, buffer, sizeof(buffer));
    
    p = strchr(buffer, ' ');
    if (!p)
	return NULL;
    *p++ = 0;			/* pointer to signature */
    
    for (i = cbFieldsCount(cb) - 1; i >= 0; i--) {
	if ((strcmp(buffer, fieldname(&fields[i])) == 0) &&
	    (strcmp(p, fieldsig(&fields[i])) == 0)) {
	    return &fields[i];
	}
    }
    return NULL;
}

/* Export the access bits for the specified field,
 * export only the flags that appear in the class file.
 */
long java_io_ObjectStreamClass_getFieldAccess(struct Hjava_io_ObjectStreamClass *this,
					      struct Hjava_lang_Class *aclass,
					      struct Hjava_lang_String *fieldname)
{
    struct fieldblock *field = findfield(aclass, fieldname);
    
    if (field == 0)
	return 0;
    
    return fieldaccess(field) & ACC_WRITTEN_FLAGS;
}
