/*
 * @(#)java_io_ObjectStreamClass_getFieldSignatures.c	1.1 98/08/28
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 */
 
#include "StubPreamble.h"
#include "native.h"
#include "sys_api.h"

#include "java_io_ObjectStreamClass.h"

extern struct methodblock *findWriteReadObject(ExecEnv *ee, ClassClass *cb, int findwrite);

/*
 * Return an array of Strings containing the field names and signatures.
 */
HArrayOfString *java_io_ObjectStreamClass_getFieldSignatures(struct Hjava_io_ObjectStreamClass *this,
							     struct Hjava_lang_Class *aclass)
{
    ClassClass *cb = aclass;
    struct fieldblock *fields = cbFields(cb);
    HArrayOfString *namearrayhandle;
    int i;
    ExecEnv *ee = EE();

    /* Make an array of Strings */
    namearrayhandle = (HArrayOfString *)ArrayAlloc(T_CLASS, cbFieldsCount(cb));
    if (namearrayhandle == 0) {
	SignalError(0, JAVAPKG "OutOfMemoryError", 0);
	return 0;
    }

    /* Set the type of the array */
    unhand((HArrayOfObject *)namearrayhandle)->body[cbFieldsCount(cb)] = 
	(JHandle *)FindClass(ee, JAVAPKG "String", TRUE);

    /* For each field: concatinate the name signature and insert it in the array */
    for (i = cbFieldsCount(cb) - 1; i >= 0; i--) {
	HString **namearray;
	Hjava_lang_String *strobj;
	char buffer[1024];
	char *p = buffer;
	char *fname = fieldname(&fields[i]);
	char *fsig = fieldsig(&fields[i]);
	int len = strlen(fname) + strlen(fsig);

	if (len >= sizeof(buffer)) {
	    p = sysMalloc(len + 1);
	    if (p == 0) {
		SignalError(0, JAVAPKG "OutOfMemoryError", 0);
	    }
	}
	
	strcpy(p, fname);
	strcat(p, " ");
	strcat(p, fsig);
	
	strobj = makeJavaString(p, strlen(p));
	namearray = (HString **)unhand(namearrayhandle)->body;
	namearray[i] = strobj;
	if (p != buffer)
	    sysFree(p);
    }
    
    return namearrayhandle;
}
