/*
 * @(#)java_io_ObjectStreamClass_getMethodSignatures.c	1.1 98/08/28
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 */
 
#include "StubPreamble.h"
#include "native.h"
#include "sys_api.h"

#include "java_io_ObjectStreamClass.h"

extern struct methodblock *findWriteReadObject(ExecEnv *ee, ClassClass *cb, int findwrite);

/*
 * Return an array of Strings containing the method names and signatures.
 */
HArrayOfString *java_io_ObjectStreamClass_getMethodSignatures(struct Hjava_io_ObjectStreamClass *this,
							      struct Hjava_lang_Class *aclass)
{
    ClassClass *cb = aclass;
    HArrayOfString *namearrayhandle;
    int namearraylen;
    int i;
    ExecEnv *ee = EE();
    
    /* Make an array of Strings */
    namearrayhandle = (HArrayOfString *)ArrayAlloc(T_CLASS, cbMethodsCount(cb));
    if (namearrayhandle == 0) {
	SignalError(0, JAVAPKG "OutOfMemoryError", 0);
	return 0;
    }
    
    /* Set the type of the array */
    unhand((HArrayOfObject *)namearrayhandle)->body[cbMethodsCount(cb)] = 
	(JHandle *)FindClass(ee, JAVAPKG "String", TRUE);
    

    /*
     * For each method: concatinate the name and signature and insert it in the array
     */
    for (i = cbMethodsCount(cb) - 1; i >= 0; i--) {
        HString **namearray;
	Hjava_lang_String *strobj;
	char buffer[1024];
	char *p = buffer;
	int len = strlen(methodname(&(cbMethods(cb)[i]))) + strlen(methodsig(&(cbMethods(cb)[i]))) + 2;

	if (len >= sizeof(buffer)) {
	    p = sysMalloc(len + 1);
	    if (p == 0) {
		SignalError(0, JAVAPKG "OutOfMemoryError", 0);
		return 0;
	    }
	}
	
	strcpy(p, methodname(&cbMethods(cb)[i]));
	strcat(p, " ");
	strcat(p, methodsig(&cbMethods(cb)[i]));

	strobj = makeJavaString(p, strlen(p));
	namearray = (HString **)unhand(namearrayhandle)->body;
	namearray[i] = strobj;
	if (p != buffer)
	    sysFree(p);
    }
    return namearrayhandle;
}
