/*
 * @(#)java_io_ObjectStreamClass_getSerialVersionUID.c	1.1 98/08/28
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 */
 
#include "StubPreamble.h"
#include "native.h"
#include "sys_api.h"

#include "java_io_ObjectStreamClass.h"

extern struct methodblock *findWriteReadObject(ExecEnv *ee, ClassClass *cb, int findwrite);

/* Look for the static final long field "serialVersionUID" and
 * return its value.
 */
int64_t
java_io_ObjectStreamClass_getSerialVersionUID(
					      struct Hjava_io_ObjectStreamClass *this,
					      struct Hjava_lang_Class *aclass)
{
    ClassClass *cb = aclass;
    struct fieldblock *fields = cbFields(cb);
    Java8 svuid;
    int i;
    
    for (i = cbFieldsCount(cb) - 1; i >= 0; i--) {
	if (fieldaccess(&fields[i]) & ACC_STATIC &&
	    fieldaccess(&fields[i]) & ACC_FINAL &&
	    fieldsig(&fields[i])[0] == SIGNATURE_LONG &&
	    (strcmp("serialVersionUID", fieldname(&fields[i])) == 0)) {
	    return GET_INT64(svuid, twoword_static_address(&fields[i]));
	}
    }
    return ll_zero_const;
}
