/*
 * @(#)Adler32.java	1.13 98/09/02
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

package java.util.zip;

/**
 * A class that can be used to compute the Adler-32 checksum of a data
 * stream. An Adler-32 checksum is almost as reliable as a CRC-32 but
 * can be computed much faster.
 *
 * @see		Checksum
 * @version 	1.13, 09/02/98
 * @author 	David Connelly
 */
public
class Adler32 implements Checksum {
    /**
     * We need an empty constructor so construction will always throw
       UnsupportedOperationException.
     */
    public Adler32() {
	throw new UnsupportedOperationException();
    }

    /**
     * Updates checksum with specified byte.
     */
    public void update(int b) {
	throw new UnsupportedOperationException();
    }

    /**
     * Updates checksum with specified array of bytes.
     */
    public void update(byte[] b, int off, int len) {
	throw new UnsupportedOperationException();
    }

    /**
     * Updates checksum with specified array of bytes.
     */
    public void update(byte[] b) {
	throw new UnsupportedOperationException();
    }

    /**
     * Resets checksum to initial value.
     */
    public void reset() {
	throw new UnsupportedOperationException();
    }

    /**
     * Returns checksum value.
     */
    public long getValue() {
	throw new UnsupportedOperationException();
    }
}
