/*
 * @(#)ZipFile.java	1.25 99/10/27
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

package java.util.zip;

import java.io.IOException;
import java.io.InputStream;
import java.util.Hashtable;
import java.util.Enumeration;

/**
 * This class can be used to read the contents of a ZIP file. It uses
 * RandomAccessFile for quick access to ZIP file entries, and supports
 * both compressed and uncompressed entries.

 * @version	1.25, 10/27/99
 * @author	David Connelly
 */
public
class ZipFile implements ZipConstants {
    /**
     * Opens a ZIP file for reading given the specified file name.
     * @param name the name of the zip file
     * @exception ZipException if a ZIP format error has occurred
     * @exception IOException if an I/O error has occurred
     */
    public ZipFile(String name) throws IOException {
	throw new UnsupportedOperationException();
    }

    /**
     * Returns the ZIP file entry for the given path name. Returns null if
     * there is no entry corresponding to the given name.
     * @param name the name of the entry
     * @return the ZIP file entry
     */
    public ZipEntry getEntry(String name) {
	throw new UnsupportedOperationException();
    }

    /**
     * Returns an input stream for reading the contents of the specified
     * ZIP file entry.
     * @param ze the zip file entry
     * @exception ZipException if a ZIP format error has occurred
     * @exception IOException if an I/O error has occurred
     */
    public InputStream getInputStream(ZipEntry ze) throws IOException {
	throw new UnsupportedOperationException();
    }

    /**
     * Returns the path name of the ZIP file.
     */
    public String getName() {
	throw new UnsupportedOperationException();
    }

    /**
     * Returns an enumeration of the ZIP file entries.
     */
    public Enumeration entries() {
	throw new UnsupportedOperationException();
    }

    /**
     * Closes the ZIP file.
     */
    public void close() throws IOException {
	throw new UnsupportedOperationException();
    }

    /*
     * Reads data at specified file position into an array of bytes.
     * This method will block until some input is available.
     */
    synchronized int read(long pos, byte b[], int off, int len)
	throws IOException
    {
	throw new UnsupportedOperationException();
    }

    /*
     * Reads a byte of data at the specified file position. This method
     * will block until some input is available.
     */
    synchronized int read(long pos) throws IOException {
	throw new UnsupportedOperationException();
    }

    /*
     * Fetch unsigned 16-bit value from byte array at specified offset.
     * The bytes are assumed to be in Intel (little-endian) byte order.
     */
    static final int get16(byte b[], int off) {
	throw new UnsupportedOperationException();
    }

    /*
     * Fetch unsigned 32-bit value from byte array at specified offset.
     * The bytes are assumed to be in Intel (little-endian) byte order.
     */
    static final long get32(byte b[], int off) {
	throw new UnsupportedOperationException();
    }
}
