/*
 * @(#)array.c	1.1 98/11/18
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * Native code for java.lang.reflect.Array.
 *
 * TODO: Performance
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#define	_REFLECT_IMPL

#include "sys_api.h"				/* sysAssert() */
#include "native.h"
#include "signature.h"
#include "typecodes.h"
#include "wrap.h"
#include "reflect.h"

/*
 *
 */

#define	IllegalArray()	\
	REFLECT_ERROR(IllegalArgumentException, "argument is not an array")

#define	ArrayIndexOutOfBounds()	\
	REFLECT_ERROR(ArrayIndexOutOfBoundsException, 0)

#define	ElementTypeMismatch() \
	REFLECT_ERROR(IllegalArgumentException, "array element type mismatch")

#define	NegativeArraySize()	\
	REFLECT_ERROR(NegativeArraySizeException, 0)

/*
 *
 */

#define	CHECK_ARRAY(harr, tag)				\
if (TRUE)						\
{							\
    if (harr == NULL) {					\
	NullPointerException();				\
	goto tag;					\
    }							\
    if (obj_isnt_array(harr)) {           		\
	IllegalArray();					\
	goto tag;					\
    }							\
} else

#define	CHECK_ARRAY_AND_INDEX(harr, index, tag)		\
if (TRUE)						\
{							\
    CHECK_ARRAY(harr, tag);				\
    if (index < 0 || index >= obj_length(harr)) {	\
	ArrayIndexOutOfBounds();			\
	goto tag;					\
    }							\
} else

#define	DECODE_ARRAY(harr, ndx, p, pCode, tag)			\
if (TRUE)							\
{								\
    CHECK_ARRAY_AND_INDEX(harr, ndx, tag);			\
    {								\
    OBJECT *_p_ = unhand(harr);					\
    switch(pCode = array_type_to_type[obj_array_flags(harr)]) { \
    case T_BOOLEAN:						\
    case T_BYTE:						\
	p = (char *) &((ArrayOfByte *)_p_)->body[ndx]; break;	\
    case T_SHORT:						\
	p = (char *) &((ArrayOfShort *)_p_)->body[ndx]; break;	\
    case T_CHAR:						\
	p = (char *) &((ArrayOfChar *)_p_)->body[ndx]; break;	\
    case T_INT:							\
	p = (char *) &((ArrayOfInt *)_p_)->body[ndx]; break;	\
    case T_LONG:						\
	p = (char *) &((ArrayOfLong *)_p_)->body[ndx]; break;	\
    case T_FLOAT:						\
	p = (char *) &((ArrayOfFloat *)_p_)->body[ndx]; break;	\
    case T_DOUBLE:						\
	p = (char *) &((ArrayOfDouble *)_p_)->body[ndx]; break;	\
    case T_CLASS:						\
	p = (char *) &((ArrayOfObject *)_p_)->body[ndx]; break;	\
    default:							\
	InternalError("illegal array type");			\
	goto tag;						\
    }								\
    }								\
} else

/*
 *
 */

/*
 *
 */

JavaValue
get_primitive_element(
    HObject *harr,
    long index,
    int wCode)
{
    char *p;
    int pCode;
    JavaValue v;

    DECODE_ARRAY(harr, index, p, pCode, bad);

    REFLECT_GET(p, pCode, v, TRUE);

    if (pCode == T_CLASS)
	goto noconversion;

    if (pCode != wCode)
	REFLECT_WIDEN(v, pCode, wCode, noconversion);

    return v;

  noconversion:
    ElementTypeMismatch();

  bad:
    v.l = int2ll(0);
    return v;
}

/*
 *
 */

void
set_primitive_element(
    struct Hjava_lang_Object *harr,
    long index,
    JavaValue v,
    unsigned char vCode)
{
    char *p;
    int pCode;

    DECODE_ARRAY(harr, index, p, pCode, bad);

    if (pCode == T_CLASS)
	goto noconversion;

    if (vCode != pCode)
	REFLECT_WIDEN(v, vCode, pCode, noconversion);

    REFLECT_SET(p, pCode, v, TRUE);
    return;

  noconversion:
    ElementTypeMismatch();

  bad:
    return;
}

/*
 *
 */

