/* 
 * @(#)java_lang_Character_getA.c	1.1 98/08/28
 * 
 * Copyright (c) 1997 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 *
 */

#include <java_lang_Character.h>
#include <stdio.h>

/* 
 * The static final arrays of bytes that make up the X and Y arrays of
 * java.lang.Character.
 * 
 * This C file saves us the extra static initializer space for that class
 */

/*
 * The A table has 124 entries for a total of 496 bytes.
 */

static HArrayOfInt Ahandle;

static const unsigned int A[124] = {
      0x0001000F,  /*   0   Cc, ignorable */
      0x0004000F,  /*   1   Cc, whitespace */
      0x0004000C,  /*   2   Zs, whitespace */
      0x00000018,  /*   3   Po */
      0x0006001A,  /*   4   Sc, currency */
      0x00000015,  /*   5   Ps */
      0x00000016,  /*   6   Pe */
      0x00000019,  /*   7   Sm */
      0x00000014,  /*   8   Pd */
      0x00036009,  /*   9   Nd, identifier part, decimal 16 */
      0x0827FE01,  /*  10   Lu, hasLower (add 32), identifier start, supradecimal 31 */
      0x0000001B,  /*  11   Sk */
      0x00050017,  /*  12   Pc, underscore */
      0x0817FE02,  /*  13   Ll, hasUpper (subtract 32), identifier start, supradecimal 31 */
      0x0000000C,  /*  14   Zs */
      0x0000001C,  /*  15   So */
      0x00070002,  /*  16   Ll, identifier start */
      0x0000600B,  /*  17   No, decimal 16 */
      0x0000500B,  /*  18   No, decimal 8 */
      0x0000800B,  /*  19   No, strange */
      0x08270001,  /*  20   Lu, hasLower (add 32), identifier start */
      0x08170002,  /*  21   Ll, hasUpper (subtract 32), identifier start */
      0xE1D70002,  /*  22   Ll, hasUpper (subtract -121), identifier start */
      0x00670001,  /*  23   Lu, hasLower (add 1), identifier start */
      0x00570002,  /*  24   Ll, hasUpper (subtract 1), identifier start */
      0xCE670001,  /*  25   Lu, hasLower (add -199), identifier start */
      0x3A170002,  /*  26   Ll, hasUpper (subtract 232), identifier start */
      0xE1E70001,  /*  27   Lu, hasLower (add -121), identifier start */
      0x4B170002,  /*  28   Ll, hasUpper (subtract 300), identifier start */
      0x34A70001,  /*  29   Lu, hasLower (add 210), identifier start */
      0x33A70001,  /*  30   Lu, hasLower (add 206), identifier start */
      0x33670001,  /*  31   Lu, hasLower (add 205), identifier start */
      0x32A70001,  /*  32   Lu, hasLower (add 202), identifier start */
      0x32E70001,  /*  33   Lu, hasLower (add 203), identifier start */
      0x33E70001,  /*  34   Lu, hasLower (add 207), identifier start */
      0x34E70001,  /*  35   Lu, hasLower (add 211), identifier start */
      0x34670001,  /*  36   Lu, hasLower (add 209), identifier start */
      0x35670001,  /*  37   Lu, hasLower (add 213), identifier start */
      0x00070001,  /*  38   Lu, identifier start */
      0x36A70001,  /*  39   Lu, hasLower (add 218), identifier start */
      0x00070005,  /*  40   Lo, identifier start */
      0x36670001,  /*  41   Lu, hasLower (add 217), identifier start */
      0x36E70001,  /*  42   Lu, hasLower (add 219), identifier start */
      0x00AF0001,  /*  43   Lu, hasLower (add 2), hasTitle, identifier start */
      0x007F0003,  /*  44   Lt, hasUpper (subtract 1), hasLower (add 1), hasTitle, identifier start */
      0x009F0002,  /*  45   Ll, hasUpper (subtract 2), hasTitle, identifier start */
      0x00000000,  /*  46   unassigned */
      0x34970002,  /*  47   Ll, hasUpper (subtract 210), identifier start */
      0x33970002,  /*  48   Ll, hasUpper (subtract 206), identifier start */
      0x33570002,  /*  49   Ll, hasUpper (subtract 205), identifier start */
      0x32970002,  /*  50   Ll, hasUpper (subtract 202), identifier start */
      0x32D70002,  /*  51   Ll, hasUpper (subtract 203), identifier start */
      0x33D70002,  /*  52   Ll, hasUpper (subtract 207), identifier start */
      0x34570002,  /*  53   Ll, hasUpper (subtract 209), identifier start */
      0x34D70002,  /*  54   Ll, hasUpper (subtract 211), identifier start */
      0x35570002,  /*  55   Ll, hasUpper (subtract 213), identifier start */
      0x36970002,  /*  56   Ll, hasUpper (subtract 218), identifier start */
      0x36570002,  /*  57   Ll, hasUpper (subtract 217), identifier start */
      0x36D70002,  /*  58   Ll, hasUpper (subtract 219), identifier start */
      0x00070004,  /*  59   Lm, identifier start */
      0x00030006,  /*  60   Mn, identifier part */
      0x09A70001,  /*  61   Lu, hasLower (add 38), identifier start */
      0x09670001,  /*  62   Lu, hasLower (add 37), identifier start */
      0x10270001,  /*  63   Lu, hasLower (add 64), identifier start */
      0x0FE70001,  /*  64   Lu, hasLower (add 63), identifier start */
      0x09970002,  /*  65   Ll, hasUpper (subtract 38), identifier start */
      0x09570002,  /*  66   Ll, hasUpper (subtract 37), identifier start */
      0x10170002,  /*  67   Ll, hasUpper (subtract 64), identifier start */
      0x0FD70002,  /*  68   Ll, hasUpper (subtract 63), identifier start */
      0x0F970002,  /*  69   Ll, hasUpper (subtract 62), identifier start */
      0x0E570002,  /*  70   Ll, hasUpper (subtract 57), identifier start */
      0x0BD70002,  /*  71   Ll, hasUpper (subtract 47), identifier start */
      0x0D970002,  /*  72   Ll, hasUpper (subtract 54), identifier start */
      0x15970002,  /*  73   Ll, hasUpper (subtract 86), identifier start */
      0x14170002,  /*  74   Ll, hasUpper (subtract 80), identifier start */
      0x14270001,  /*  75   Lu, hasLower (add 80), identifier start */
      0x0C270001,  /*  76   Lu, hasLower (add 48), identifier start */
      0x0C170002,  /*  77   Ll, hasUpper (subtract 48), identifier start */
      0x00034009,  /*  78   Nd, identifier part, decimal 0 */
      0x00000007,  /*  79   Me */
      0x00030008,  /*  80   Mc, identifier part */
      0x00037409,  /*  81   Nd, identifier part, decimal 26 */
      0x00005A0B,  /*  82   No, decimal 13 */
      0x00006E0B,  /*  83   No, decimal 23 */
      0x0000740B,  /*  84   No, decimal 26 */
      0x0000000B,  /*  85   No */
      0xFE170002,  /*  86   Ll, hasUpper (subtract -8), identifier start */
      0xFE270001,  /*  87   Lu, hasLower (add -8), identifier start */
      0xED970002,  /*  88   Ll, hasUpper (subtract -74), identifier start */
      0xEA970002,  /*  89   Ll, hasUpper (subtract -86), identifier start */
      0xE7170002,  /*  90   Ll, hasUpper (subtract -100), identifier start */
      0xE0170002,  /*  91   Ll, hasUpper (subtract -128), identifier start */
      0xE4170002,  /*  92   Ll, hasUpper (subtract -112), identifier start */
      0xE0970002,  /*  93   Ll, hasUpper (subtract -126), identifier start */
      0xFDD70002,  /*  94   Ll, hasUpper (subtract -9), identifier start */
      0xEDA70001,  /*  95   Lu, hasLower (add -74), identifier start */
      0xFDE70001,  /*  96   Lu, hasLower (add -9), identifier start */
      0xEAA70001,  /*  97   Lu, hasLower (add -86), identifier start */
      0xE7270001,  /*  98   Lu, hasLower (add -100), identifier start */
      0xFE570002,  /*  99   Ll, hasUpper (subtract -7), identifier start */
      0xE4270001,  /* 100   Lu, hasLower (add -112), identifier start */
      0xFE670001,  /* 101   Lu, hasLower (add -7), identifier start */
      0xE0270001,  /* 102   Lu, hasLower (add -128), identifier start */
      0xE0A70001,  /* 103   Lu, hasLower (add -126), identifier start */
      0x00010010,  /* 104   Cf, ignorable */
      0x0004000D,  /* 105   Zl, whitespace */
      0x0004000E,  /* 106   Zp, whitespace */
      0x0000400B,  /* 107   No, decimal 0 */
      0x0000440B,  /* 108   No, decimal 2 */
      0x0427420A,  /* 109   Nl, hasLower (add 16), identifier start, decimal 1 */
      0x0427800A,  /* 110   Nl, hasLower (add 16), identifier start, strange */
      0x0417620A,  /* 111   Nl, hasUpper (subtract 16), identifier start, decimal 17 */
      0x0417800A,  /* 112   Nl, hasUpper (subtract 16), identifier start, strange */
      0x0007800A,  /* 113   Nl, identifier start, strange */
      0x0000420B,  /* 114   No, decimal 1 */
      0x0000720B,  /* 115   No, decimal 25 */
      0x06A0001C,  /* 116   So, hasLower (add 26) */
      0x0690001C,  /* 117   So, hasUpper (subtract 26) */
      0x00006C0B,  /* 118   No, decimal 22 */
      0x0000560B,  /* 119   No, decimal 11 */
      0x0007720A,  /* 120   Nl, identifier start, decimal 25 */
      0x0007400A,  /* 121   Nl, identifier start, decimal 0 */
      0x00000013,  /* 122   Cs */
      0x00000012   /* 123   Co */
  };


HArrayOfInt *
java_lang_Character_getA(struct Hjava_lang_Character *this)
{
    HArrayOfInt *aHandle = &Ahandle;

    unhand(aHandle) = (ClassArrayOfInt *)A;
    obj_methodtable(aHandle) = (struct methodtable *) mkatype(T_INT, 124);
    return aHandle;
}
