/*
 * @(#)java_lang_ClassLoader_init.c	1.1 98/09/24
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*-
 *      Implementation of class Class
 *
 *      former threadruntime.c, Sun Sep 22 12:09:39 1991
 */

#include <stdio.h>

#include "tree.h"
#include "javaString.h"

#include "monitor.h"
#include "threads.h"
#include "exceptions.h"
#include "reflect.h"
#include "utf.h"

#include "java_lang_Class.h"
#include "java_lang_ClassLoader.h"

extern ClassClass *allocClassClass(void);

extern struct methodblock *loadClassInternal;

/* Initialize loadClassInternal to contain the methodblock that actually
 * implements the code
 */

void java_lang_ClassLoader_init(Hjava_lang_ClassLoader *this) 
{ 
    ClassClass *cb = FindClassFromClass(0, JAVAPKG "ClassLoader", FALSE, 0);
    char *name = "loadClassInternal";
    char *signature = "(L" JAVAPKG "String;Z)L" JAVAPKG "Class;";
    long ID = NameAndTypeToHash(name, signature);

    struct methodblock *mb = cbMethods(cb);
    int n = cbMethodsCount(cb);
    
    for (; --n >= 0; mb++) {
	if (methodID(mb) == ID) {
	    loadClassInternal = mb;
	    return;
	}
    }
    /* Should never reach this point */
    sysAssert(FALSE);
}
