/*
 * @(#)java_lang_ClassLoader_resolveClass0.c	1.1 98/08/28
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*-
 *      Implementation of class Class
 *
 *      former threadruntime.c, Sun Sep 22 12:09:39 1991
 */

#include <stdio.h>

#include "tree.h"
#include "javaString.h"

#include "monitor.h"
#include "threads.h"
#include "exceptions.h"
#include "reflect.h"
#include "utf.h"

#include "java_lang_Class.h"
#include "java_lang_ClassLoader.h"

extern ClassClass *allocClassClass(void);


void
java_lang_ClassLoader_resolveClass0(Hjava_lang_ClassLoader *this, Hjava_lang_Class *c)
{
    ClassClass  *cb;
    char	*detail = 0;
    char	*ename;

    if (this == NULL || c == NULL) {
	SignalError(0, JAVAPKG "NullPointerException", 0);
	return;
    }

    cb = c;
    /* ResolveClass will lock the class and resolve it if necessary */
    if ((ename = ResolveClass(cb, &detail))) {
	/* Should InitializeClass return JAVAPKG ename? */
	/* Sometimes it does! */
	if (strncmp(ename, JAVAPKG, strlen(JAVAPKG)) != 0) {
	    char buf[256];
	    jio_snprintf(buf, 256, "%s%s", JAVAPKG, ename);
	    SignalError(0, buf, detail);
	} else {
	    SignalError(0, ename, detail);
	}
    }
}
