/*
 * @(#)java_lang_Class_forName.c	1.2 98/12/07
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*-
 *      Implementation of class Class
 *
 *      former threadruntime.c, Sun Sep 22 12:09:39 1991
 */

#include <stdio.h>

#include "tree.h"
#include "javaString.h"

#include "monitor.h"
#include "threads.h"
#include "exceptions.h"
#include "reflect.h"
#include "utf.h"

#include "java_lang_Class.h"
#include "java_lang_ClassLoader.h"

extern ClassClass *allocClassClass(void);


Hjava_lang_Class *
java_lang_Class_forName(Hjava_lang_Class *this, HString *classname)
{
    char clname[256], *p;
    ClassClass *cb;
    ClassClass *fromClass;
    ExecEnv *ee = EE();

    javaString2UTF(classname, clname, sizeof(clname));
    /*
     * Must catch slash here; would be missed by IsLegalClassname
     * Note: this is a UTF8 string.
     */
    p = clname;
    while (*p != '\0') {
	unicode ch = next_utf2unicode(&p);
	if (ch == '.') 
	    p[-1] = '/';
	if (ch == '/') {
	    SignalError(ee, JAVAPKG "IllegalArgumentException",
		javaString2UTF(classname, clname, sizeof(clname)));
	    return 0;
	}
    }
    if (!IsLegalClassname(clname, TRUE)) {	/* expects slashed name */
	SignalError(ee, JAVAPKG "IllegalArgumentException", 
	    javaString2UTF(classname, clname, sizeof(clname)));
	return 0;
    }
    /*
     * Make sure you skip the frame for Class.forName() to find
     * the requesting class
     */
    fromClass = getCallerClass(ee, 1);
    if ((cb = FindClassFromClass(ee, clname, TRUE, fromClass)) == 0) {
        /* Check for underlying errors already thrown. */
        if (!exceptionOccurred(ee))
	    SignalError(0, JAVAPKG "ClassNotFoundException", 
		javaString2UTF(classname, clname, sizeof(clname)));
	return 0;
    }

    return cbHandle(cb);
}
