/*
 * @(#)java_lang_Class_getInterfaces.c	1.1 98/08/28
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*-
 *      Implementation of class Class
 *
 *      former threadruntime.c, Sun Sep 22 12:09:39 1991
 */

#include <stdio.h>

#include "tree.h"
#include "javaString.h"

#include "monitor.h"
#include "threads.h"
#include "exceptions.h"
#include "reflect.h"
#include "utf.h"

#include "java_lang_Class.h"
#include "java_lang_ClassLoader.h"

extern ClassClass *allocClassClass(void);


HArrayOfObject *
java_lang_Class_getInterfaces(Hjava_lang_Class *this)
{
    int i;
    ClassClass *cb = this;
    HArrayOfObject *list;
    ExecEnv *ee = EE();
    Hjava_lang_Class **listdata;

    if (!CCIs(cb, Resolved)) {
	char   *detail = NULL;
	char   *exception = ResolveClass(cb, &detail);
	if (exception != NULL) {
	    SignalError(0, exception, detail);
	    return NULL;
	}
    }

    list = (HArrayOfObject *)ArrayAlloc(T_CLASS, cbImplementsCount(cb));
    if (list == 0) {
	SignalError(0, JAVAPKG "OutOfMemoryError", 0);
	return 0;
    }
    listdata = (Hjava_lang_Class **)unhand(list)->body;
    listdata[cbImplementsCount(cb)] = classJavaLangClass;

    /* See if any of the interfaces that we implement possibly implement icb */
    for (i = 0 ; i < (int)cbImplementsCount(cb) ; i++) {
	if (!ResolveClassConstantFromClass(cb,  cbImplements(cb)[i], 
					   ee, 1 << CONSTANT_Class)) {
  	    /* An error occurred during class resolution; propagate it */
  	    return 0;
  	}
	listdata[i] = cbHandle((cbConstantPool(cb)[cbImplements(cb)[i]].clazz));

    }

    KEEP_POINTER_ALIVE(listdata);

    return list;
}
