/*
 * @(#)java_lang_Compiler_compileClass.c	1.1 98/08/28
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

#include "oobj.h"
#include "interpreter.h"
#include "exceptions.h"
#include "java_lang_Compiler.h"
#include "java_lang_String.h"
#include "java_lang_Object.h"

#ifdef SUPPORTCOMPILER

/* This version number should be updated whenever there are changes to
 * the interface between the interpreter and JIT compilers. */
#define COMPILER_VERSION 5

/**
 * JavaVersion is a unique number which changes whenever the interpreter
 * or compiler interface changes.  Compiler writers should treat this value
 * as a fixed constant (ie, don't extract the numbers used to create it), 
 * as how this number is determined may change in future releases.
 */  
static int JavaVersion = (COMPILER_VERSION << 24) | (JAVA_VERSION << 16) | 
                         JAVA_MINOR_VERSION;

/* Flag set when the compiler becomes initialized */
bool_t compilerInitialized = FALSE;

/* The name of the attribute that represents compiled code on this machine. */
char *CompiledCodeAttribute = NULL;

static void (*p_InitializeForCompiler)(ClassClass *cb) = 0;
static void (*p_CompilerFreeClass)(ClassClass *cb) = 0;
static bool_t (*p_invokeCompiledMethod)(JHandle *o, struct methodblock *mb, 
			       int args_size, ExecEnv *ee) = 0; 
static void (*p_CompiledCodeSignalHandler)(int sig, void *info, void *uc) = 0;

static bool_t (*p_CompilerCompileClass)(ClassClass *cb) = 0;
static bool_t (*p_CompilercompileClasses)(Hjava_lang_String *name) = 0;
static Hjava_lang_Object *(*p_CompilerCommand)(Hjava_lang_Object *any) = 0;
static void (*p_CompilerEnable)() = 0;
static void (*p_CompilerDisable)() = 0;
static bool_t (*p_PCinCompiledCode)(unsigned char *, struct methodblock *) = 0;
static unsigned char *(*p_CompiledCodePC)(JavaFrame *frame, struct methodblock *mb) = 0;
static JavaFrame *(*p_CompiledFramePrev)(JavaFrame *frame, JavaFrame *buf) = 0;

void (*p_ReadInCompiledCode)(void *context, 
			     struct methodblock *mb, 
			     int attribute_length, 
			     unsigned long (*get1byte)(),
			     unsigned long (*get2bytes)(), 
			     unsigned long (*get4bytes)(), 
			     void (*getNbytes)());

#endif   /* SUPPORTCOMPILER */

long
java_lang_Compiler_compileClass(Hjava_lang_Compiler *this, 
				     Hjava_lang_Class *clazz) { 
#ifdef SUPPORTCOMPILER
    if (clazz == NULL) { 
	SignalError(0, JAVAPKG "NullPointerException", 0);
	return FALSE;
    } else if (p_CompilerCompileClass != NULL) { 
	return p_CompilerCompileClass(clazz);
    } else { 
	return FALSE;
    }
#else
    return FALSE;
#endif
}
