/*
 * @(#)java_lang_Object_clone.c	1.1 98/08/28
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*-
 *      Implementation of class Object
 *
 *      former threadruntime.c, Sun Sep 22 12:09:39 1991
 */

#include <stdio.h>
#include <limits.h>

#include "tree.h"
#include "typecodes.h"
#include "javaString.h"
#include "signature.h"

#include "monitor.h"
#include "threads.h"
#include "exceptions.h"
#include "path.h"

#include "java_lang_Object.h"

HObject *java_lang_Object_clone(HObject *this)
{
    if (obj_isnt_array(this)) {
	ClassClass *cb = obj_classblock(this);
	HObject *clone;
	if (!is_instance_of(this, interfaceJavaLangCloneable, EE())) { 
	    char clname[256];
	    classname2string(cbName(cb), clname, sizeof(clname));
	    SignalError(0, JAVAPKG "CloneNotSupportedException", clname);
	    return NULL;
	}
	clone = ObjAlloc(cb, 0);
	if (clone == 0) {
	    char buf[128];
	    SignalError(0, JAVAPKG "OutOfMemoryError", 
			classname2string(cbName(cb), buf, sizeof(buf)));
	    return NULL;
	}
	{
	    char *to = (char*)unhand(clone);
	    char *from = (char*)unhand(this);
	    memcpy(to, from, cbInstanceSize(cb));
	    KEEP_POINTER_ALIVE(to && from);
	}
	return clone;
    } else { 
	int type = array_type_to_type[obj_array_flags(this)];
	int size = obj_length(this);
	int bytes = 
	       sizearray(type, size) + (type == T_CLASS ? sizeof(OBJECT) : 0);
	HObject *clone = ArrayAlloc(type, size);
	if (clone == 0) {
	    SignalError(0, JAVAPKG "OutOfMemoryError", 0);
	    return NULL;
	}
	{
	    char *to = (char*)unhand(clone);
	    char *from = (char*)unhand(this);
	    memcpy(to, from, bytes);
	    KEEP_POINTER_ALIVE(to && from);
	}
	return clone;
    }
}

