/*
 * @(#)java_lang_Object_wait.c	1.1 98/08/28
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*-
 *      Implementation of class Object
 *
 *      former threadruntime.c, Sun Sep 22 12:09:39 1991
 */

#include <stdio.h>
#include <limits.h>

#include "tree.h"
#include "typecodes.h"
#include "javaString.h"
#include "signature.h"

#include "monitor.h"
#include "threads.h"
#include "exceptions.h"
#include "path.h"

#include "java_lang_Object.h"


void
java_lang_Object_wait(JHandle *p, int64_t millis)
{
    int ms;

    if (ll_ltz(millis)) {
        SignalError(0, JAVAPKG "IllegalArgumentException",
                    "timeout value is negative");
        return;
    }

    /*
     * monitorWait() takes a C long, not a long long.  We could redo
     * that to take a 64-bit integer, but that breaks the JIT interface
     * and doesn't seem very motivated.  So we truncate.
     */
    if (ll_lt(millis, int2ll(LONG_MAX))) {
	ms = ll2int(millis);
    } else {
	ms = TIMEOUT_INFINITY;
    }

    if (p == 0) {	/* Should this report a NullPointerException? */
	return;
    }

    if (ms) {
	monitorWait(obj_monitor(p), ms);
    } else {
	monitorWait(obj_monitor(p), TIMEOUT_INFINITY);
    }
    return;
}
