/*
 * @(#)java_lang_SecurityManager_classDepth.c	1.1 98/10/14
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include "native.h"
#include "java_lang_SecurityManager.h"
#include "javaString.h"

extern bool_t
checkSecurityManagerInitialized(JNIEnv *env, jobject this);

JNIEXPORT jint JNICALL
Java_java_lang_SecurityManager_classDepth(JNIEnv *env, jobject this, jstring _name)
{
    struct javaframe *frame, frame_buf;
    ClassClass	*cb;
    char buf[128], *p;
    int depth = 0;
    HString *name = (HString *)DeRef(env, _name);

    /* Make sure the security manager instance is initialized */
    if (!checkSecurityManagerInitialized(env, this))
	return -1;		/* exception */

    javaString2CString(name, buf, sizeof(buf));
    for (p = buf ; *p ; p++) {
	if (*p == '.') {
	    *p = '/';
	}
    }

    for (frame = EE()->current_frame ; frame != 0 ; ) {
	if (!IS_NATIVE_FRAME(frame)) {
	    cb = methodclass(frame->current_method);
	    if (cb && !strcmp(cbName(cb), buf)) {
		return depth;
	    }
	    depth++;
	}
	frame = FRAME_PREV(frame, &frame_buf);
    }
    return -1;
}

