/*
 * @(#)java_lang_SecurityManager_currentClassLoader.c	1.1 98/10/14
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include "native.h"
#include "java_lang_SecurityManager.h"
#include "javaString.h"

extern bool_t
checkSecurityManagerInitialized(JNIEnv *env, jobject this);

JNIEXPORT jobject JNICALL
Java_java_lang_SecurityManager_currentClassLoader(JNIEnv *env, jobject this)
{
    struct javaframe *frame, frame_buf;
    ClassClass	*cb;

    /* Make sure the security manager instance is initialized */
    if (!checkSecurityManagerInitialized(env, this))
	return NULL;		/* exception */

    for (frame = EE()->current_frame ; frame != 0 ;) {
	if (!IS_NATIVE_FRAME(frame)) {
	    cb = methodclass(frame->current_method);
	    if (cb && cbLoader(cb) && is_untrusted(cb)) {
	        return MkRefLocal(env, cbLoader(cb));
	    }
	}
	frame = FRAME_PREV(frame, &frame_buf);
    }
    return 0;
}

