/*
 * @(#)java_lang_System_setErr0.c	1.2 98/10/28
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * Modification History:
 *
 * 22 Aug 1994	eugene
 *
 *	inserted a "machine independent" porting layer for machine
 *	specific non-posix lib and system calls.
 *	removed the open boot prom reading and writing code.  should
 *	use getenv and putenv for environment variable moshing.  no
 *	other reason to keep prom code around (we run hosted now!!).
 *
 */

#include <stdlib.h>
#include <fcntl.h>

#include "oobj.h"
#include "tree.h"
#include "interpreter.h"
#include "javaString.h"
#include "typecodes.h"
#include "sys_api.h"

#include "java_lang_System.h"
#include "jni.h"


void
java_lang_System_setErr0(struct Hjava_lang_System *this,
			struct Hjava_io_PrintStream *stream)
{
    JNIEnv *env = EE2JNIEnv(EE());
    jclass cls = (*env)->FindClass(env, "java/lang/System");
    jobject stm = MkRefLocal(env, stream);

    Java_java_2lang_2System_setErr (env, cls, stm);

    (*env)->DeleteLocalRef(env, cls);
    (*env)->DeleteLocalRef(env, stm);
}
