/*
 * @(#)java_lang_Thread_countStackFrames.c	1.2 98/09/05
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*-
 *      Stuff for dealing with threads.
 *      originally in threadruntime.c, Sun Sep 22 12:09:39 1991
 */

#include <stdio.h>
#include <limits.h>

#include "tree.h"
#include "threads.h"
#include "monitor.h"
#include "threads.h"
#include "exceptions.h"
#include "sys_api.h"

#include "java_lang_Object.h"
#include "java_lang_Throwable.h"
#include "java_lang_Thread.h"

/* This doesn't count methods implemented in C. */
JNIEXPORT jint JNICALL
Java_java_lang_Thread_countStackFrames(JNIEnv *env, jobject this)
{
    Hjava_lang_Thread *hp = (Hjava_lang_Thread *)DeRef(env, this);
    if (hp == 0) {
	SignalError(0, JAVAPKG "NullPointerException", 0);
	return -1;
    } else {
	Classjava_lang_Thread *p = unhand(hp);
	ExecEnv *this_ee = (ExecEnv *) p->eetop;
	JavaFrame *frame, frame_buf;
	int count;

	if (this_ee == 0) {
	    /* Thread hasn't any state yet. */
	    return 0;
	}
	frame = this_ee->current_frame;
	for (count = 0; frame != 0 ; ) {
            if (!IS_NATIVE_FRAME(frame)) {
		count++;
	    }
	    frame = FRAME_PREV(frame, &frame_buf);
	}
	return count;
    }
}
