/*
 * @(#)java_lang_Thread_isAlive.c	1.2 98/09/05
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*-
 *      Stuff for dealing with threads.
 *      originally in threadruntime.c, Sun Sep 22 12:09:39 1991
 */

#include <stdio.h>
#include <limits.h>

#include "tree.h"
#include "threads.h"
#include "monitor.h"
#include "threads.h"
#include "exceptions.h"
#include "sys_api.h"

#include "java_lang_Object.h"
#include "java_lang_Throwable.h"
#include "java_lang_Thread.h"

/*
 * Note that we don't go to the native thread to determine whether the Java
 * thread is alive.  The status of the native thread doesn't matter, to the
 * first approximation at least, if the Java thread object isn't set up
 * properly.  However, we could also double-check the liveness of the native
 * thread.
 */
JNIEXPORT jboolean JNICALL
Java_java_lang_Thread_isAlive(JNIEnv *env, jobject this)
{
    struct Classjava_lang_Thread *tid;
    tid = (struct Classjava_lang_Thread *) unhand(DeRef(env, this));
    return (jboolean)(tid->PrivateInfo != 0 && !tid->stillborn);
}
