/*
 * @(#)java_lang_Thread_sleep.c	1.3 99/09/08
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*-
 *      Stuff for dealing with threads.
 *      originally in threadruntime.c, Sun Sep 22 12:09:39 1991
 */

#include <stdio.h>
#include <limits.h>

#include "tree.h"
#include "threads.h"
#include "monitor.h"
#include "threads.h"
#include "exceptions.h"
#include "sys_api.h"

#include "java_lang_Object.h"
#include "java_lang_Throwable.h"
#include "java_lang_Thread.h"


JNIEXPORT void JNICALL
Java_java_lang_Thread_sleep(JNIEnv *env, jclass this, jlong millis)
{
    int ms;

    if (ll_ltz(millis)) {
	SignalError(0, JAVAPKG "IllegalArgumentException",
		    "timeout value is negative");
	return;
    }   

    /*   
     * monitorWait() takes a C long, not a long long.  We could redo
     * that to take a 64-bit integer, but that breaks the JIT interface
     * and doesn't seem very motivated.  So we truncate.
     */  
    if (ll_lt(millis, int2ll(LONG_MAX))) { 
	ms = ll2int(millis);
    } else {
	ms = TIMEOUT_INFINITY;
    }

    threadSleep(ms);
    return;
}
