/*
 * @(#)java_lang_Throwable_fillInStackTrace.c	1.2 98/09/05
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*-
 *      Implementation of class Throwable
 *
 *      former classruntime.c, Wed Jun 26 18:43:20 1991
 */

#include <stdio.h>

#include "tree.h"
#include "javaString.h"

#include "monitor.h"
#include "threads.h"
#include "exceptions.h"

#include "java_lang_Throwable.h"
#include "java_lang_Thread.h"

#undef min
#define min(x, y) (((int)(x) < (int)(y)) ? (x) : (y))

/*
 * Fill in the current stack trace in this exception.  This is
 * usually called automatically when the exception is created but it
 * may also be called explicitly by the user.  This routine returns
 * `this' so you can write 'throw e.fillInStackTrace();'
 */
Hjava_lang_Throwable *
java_lang_Throwable_fillInStackTrace(Hjava_lang_Throwable *obj)
{
    JavaFrame frame_buf, *start_frame;

#if defined(SELFTEST)
	/* 	For SELFTEST specifically -- but this may be useful in other
		contexts also -- it's convenient to throw an exception when
		there is no thread active.  */
    if (threadSelf())
	{
	    ExecEnv *ee = (ExecEnv *)(THREAD(threadSelf())->eetop);

	    start_frame = FRAME_PREV(ee->current_frame, &frame_buf);
	    fillInStackTraceFromFrame(obj, ee, start_frame);
	}
#else
    ExecEnv *ee = (ExecEnv *)(THREAD(threadSelf())->eetop);

    start_frame = FRAME_PREV(ee->current_frame, &frame_buf);
    fillInStackTraceFromFrame(obj, ee, start_frame);
#endif
    return obj;
}
