/*
 * @(#)java_lang_Throwable_printStackTrace0.c	1.3 98/11/10
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*-
 *      Implementation of class Throwable
 *
 *      former classruntime.c, Wed Jun 26 18:43:20 1991
 */

#include <stdio.h>

#include "tree.h"
#include "javaString.h"

#include "monitor.h"
#include "threads.h"
#include "exceptions.h"

#include "java_lang_Throwable.h"
#include "java_lang_Thread.h"

#undef min
#define min(x, y) (((int)(x) < (int)(y)) ? (x) : (y))


/* NOTE: The second argument to printStackTrace0() is expected to be an object
 * with a void println(char[]) method, such as a PrintStream or a PrintWriter.
 */

void
java_lang_Throwable_printStackTrace0(Hjava_lang_Throwable *o,
				     HObject *s)
{
    struct HArrayOfInt *backtrace = (HArrayOfInt *)(unhand(o)->backtrace);

    /* This is a hack to make printStackTrace() work if System.err is still
     * null. Since printStackTrace() doesn't do the println(o->toString())
     * in that case, we do it here instead.
     */
    if (s == NULL) {
	HString* exceptionString;
        char buf[256];
       	exceptionString = (HString*)execute_java_dynamic_method
	    (EE(), (HObject*)o, "toString", "()Ljava/lang/String;");
	if (exceptionString != NULL) {
	    javaString2CString(exceptionString, buf, sizeof(buf)/sizeof(char));
	    fprintf(stderr, "%s\n", buf);
	}
    }
    	
    if (backtrace != NULL) {
	long *real_data = unhand(backtrace)->body;
	unsigned char **data = (unsigned char **)(real_data);
	unsigned char **enddata = 
	     (unsigned char **)(real_data + obj_length(backtrace));
	for (; data < enddata; data++) { 
	    if (*data != 0) {
		#define LEN 128
		char where[LEN];
		HArrayOfChar *chars;
		int i = 0;

		strncpy(where + i, "\tat ", 4); i += 4;
		pc2string(*data, 0, where + i, where + sizeof(where));

		if (s == NULL) {
		    /* this is a continuation of the System.err == null hack.
		     * Instead of calling s->println, we just send the
		     * output to stderr here.
		     */
		    fprintf(stderr, "%s\n", where);
		}
		else {
		    i = strlen(where);
		    i = min(i, LEN-2);
		    chars = MakeString(where, i);
		    execute_java_dynamic_method(EE(), s,
					    "println", "([C)V", chars);
		}
	    }
	}
	KEEP_POINTER_ALIVE(real_data);
    }
}
