/*
 * @(#)java_lang_reflect_Array_multiNewArray.c	1.1 98/08/28
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*
 * Native code for java.lang.reflect.Array.
 *
 * TODO: Performance
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#define	_REFLECT_IMPL

#include "sys_api.h"				/* sysAssert() */
#include "native.h"
#include "signature.h"
#include "reflect.h"

#include "java_lang_reflect_Array.h"

#define	NegativeArraySize()	\
	REFLECT_ERROR(NegativeArraySizeException, 0)

/* Maximum allowed in a class file */
#define	MAXDIM	255

struct Hjava_lang_Object *
java_lang_reflect_Array_multiNewArray(
    struct Hjava_lang_reflect_Array *ignore,
    struct Hjava_lang_Class *eltType,
    HArrayOfInt *hdim)
{
    stack_item dim[MAXDIM];
    int i, len;
    long l, *lp;
    char aname[MAXPATHLEN+8], *np = aname;
    ClassClass *eltcb, *acb;

    if (eltType == NULL || hdim == NULL) {
	NullPointerException();
	return NULL;
    }

    len = obj_length(hdim);
    if (len <= 0) {
	REFLECT_ERROR(IllegalArgumentException, "zero dimensions");
	return NULL;
    }
    if (len >= MAXDIM || len >= MAXPATHLEN) {
	REFLECT_ERROR(IllegalArgumentException, "too many dimensions");
	return NULL;
    }

    lp = unhand(hdim)->body;

    for (i = 0; i < len; i++) {
	l = lp[i];
	if (l < 0) {
	    NegativeArraySize();
	    return NULL;
	}
	dim[i].i = l;				/* XXX int = long */
    }

    KEEP_POINTER_ALIVE(lp);

    eltcb = eltType;

    /*
     * Cook up a string naming the required array class
     */
    for (i = 0; i < len; i++) {
	*np++ = SIGNATURE_ARRAY;
    }
    if (cbIsPrimitive(eltcb)) {
	/* Primitive array */
	*np++ = cbTypeSig(eltcb);
    } else {
	char *eltname = cbName(eltcb);
	int eltnamelen = strlen(eltname);

	if (eltnamelen + len >= MAXPATHLEN) {
	    InternalError("signature overflow");
	    return NULL;
	}

	if (eltname[0] == SIGNATURE_ARRAY) {
	    /* Array of array type: handle it */
	    strcpy(np, eltname);
	    np += eltnamelen;
	} else {
	    /* Class or interface array */
	    *np++ = SIGNATURE_CLASS;
	    strcpy(np, eltname);
	    np += eltnamelen;
	    *np++ = SIGNATURE_ENDCLASS;
	}
    }
    *np = '\0';					/* NUL-terminate */
    
    if ((acb = FindClassFromClass(0, aname, TRUE, eltcb)) == NULL) {
	REFLECT_ERROR(NoClassDefFoundError, aname); /* XXX */
	return NULL;
    }

    return MultiArrayAlloc(len, acb, dim);

}
