/*
 * @(#)java_lang_reflect_Array_newArray.c	1.1 98/08/28
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*
 * Native code for java.lang.reflect.Array.
 *
 * TODO: Performance
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#define	_REFLECT_IMPL

#include "sys_api.h"				/* sysAssert() */
#include "reflect.h"

#include "java_lang_reflect_Array.h"

#define	NegativeArraySize()	\
	REFLECT_ERROR(NegativeArraySizeException, 0)

struct Hjava_lang_Object *
java_lang_reflect_Array_newArray(
    struct Hjava_lang_reflect_Array *ignore,
    struct Hjava_lang_Class *eltType,
    long length)
{
    if (eltType == NULL) {
	NullPointerException();
	return NULL;
    }
    if (length < 0) {
	NegativeArraySize();
	return NULL;
    }
    return reflect_new_array(eltType, length);
}
