/*
 * @(#)java_lang_reflect_Array_set.c	1.1 98/08/28
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*
 * Native code for java.lang.reflect.Array.
 *
 * TODO: Performance
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#define	_REFLECT_IMPL

#include "sys_api.h"				/* sysAssert() */
#include "native.h"
#include "typecodes.h"
#include "wrap.h"
#include "reflect.h"

#include "java_lang_reflect_Array.h"

#define	IllegalArray()	\
	REFLECT_ERROR(IllegalArgumentException, "argument is not an array")

#define	ArrayIndexOutOfBounds()	\
	REFLECT_ERROR(ArrayIndexOutOfBoundsException, 0)

#define	ElementTypeMismatch() \
	REFLECT_ERROR(IllegalArgumentException, "array element type mismatch")

#define	CHECK_ARRAY(harr, tag)				\
if (TRUE)						\
{							\
    if (harr == NULL) {					\
	NullPointerException();				\
	goto tag;					\
    }							\
    if (obj_isnt_array(harr)) {           		\
	IllegalArray();					\
	goto tag;					\
    }							\
} else

#define	CHECK_ARRAY_AND_INDEX(harr, index, tag)		\
if (TRUE)						\
{							\
    CHECK_ARRAY(harr, tag);				\
    if (index < 0 || index >= obj_length(harr)) {	\
	ArrayIndexOutOfBounds();			\
	goto tag;					\
    }							\
} else

#define	DECODE_ARRAY(harr, ndx, p, pCode, tag)			\
if (TRUE)							\
{								\
    CHECK_ARRAY_AND_INDEX(harr, ndx, tag);			\
    {								\
    OBJECT *_p_ = unhand(harr);					\
    switch(pCode = array_type_to_type[obj_array_flags(harr)]) { \
    case T_BOOLEAN:						\
    case T_BYTE:						\
	p = (char *) &((ArrayOfByte *)_p_)->body[ndx]; break;	\
    case T_SHORT:						\
	p = (char *) &((ArrayOfShort *)_p_)->body[ndx]; break;	\
    case T_CHAR:						\
	p = (char *) &((ArrayOfChar *)_p_)->body[ndx]; break;	\
    case T_INT:							\
	p = (char *) &((ArrayOfInt *)_p_)->body[ndx]; break;	\
    case T_LONG:						\
	p = (char *) &((ArrayOfLong *)_p_)->body[ndx]; break;	\
    case T_FLOAT:						\
	p = (char *) &((ArrayOfFloat *)_p_)->body[ndx]; break;	\
    case T_DOUBLE:						\
	p = (char *) &((ArrayOfDouble *)_p_)->body[ndx]; break;	\
    case T_CLASS:						\
	p = (char *) &((ArrayOfObject *)_p_)->body[ndx]; break;	\
    default:							\
	InternalError("illegal array type");			\
	goto tag;						\
    }								\
    }								\
} else

void
java_lang_reflect_Array_set(
    struct Hjava_lang_reflect_Array *ignore,
    struct Hjava_lang_Object *harr,
    long index,
    struct Hjava_lang_Object *value)
{
    char *p;
    int pCode;

    DECODE_ARRAY(harr, index, p, pCode, bad);

    if (pCode == T_CLASS) {
	long len = obj_length(harr);
	ArrayOfObject *optr = (ArrayOfObject *)unhand(harr);
	ClassClass *eltcb = (ClassClass *)optr->body[len];

	if (!is_instance_of(value, eltcb, NULL))
	    goto noconversion;
	*(HObject **)p = value;

    } else {
	JavaValue v;
	unsigned char vCode;

	if ((vCode = java_unwrap(value, &v)) == T_BAD)
	    return;				/* exception */
	if (vCode != pCode)
	    REFLECT_WIDEN(v, vCode, pCode, noconversion);
	REFLECT_SET(p, pCode, v, TRUE);
    }

    return;

  noconversion:
    ElementTypeMismatch();

  bad:
    return;
}
