/*
 * @(#)java_lang_reflect_Constructor_getModifiers.c	1.1 98/08/28
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*
 * Native code for java.lang.reflect.Method and
 * java.lang.reflect.Constructor.
 * 
 * TODO: Performance.
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#define	_REFLECT_IMPL

#include "sys_api.h"				/* sysAssert */
#include "reflect.h"

#include "java_lang_reflect_Constructor.h"

/*
 * A reflected method's slot is an index into the methods list of its
 * declaring classblock.
 */

#define	GET_CLASS_METHODBLOCK(cb, slot)				\
    (((slot) < 0 || (slot) >= (cbMethodsCount(cb)))		\
	? NULL : (cbMethods(cb) + (slot)))

/*
 * NOTE: Relies on the fact that methods are allocated contiguously in
 * cbMethods(cb).  Else, we have to match on ID.
 */
#define	GET_METHODBLOCK_SLOT(cb, mb) ((mb) - cbMethods(cb))

/*
 * Get the modifiers for a constructor
 */
long
java_lang_reflect_Constructor_getModifiers(
    struct Hjava_lang_reflect_Constructor * hc)
{
    struct methodblock *mb = 
	GET_CLASS_METHODBLOCK(member_class(hc), member_slot(hc));
    if (mb == NULL) {
	InternalError("getModifiers");
	return 0;
    }
    return mbAccess(mb) & ACC_WRITTEN_FLAGS;
}
