/*
 * @(#)java_lang_reflect_Field_getModifiers.c	1.1 98/08/28
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*
 * Native code for java.lang.reflect.Field.
 *
 * TODO: Performance
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#define _REFLECT_IMPL

#include "sys_api.h"				/* sysAssert() */
#include "reflect.h"

#include "java_lang_reflect_Field.h"

/*
 * A reflected field's slot is an index into cbFields(cb) of its
 * declaring class.
 */

#define	GET_CLASS_FIELDBLOCK(cb, slot)				\
    (((slot) < 0 || (slot) >= (cbFieldsCount(cb)))		\
	? NULL : (cbFields(cb) + (slot)))

/*
 * Get the modifiers for a field
 */
long
java_lang_reflect_Field_getModifiers(struct Hjava_lang_reflect_Field * hf)
{
    struct fieldblock *fb;

    /* Get class fieldblock for slot */
    if ((fb = GET_CLASS_FIELDBLOCK(member_class(hf), member_slot(hf)))
	== NULL)
	return 0;				/* exception */
    return fbAccess(fb) & ACC_WRITTEN_FLAGS;
}
