/*
 * @(#)java_lang_reflect_Field_set.c	1.1 98/08/28
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*
 * Native code for java.lang.reflect.Field.
 *
 * TODO: Performance
 */

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

#define	_REFLECT_IMPL

#include "sys_api.h"				/* sysAssert() */
#include "native.h"
#include "typecodes.h"
#include "wrap.h"
#include "reflect.h"

#include "java_lang_reflect_Field.h"

#define	FieldTypeMismatch()					\
	REFLECT_ERROR(IllegalArgumentException, "field type mismatch")

#define	IllegalAccess(s)					\
	REFLECT_ERROR(IllegalAccessException, s)

extern struct fieldblock *
get_field( struct Hjava_lang_reflect_Field * hf,
           struct Hjava_lang_Object * o,
           OBJECT **addrp,                     
           ClassClass **typep);     

void
java_lang_reflect_Field_set(
    struct Hjava_lang_reflect_Field * hf,
    struct Hjava_lang_Object * o,
    struct Hjava_lang_Object * value)
{
    struct fieldblock *fb;
    ClassClass *cb;
    OBJECT *p;
    void *unhandO = o ? unhand(o) : 0;

    if ((fb = get_field(hf, o, &p, &cb)) == NULL)
	return;					/* exception */

    if (fbIsFinal(fb)) {
	IllegalAccess("field is final");
	return;
    }

    if (cbIsPrimitive(cb)) {
	JavaValue v;
	unsigned char pCode = cbTypeCode(cb);
	unsigned char vCode;

	if ((vCode = java_unwrap(value, &v)) == T_BAD)
	    return;				/* exception */
	if (vCode != pCode)
	    REFLECT_WIDEN(v, vCode, pCode, bad);
	REFLECT_SET(p, pCode, v, FALSE);
	KEEP_POINTER_ALIVE(unhandO);
	return;

    } else if (is_instance_of(value, cb, NULL)) {
	*(HObject **)p = value;
	KEEP_POINTER_ALIVE(unhandO);
	return;
    }
	
  bad:
    FieldTypeMismatch();
}
