/*
 * @(#)system.c	1.1 98/11/18
 * 
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 * Modification History:
 *
 * 22 Aug 1994	eugene
 *
 *	inserted a "machine independent" porting layer for machine
 *	specific non-posix lib and system calls.
 *	removed the open boot prom reading and writing code.  should
 *	use getenv and putenv for environment variable moshing.  no
 *	other reason to keep prom code around (we run hosted now!!).
 *
 */

#include <stdlib.h>
#include <fcntl.h>

#include "oobj.h"
#include "tree.h"
#include "interpreter.h"
#include "javaString.h"
#include "typecodes.h"
#include "sys_api.h"

#include "java_lang_System.h"
#include "jni.h"


/**
 * The following three functions implement setter methods for
 * java.lang.System.{in, out, err}. There are written to the new Java
 * Native Interface (JNI). They are natively implemented because they
 * violate the semantics of the language (i.e. set final
 * variable). Currently our build process cannot deal with both
 * old-style and new-style native interfaces so we include functions
 * for both, with the old calling the new.
 */

void
Java_java_2lang_2System_setIn
(JNIEnv * env, jclass cla, jobject stream) 
{
    jfieldID fid = 
        (*env)->GetStaticFieldID(env,cla,"in","Ljava/io/InputStream;");
    (*env)->SetStaticObjectField(env,cla,fid,stream);
}

void 
Java_java_2lang_2System_setOut
(JNIEnv * env, jclass cla, jobject stream) 
{
    jfieldID fid =
        (*env)->GetStaticFieldID(env,cla,"out","Ljava/io/PrintStream;");
    (*env)->SetStaticObjectField(env,cla,fid,stream);
}

void
Java_java_2lang_2System_setErr
(JNIEnv * env, jclass cla, jobject stream)
{
    jfieldID fid = 
        (*env)->GetStaticFieldID(env,cla,"err","Ljava/io/PrintStream;");
    (*env)->SetStaticObjectField(env,cla,fid,stream);
}

