/*
 * @(#)common_exceptions.c	1.15 98/09/04
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*-
 * Common exceptions thrown from within the interpreter (and
 * associated libraries).
 */

/*
 * Header files.
 */
#include "common_exceptions.h"
#include "oobj.h"
#include "interpreter.h"
#include "threads.h"

#include "java_lang_Thread.h"

/*
 * Macros.
 */

#define	JAVA_LANG_EXCEPTION_ROUTINE(name)			\
void								\
name(void)							\
{								\
    SignalError(0, JAVAPKG #name, 0);				\
}

/*
 * External routines.
 */
JAVA_LANG_EXCEPTION_ROUTINE(OutOfMemoryError)

void ThrowOutOfMemoryError(ExecEnv *ee, char *s)
{
    SignalError(ee, JAVAPKG "OutOfMemoryError", s);
}

void ThrowStackOverflowError(ExecEnv *ee, char *s)
{
    SignalError(ee, JAVAPKG "StackOverflowError", s);
}

void ThrowStringIndexOutOfBoundsException(ExecEnv *ee, char *s)
{
    SignalError(ee, JAVAPKG "StringIndexOutOfBoundsException", s);
}

void ThrowIllegalArgumentException(ExecEnv *ee, char *s)
{
    SignalError(ee, JAVAPKG "IllegalArgumentException", s);
}

void ThrowArrayIndexOutOfBoundsException(ExecEnv *ee, char *s)
{
    SignalError(ee, JAVAPKG "ArrayIndexOutOfBoundsException", s);
}
