/*
 * Copyright (c) 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

#ident "@(#)preloader.c	1.12 98/09/28 SMI"

#include <stdio.h>
#include <oobj.h>
#include <interpreter.h>
#include <sys_api.h>

extern ClassClass ROMClassHandles[];

/*
 * The code to initialize the pointers that will
 * cause java to use the ROM-based data structures
 */
void
UseROMClasses()
{
    int i;
    int romCount = numRomClasses;
    ClassClass *classP = ROMClassHandles;

    nbinclasses = romCount;
    sizebinclasses = romCount * 2;
    
    /* Allocate memory and copy initial list of classes */
    binclasses = (ClassClass **)sysCalloc(sizebinclasses,
					     sizeof (ClassClass *));
    for (i = 0; i < romCount; i++) 
        binclasses[i] = classP++;

    /* By putting this initialization here, ROMClassesInfo goes into BSS */
    ROMClassesInfo[0] = ROMCLASS_Initializing | ROMCLASS_Initialized;

    javaLangClassMethods = cbMethodTable(classJavaLangClass);
}
