/*
 * @(#)globals.c	1.27 98/08/31
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*
 *      Some development environments don't support common storage
 *      (i.e. data in multiply included .h files not marked extern).
 *      Here is where we declare everything in .h files marked extern.
 */


#include "oobj.h"
#include "tree.h"
#include "interpreter.h"

char *progname;
ClassClass **binclasses;
long nbinclasses, sizebinclasses;
bool_t verbose;
bool_t verbosegc;
bool_t noasyncgc;
bool_t classgc;
int verifyclasses;
bool_t debugging;

typedef jint (JNICALL *vfprintf_hook_t)(FILE *fp, const char *format, 
					va_list args);
typedef void (JNICALL *exit_hook_t)(jint code);
typedef void (JNICALL *abort_hook_t)();

/* initialize all to zero, so that we can tell whether they've been 
   overwritten.
 */
vfprintf_hook_t vfprintf_hook = 0;
exit_hook_t exit_hook = 0;
abort_hook_t abort_hook = 0;

unsigned char **mainstktop;

/* Win32 can't export variables to shared-libraries, just functions.
 * These access routines are therefore needed by the debugger.
 */
ClassClass** get_binclasses(void)  { return binclasses; }
ClassClass*  get_classClass(void)  { return classJavaLangClass; }
ClassClass*  get_classObject(void) { return classJavaLangObject; }
long         get_nbinclasses(void) { return nbinclasses; }

#ifdef JCOV
char* testname = (char *)NULL; 		/* Name of test */
char* cov_file = (char *)NULL;		/* Name of code coverage file */
#endif /* JCOV */

char* prof_file = (char *)NULL;		/* Name of profiling output file */
