/*
 * @(#)java_util_zip_Adler32_update.c	1.2 98/10/12
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*
 * Native method support for compression classes.
 */

#include <errno.h>
#include <string.h> /* for strerror() */

#include "sys_api.h"
#include "zlib.h"
#include "jni.h"

#ifdef ZIPEXTRAS
#include "java_util_zip_Adler32.h"

void
java_util_zip_Adler32_update(Hjava_util_zip_Adler32 *Hthis,
			     HArrayOfByte *Hbuf, long off, long len)
{
    Classjava_util_zip_Adler32 *this = unhand(Hthis);
    Bytef *buf = (Bytef *)unhand(Hbuf)->body;

    if (Hbuf == 0) {
	SignalError(0, JAVAPKG "NullPointerException", 0);
    } else if (off < 0 || len < 0 || off + len > obj_length(Hbuf)) {
	SignalError(0, JAVAPKG "ArrayIndexOutOfBoundsException", 0);
    } else if (len > 0) {
	this->adler = adler32(this->adler, buf + off, len);
    }
    KEEP_POINTER_ALIVE(buf);
}
#endif
