/*
 * @(#)java_util_zip_Deflater_init.c	1.2 98/10/12
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*
 * Native method support for compression classes.
 */

#include <errno.h>
#include <string.h> /* for strerror() */

#include "sys_api.h"
#include "zlib.h"
#include "jni.h"

#ifdef ZIPEXTRAS
#include "java_util_zip_Deflater.h"
#define DEF_MEM_LEVEL 8

void
java_util_zip_Deflater_init(Hjava_util_zip_Deflater *Hthis, long nowrap)
{
    Classjava_util_zip_Deflater *this = unhand(Hthis);
    z_stream *strm = sysCalloc(1, sizeof(z_stream));
    char *msg;

    if (strm == 0) {
	SignalError(0, JAVAPKG "OutOfMemory", 0);
    } else {
	switch (deflateInit2(strm, this->level, Z_DEFLATED,
			     nowrap ? -MAX_WBITS : MAX_WBITS,
			     DEF_MEM_LEVEL, this->strategy)) {
	  case Z_OK:
	    this->strm = (long)strm;
	    return;
	  case Z_MEM_ERROR:
	    sysFree(strm);
	    SignalError(0, JAVAPKG "OutOfMemoryError", 0);
	    return;
	  case Z_STREAM_ERROR:
	    sysFree(strm);
	    SignalError(0, JAVAPKG "IllegalArgumentException", 0);
	    return;
	  default:
	    msg = strm->msg;
	    sysFree(strm);
	    SignalError(0, JAVAPKG "InternalError", msg);
	    return;
	}
    }
}
#endif
