/*
 * @(#)java_util_zip_Inflater_getAdler.c	1.2 98/10/12
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*
 * Native method support for compression classes.
 */

#include <errno.h>
#include <string.h> /* for strerror() */

#include "sys_api.h"
#include "zlib.h"
#include "jni.h"

#include "java_util_zip_Inflater.h"

long
java_util_zip_Inflater_getAdler(Hjava_util_zip_Inflater *Hthis)
{
#ifdef ZIPEXTRAS
    Classjava_util_zip_Inflater *this = unhand(Hthis);
    z_stream *strm = (z_stream *)this->strm;

    if (strm == 0) {
	SignalError(0, JAVAPKG "NullPointerException", 0);
	return 0;
    }
    return strm->adler;
#else
    SignalError(0, JAVAPKG "UnsupportedOperationException", 0);
    return 0;
#endif
}
