/*
 * @(#)java_util_zip_Inflater_inflate.c	1.2 98/10/12
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*
 * Native method support for compression classes.
 */

#include <errno.h>
#include <string.h> /* for strerror() */

#include "sys_api.h"
#include "zlib.h"
#include "jni.h"

#include "java_util_zip_Inflater.h"

#define ZIPPKG "java/util/zip/"

long
java_util_zip_Inflater_inflate(Hjava_util_zip_Inflater *Hthis,
			       HArrayOfByte *Hbuf, long off, long len)
{
    Classjava_util_zip_Inflater *this = unhand(Hthis);
    z_stream *strm = (z_stream *)this->strm;
    Bytef *in_buf, *out_buf;

    if (this->buf == 0 || Hbuf == 0 || strm == 0) {
	SignalError(0, JAVAPKG "NullPointerException", 0);
	return 0;
    }
    if (off < 0 || len < 0 || off + len > obj_length(Hbuf)) {
	SignalError(0, JAVAPKG "ArrayIndexOutOfBoundsException", 0);
	return 0;
    }
    
    in_buf  = (Bytef *)unhand(this->buf)->body;
    out_buf = (Bytef *)unhand(Hbuf)->body;
    strm->next_in  = in_buf + this->off;
    strm->next_out = out_buf + off;
    strm->avail_in  = this->len;
    strm->avail_out = len;
    switch (inflate(strm, Z_PARTIAL_FLUSH)) {
      case Z_STREAM_END:
	this->finished = TRUE;
      case Z_OK:
	this->off += this->len - strm->avail_in;
	this->len = strm->avail_in;
	return len - strm->avail_out;
      case Z_NEED_DICT:
	this->needsDictionary = TRUE;
	/* We actually will have consumed some input here! */
	this->off += this->len - strm->avail_in;
	this->len = strm->avail_in;
      case Z_BUF_ERROR:
	return 0;
      case Z_DATA_ERROR:
	SignalError(0, ZIPPKG "DataFormatException", strm->msg);
	return 0;
      case Z_MEM_ERROR:
	SignalError(0, JAVAPKG "OutOfMemoryError", 0);
	return 0;
      default:
	SignalError(0, JAVAPKG "InternalError", strm->msg);
    }
    KEEP_POINTER_ALIVE(in_buf && out_buf);
    return 0;
}
