/*
 * @(#)java_util_zip_Inflater_setDictionary.c	1.2 98/10/12
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*
 * Native method support for compression classes.
 */

#include <errno.h>
#include <string.h> /* for strerror() */

#include "sys_api.h"
#include "zlib.h"
#include "jni.h"

#include "java_util_zip_Inflater.h"

void
java_util_zip_Inflater_setDictionary(Hjava_util_zip_Inflater *Hthis,
				     HArrayOfByte *Hbuf, long off, long len)
{
#ifdef ZIPEXTRAS
    Classjava_util_zip_Inflater *this = unhand(Hthis);
    z_stream *strm = (z_stream *)this->strm;
    
    if (Hbuf == 0 || strm == 0) {
	SignalError(0, JAVAPKG "NullPointerException", 0);
    } else if (off < 0 || len < 0 || off + len > obj_length(Hbuf)) {
	SignalError(0, JAVAPKG "ArrayIndexOutOfBoundsException", 0);
    } else {
	Bytef *buf = (Bytef *)unhand(Hbuf)->body;
	switch (inflateSetDictionary(strm, buf + off, len)) {
	  case Z_OK:
	    this->needsDictionary = FALSE;
	    break;
	  case Z_STREAM_ERROR:
	  case Z_DATA_ERROR:
	    SignalError(0, JAVAPKG "IllegalArgumentException", strm->msg);
	    break;
	  default:
	    SignalError(0, JAVAPKG "InternalError", strm->msg);
	    break;
	}
	KEEP_POINTER_ALIVE(buf);
    }
    return;
#else
    SignalError(0, JAVAPKG "UnsupportedOperationException", 0);
    return;
#endif
}
