/*
 *	JDKVM.java	1.6	98/01/08 SMI
 *
 * Copyright (c) 1997 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

package vm;
import components.*;
import Const;
import DataFormatException;

/*
 * This code knows information about the JDK1.x virtual machine
 * that is not really platform-specific. Extend this class to
 * make a core-image writer for your platform.
 */

public class JDKVM {

    public static boolean staticMember( ClassMemberInfo f ){
	return ( (f.access & Const.ACC_STATIC) != 0 );
    }

    public static boolean privateMember( ClassMemberInfo f ){
	return ( (f.access & Const.ACC_PRIVATE) != 0 );
    }

    public static boolean isClassType( FieldInfo f ){
	char t = f.type.string.charAt(0);
	return ( ( t == Const.SIGC_ARRAY ) || ( t == Const.SIGC_CLASS ));
    }

    public static boolean needsExtraStorage( FieldInfo f ){
        return true;
    }

    public static boolean isDataPure( FieldInfo f[] ){
	return true;
    }


}
