/*
 * @(#)awt_access.c	1.9 98/12/02 SMI
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */
#include <jni.h>

static jclass   ComponentClass;
static jclass   MenuComponentClass;
static jfieldID background;
static jfieldID foreground;
static jfieldID locale;
static jfieldID componentFont;
static jfieldID menuFont;
static jfieldID componentPeer;


JNIEXPORT void JNICALL
Java_sun_awt_tk_TKWindow_initJNI(JNIEnv *env, jclass cls)
{
    ComponentClass     = (*env)->FindClass(env, "java/awt/Component");
    MenuComponentClass = (*env)->FindClass(env, "java/awt/MenuComponent");


    background    = (*env)->GetFieldID(env, ComponentClass,
				       "background", "Ljava/awt/Color;");

    foreground    = (*env)->GetFieldID(env, ComponentClass,
				       "foreground", "Ljava/awt/Color;");

    componentFont = (*env)->GetFieldID(env, ComponentClass,
				       "font", "Ljava/awt/Font;");

    componentPeer = (*env)->GetFieldID(env, ComponentClass,
				       "peer", "Ljava/awt/peer/ComponentPeer;");

    locale	  = (*env)->GetFieldID(env, ComponentClass,
					"locale", "Ljava/util/Locale;");

    menuFont      = (*env)->GetFieldID(env, MenuComponentClass,
				       "font", "Ljava/awt/Font;");
}

JNIEXPORT void JNICALL
Java_sun_awt_otk_ComponentModel_initJNI(JNIEnv *env, jclass cls) 
{
    Java_sun_awt_tk_TKWindow_initJNI(env, cls);
}


JNIEXPORT jobject JNICALL
Java_sun_awt_tk_TKWindow_getTargetRealBackground(JNIEnv *env, 
						 jobject this,
						 jobject target)

{
    if (target == NULL) return NULL;
    return (*env)->GetObjectField(env, target, background);
}

JNIEXPORT jobject JNICALL
Java_sun_awt_otk_ComponentModel_getRealBackground0(JNIEnv *env, 
						   jobject this,
						   jobject target)
{
    return Java_sun_awt_tk_TKWindow_getTargetRealBackground(env, this, target);
}

JNIEXPORT jobject JNICALL
Java_sun_awt_otk_ComponentModel_getRealLocale0(JNIEnv *env, 
					      jobject this,
					      jobject target)
{
    if (target == NULL) return NULL;
    return (*env)->GetObjectField(env, target, locale);
}

JNIEXPORT jobject JNICALL
Java_sun_awt_tk_TKWindow_getTargetRealForeground(JNIEnv *env, 
						 jobject this,
						 jobject target)
{
    if (target == NULL) return NULL;
    return (*env)->GetObjectField(env, target, foreground);
}

JNIEXPORT jobject JNICALL
Java_sun_awt_otk_ComponentModel_getRealForeground0(JNIEnv *env, 
						   jobject this,
						   jobject target)
{
    return Java_sun_awt_tk_TKWindow_getTargetRealForeground(env, this, target);
}


JNIEXPORT jobject JNICALL
Java_sun_awt_tk_TKWindow_getTargetRealFont(JNIEnv *env, 
					   jobject this,
					   jobject target)
{
    if (target == NULL) return NULL;
    return (*env)->GetObjectField(env, target, componentFont);
}

JNIEXPORT jobject JNICALL
Java_sun_awt_tk_TKWindow_getTargetRealLocale(JNIEnv *env, 
					     jobject this,
					     jobject target)
{
    if (target == NULL) return NULL;
    return (*env)->GetObjectField(env, target, locale);
}

JNIEXPORT jobject JNICALL
Java_sun_awt_tk_TKWindow_getMenuRealFont(JNIEnv *env, 
					 jobject this,
					 jobject menu)
{
    if (menu == NULL) return NULL;
    return (*env)->GetObjectField(env, menu, menuFont);
}

JNIEXPORT void JNICALL
Java_sun_awt_EmbeddedFrame_setPeer(JNIEnv *env, jobject this, jobject peer) {
    (*env)->SetObjectField(env, this, componentPeer, peer);
}
