/*
 *	@(#)FileFileIO.java	1.4	98/11/12 SMI
 * 
 * Copyright (c) 1995-1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */


package sun.io;

import java.io.File;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;

public class FileFileIO extends sun.io.FileIO {

    File file;

    protected FileFileIO(String path) {
	super(path);
	file = new File(path);
    }

    public FileFileIO(String path, String name) {
	super(path, name);
	file = new File(path, name);
    }

    public FileFileIO(FileIO dir, String name) {
	this(dir.getPath(), name);
    }

    public InputStream getInputStream() throws IOException {
	return new java.io.FileInputStream(this.path);
    }

    public OutputStream getOutputStream() throws IOException {
	return new java.io.FileOutputStream(this.path);
    }

    public String canonPath(String path) throws IOException {
	return file.getCanonicalPath();
    }                                                

    public boolean exists() {
	return file.exists();
    }

    public boolean canWrite() {
	return file.canWrite();
    }

    public boolean canRead() {
	return file.canRead();
    }

    public boolean isFile() {
	return file.isFile();
    }

    public boolean isDirectory() {
	return file.isDirectory();
    }

    public boolean isAbsolute() {
	return file.isAbsolute();
    }

    public long lastModified() {
	return file.lastModified();
    }

    public long length() {
	return file.length();
    }

    public String[] list() {
	return file.list();
    }

    public boolean delete () {
	return file.delete();
    }

    public boolean mkdir () {
	return file.mkdir();
    }
}

