/*
 *	@(#)NullFileIO.java	1.4	98/11/12 SMI
 * 
 * Copyright (c) 1995-1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */


package sun.io;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;

public class NullFileIO extends sun.io.FileIO {

    protected NullFileIO(String path) {
	super(path);
    }

    public NullFileIO(String path, String name) {
	super(path, name);
    }

    public NullFileIO(FileIO dir, String name) {
	this(dir.getPath(), name);
    }

    public InputStream getInputStream() throws IOException {
	    throw new IOException("Null FileIO");
    }

    public OutputStream getOutputStream() throws IOException {
	    throw new IOException("Null FileIO");
    }

    public String canonPath(String path) {
	return path;
    }                                                
    public boolean exists() {
	return false;
    }

    public boolean canWrite() {
	return false;
    }

    public boolean canRead() {
	return false;
    }

    public boolean isFile() {
	return false;
    }

    public boolean isDirectory() {
	return false;
    }

    public boolean isAbsolute() {
	return false;
    }

    public long lastModified() {
	return 0;
    }

    public long length() {
	return 0;
    }
    public String[] list() {
	return null;
    }

    public boolean delete () {
	return true;
    }

    public boolean mkdir () {
	return true;
    }
}

