/*
 *	@(#)RomFileIO.java	1.7	98/11/24 SMI
 * 
 * Copyright (c) 1995-1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */


package sun.io;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;


public class RomFileIO extends sun.io.FileIO {

    private RandomAccessROMFile raf = null;

    protected RomFileIO(String path) throws IOException {
	super(path);
    }

    public RomFileIO(String path, String name) throws IOException {
	super(path, name);
    }

    public RomFileIO(FileIO dir, String name) throws IOException {
	this(dir.getPath(), name);
    }

    public InputStream getInputStream() throws IOException {
	return new RomInputStream(this.getPath());
    }

    public OutputStream getOutputStream() throws IOException {
	throw new IOException("Can not Write ROM File");
    }

    public String canonPath(String path) {
	return path;
    }                                                
    public boolean exists() {
	try {
	    if (raf == null) {
		raf = new RandomAccessROMFile(this.getPath(), "r");
	    }
	    return true;
	} catch (IOException e) {
	    return false;
	}
    }

    public boolean canWrite() {
	return false;
    }

    public boolean canRead() {
	return exists();
    }

    public boolean isFile() {
	return true;
    }

    public boolean isDirectory() {
	return false;
    }

    public boolean isAbsolute() {
	return true;
    }

    public long lastModified() {
	return 0;
    }

    public long length() {
	try {
	    if (raf == null) {
		raf = new RandomAccessROMFile(this.getPath(), "r");
	    }
	    return raf.length();
	    
	} catch (IOException e) {
	    return 0;
	}
    }
    public String[] list() {
	return null;
    }

    public boolean delete () {
	return false;
    }

    public boolean mkdir () {
	return false;
    }
}

