/*
 *	@(#)FileIOFactory.java	1.3	98/11/12 SMI
 * 
 * Copyright (c) 1995-1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */


package sun.io;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;

public class FileIOFactory {

	public static FileIO newInstance(String path) {
		return new URLFileIO(path);
	}
	public static FileIO newInstance(String path, String name) {
		return new URLFileIO(path, name);
	}
	public static FileIO newInstance(FileIO dir, String name) {
		return new URLFileIO(dir, name);
	}

	public static InputStream getInputStream(String path) throws IOException {
		FileIO f = new URLFileIO(path);
		return f.getInputStream();
	}
	public static OutputStream getOutputStream(String path) throws IOException {
		FileIO f = new URLFileIO(path);
		return f.getOutputStream();
	}

}


