/*
 *	@(#)URLFileIO.java	1.5	98/11/12 SMI
 * 
 * Copyright (c) 1995-1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */


package sun.io;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.IOException;

public class URLFileIO extends sun.io.FileIO {

    private java.net.URL url = null;
    private java.io.InputStream url_is = null;

    protected URLFileIO(String path) {
	super(path);
    }

    public URLFileIO(String path, String name) {
	super(path, name);
    }

    public URLFileIO(FileIO dir, String name) {
	this(dir.getPath(), name);
    }

    public InputStream getInputStream() throws IOException {
	if (url == null) url = new java.net.URL(this.path);
	if (url_is == null) url_is = url.openStream();
	return(url.openStream());   
    }

    public OutputStream getOutputStream() throws IOException {
	    throw new IOException("URL FileIO");
    }

    public String canonPath(String path) {
	return path;
    }                                                
    public boolean exists() {
	try {
	    if (url == null) url = new java.net.URL(this.path);
	    java.net.URLConnection conn = url.openConnection();

	    if (conn instanceof java.net.HttpURLConnection) {
		java.net.HttpURLConnection hconn = 
		    (java.net.HttpURLConnection) conn;
		int code = hconn.getResponseCode();
		if (code == java.net.HttpURLConnection.HTTP_OK) {
		    url_is = url.openStream();
		    return true;
		} if (code >= java.net.HttpURLConnection.HTTP_BAD_REQUEST) {
		    return false;
		} else {
		    return false;
		}
	    } else {
		url_is = url.openStream();
	        if (url_is.available() > 0) {
		    return true;
		} else {
		    return false;
		}
	    }
	} catch (IOException e) {
	    return false;
	}
    }

    public boolean canWrite() {
	return false;
    }

    public boolean canRead() {
	return exists();
    }

    public boolean isFile() {
	return exists();
    }

    public boolean isDirectory() {
	return false;
    }

    public boolean isAbsolute() {
	return false;
    }

    public long lastModified() {
	return 0;
    }

    public long length() {
	try {
	    if (url == null) url = new java.net.URL(this.path);
	    if (url_is == null) url_is = url.openStream();

	    return(url_is.available());

	} catch (IOException e) {
	    return 0;
	}
    }

    public String[] list() {
	return null;
    }

    public boolean delete () {
	return true;
    }

    public boolean mkdir () {
	return false;
    }
}

