/*
 * @(#)img_fsutil.h	1.3 98/09/22
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*
 * This file contains utility macros used by the Floyd-Steinberg
 * algorithms used in some of the other include files.
 */

#ifndef IMG_FSUTIL_H
#define IMG_FSUTIL_H

#define DitherDist(ep, e1, e2, e3, ec, c)		\
    do {						\
	e3 = (ec << 1);					\
	e1 = e3 + ec;					\
	e2 = e3 + e1;					\
	e3 += e2;					\
							\
	ep[0].c += e1 >>= 4;				\
	ep[1].c += e2 >>= 4;				\
	ep[2].c += e3 >>= 4;				\
	ec -= e1 + e2 + e3;				\
    } while (0)

#endif /* IMG_FSUTIL_H */
