/*
 * @(#)img_nodither.h	1.2 96/08/02 Jim Graham
 *
 * Copyright (c) 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

/*
 * This file contains macro definitions for the Encoding category of
 * the macros used by the generic scaleloop function.
 *
 * This implementation performs no encoding of output pixels at all
 * and is only useful for output pixel formats which consist of 3
 * bytes per pixel containing the red, green and blue components.
 * Since the components are stored explicitly in their own memory
 * accesses, they do not need to be encoded into a single monolithic
 * pixel first.  The value of the "pixel" variable will be undefined
 * during the output stage of the generic scale loop if this file
 * is used.
 */

#define DeclareDitherVars

#define InitDither(cvdata, clrdata, dstTW)			\
    do {} while (0)

#define StartDitherLine(cvdata, dstX1, dstY)			\
    do {} while (0)

#define DitherPixel(dstX, dstY, pixel, red, green, blue) 	\
    do {} while (0)

#define DitherBufComplete(cvdata, dstX1)			\
    do {} while (0)
