/*
 * @(#)img_output16_32.h	1.6 98/09/22
 * 
 * Copyright (c) 1995, 1996, 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

/*
 * This file contains macro definitions for the Storing category of
 * the macros used by the generic scaleloop function.
 *
 * This implementation can store 16-bit or 32-bit pixels into an
 * array of shorts, or longs such that the pixel for (srcX, srcY)
 * is stored at index (srcOff + srcY * srcScan + srcX) in the array.
 */

#define DeclareOutputVars				\
    pixptr dstP;					\
    int dst32;

#define InitOutput(cvdata, clrdata, dstX, dstY)			\
    do {							\
	switch (clrdata->bitsperpixel) {			\
	case 16: dst32 = 1; break;				\
	case 32: dst32 = 2; break;				\
	default:						\
	    InternalError("unsupported screen depth");		\
	    return SCALEFAILURE;				\
	}							\
	img_check((ScanBytes(cvdata) & ((1 << dst32)-1)) == 0);	\
	dstP.vp = cvdata->outbuf;				\
	dstP.bp += dstY * ScanBytes(cvdata) + (dstX << dst32);	\
    } while (0)


#ifdef CHECKPUTPIXEL
#define PutPixelInc(pixel, red, green, blue)			\
    do {							\
	switch (dst32) {					\
	case 1:							\
	    CHECKPUTPIXEL(dstP.sp);				\
	    *dstP.sp++ = ((unsigned short) pixel);		\
	    break;						\
	case 2:							\
	    CHECKPUTPIXEL(dstP.ip);				\
	    *dstP.ip++ = pixel;					\
	    break;						\
	}							\
    } while (0)
#else
#define PutPixelInc(pixel, red, green, blue)			\
    do {							\
	switch (dst32) {					\
	case 1:							\
	    *dstP.sp++ = ((unsigned short) pixel);		\
	    break;						\
	case 2:							\
	    *dstP.ip++ = pixel;					\
	    break;						\
	}							\
    } while (0)
#endif

#define EndOutputRow(cvdata, dstY, dstX1, dstX2)		\
    do {							\
	SendRow(cvdata, dstY, dstX1, dstX2);			\
	dstP.bp += (ScanBytes(cvdata)				\
		    - ((dstX2 - dstX1) << dst32));		\
    } while (0)

#define EndOutputRect(cvdata, dstX1, dstY1, dstX2, dstY2)	\
    SendBuffer(cvdata, dstX1, dstY1, dstX2, dstY2)
