/*
 * @(#)sun_io_FDInputStream_skip.c	1.2	98/10/23 SMI
 * 
 * Copyright (c) 1995-1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

#include "oobj.h"
#include "interpreter.h"
#include "javaString.h"
#include "fd_md.h"

#include "sun_io_FDInputStream.h"
#include "java_io_FileDescriptor.h"
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>

#define IO_EXCEPTION "java/io/IOException"


int64_t
sun_io_FDInputStream_skip(Hsun_io_FDInputStream *this, int64_t n) 
{
    Classsun_io_FDInputStream *thisptr = unhand(this);
    Classjava_io_FileDescriptor *fdptr = unhand(thisptr->fd);
    off_t cur = 0, end = 0;

     if (fdptr == 0) {
	SignalError(0, JAVAPKG "NullPointerException", "null FileDescriptor");
	return int2ll(0);
    }

    if ((cur = sysLseekFD(fdptr, 0L, SEEK_CUR)) == -1) {
	SignalError(0, IO_EXCEPTION, 0);
	/* The semantics of InputStream.skip() are that skip
	 * cannot go backwards. lseek() takes a signed 32 bit
	 * number, but InputStream.skip() takes a 64 bit number,
	 * so we lop of the sign byte to ensure it is positive.
	 * These numbers are far too big to really matter anyway.
	 * -brown
	 */
    } else if ((end = sysLseekFD(fdptr, ll2int(n) & 0xEFFFFFFF, SEEK_CUR)) == -1) {
	SignalError(0, IO_EXCEPTION, 0);
    }
    return int2ll(end - cur);
}
