/*
 * @(#)sun_io_FDOutputStream_writeBytes.c	1.2	98/10/23 SMI
 * 
 * Copyright (c) 1995-1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

#include "oobj.h"
#include "interpreter.h"
#include "javaString.h"
#include "fd_md.h"

#include "sun_io_FDOutputStream.h"
#include "java_io_FileDescriptor.h"
#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/stat.h>

#define IO_EXCEPTION "java/io/IOException"


void
sun_io_FDOutputStream_writeBytes(Hsun_io_FDOutputStream *this, HArrayOfByte *data, long off, long len) 
{
    Classsun_io_FDOutputStream *thisptr = unhand(this);
    Classjava_io_FileDescriptor *fdptr = unhand(thisptr->fd);
    char *dataptr;
    int datalen, n = -1;

    if (fdptr == 0) {
	SignalError(0, JAVAPKG "NullPointerException", "null FileDescriptor");
	return;
    }

    if (data == 0) {
	SignalError(0, JAVAPKG "NullPointerException", 0);
	return;
    }
    dataptr = unhand(data)->body;
    datalen = obj_length(data);

    if ((off < 0) || (len < 0) || (off + len > datalen)) {
	SignalError(0, JAVAPKG "ArrayIndexOutOfBoundsException", 0);
	return;
    }

    while (len > 0) {
	n = sysWriteFD(fdptr, dataptr + off, len);
	if (n == -1) {
	    SignalError(0, IO_EXCEPTION, "write error");
	    break;
	} else if (n == -2) {
	    SignalError(0, JAVAIOPKG "InterruptedIOException",
			"operation interrupted");

	    break;
	}
        off += n;
	len -= n;
    }
    KEEP_POINTER_ALIVE(dataptr);
}
