/*
 * @(#)AppletAudioClip.java	1.12 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.applet;


import java.io.IOException;
import java.io.InputStream;
import java.net.URL;
import java.net.URLConnection;
import java.applet.AudioClip;
import sun.audio.*;

/**
 * Applet audio clip;
 *
 * @version 	1.12, 07/01/98
 * @author Arthur van Hoff
 */
public class AppletAudioClip implements AudioClip {
    URL url;
    AudioData data;
    InputStream stream;
    
    /**
     * This should really fork a seperate thread to
     * load the data.
     */
    public AppletAudioClip(URL url) {
	InputStream in = null;
	try {
	    try {
		URLConnection uc = url.openConnection();
		uc.setAllowUserInteraction(true);
		in = uc.getInputStream();
		data = new AudioStream(in).getData();
	    } finally {
		if (in != null) {
		    in.close();
		}
	    }
	} catch (IOException e) {
	    data = null;
	}
    }

    /* 
     * For constructing directly from Jar entries.  Or any other
     * raw Audio data.
     */

    public AppletAudioClip(byte [] data) {
	this.data = new AudioData(data);
    }

    public synchronized void play() {
	stop();
	if (data != null) {
	    stream = new AudioDataStream(data);
	    AudioPlayer.player.start(stream);
	}
    }

    public synchronized void loop() {
	stop();
	if (data != null) {
	    stream = new ContinuousAudioDataStream(data);
	    AudioPlayer.player.start(stream);
	}
    }

    public synchronized void stop() {
	if (stream != null) {
	    AudioPlayer.player.stop(stream);
	    try {
		stream.close();
	    } catch (IOException e) {
	    }
	}
    }

    public String toString() {
	return getClass().toString() + "[" + url + "]";
    }
}
