/*
 * @(#)AppletClassEntry.java	1.3 98/10/29
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.applet;


/** This class is basically a struct to enable lazy class loading.
 *  By defining classes lazily, we prevent the case where a
 *  derived class was found in a jar before its super class also
 *  in the jar.  The derived class cannot be defined before it's
 *  super class has even been loaded from the archive.
 *
 *  An instance of this class holds:
 *  - a byte[] denoting a class file
 *  - length of class data in byte[]
 *  - name of the class
 *  - Identity[] of signers, if any
 *
 *  This information is stored by AppletClassLoader and used to
 *  define a given class on demand.  Once a class is loaded the
 *  loader discards this object.
 *
 *  classEntries are hashed by fully qualified name - "my.package.MyApplet"
 *  This objects member "name" should also be a String of this form.
 */

class AppletClassEntry {

    byte[] classBuf;
    int start;
    int len;
    /* a String of the form "my.package.MyApplet" */
    String name;
    Object[] ids;

    AppletClassEntry (byte[] b, int start, int l, String n, Object[] i) {
	classBuf = b;
	this.start = start;
	len = l;
	name = n;
	ids = i;
    }

    public int hashCode() {
	return name.hashCode();
    }

    public String toString() {
	return "className="+name;
    }
}
