/*
 * @(#)AppletImageRef.java	1.4 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.applet;

import java.awt.Toolkit;
import java.awt.Image;
import sun.awt.image.URLImageSource;
import java.awt.image.ImageProducer;
import java.net.URL;

class AppletImageRef extends sun.misc.Ref {
    URL url;

    /**
     * Create the Ref
     */
    AppletImageRef(URL url) {
	this.url = url;
    }

    public void flush() {
	super.flush();
    }

    /**
     * Reconsitute the image.  Only called when the ref has been flushed.
     */
    public Object reconstitute() {
	ImageProducer producer = null;
	// Check if URL is in our cache
	Object o = AppletResourceLoader.getLocalResource(url);
	if (o != null) {
	    // Yes, it should be an image
	    if (o instanceof ImageProducer) {
		producer = (ImageProducer) o;
	    } else {
		// Not an image, return null (?)
		return null;
	    }
	} else {
	    // not in the cache under this name, so try as a full-fledged URL
	    producer = new URLImageSource(url);
	}
	return Toolkit.getDefaultToolkit().createImage(producer);
    }
}
