/*
 * @(#)AppletProps.java	1.17 98/11/02
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.applet;

import java.awt.*;
import java.io.*;
import java.util.Properties;
import sun.net.www.http.HttpClient;
import sun.net.ftp.FtpClient;

class AppletProps extends Frame {
    
    TextField proxyHost;
    TextField proxyPort;
    Choice networkMode;
    Choice accessMode;
    Choice unsignedMode;

    AppletProps() {
        setTitle(amh.getMessage("title"));
	Panel p = new Panel();
	p.setLayout(new GridLayout(0, 2));

        p.add(new Label(amh.getMessage("label.http.server", "Http proxy server:")));
	p.add(proxyHost = new TextField());

        p.add(new Label(amh.getMessage("label.http.proxy")));
	p.add(proxyPort = new TextField());

        p.add(new Label(amh.getMessage("label.network")));
	p.add(networkMode = new Choice());
        networkMode.addItem(amh.getMessage("choice.network.item.none"));
        networkMode.addItem(amh.getMessage("choice.network.item.applethost"));
        networkMode.addItem(amh.getMessage("choice.network.item.unrestricted"));

        p.add(new Label(amh.getMessage("label.class")));
	p.add(accessMode = new Choice());
        accessMode.addItem(amh.getMessage("choice.class.item.restricted"));
        accessMode.addItem(amh.getMessage("choice.class.item.unrestricted"));

        p.add(new Label(amh.getMessage("label.unsignedapplet")));
	p.add(unsignedMode = new Choice());
        unsignedMode.addItem(amh.getMessage("choice.unsignedapplet.no"));
        unsignedMode.addItem(amh.getMessage("choice.unsignedapplet.yes"));

	add("Center", p);
	p = new Panel();
        p.add(new Button(amh.getMessage("button.apply")));
        p.add(new Button(amh.getMessage("button.reset")));
        p.add(new Button(amh.getMessage("button.cancel")));
	add("South", p);
	move(200, 150);
	pack();
	reset();
    }

    void reset() {
	((AppletSecurity)System.getSecurityManager()).reset();

	switch (((AppletSecurity)System.getSecurityManager()).networkMode) {
	  case AppletSecurity.NETWORK_UNRESTRICTED:
            networkMode.select(amh.getMessage("choice.network.item.unrestricted"));
	    break;
	  case AppletSecurity.NETWORK_NONE:
            networkMode.select(amh.getMessage("choice.network.item.none"));
	    break;
	  default:
            networkMode.select(amh.getMessage("choice.network.item.applethost"));
	    break;
	}

	if (Boolean.getBoolean("package.restrict.access.sun")) {
            accessMode.select(amh.getMessage("choice.class.item.restricted"));
	} else {
            accessMode.select(amh.getMessage("choice.class.item.unrestricted"));
	}

	if (System.getProperty("http.proxyHost") != null) {
	    proxyHost.setText(System.getProperty("http.proxyHost"));
	    proxyPort.setText(System.getProperty("http.proxyPort"));
	    HttpClient.proxyPort = 
		Integer.valueOf(System.getProperty("http.proxyPort")).intValue();
	} else {
	    proxyHost.setText("");
	    proxyPort.setText("");
	}

	if (Boolean.getBoolean("appletviewer.security.allowUnsigned")) {
            unsignedMode.select(amh.getMessage("choice.unsignedapplet.yes"));
	} else {
            unsignedMode.select(amh.getMessage("choice.unsignedapplet.no"));
	}
    }

    void apply() {
	// Get properties, set version
	Properties props = System.getProperties();
	props.put("appletviewer.version", AppletViewer.theVersion);
	if (proxyHost.getText().length() > 0) {
	    props.put("http.proxyHost", proxyHost.getText().trim());
	    props.put("http.proxyPort", proxyPort.getText().trim());
	} else {
	    props.remove("http.proxyHost");
	}

	if (amh.getMessage("choice.network.item.none").equals(networkMode.getSelectedItem())) {
	    props.put("appletviewer.security.mode", "none");
	} else if (amh.getMessage("choice.network.item.unrestricted").equals(networkMode.getSelectedItem())) {
	    props.put("appletviewer.security.mode", "unrestricted");
	} else {
	    props.put("appletviewer.security.mode", "host");
	}

	if (amh.getMessage("choice.class.item.restricted").equals(accessMode.getSelectedItem())) {
	    props.put("package.restrict.access.sun", "true");
	    props.put("package.restrict.access.netscape", "true");
	} else {
	    props.put("package.restrict.access.sun", "false");
	    props.put("package.restrict.access.netscape", "false");
	}

        if (amh.getMessage("choice.unsignedapplet.yes").equals(unsignedMode.getSelectedItem())) {
            props.put("appletviewer.security.allowUnsigned", "true");
        } else {
            props.put("appletviewer.security.allowUnsigned", "false");
        }

	// Save properties
	try {
	    reset();

	    OutputStream out = AppletViewer.theUserPropertiesFile.getOutputStream();
	    props.save(out, "AppletViewer");
	    out.close();
	    hide();
	} catch (IOException e) {
            System.out.println(amh.getMessage("apply.exception", e));
	    e.printStackTrace();
	    reset();
	}
    }

    public boolean action(Event evt, Object obj) {
        if (amh.getMessage("button.apply").equals(obj)) {
	    apply();
	    return true;
	}
        if (amh.getMessage("button.reset").equals(obj)) {
	    reset();
	    return true;
	}
        if (amh.getMessage("button.cancel").equals(obj)) {
	    hide();
	    return true;
	}
	return false;
    }

    private static AppletMessageHandler amh = new AppletMessageHandler("appletprops");

}
