/**
 * @(#)ImageProductionMonitor.java	1.3 98/06/26
 *
 * Copyright 1998 Sun Microsystems, Inc. 901 San Antonio Road, 
 * Palo Alto, California, 94303, U.S.A.  All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 **/

package sun.awt.image;

import sun.misc.VM;
/**
 * This class monitors image production.  
 *
 * Currently it excersizes its control in two ways:
 *
 * 1) It determines whether image production is allowed or not
 *    by checkingn the VM's memory state.  Image production is
 *    disabled when the state reaches a certain level.
 *    By default, image production is disabled when the state 
 *    reaches VM.STATE_YELLOW.
 *
 * 2) It also determines how many image fetcher threads are allowed
 *    to function concurrently.  This number is by default 4.
 *
 **/
class ImageProductionMonitor {

    private static final int abortMemState = VM.STATE_YELLOW;

    static final int MAX_FETCHER_THREADS = 4;

    static boolean allowsProduction() {
	if (VM.getStateQuick() >= abortMemState) {
	    return false;
	}
	return true;
    }
}
