/*
 * @(#)Handler.java	1.30 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.net.www.protocol.file;

import java.net.InetAddress;
import java.net.URLConnection;
import java.net.URL;
import java.net.MalformedURLException;
import java.net.URLStreamHandler;
import java.io.InputStream;
import java.io.IOException;

/**
 * Open an file input stream given a URL.
 * @author	James Gosling
 * @version 	1.25, 07/12/96
 */
public class Handler extends URLStreamHandler {
    private static String installDirectory = System.getProperty("hotjava.home");

    public synchronized URLConnection openConnection(URL u) 
           throws IOException
    {
	String host = u.getHost();
	if (host == null || host.equals("") || host.equals("~") ||
	    host.equals("localhost")) {
	    return new FileURLConnection(u);
	} 

	/* If you reach here, it implies that you have a hostname
	   so attempt an ftp connection.
	 */
	URLConnection uc;
	URL ru;

	try {
	    ru = new URL("ftp", host, u.getFile() + (u.getRef() == null ? "": "#" + u.getRef()));
	    uc = ru.openConnection();
	} catch (IOException e) {
	    uc = null;
	}
	if (uc == null) {
	    throw new IOException("Unable to connect to: " + u.toExternalForm());
	}
	return uc;
    }
}
