/*
 * @(#)Handler.java	1.32 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

/*-
 *	FTP stream opener
 */

package sun.net.www.protocol.ftp;

import java.net.URL;
import sun.net.ftp.FtpClient;
import sun.net.www.protocol.http.HttpURLConnection;

/** open an ftp connection given a URL */
public class Handler extends java.net.URLStreamHandler {

    protected java.net.URLConnection openConnection(URL u) {
	/* if set for proxy usage then go through the http code to get */
	/* the url connection. */
	if (FtpClient.useFtpProxy &&
	    FtpClient.ftpProxyHost != null &&
	    FtpClient.ftpProxyHost.length() > 0) {
	    return new HttpURLConnection(u,
					 FtpClient.ftpProxyHost,
					 FtpClient.ftpProxyPort);
	}

	/* make a direct ftp connection */
	return new FtpURLConnection(u);
    }
}
