/*
 * @(#)Handler.java	1.11 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.net.www.protocol.gopher;

import java.io.*;
import java.util.*;
import sun.net.NetworkClient;
import java.net.URL;
import java.net.URLStreamHandler;
import sun.net.www.protocol.http.HttpURLConnection;

/**
 * A class to handle the gopher protocol.
 */

public class Handler extends java.net.URLStreamHandler {
    public java.net.URLConnection openConnection(URL u) {
	/* if set for proxy usage then go through the http code to get */
	/* the url connection. */
	if (GopherClient.useGopherProxy &&
	    GopherClient.gopherProxyHost != null &&
	    GopherClient.gopherProxyHost.length() > 0) {
	    return new HttpURLConnection(u,
					 GopherClient.gopherProxyHost,
					 GopherClient.gopherProxyPort);
	}
	return new GopherURLConnection(u);
    }
}

class GopherURLConnection extends sun.net.www.URLConnection {
    GopherURLConnection(URL u) {
	super(u);
    }

    public void connect() throws IOException {
    }

    public InputStream getInputStream() throws IOException {
	return new GopherClient(this).openStream(url);
    }
}

