/*
 * @(#)ParseSystemURL.java	1.6 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.net.www.protocol.systemresource;

import java.net.*;

/**
 * Parse a System Resource file.
 *
 * @see		SystemResourceManager
 * @version 	1.6, 07/01/98
 * @author	Eduardo Pelegri-Llopart
 */

class ParseSystemURL {
    private String base;
    private String member;
    private boolean isAFile;
    private boolean isInZip;

    public boolean isValid() {
	return isAFile || isInZip;
    }

    public boolean isFile() {
	return isAFile;
    }

    public boolean isZip() {
	return isInZip;
    }

    public String getBase() {
	return base;
    }

    public String getMember() {
	return member;
    }

    public ParseSystemURL(URL url) {
	String file = url.getFile();
	if (file.startsWith("/FILE")) {
	    isAFile = true;
	    file = file.substring(5);
	} else if (file.startsWith("/ZIP")) {
	    isInZip = true;
	    file = file.substring(4);
	} else {
	    // Not a valid URL
	    return;
	}

	base = file.substring(0, file.indexOf("/+/"));
	member = file.substring(file.indexOf("/+/")+3);
    }
}

