/*
 * @(#)RegistryHandler.java	1.4 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.rmi.registry;

import java.rmi.RemoteException;
import java.rmi.UnknownHostException;
import java.rmi.registry.Registry;
import java.rmi.server.ObjID;
import sun.rmi.server.RemoteProxy;
import sun.rmi.server.UnicastRef;
import sun.rmi.transport.Endpoint;
import sun.rmi.transport.LiveRef;
import sun.rmi.transport.tcp.TCPEndpoint;

public class RegistryHandler implements java.rmi.registry.RegistryHandler {

    public Registry registryStub(String host, int port)
	throws RemoteException, UnknownHostException
    {
	String stubname = "sun.rmi.registry.RegistryImpl";
	if (port <= 0)
	    port = Registry.REGISTRY_PORT;

	if (host == null || host.length() == 0) {
	    // If host is blank (as returned by "file:" URL in 1.0.2 used in
	    // java.rmi.Naming), try to convert to real local host name so
	    // that the RegistryImpl's checkAccess will not fail.
	    try {
		host = java.net.InetAddress.getLocalHost().getHostName();
	    } catch (Exception e) {
		// If that failed, at least try "" (localhost) anyway...
		host = "";
	    }
	}

	// Create the needed remote reference 
	// Then find and initialize the stub
	ObjID id = new ObjID(ObjID.REGISTRY_ID);
	Endpoint ep = new TCPEndpoint(host, port);
	LiveRef ref = new LiveRef(id, ep, false);
	return (Registry)RemoteProxy.getStub(stubname, new UnicastRef(ref));
    }

    public Registry registryImpl(int port) throws RemoteException 
    {
	return new sun.rmi.registry.RegistryImpl(port);
    }
}
