/*
 * @(#)LoaderHandler.java	1.5 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.rmi.server;

import java.net.MalformedURLException;
import java.net.URL;

public class LoaderHandler implements java.rmi.server.LoaderHandler {

    /** Load class using java.rmi.server.codebase property */
    public Class loadClass(String name)
	throws MalformedURLException, ClassNotFoundException
    {
	RMIClassLoader loader = RMIClassLoader.getLocalLoader();
	if (loader != null) {
	    return loader.loadClass(name);
	} else {
	    return Class.forName(name);
	}
    }

    /** Load class 'name' from URL */
    public Class loadClass(URL codebase, String name)
	throws MalformedURLException, ClassNotFoundException
    {
	if (codebase == null)
	    throw new MalformedURLException("null URL");
	
	RMIClassLoader loader = RMIClassLoader.getClassLoader(codebase);
	return loader.loadClass(name);
    }

    /** Returns the security context of the given class loader */
    public Object getSecurityContext(ClassLoader loader)
    {
	if (loader != null && loader instanceof RMIClassLoader) {
	    return ((RMIClassLoader)loader).getCodeBase();
	} else {
	    return null;
	}
    }
}

    
