/*
 * @(#)JarImageSource.java	1.4 98/08/06
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */


package sun.tools.jar;

import sun.awt.image.URLImageSource;
import sun.awt.image.ImageDecoder;
import java.net.URL;
import java.io.InputStream;
import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;


public class JarImageSource extends URLImageSource {

    byte[] buf;
    String mimeType;
    public JarImageSource(URL u, byte[] buf, String type) {
	super(u);
        this.buf = buf;
	mimeType = type;
    }

    protected ImageDecoder getDecoder() {
	InputStream is =
	    new BufferedInputStream(new ByteArrayInputStream(buf));
	ImageDecoder id = decoderForType(is, mimeType);
	if (id == null) {
	    id = getDecoder(is);
	}
	return id;
    }
}
