/*
 * @(#)java.c	1.17 99/05/25
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include <windows.h>

#include <stdio.h>
#include <stdlib.h>
#include <sys_api.h>

#ifdef JAVA_ARGS
#define NUM_ARGS (sizeof(java_args) / sizeof(char *))
char *java_args[] = JAVA_ARGS;
#else
#define NUM_ARGS 0
#endif

#ifdef WINMAIN
#define main _main
__declspec(dllimport) char **__initenv;
#endif

int
main(int argc, char *argv[])
{
    char **newargv, **ap;
    int i;

    newargv = ap = (char **) calloc(argc + NUM_ARGS + 1, sizeof(char *));

    *ap++ = argv[0];

#ifdef JAVA_ARGS
    for (i = 0; i < NUM_ARGS; i++) {
	*ap++ = java_args[i];
    }
#endif

    for (i = 1; i < argc; i++) {
	*ap++ = argv[i];
    }

#ifdef JRE
    {
	char pwd[MAX_PATH];
	char *cp;
	/* We explicitly do not want the classpath environment variable
	 * already present in the environment.  This avoids classpath
	 * conflicts with other java products installed on this machine.
	 * The classpath defined here points to the java runtime's core
	 * classes.  Prepend/append elements to this to point to your
	 * product.
	 */
	GetModuleFileName(NULL, pwd, MAX_PATH);
	*(strrchr(pwd, '\\')) = '\0';
	cp = (char *)malloc(100 + (strlen(pwd) * 3));
	sprintf(cp, 
		"CLASSPATH=%s\\..\\lib\\rt.jar;%s\\..\\lib\\classes;%s\\..\\lib\\i18n.jar;.",
		pwd, pwd, pwd);
	putenv(cp);
    }
#endif /* JRE */
    return java_main(argc + NUM_ARGS, newargv);
}

#ifdef WINMAIN

int WINAPI
WinMain(HINSTANCE inst, HINSTANCE previnst, LPSTR cmdline, int cmdshow)
{
    int mainret;

    __initenv = _environ;
    mainret = main(__argc, __argv);
    sysExit(mainret);
}

#endif
