@echo off  
rem @(#)run.bat	1.43 98/12/17 Sun Microsystems
rem Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
rem 
rem Run script for Windows
rem 

if not 1%11 == 1-version1 goto no_version
:version
echo PersonalJava(tm) PSWSGS 1.0w
goto done
:no_version

if 1%11 == 1-help1 goto help
if 1%11 == 1/help1 goto help
if 1%11 == 1/?1 goto help
if 1%11 == 1-h1 goto help
if 1%11 == 1/h1 goto help

REM Check for JAVA_HOME & TK_HOME BEFORE parsing options which may use them
if 1%JAVA_HOME%1 == 11 goto no_javahome
if 1%TK_HOME%1 == 11 goto no_tkhome
if not exist %TK_HOME%\win32\bin\run.bat goto bad_tkhome

REM
REM Assume no physical keyboard
REM
set KB_OPT=false

REM
REM Assume no sound
REM
set SOUND_OPT=false

REM
REM Assume fingerprint cursor
REM
set CURSOR=

REM
REM Assume current directory
REM
set DIR_OPT=.

REM
REM Always activate text entry popup
REM
set POPUP_OPT=false

REM
REM Always place caret at end of text component on selection
REM
set CARET_OPT=false

REM
REM Turn off focus rectangles
REM
set F_OPT=sun.awt.TabFocusManager

REM
REM Assume default color palette database
REM
set COLORDB_OPT=%TK_HOME%\win32\lib\touchable.palettes

REM
REM Set default width and height
REM
set WIDTH_OPT=640
set HEIGHT_OPT=480


REM
REM Top of loop parsing for options
REM
:parse

if not 1%11 == 1-c1 goto no_cursor
shift
set CURSOR=%1
shift
goto parse
:no_cursor

if not 1%11 == 1-d1 goto no_dir_opt
shift
set DIR_OPT=%1
shift
goto parse
:no_dir_opt

if not 1%11 == 1-k1 goto no_kb_opt
set KB_OPT=true
shift
goto parse
:no_kb_opt

if not 1%11 == 1-J1 goto no_japanese_opt
set JAPANESE_OPT=true
shift
goto parse
:no_japanese_opt

if not 1%11 == 1-R1 goto no_random_opt
set RANDOM_OPT=true
shift
goto parse
:no_random_opt

if not 1%11 == 1-s1 goto no_sound_opt
set SOUND_OPT=true
shift
goto parse
:no_sound_opt

if not 1%11 == 1-W1 goto no_word_opt
set NO_WORD_OPT=true
shift
goto parse
:no_word_opt

if not 1%11 == 1-F1 goto no_F_opt
set F_OPT=true
shift
goto parse
:no_F_opt

if not 1%11 == 1-C1 goto no_colordb_opt
shift
set COLORDB_OPT=%1
shift
goto parse
:no_colordb_opt

if not 1%11 == 1-P1 goto no_colorpal_opt
shift
set COLORPAL_OPT=%1
shift
goto parse
:no_colorpal_opt

if not 1%11 == 1-i1 goto no_imf_opt
shift
set IMF_OPT=%1
shift
goto parse
:no_imf_opt

if not 1%11 == 1-v1 goto no_height_opt
shift
set HEIGHT_OPT=%1
shift
goto parse
:no_height_opt

if not 1%11 == 1-w1 goto no_width_opt
shift
set WIDTH_OPT=%1
shift
goto parse
:no_width_opt

REM What kind of environment are we running in?

if exist %JAVA_HOME%\bin\pjava.exe goto got_pjava
if exist %JAVA_HOME%\bin\java.exe goto got_jdk
if exist %JAVA_HOME%\bin\jre.exe goto got_jre
goto bad_javahome

:got_pjava
echo Running on PersonalJava
set cmd=%JAVA_HOME%\bin\pjava
set CP=-classpath
set CP_ARG=.;%JAVA_HOME%\lib\classes.zip
goto got_cmd

:got_jre
echo Running on JRE
set CMD=%JAVA_HOME%\bin\jre
set CP=-cp
set CP_ARG=.
goto got_cmd

:got_jdk
echo Running on JDK
set CMD=%JAVA_HOME%\bin\java
set CP=-classpath
set CP_ARG=.;%JAVA_HOME%\lib\classes.zip
goto got_cmd

:got_cmd
set OLDPATH=%PATH%

set PATH=%PATH%;%TK_HOME%\win32\bin;

rem 
rem If PJAVA_HOME specified, pick up PJAVA classes before rt.jar
rem
if 1%PJAVA_HOME%1 == 11 goto default_pjavart
set CP_ARG=%CP_ARG%;%PJAVA_HOME%\lib\classes.zip

:default_pjavart
set CP_ARG=%CP_ARG%;%TK_HOME%\win32\lib\rt.jar

rem 
rem Define which toolkit to use
rem
rem set PJAVA_TOOLKIT=sun.awt.tk.Toolkit 
set PJAVA_TOOLKIT=sun.awt.touchable.TouchableToolkit

rem 
rem Define which graphics system to use
rem
set PJAVA_GRAPHICSSYSTEM=sun.awt.gfW.GraphicsSystem

REM if no arguments, then run put up menu of test programs
if 1%11 == 11 goto pick_test


rem 
rem Invoke the JVM with our toolkit and graphics system
rem
cd %DIR_OPT%
%CMD% -Dsun.graphicssystem.height=%HEIGHT_OPT% -Dsun.graphicssystem.width=%WIDTH_OPT% -Dawt.toolkit=%PJAVA_TOOLKIT% -Dsun.awt.aw.DefaultCursor=%CURSOR% -Dsun.awt.im.NoVirtualKeyboard=%KB_OPT% -Dsun.awt.otk.noRandomSelectionMode=%RANDOM_OPT% -Dsun.awt.im.Japanese=%JAPANESE_OPT% -Dsun.awt.im.InputMethod=%IMF_OPT% -Dsun.awt.touchable.sound=%SOUND_OPT% -Dsun.awt.otk.textWordSelectionOff=%NO_WORD_OPT% -Dsun.awt.touchable.doNotDrawFocusRectangle=%F_OPT% -Dsun.awt.palette.definitions=%COLORDB_OPT% -Dsun.awt.palette=%COLORPAL_OPT% -Dsun.graphicssystem=%PJAVA_GRAPHICSSYSTEM% %CP% %CP_ARG%;%TK_HOME%\win32\classes %1 %2 %3 %4 %5 %6 %7 %8 %9
goto cleanup

:pick_test
cd %DIR_OPT%
%CMD% %CP% %CP_ARG%;%TK_HOME%\test\classes PickTest doit.bat %CMD% -Dsun.graphicssystem.height=%HEIGHT_OPT% -Dsun.graphicssystem.width=%WIDTH_OPT% -Dsun.awt.aw.DefaultCursor=%CURSOR% -Dsun.awt.im.NoVirtualKeyboard=%KB_OPT% -Dsun.awt.otk.noRandomSelectionMode=%RANDOM_OPT% -Dsun.awt.im.Japanese=%JAPANESE_OPT% -Dsun.awt.im.InputMethod=%IMF_OPT% -Dsun.awt.touchable.sound=%SOUND_OPT% -Dawt.toolkit=%PJAVA_TOOLKIT% -Dsun.awt.otk.textWordSelectionOff=%NO_WORD_OPT% -Dsun.awt.touchable.doNotDrawFocusRectangle=%F_OPT% -Dsun.awt.palette.definitions=%COLORDB_OPT% -Dsun.awt.palette=%COLORPAL_OPT% -Dsun.graphicssystem=%PJAVA_GRAPHICSSYSTEM% %CP% %CP_ARG%;%TK_HOME%\win32\classes;%TK_HOME%\test\classes 
call doit.bat
del doit.bat
goto cleanup


:no_tkhome
echo Environment variable TK_HOME not set
goto done

:bad_tkhome
echo Environment variable TK_HOME is invalid
goto done

:no_javahome
echo Environment variable JAVA_HOME not set
goto done

:bad_javahome
echo Environment variable JAVA_HOME is invalid
goto done

:help
echo .
echo .  PersonalJava PeerSet Run Script
echo .
echo .     -version  Shows version
echo .     -help     Shows this help screen
echo .     -c (name) Use (name) as name of cursor instead of default
echo .               Use the string "blank" for no cursor
echo .     -C (name) Use the specified path name for the color database
echo .     -d (dir)  Change to (dir) before executing
echo .     -F        Turn off drawing of focus rectangle
echo .     -i class  Use classname for creating the input method. Use
echo .               "default" to create sun.awt.otk.SampleInputMethod.
echo .     -J        Use the Japanese kana keyboard
echo .     -k        Use physical keyboard instead of virtual keyboard
echo .     -P (name) Will use the named color palette
echo .     -R        Turn on random selection mode
echo .     -s        Use sound effects
echo .     -v (nnn)  Set screen height in pixels
echo .     -W        Turn off the default word selection mode for text components
echo .     -w (nnn)  Set screen width in pixels
echo .
goto version

rem
rem Clean up
rem
:cleanup
set PJAVA_TOOLKIT=
set PJAVA_GRAPHICSSYSTEM=
set PATH=%OLDPATH%
set OLDPATH=
set CP=
set CP_ARG=
set KB_OPT=
set SOUND_OPT=
set F_OPT=
set DIR_OPT=
set CURSOR=
set NO_WORD_OPT=
set COLORDB_OPT=
set COLORPAL_OPT=
set JAPANESE_OPT=
set RANDOM_OPT=
set WIDTH_OPT=
set HEIGHT_OPT=

:done
rem
