/*
 * @(#)condvar_md.h	1.13 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef	_WIN32_CONDVAR_MD_H_
#define	_WIN32_CONDVAR_MD_H_

#include <windows.h>
#include "bool.h"
#include "mutex_md.h"
#include "threads_md.h"

/*
 * Condition variable object.
 */
typedef	struct condvar {
    HANDLE event;	    /* Manual-reset event for notifications */
    unsigned int counter;   /* Current number of notifications */
    unsigned int waiters;   /* Number of threads waiting for notification */
    unsigned int tickets;   /* Number of waiters to be notified */
} condvar_t;

bool_t	condvarInit(condvar_t *);
void	condvarDestroy(condvar_t *);
void	condvarWait(sys_thread_t *, condvar_t *, mutex_t *);
void	condvarTimedWait(sys_thread_t *, condvar_t *, mutex_t *, unsigned long);
bool_t	condvarSignal(condvar_t *);
bool_t	condvarBroadcast(condvar_t *);

#endif	/* !_WIN32_CONDVAR_MD_H_ */
