/*
 * @(#)Win32Process.java	1.10 98/10/28
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package java.lang;

import java.io.*; 

class Win32Process extends Process {
    private int handle = 0;
    private FileDescriptor stdin_fd;
    private FileDescriptor stdout_fd;
    private FileDescriptor stderr_fd;
    private OutputStream stdin_stream;
    private InputStream stdout_stream;
    private InputStream stderr_stream;

    Win32Process(String cmd[], String env[]) throws Exception {
	if (cmd.length < 1) {
	    throw new IllegalArgumentException();
	}
	StringBuffer cmdbuf = new StringBuffer(cmd[0]);
	for (int i = 1; i < cmd.length; i++) {
	    cmdbuf.append(' ').append(cmd[i]);
	}
	String cmdstr = cmdbuf.toString();

	String envstr = null;
	if (env != null) {
	    StringBuffer envbuf = new StringBuffer();
	    for (int i = 0; i < env.length; i++) {
		envbuf.append(env[i]).append('\0');
	    }
	    envstr = envbuf.toString();
	}

	stdin_fd = new FileDescriptor();
	stdout_fd = new FileDescriptor();
	stderr_fd = new FileDescriptor();
	
	create(cmdstr, envstr);
	stdin_stream = new BufferedOutputStream(new sun.io.FDOutputStream(stdin_fd));
	stdout_stream = new BufferedInputStream(new sun.io.FDInputStream(stdout_fd));
	stderr_stream = new sun.io.FDInputStream(stderr_fd);
    }

    public OutputStream getOutputStream() {
	return stdin_stream;
    }

    public InputStream getInputStream() {
	return stdout_stream;
    }

    public InputStream getErrorStream() {
	return stderr_stream;
    }

    public void finalize() {
	close();
    }

    public native int exitValue();
    public native int waitFor();
    public native void destroy();

    private native void create(String cmdstr, String envstr);
    private native void close();
}
