/*
 * @(#)java_lang_Runtime_execInternal.c	1.2 98/10/13
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#include <windows.h>
#include <stdio.h>
#include <errno.h>
#include <ctype.h>

#include "sys_api.h"

#ifndef _WIN32_WCE /* pJava/WinCE does not support java.lang.Win32Process */

#include "java_lang_Process.h"
#include "java_lang_Win32Process.h"
#include "java_lang_Runtime.h"

Hjava_lang_Process *
java_lang_Runtime_execInternal(Hjava_lang_Runtime *Hthis, 
			       HArrayOfString *Hcmd, HArrayOfString *Henv)
{
    Hjava_lang_Process *Hproc;
    ClassClass *cb;

    if (Hcmd == 0) {
	SignalError(0, JAVAPKG "NullPointerException", 0);
	return 0;
    }
    Hproc = (Hjava_lang_Process *)
	    execute_java_constructor(EE(), JAVAPKG "Win32Process", 0,
				     "([Ljava/lang/String;[Ljava/lang/String;)",
				     Hcmd, Henv);
    return Hproc;
}

#else /* !_WIN32_WCE */
/*
 * WinCE does not have functionality to support java.lang.Process
 * (no pipe, no concept of console I/O), so give it up.
 * We throw UnsupportedOperationException instead of RuntimeException 
 * which is thrown by JavaOS implementation.
 */

Hjava_lang_Process *
java_lang_Runtime_execInternal(Hjava_lang_Runtime *Hthis, 
			       HArrayOfString *Hcmd, HArrayOfString *Henv) 
{
    if (Hcmd == NULL) {
	SignalError(NULL, JAVAPKG "NullPointerException", NULL);
	return NULL;
    }
    SignalError(NULL, JAVAPKG "UnsupportedOperationException", NULL);
    return NULL;
}

#endif /* !_WIN32_WCE */
