/*
 * @(#)java_net_InetAddressImpl_lookupAllHostAddr.c	1.2 98/10/12
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#include <windows.h>
#include <windef.h>
#include <winsock.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <sys/types.h>

#include "javanet_common.h"
#include "java_net_InetAddressImpl.h"
#include "javaString.h"

/*
 * Find an internet address for a given hostname.  Not this this
 * code only works for addresses of type INET.   The translation
 * of %d.%d.%d.%d to an address (int) occurs in java now, so the
 * String "host" shouldn't *ever* be a %d.%d.%d.%d string
 */
HArrayOfArray *
java_net_InetAddressImpl_lookupAllHostAddr(Hjava_net_InetAddressImpl *dummy, HString *host)
{
    char hostname[256];
    struct hostent *hp;
    HArrayOfArray *ret;

    if (host == 0) {
	NET_ERROR(0, JAVAPKG "NullPointerException", 0);
	return 0;
    }

    javaString2CString(host, hostname, sizeof (hostname));

    if ((hp = gethostbyname(hostname)) != NULL) {
	struct in_addr **addrp = (struct in_addr **) hp->h_addr_list;
	int i = 0;

	while (*addrp != (struct in_addr *) 0) {
	    i++;
	    addrp++;
	}

	ret = (HArrayOfArray *) ArrayAlloc(T_CLASS, i);
	if (ret == 0)
	    return 0;
	memset((char *) unhand(ret), 0, sizearray(T_CLASS, i));
	unhand(ret)->body[i] = (HObject*)FindClass(0, "[B", TRUE);

	addrp = (struct in_addr **) hp->h_addr_list;
	i = 0;
	while (*addrp != (struct in_addr *) 0) {
	    HArrayOfByte *barray = (HArrayOfByte *)
		ArrayAlloc(T_BYTE, sizeof(struct in_addr));
	    if (barray == 0) 
		return 0;
	    memcpy(unhand(barray)->body, (char *) (*addrp), sizeof(struct in_addr));
	    unhand(ret)->body[i] = (Hjava_lang_Object *) barray;
	    addrp++;
	    i++;
	}
	return ret;
    } else {
	NET_ERROR(0, JAVANETPKG "UnknownHostException", hostname);
	return 0;
    }
}

