/*
 * @(#)java_net_PlainDatagramSocketImpl_bind.c	1.3 99/02/11
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#include <windows.h>
#include <windef.h>
#include <winsock.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <sys/types.h>

#include "javanet_common.h"
#include "java_net_PlainDatagramSocketImpl.h"
#include "java_net_InetAddress.h"

void 
java_net_PlainDatagramSocketImpl_bind(struct Hjava_net_PlainDatagramSocketImpl *Hthis, 
					   long port, struct Hjava_net_InetAddress *laddr)
{
    Classjava_net_PlainDatagramSocketImpl *this = unhand(Hthis);
    Classjava_net_InetAddress *addrptr;
    struct sockaddr_in lcladdr;
    int lcladdrlen= sizeof(lcladdr);
    Classjava_io_FileDescriptor *fdptr;

    if (this->fd == 0) {
	NET_ERROR(0, JAVANETPKG "SocketException", "Socket closed");
	return;
    }
    fdptr = unhand(this->fd);

    if (laddr == 0) {
	NET_ERROR(0, JAVAPKG "NullPointerException", "null Address");
	return;
    }

    addrptr = unhand(laddr);

    /* bind - pick a port number for local addr*/
    memset((char *) &lcladdr, 0, sizeof(lcladdr));
    lcladdr.sin_family      = AF_INET;
    lcladdr.sin_port        = htons((short)port);
    lcladdr.sin_addr.s_addr = htonl(addrptr->address);

    if (bind(fdptr->fd - 1, (struct sockaddr *)&lcladdr, sizeof(lcladdr)) == -1) {
	raiseSocketException(WSAGetLastError(), "Cannot bind");
	return;
    }

    /* find what port system picked for us - the interface should have told 
       me in the bind call itself, but has not been designed to */
    if (getsockname(fdptr->fd - 1, (struct sockaddr *)&lcladdr, &lcladdrlen) == -1) {
	raiseSocketException(WSAGetLastError(), "getsockname");
	return;
    }
    this->localPort = ntohs(lcladdr.sin_port);
}

