/*
 * @(#)java_net_PlainDatagramSocketImpl_getTTL.c	1.2 98/10/12
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#include <windows.h>
#include <windef.h>
#include <winsock.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <sys/types.h>

#include "javanet_common.h"
#include "java_net_PlainDatagramSocketImpl.h"
#include "java_io_FileDescriptor.h"

char 
java_net_PlainDatagramSocketImpl_getTTL(struct Hjava_net_PlainDatagramSocketImpl *this)
{
    Classjava_net_PlainDatagramSocketImpl *thisptr = unhand(this);
    Classjava_io_FileDescriptor *fdptr;
    int ttl = 0;
    int len = sizeof(ttl);
    if (thisptr->fd == 0) {
      SignalError(0, JAVAPKG "NullPointerException", "null FileDescriptor");
      return -1;
    }
    fdptr = unhand(thisptr->fd);

    /* getsockopt of ttl */
    if (getsockopt(fdptr->fd -1, IPPROTO_IP, IP_MULTICAST_TTL, (char*)&ttl,
	    &len) < 0) {
	struct execenv *ee = EE();
	if (!(ee && exceptionOccurred(ee))) {
	    raiseSocketException(WSAGetLastError(), "get ttl failed");
	    return -1;
	}
    }
    return ttl;
}


