/*
 * @(#)java_net_PlainDatagramSocketImpl_leave.c	1.2 98/10/12
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#include <windows.h>
#include <windef.h>
#include <winsock.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <sys/types.h>

#include "javanet_common.h"
#include "java_net_PlainDatagramSocketImpl.h"
#include "java_net_InetAddress.h"
#include "java_io_FileDescriptor.h"

void 
java_net_PlainDatagramSocketImpl_leave(struct Hjava_net_PlainDatagramSocketImpl *this, 
					    struct Hjava_net_InetAddress *mcast_address)
{
  struct sockaddr_in name;
  struct ip_mreq mname;
  Classjava_net_InetAddress *addrptr;
  Classjava_net_PlainDatagramSocketImpl *thisptr = unhand(this);
  Classjava_io_FileDescriptor *fdptr = unhand(thisptr->fd);

  if (fdptr == 0) {
    SignalError(0, JAVAPKG "NullPointerException", "null FileDescriptor");
    return;
  }

  if (mcast_address == 0) {
      SignalError(0, JAVAPKG "NullPointerException", 0);
      return;
  }

  addrptr = unhand(mcast_address);  

  /* Set the multicast group address in the ip_mreq field */
  /* eventually this check should be done by the security manager */
  mname.imr_multiaddr.s_addr = htonl(addrptr->address);
  if (!IN_MULTICAST(addrptr->address)) {
        struct execenv *ee = EE();
        if (!(ee && exceptionOccurred(ee))) {
	    raiseSocketException(WSAGetLastError(), "not a multicast address multicast");            
	    return;
        }
  }
  /* Set the interface to be default */
  mname.imr_interface.s_addr = INADDR_ANY;
  
  /* Join the multicast group */
  if (setsockopt(fdptr->fd- 1, IPPROTO_IP, IP_DROP_MEMBERSHIP,(char *) &mname,
	   sizeof (mname)) < 0) {
        struct execenv *ee = EE();
        if (!(ee && exceptionOccurred(ee))) {
	    raiseSocketException(WSAGetLastError(), "multicast leave group failed");
        }
  }
  return;
}

