/*
 * @(#)java_net_PlainDatagramSocketImpl_peek.c	1.2 98/10/12
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#include <windows.h>
#include <windef.h>
#include <winsock.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <sys/types.h>

#include "javanet_common.h"
#include "java_net_PlainDatagramSocketImpl.h"
#include "java_net_InetAddress.h"
#include "java_io_FileDescriptor.h"

long
java_net_PlainDatagramSocketImpl_peek(struct Hjava_net_PlainDatagramSocketImpl *Hthis, struct Hjava_net_InetAddress *in)
{
    Classjava_net_PlainDatagramSocketImpl *this = unhand(Hthis);
    Classjava_io_FileDescriptor *fdptr;
    Classjava_net_InetAddress *addrptr = unhand(in);
    int n;
    struct sockaddr_in remote_addr;
    int remote_addrsize = sizeof (remote_addr);
    char buf[1];

    if (this->fd == 0) {
	NET_ERROR(0, JAVANETPKG "SocketException", "Socket closed");
	return -1;
    }
    fdptr = unhand(this->fd);
    
    if (addrptr==0) {
        NET_ERROR(0, JAVAPKG "NullPointerException", 0);
        return 0;
    }

    if (this->timeout) {
	int ret = sysTimeoutFD(fdptr, this->timeout);
	if (ret == 0) {
	    NET_ERROR(0, JAVAIOPKG "InterruptedIOException", "Receive timed out");
	    return ret;
	} else if (ret == -1) {
	    if (fdptr->fd < 0) {
		NET_ERROR(0, JAVANETPKG "SocketException", "Socket was closed");
	    } else {
		raiseSocketException(WSAGetLastError(), "Receive failed");
	    }
	    return ret;
	}
    }

    n = recvfrom(fdptr->fd - 1, buf, 1, MSG_PEEK, 
		 (struct sockaddr *)&remote_addr, &remote_addrsize);

    if (n==-1 && WSAGetLastError() != WSAEMSGSIZE) {
	if (fdptr->fd < 0) {
	    NET_ERROR(0, JAVANETPKG "SocketException", "Socket was closed");
	} else {
	    raiseSocketException(WSAGetLastError(), "Datagram receive failed");
	}
        return 0;
    }
 
    addrptr->family = remote_addr.sin_family;
    addrptr->address = ntohl(remote_addr.sin_addr.s_addr);

    /* return port */
    return ntohs(remote_addr.sin_port);
}

