/*
 * @(#)java_net_PlainDatagramSocketImpl_receive.c	1.2 98/10/12
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#include <windows.h>
#include <windef.h>
#include <winsock.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <sys/types.h>

#include "javanet_common.h"
#include "java_net_PlainDatagramSocketImpl.h"
#include "java_net_InetAddress.h"
#include "java_net_DatagramPacket.h"
#include "java_io_FileDescriptor.h"

void
java_net_PlainDatagramSocketImpl_receive(struct Hjava_net_PlainDatagramSocketImpl *Hthis, 
					 struct Hjava_net_DatagramPacket *packet)
{
    Classjava_net_PlainDatagramSocketImpl *this = unhand(Hthis);
    Classjava_io_FileDescriptor *fdptr;
    Classjava_net_DatagramPacket *packetptr;
    Classjava_net_InetAddress *addrptr=0;
    HArrayOfByte *data;
    char *dataptr;
    int datalen;
    long n;
    struct sockaddr_in remote_addr;
    int remote_addrsize = sizeof (remote_addr);

    if (this->fd == 0) {
	NET_ERROR(0, JAVANETPKG "SocketException", "Socket closed");
	return;
    }
    fdptr = unhand(this->fd);
    
    if (packet == 0) {
	NET_ERROR(0, JAVAPKG "NullPointerException", 0);
	return;
    }

    packetptr = unhand(packet);
    if ((data = packetptr->buf) == 0) {
	NET_ERROR(0, JAVAPKG "NullPointerException", 0);
	return;
    }

    packetptr->address = (Hjava_net_InetAddress *) execute_java_constructor(EE(),
				  "java/net/InetAddress",
				  (ClassClass *) 0, "()"); 

    addrptr = unhand(packetptr->address);

    dataptr = unhand(data)->body;
    datalen = packetptr->length;
    if (this->timeout) {
	int ret = sysTimeoutFD(fdptr, this->timeout);
	if (ret == 0) {
	    NET_ERROR(0, JAVAIOPKG "InterruptedIOException", "Receive timed out");
	    return;
	} else if (ret == -1) {
	    if (fdptr->fd < 0) {
		NET_ERROR(0, JAVANETPKG "SocketException", "Socket was closed");
	    } else {
		raiseSocketException(WSAGetLastError(), "Receive failed");
	    }
	    return;
	}
    }

    n = recvfrom(fdptr->fd - 1, dataptr, datalen, 0, 
		 (struct sockaddr *)&remote_addr, &remote_addrsize);
    if (n == -1 && WSAGetLastError() != WSAEMSGSIZE) {
	if (fdptr->fd < 0) {
	    NET_ERROR(0, JAVANETPKG "SocketException", "Socket was closed");
	} else {
	    raiseSocketException(WSAGetLastError(), "Receive failed");
	}
	packetptr->length = 0;
    } else { /* success */
      packetptr->port = ntohs(remote_addr.sin_port);
      packetptr->length = (WSAGetLastError() == WSAEMSGSIZE) ? datalen: n;
      addrptr->family = remote_addr.sin_family;
      addrptr->address = ntohl(remote_addr.sin_addr.s_addr);
    }

    return;
}

