/*
 * @(#)java_net_PlainDatagramSocketImpl_send.c	1.2 98/10/12
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#include <windows.h>
#include <windef.h>
#include <winsock.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <sys/types.h>

#include "javanet_common.h"
#include "java_net_PlainDatagramSocketImpl.h"
#include "java_net_InetAddress.h"
#include "java_net_DatagramPacket.h"
#include "java_io_FileDescriptor.h"

void
java_net_PlainDatagramSocketImpl_send(struct Hjava_net_PlainDatagramSocketImpl *Hthis,
struct Hjava_net_DatagramPacket *packet)
{
    Classjava_net_PlainDatagramSocketImpl *this = unhand(Hthis);
    Classjava_io_FileDescriptor *fdptr;
    Classjava_net_DatagramPacket *packetptr;
    Classjava_net_InetAddress *addrptr;
    HArrayOfByte *data; 
    char *dataptr;
    int datalen;
    long n;
    struct sockaddr_in rmtaddr;

    if (this->fd == 0) {
	NET_ERROR(0, JAVANETPKG "SocketException", "Socket closed");
	return;
    }
    fdptr = unhand(this->fd);
    if (packet == 0) {
	NET_ERROR(0, JAVAPKG "NullPointerException", 0);
	return;
    }

    packetptr = unhand(packet);

    if ((data = packetptr->buf) == 0) {
	NET_ERROR(0, JAVAPKG "NullPointerException", 0);
	return;
    }

    if (packetptr->address == 0) {
	NET_ERROR(0, JAVAPKG "NullPointerException","null Address in packet");
	return;
    }

    addrptr = unhand(packetptr->address);

    dataptr = unhand(data)->body;
    datalen = packetptr->length;
    rmtaddr.sin_port = htons((short)(packetptr->port));
    rmtaddr.sin_addr.s_addr = htonl(addrptr->address);
    rmtaddr.sin_family = addrptr->family;

    n = sendto(fdptr->fd - 1, dataptr, datalen, 0, (struct sockaddr *)&rmtaddr, sizeof(rmtaddr));
    if (n == -1) {
      	raiseSocketException(WSAGetLastError(), "Datagram send failed");
	packetptr->length = 0;
	return;
    }

    packetptr->length = n;
    return;
}

