/*
 * @(#)java_net_PlainDatagramSocketImpl_socketGetOption.c	1.2 98/10/12
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#include <windows.h>
#include <windef.h>
#include <winsock.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <sys/types.h>

#include "javanet_common.h"
#include "java_net_PlainDatagramSocketImpl.h"
#include "java_io_FileDescriptor.h"

/*
 * return data as 32-bit quantity
 */
long
java_net_PlainDatagramSocketImpl_socketGetOption(struct Hjava_net_PlainDatagramSocketImpl *Hthis, long optID) {
    Classjava_net_PlainDatagramSocketImpl *this = unhand(Hthis);
    Classjava_io_FileDescriptor *fdptr;
    int fd;

    if (this->fd == 0) {
	NET_ERROR(0, JAVANETPKG "SocketException", "Socket closed");
	return -1;
    }

    fdptr = unhand(this->fd);
    
    if ((fd = fdptr->fd - 1) < 0) {
      NET_ERROR(0, JAVANETPKG "SocketException", "socket closed");
      return -1;
    } else if (optID == JIP_MULTICAST_IF) {
	struct in_addr in;
	int len = sizeof(struct in_addr);
	if (getsockopt(fd, IPPROTO_IP, IP_MULTICAST_IF, (char *)&in, &len) < 0) {
	    raiseSocketException(WSAGetLastError(), "get IP_MULTICAST_IF failed");
	    return -1;
	}
	return ntohl(in.s_addr);    
    } else if (optID == JSO_BINDADDR) {
	/* find out local IP address, return as 32 bit value */
	struct sockaddr_in him;
	int len = sizeof(struct sockaddr_in);
	memset(&him, 0, len);
	if (getsockname(fd, (struct sockaddr *)&him, &len) == -1) {
	    raiseSocketException(WSAGetLastError(), "getsockopt() SO_BINDADDR");
	    return -1;
	}
	return htonl(him.sin_addr.s_addr);
    } else {
	NET_ERROR(0, JAVANETPKG "SocketException", "invalid DatagramSocket option");
	return -1;
    }
}
