/*
 * @(#)java_net_PlainDatagramSocketImpl_socketSetOption.c	1.2 98/10/12
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#include <windows.h>
#include <windef.h>
#include <winsock.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <sys/types.h>

#include "javanet_common.h"
#include "java_net_PlainDatagramSocketImpl.h"
#include "java_net_InetAddress.h"
#include "java_io_FileDescriptor.h"
#include "java_lang_Object.h"
#include "java_lang_Integer.h"

void
java_net_PlainDatagramSocketImpl_socketSetOption(struct Hjava_net_PlainDatagramSocketImpl *Hthis, 
						 long optID, struct Hjava_lang_Object *val) {
    Classjava_net_PlainDatagramSocketImpl *this = unhand(Hthis);
    Classjava_io_FileDescriptor *fdptr;
    int fd;

    if (this->fd == 0) {
	NET_ERROR(0, JAVANETPKG "SocketException", "Socket closed");
	return;
    }

    fdptr = unhand(this->fd);
    
    if (val == 0) {
	NET_ERROR(0, JAVAPKG "NullPointerException", 0);
    }

    if ((fd = fdptr->fd - 1) < 0) {
	NET_ERROR(0, JAVANETPKG "SocketException", "Socket closed");
    } else if (optID == JIP_MULTICAST_IF) {
	Classjava_net_InetAddress *addrptr = (Classjava_net_InetAddress*)(unhand(val));
	struct in_addr in;
	in.s_addr = htonl(addrptr->address);
	if (setsockopt(fd, IPPROTO_IP, IP_MULTICAST_IF, (const char*)&in, sizeof(in)) < 0) {
	    raiseSocketException(WSAGetLastError(), "set IP_MULTICAST_IF failed");
	}
    } else if (optID == JSO_REUSEADDR) {
	Classjava_lang_Integer *intptr = (Classjava_lang_Integer*)(unhand(val));
	int arg = (intptr->value) ? -1: 0;
	if (setsockopt(fd, SOL_SOCKET, SO_REUSEADDR, (char *)&arg, sizeof(arg)) < 0) {
	    raiseSocketException(WSAGetLastError(), "set REUSEADDR failed");
	}
    } else {
	NET_ERROR(0, JAVANETPKG "SocketException", "invalid DatagramSocket option");
    }
    return;
}
	
