/*
 * @(#)java_net_PlainSocketImpl_socketAccept.c	1.2 98/10/12
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#include <windows.h>
#include <windef.h>
#include <winsock.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <sys/types.h>

#include "javanet_common.h"
#include "java_net_PlainSocketImpl.h"
#include "java_net_SocketImpl.h"
#include "java_net_InetAddress.h"
#include "java_io_FileDescriptor.h"

void 
java_net_PlainSocketImpl_socketAccept(Hjava_net_PlainSocketImpl *Hthis,
				      Hjava_net_SocketImpl *Hs)
{
    Classjava_net_PlainSocketImpl *this = unhand(Hthis);
    Classjava_io_FileDescriptor *fdptr;
    int infd;
    Classjava_net_SocketImpl *sptr;
    Classjava_io_FileDescriptor *sptr_fdptr;
    Classjava_net_InetAddress *addr;
    struct sockaddr_in him;
    int len = sizeof(him);
    int fd;

    if (this->fd == 0) {
	NET_ERROR(0, JAVANETPKG "SocketException", "Socket closed");
	return;
    }
    fdptr = unhand(this->fd);

    infd = fdptr->fd - 1;

    if (Hs == NULL) {
	NET_ERROR(0, JAVAPKG "NullPointerException", 0);
	return;
    }
    sptr = unhand(Hs);
    sptr_fdptr = unhand(sptr->fd);

    if (sptr->address == NULL){
	NET_ERROR(0, JAVAPKG "NullPointerException", 0);
	return;
    }
    addr = unhand(sptr->address);
    if (this->timeout) {
	int ret = sysTimeoutFD(fdptr, this->timeout);
	if (ret == 0) {
	    NET_ERROR(0, JAVAIOPKG "InterruptedIOException", "Accept timed out");
	    return;
	} else if (ret == SOCKET_ERROR) {
	    if (fdptr->fd < 0) {
		NET_ERROR(0, JAVANETPKG "SocketException", "socket was closed");
	    } else {
		raiseSocketException(WSAGetLastError(), "Accept failed");
	    }
	    return;
	}
    }
    fd = accept(infd, (struct sockaddr *)&him, &len);
    if (fd < 0) {
	if (fdptr->fd < 0) {
	    NET_ERROR(0, JAVANETPKG "SocketException", "socket was closed");
	} else {
	    raiseSocketException(WSAGetLastError(), "Accept failed");
	}
	return;
    }
    sptr_fdptr->fd = fd + 1;
    sptr->port = ntohs(him.sin_port);
    addr->family = him.sin_family;
    addr->address = ntohl(him.sin_addr.s_addr);
    /* also fill up the local port information */
    sptr->localport = this->localport;
}

