/*
 * @(#)java_net_PlainSocketImpl_socketBind.c	1.2 98/10/12
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#include <windows.h>
#include <windef.h>
#include <winsock.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <sys/types.h>

#include "javanet_common.h"
#include "java_net_PlainSocketImpl.h"
#include "java_net_InetAddress.h"
#include "java_io_FileDescriptor.h"

void 
java_net_PlainSocketImpl_socketBind(Hjava_net_PlainSocketImpl *Hthis,
				    Hjava_net_InetAddress *Haddr,
				    long port)
{
    Classjava_net_PlainSocketImpl *this = unhand(Hthis);
    Classjava_net_InetAddress *addr;
    struct sockaddr_in him;
    Classjava_io_FileDescriptor *fdptr;
    int fd;

    if (this->fd == 0) {
	NET_ERROR(0, JAVANETPKG "SocketException", "Socket closed");
	return;
    }
    fdptr = unhand(this->fd);

    fd = fdptr->fd - 1;

    if (Haddr == NULL) {
	NET_ERROR(0, JAVAPKG "NullPointerException", 0);
	return;
    }
    addr = unhand(Haddr);

    /* bind */
    memset(&him, 0, sizeof him);
    him.sin_port = htons((short)port);
    him.sin_addr.s_addr = (unsigned long)htonl(addr->address);
    him.sin_family = addr->family;

    if (bind(fd, (struct sockaddr *)&him, sizeof him) == -1) {
	raiseSocketException(WSAGetLastError(), "bind");
	return;
    }

    /* set the address */
    this->address = Haddr;

    /* intialize the local port */
    if (port == 0) {
	/* Now that we're a connected socket, let's extract the port number
	 * that the system chose for us and store it in the Socket object. 
  	 */
	int len = sizeof(him);
	if (getsockname(fd, (struct sockaddr *)&him, &len) == -1) {
	    raiseSocketException(WSAGetLastError(), "getsockname");
	    return;
	}
	this->localport = ntohs(him.sin_port);
    } else {
	this->localport = port;
    }
}

