/*
 * @(#)java_net_SocketOutputStream_socketWrite.c	1.2 98/10/12
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#include <windows.h>
#include <windef.h>
#include <winsock.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <sys/types.h>

#include "javanet_common.h"
#include "java_net_SocketOutputStream.h"
#include "java_io_FileDescriptor.h"

void
java_net_SocketOutputStream_socketWrite(Hjava_net_SocketOutputStream *Hthis,
					HArrayOfByte *Hdata, long off, long len)
{
    Classjava_net_SocketOutputStream *this = unhand(Hthis);
    Classjava_io_FileDescriptor *fdptr;
    char *data;
    int datalen, n;

    if (this->fd == 0) {
	NET_ERROR(0, JAVANETPKG "SocketException", "Socket closed");
	return;
    }
    fdptr = unhand(this->fd);

    if (Hdata == NULL) {
	NET_ERROR(0, JAVAPKG "NullPointerException", 0);
	return;
    }
    data = unhand(Hdata)->body;
    datalen = obj_length(Hdata);

    if (len < 0 || off < 0 || len + off > datalen) {
        NET_ERROR(0, JAVAPKG "ArrayIndexOutOfBoundsException", 0);
        return;
    }

    while (len > 0) {
	n = sysSendFD(fdptr, data + off, len, 0);
	if (n == -1) {
	    raiseSocketException(WSAGetLastError(), "Socket write failed");
	    break;
	}
        off += n;
	len -= n;
    }
}

