/*
 * @(#)javanet_common.h	1.1 98/10/12
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#include "fd_md.h"
#include "bool.h"

/* The socket option constants in java are the same as in C
 * for Solaris and win32, but this may not be the case
 * everywhere.  (Actually, they're not the same on
 * win32 for MCAST_LOOP).  If you're porting, tweek these as
 * need be.  Otherwise, don't screw with these 
 */

#define JSO_TCP_NODELAY TCP_NODELAY
#define JSO_LINGER SO_LINGER
#define JSO_TIMEOUT SO_RCVTIMEO
#define JSO_REUSEADDR SO_REUSEADDR

/* different constants */

#define JIP_MULTICAST_IF 0x10
#define JSO_BINDADDR 0x000F

#define NET_ERROR(_ee, _ex, _msg) if (!exceptionOccurred(EE())) \
                                   SignalError(_ee, _ex, _msg)

#define IN_CLASSD(i)	(((long)(i) & 0xf0000000) == 0xe0000000)
#define IN_MULTICAST(i)	IN_CLASSD(i)

/*
 * the level of the TCP protocol for setsockopt and getsockopt
 * we only want to look this up once, from the static initializer
 * of PlainSocketImpl
 */
extern int tcp_level;

extern void raiseSocketException(DWORD errval, char *reason);

