/*
 * @(#)sun_audio_AudioDevice_audioClose.c	1.1 98/10/12
 * 
 * Copyright (c) 1995, 1996 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 */

#include <io.h> 
#include <fcntl.h> 
#include <sys/types.h> 
#include <sys/stat.h> 
#include <stdio.h> 
#include <windows.h> 
#ifdef WIN32_LEAN_AND_MEAN
#include <mmsystem.h>
#endif

#include "sunaudio_common.h"
#include "sun_audio_AudioDevice.h"

void
sun_audio_AudioDevice_audioClose(struct Hsun_audio_AudioDevice *aP)
{
    struct buf *bp, *next;
    int r;

    /* Force cancellation of any pending buffers */
    (void)waveOutReset(waveHandle);

    /* Wait until all pending buffers have been freed */
    while (free_buffers < total_buffers) {
	WaitForSingleObject(free_buffer_event, INFINITE);
    }

    /* Close the device */
    if ((r = waveOutClose(waveHandle)) != 0) {
	printError("waveOutClose", r);
	return;
    }

    /* Free allocated buffers */
    for (bp = free_list; bp != NULL; bp = next) {
	next = bp->next;
	(void)free(bp);
    }
	
    waveHandle = NULL;
}

