/*
 * @(#)sunaudio_common.h	1.2 98/10/12
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#define	MAXBUF	    10		/* Maximum number of buffers */
#define	DATALEN     640		/* Size of wave data buffer */

struct buf {
    WAVEHDR hdr;		/* Wave data header */
    short data[DATALEN];	/* Actual wave data */
    struct buf *next;		/* Next buffer in free list */
};

extern HWAVEOUT waveHandle;		/* Handle of wave output device */
extern struct buf *free_list;		/* List of available buffers */
extern CRITICAL_SECTION free_list_lock;
extern int free_buffers;		/* Number of buffers in free list */
extern int total_buffers;		/* Total number of buffers allocated */
extern HANDLE free_buffer_event;	/* Automatic-reset event triggered
					   whenever a buffer is freed by the
					   callback routine */

extern void CALLBACK 
waveCallBack(HWAVE waveHandle, UINT msg, DWORD inst, DWORD p1, DWORD p2);

extern void
audioWrite(char *data, long dataLen);

extern void
printError(char *f, int r);
