/*
 * @(#)GraphicsSystem.h	1.4 98/08/31
 *
 * Copyright (c) 1998 Sun Microsystems, Inc. All Rights Reserved.
 *
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 */

#ifndef _GRAPHICSSYSTEM_H_
#define _GRAPHICSSYSTEM_H_


/*
 * Constants
 */
#define STDENTRY


/*
 * Types
 */
typedef struct _GFWSYSTEMWNDDATA
{
   JNIEnv*   env;          // JNI Environment ptr for system window's thread.
   jobject   obj;          // GraphicsSystem instance for system window.
   int       cxMax;        // Maximum screen width for emulator screen(s).
   int       cyMax;        // Maximum screen height for emulator screen(s).
   HWND      hwndScreen;   // Handle(s) of emulator screen(s).
} GFWSYSTEMWNDDATA, *PGFWSYSTEMWNDDATA;


/*
 * Globals
 */
extern HINSTANCE   hinstGlobal;


/* 
 * Constants
 */
#define UM_GFWSYSTEM_COMMAND   (WM_USER + 100)

#define GFWCMD_CREATESCREEN    0x00000001
#define GFWCMD_SETCURSOR       0x00000002
#define GFWCMD_SHOWCURSOR      0x00000003
#define GFWCMD_GETCURSORPOS    0x00000004


/*
 * Function prototypes
 */
HWND STDENTRY GFWCreateScreenWnd( int, int );


#endif   /* _GRAPHICSSYSTEM_H_ */
