/*
 * @(#)img_util_md.h	1.3 98/09/30 SMI
 * 
 * Copyright (c) 1995, 1996, 1998 Sun Microsystems, Inc. All Rights Reserved.
 * 
 * This software is the confidential and proprietary information of Sun
 * Microsystems, Inc. ("Confidential Information").  You shall not
 * disclose such Confidential Information and shall use it only in
 * accordance with the terms of the license agreement you entered into
 * with Sun.
 * 
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF THE
 * SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
 * PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR ANY DAMAGES
 * SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING
 * THIS SOFTWARE OR ITS DERIVATIVES.
 * 
 * CopyrightVersion 1.1_beta
 * 
 */

#include "ImageRepresentation.h"
#include "common.h"

/* For sysMalloc() prototype. */
#include <sys_api.h>


extern int getRGBFromPixel(JNIEnv *env, jobject obj, unsigned int pixel);
extern jint *getICMParams(JNIEnv *env, jobject obj, int *length);
extern void freeICMParams(JNIEnv *env, jobject obj, jint *data);
extern void getDCMParams(JNIEnv *env, jobject obj,
			 int *red_mask, int *red_off, int *red_scale,
			 int *green_mask, int *green_off, int *green_scale,
			 int *blue_mask, int *blue_off, int *blue_scale,
			 int *alpha_mask, int *alpha_off, int *alpha_scale);

typedef unsigned char MaskBits;

extern uns_ordered_dither_array img_oda_alpha;
extern sgn_ordered_dither_array img_oda_red;
extern sgn_ordered_dither_array img_oda_green;
extern sgn_ordered_dither_array img_oda_blue;

#define BufComplete(cvdata, dstX1, dstY1, dstX2, dstY2)		\
    (((AwtImage *)cvdata)->BufDone(env,dstX1, dstY1, dstX2, dstY2))

#define SendRow(cvdata, dstY, dstX1, dstX2)

#define ImgInitMask(cvdata, x1, y1, x2, y2)			\
    (((AwtImage *) cvdata)->GetMaskBuf(TRUE, x1, y1, x2, y2))

#define ScanBytes(cvdata)	(((AwtImage *) cvdata)->GetBufScan())

#define MaskScan(cvdata)					\
    MaskOffset((((AwtImage *) cvdata)->GetWidth() + 31) & (~31))

#define MaskOffset(x)		((x) >> 3)

#define MaskInit(x)		(0x80 >> ((x) & 7))

#define SetOpaqueBit(mask, bit)		(mask &= ~bit)
#define SetTransparentBit(mask, bit)	(mask |= bit)

#define ColorCubeFSMap(r, g, b)		AwtImage::CubeMap(r, g, b)

#define ColorCubeOrdMapSgn(r, g, b)	AwtImage::CubeMap(r, g, b);

#define GetPixelRGB(pixel, red, green, blue)			\
    do {							\
	RGBQUAD *cp = AwtImage::PixelColor(pixel);		\
	red = cp->rgbRed;					\
	green = cp->rgbGreen;					\
	blue = cp->rgbBlue;					\
    } while (0)

#ifdef DEBUG
#undef img_check
#define img_check(condition)					\
    do {							\
	if (!(condition)) {					\
	    SignalError(0, JAVAPKG "InternalError",		\
			"assertion failed:  " #condition);	\
	    return SCALEFAILURE;				\
	}							\
    } while (0)
#else /* DEBUG */
#undef img_check
#define img_check(condition)	do {} while (0)
#endif /* DEBUG */
