/*
 * @(#)WFileDialogPeer.java	1.8 98/07/21
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.windows;

import java.awt.*;
import java.awt.peer.*;
import sun.awt.ScreenUpdater;
import java.io.FilenameFilter;

public class WFileDialogPeer extends WWindowPeer implements FileDialogPeer {

    private WComponentPeer parent;

    public void setDirectory(String dir) {}
    public void setFile(String file) {}
    public void setTitle(String title) {}

    public void	setFilenameFilter(FilenameFilter filter) {
        // We can set the filter, but can't do anything with it yet.
        System.err.println("setFilenameFilter not implemented\n");
    }

    // Toolkit & peer internals
    WFileDialogPeer(FileDialog target) {
	super(target);
    }

    void create(WComponentPeer parent) {
        this.parent = parent;
    }

    void initialize() {
        FileDialog target = (FileDialog)this.target;
    }

    protected void disposeImpl() {
        ScreenUpdater.updater.removeClient(this);
        WToolkit.targetDisposedPeer(target, this);
    }

    public native void show();

    // native callbacks
    void handleSelected(String file) {
	int index = file.lastIndexOf('\\');
        String dir;

	if (index == -1) {
	    dir = ".\\";
	    ((FileDialog)target).setFile(file);
	}
        else {
	    dir = file.substring(0, index+1);
	    ((FileDialog)target).setFile(file.substring(index+1));
	}
	((FileDialog)target).setDirectory(dir);
	((FileDialog)target).setVisible(false);
    }

    void handleCancel() {
	((FileDialog)target).setFile(null);
	((FileDialog)target).setVisible(false);
    }

    // unused methods.
    public void beginValidate() {}
    public void endValidate() {}
    public void toFront() {}
    public void toBack() {}
    public void setResizable(boolean resizable) {}
    public void hide() {}
    public void enable() {}
    public void disable() {}
    public void reshape(int x, int y, int width, int height) {}
    public boolean handleEvent(Event e) { return false;}
    public void setForeground(Color c) {}
    public void setBackground(Color c) {}
    public void setFont(Font f) {}
    public void requestFocus() {}
    public void nextFocus() {}
    public void setCursor(int cursorType) {}
    void start() {}
    void invalidate(int x, int y, int width, int height) {}
}
