/*
 * @(#)awt_event.h	1.7 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef _AWTEVENT_H_
#define _AWTEVENT_H_

#include "stdafx.h"
#include "awt.h"

// Enable the following lines to turn on the new input event routing:
// NEW_EVENT_MODEL:  general input event filtering support.
// KEYBOARD_EVENT_FILTER:  code specific to key events
// MOUSE_EVENT_FILTER:  code specific to mouse events.
#define NEW_EVENT_MODEL
#define KEYBOARD_EVENT_FILTER
//#define MOUSE_EVENT_FILTER

#define FILTER_SIGNATURE 25549

class AwtEvent {
public:
    MSG* pMsg;
    Hjava_awt_Component* pJavaObject;

    AwtEvent(Hjava_awt_Component* pObject);
    void CopyMessage(MSG* pMsg);
    void FreeMessage();
    Hsun_awt_win32_MComponentPeer* pPeer() {
        return (Hsun_awt_win32_MComponentPeer *)unhand(pJavaObject)->peer;
    };

    // Mouse variables
    BOOL m_bMouseDown;
    BOOL m_bMouseInside;
    CPoint m_curPt;
    HWND m_hCurWnd;
    BOOL m_bCurWndIsChild;

    BOOL PreKeyDown();
    BOOL PreKeyUp();
    BOOL PreChar();
    BOOL PreButtonDown();
    BOOL PreButtonUp(BOOL fPostMsg);
    BOOL PreMouseMove();
    BOOL PreTimer();
    BOOL PreSetFocus();
    BOOL PreKillFocus();
    void DoMouseMove(UINT nFlags, POINT pt, BOOL fPostMsg);
};

extern BOOL HandleInputEvent(MSG *pMsg);
extern void DispatchInputEvent(Classjava_awt_Event *eventPtr);

/////////////////////////////////////////////////////////////////////////////

#endif // _AWTEVENT_H
