/*
 * @(#)awt_font.h	1.19 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
#include "awt_window.h"

#ifndef _AWTFONT_H_
#define _AWTFONT_H_

#include "awtapp.h"

class AwtFont : public CFont
{
public:
    // Debug link used for list of ALL objects...
    DEFINE_AWT_LIST_LINK

	AwtFont();
	~AwtFont();
	DECLARE_DYNCREATE(AwtFont)

public:
	// These are the messages that can be sent to this class.
	enum {CREATE, DISPOSE};

// Operations
	// Returns the AwtFont object associated with the pFontJavaObject.
	// If none exists, create one.
	static AwtFont *GetFont(Hjava_awt_Font *pJavaObject);
	
	// Creates the specified font.  pzName names the font.  nStyle is a bit
	// vector that describes the style of the font.  nHeight is the point
	// size of the font.
	static AwtFont *Create(char *pzName, int nStyle, int nHeight);

	// Maps a platform-independent name to a platform-specific name.
	static const char *PINameToPSName(char *pzPIName);

	// Called from AwtApp.
	static long HandleMsg(UINT nMsg, long p1 = NULL, long p2 = NULL, 
                              long p3 = NULL, long p4 = NULL, long p5 = NULL, 
                              long p6 = NULL, long p7 = NULL, long p8 = NULL);

	// Releases all resources and destroys the object.  After this call,
	// this object is no longer usable.
	void Dispose();

	static void Cleanup();

// Variables
public:
	// The ascent of this font.
	int m_nAscent;
	int GetAscent() { return m_nAscent; }


private:
// Variables
	// The oak font object.
	//Hjava_awt_Font *m_pJavaObject;
};

#endif // _AWTFONT_H_
