/*
 * @(#)awt_fontmetrics.h	1.14 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
#include "awt_window.h"

#ifndef _AwtFontMetrics_H_
#define _AwtFontMetrics_H_

class AwtFontMetrics
{
public:
    // Debug link used for list of ALL objects...
    DEFINE_AWT_LIST_LINK

	AwtFontMetrics();
	~AwtFontMetrics();

public:
// Operations
	// Loads the metrics of the associated font.
	// See Font.GetFont for purpose of pWS.  (Also, client should provide
	// Font java object instead of getting it from the FontMetrics instance variable.)
	static void LoadMetrics(Hsun_awt_win32_Win32FontMetrics *pJavaObject);

	static long StringWidth(Hsun_awt_win32_Win32FontMetrics *pJavaObject, char *pzString);

	// Returns the AwtFont associated with this metrics.
	static AwtFont *GetFont(Hsun_awt_win32_Win32FontMetrics *pJavaObject);

	// Sets the ascent of the font.  This member should be called if pFont->m_nAscent < 0.
	static void SetFontAscent(AwtFont *pFont);

	//long CharWidth(char ch);
	//long StringWidth(char *pzString);

	// Determines the average dimension of the character in the
	// specified font 'pFont' and multiplies it by the specified number of
	// rows and columns.  
	// 'pFont' can be a temporary object.
	static CSize AwtFontMetrics::TextSize(CFont *pFont, int nColumns, int nRows);

	// If 'pFont' is NULL, the SYSTEM_FONT is used to compute the size.
	// 'pFont' can be a temporary object.
	static CSize StringWidth(CFont *pFont, char *pzString);
};

#endif // _AwtFontMetrics_H_
