/*
 * @(#)awt_menu.h	1.19 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
#include "awt_mainfrm.h"

class AwtMenu : public CMenu
{
public:
	// These are the messages that can be sent to this class.
	enum {CREATE, DISPOSE, APPENDITEM, APPENDSEPARATOR, ENABLE,
              ENABLEITEM, ISENABLED, SETMARK, ISMARKED, DISPOSEITEM};

    // Debug link used for list of ALL objects...
    DEFINE_AWT_LIST_LINK

// Construction
	AwtMenu();
	~AwtMenu();
	DECLARE_DYNCREATE(AwtMenu)

// Operations
public:
	// Crates the Windows menu control
	static AwtMenu *Create(void *pJavaObject, MainFrame *pFrame, HMENU hMenuBar, char *pzLabel);
	UINT AppendItem(Hjava_awt_MenuItem *pItemObject, char *pzItemName);
	void AppendSeparator();
	void Enable(BOOL bEnable);
	void EnableItem(UINT nCmdID, BOOL bEnable);
	BOOL IsEnabled(UINT nCmdID);
	void SetMark(UINT nCmdID, BOOL bMark);
	BOOL IsMarked(UINT nCmdID);
	MainFrame *GetFrame() { return m_pFrame; };
	void DisposeItem(UINT nCmdID);
	void Dispose();

	void InvokeItem(UINT nCmdID);

// Awt Message-Related Operations
	
	// Posts a message to the server thread.  Returns immediately and does not wait for a reply.
	void PostMsg(UINT nMsg, long p1 = NULL, long p2 = NULL, long p3 = NULL, 
					long p4 = NULL, long p5 = NULL, long p6 = NULL) {
		GetApp()->PostAwtMsg(CAwtApp::AWT_MENU, nMsg, (long)this, p1, p2, p3, p4, p5, p6);
	}

	// Sends a message to the server thread and waits for a reply.  
	// This call blocks until the operation is completed.  The result is returned.
	long SendMsg(UINT nMsg, long p1 = NULL, long p2 = NULL, long p3 = NULL, 
						long p4 = NULL, long p5 = NULL, long p6 = NULL) {
		return GetApp()->SendAwtMsg(CAwtApp::AWT_MENU, nMsg, (long)this, p1, p2, p3, p4, p5, p6);
	}

	// Called from AwtApp.
	static long HandleMsg(UINT nMsg, long p1 = NULL, long p2 = NULL, long p3 = NULL, 
						  long p4 = NULL, long p5 = NULL, long p6 = NULL, long p7 = NULL, long p8 = NULL);


// Variables
private:
	MainFrame *m_pFrame;
	HMENU m_hMenuBar;
	void *m_pJavaObject;

	// Maps CmdID's to Hjava_awt_MenuItem objects.
	CMapWordToPtr m_ItemMap;
};
