/*
 * @(#)WButtonPeer.java	1.10 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.windows;

import java.awt.*;
import java.awt.peer.*;
import java.awt.event.ActionEvent;

class WButtonPeer extends WComponentPeer implements ButtonPeer {
    
    // ComponentPeer overrides
    
    public Dimension getMinimumSize() {
	FontMetrics fm = getFontMetrics(((Button)target).getFont());
	return new Dimension(fm.stringWidth(((Button)target).getLabel()) + 14, 
			     fm.getHeight() + 8);
    }
    public boolean isFocusTraversable() {
	return true;
    }

    // ButtonPeer implementation

    public native void setLabel(String label);

    void clearRectBeforePaint(Graphics g, Rectangle r) {
        // Overload to do nothing for native components
    }

    // Toolkit & peer internals
    
    WButtonPeer(Button target) {
	super(target);
    }

    native void create(WComponentPeer peer);

    // native callbacks

    public void handleAction() {
        WToolkit.postEvent(new ActionEvent(target, ActionEvent.ACTION_PERFORMED,
                                  ((Button)target).getActionCommand()));
    }

    /**
     * DEPRECATED
     */
    public Dimension minimumSize() {
	return getMinimumSize();
    }

}
