/*
 * @(#)WFramePeer.java	1.18 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.windows;

import java.util.Vector;
import java.awt.*;
import java.awt.peer.*;
import java.awt.image.ImageObserver;
import sun.awt.image.ImageRepresentation;

class WFramePeer extends WWindowPeer implements FramePeer {

    // FramePeer implementation

    public Dimension minimumSize() {
        int height = (((Frame)target).getMenuBar() != null) ? 45 : 30;
	return (new Dimension(30, height));
    }

    public void setIconImage(Image im) {
        ImageRepresentation ir = ((WImage)im).getImageRep();
        ir.reconstruct(ImageObserver.ALLBITS);
        _setIconImage(ir);
    }

    // Fix for 1251439: like WComponentPeer.reshape, but checks SM_C[XY]MIN
    public synchronized native void reshape(int x, int y, int width, int height);

    public void setMenuBar(MenuBar mb) {
	WMenuBarPeer mbPeer = (WMenuBarPeer) WToolkit.targetToPeer(mb);
        setMenuBar0(mbPeer);
        updateInsets(insets_);
    }
    private native void setMenuBar0(WMenuBarPeer mbPeer);

    // Toolkit & peer internals

    WFramePeer(Frame target) {
	super(target);
    }

    native void create(WComponentPeer parent);

    void initialize() {
        super.initialize();

        Frame target = (Frame)this.target;

	if (target.getTitle() != null) {
	    setTitle(target.getTitle());
	}
	setResizable(target.isResizable());

	Image icon = target.getIconImage();
	if (icon != null) {
	    setIconImage(icon);
	}
	if (!target.getCursor().equals(Cursor.getDefaultCursor())) {
	    setCursor(target.getCursor());
	}
    }
    native void _setIconImage(ImageRepresentation ir);
}
