/*
 * @(#)WImage.java	1.6 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.windows;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.image.ImageProducer;

import sun.awt.image.ImageRepresentation;

class WImage extends sun.awt.image.Image {
    /* Tunnel the Offscreen image constructor to the super class. */
    protected WImage(Component c, int w, int h) {
	super(c, w, h);
    }

    /**
     * Construct an image from an ImageProducer object.
     */
    public WImage(ImageProducer producer) {
	super(producer);
    }

    public Graphics getGraphics() {
	throw new IllegalAccessError("getGraphics() only valid for images created with createImage(w, h)");
    }

    protected ImageRepresentation makeImageRep() {
	return new ImageRepresentation(this, -1, -1, 0);
    }

    protected ImageRepresentation getImageRep() {
	return super.getImageRep();
    }
}
