/*
 * @(#)WMenuPeer.java	1.8 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.windows;

import java.awt.*;
import java.awt.peer.*;

class WMenuPeer extends WMenuItemPeer implements MenuPeer {
  
    // MenuPeer implementation

    public native void addSeparator();
    public void addItem(MenuItem item) {
	WMenuItemPeer itemPeer = (WMenuItemPeer) WToolkit.targetToPeer(item);
    }
    public native void delItem(int index);

    // Toolkit & peer internals

    WMenuPeer() {}   // used by subclasses.

	//Netscape: Menus require a 2 step construction in the event that
	//the menu is displayed before any items are added to it.

    WMenuPeer(Menu target) {
	this.target = target;
	}
	void create() {
	MenuContainer parent = ((Menu) target).getParent();

	if (parent instanceof MenuBar) {
	    WMenuBarPeer mbPeer = (WMenuBarPeer) WToolkit.targetToPeer(parent);
	    createMenu(mbPeer);
	}
        else if (parent instanceof Menu) {
	    WMenuPeer mPeer = (WMenuPeer) WToolkit.targetToPeer(parent);
	    createSubMenu(mPeer);
	}
        else {
	    throw new IllegalArgumentException("unknown menu container class");
	}
    }

    native void createMenu(WMenuBarPeer parent);
    native void createSubMenu(WMenuPeer parent);
}
