/*
 * @(#)WOffScreenImage.java	1.3 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

package sun.awt.windows;

import java.awt.Component;
import java.awt.Graphics;
import sun.awt.DrawingSurface;
import sun.awt.DrawingSurfaceInfo;

class WOffScreenImage extends WImage implements DrawingSurface {
    /**
     * Construct an image for offscreen rendering to be used with a
     * given Component.
     */
    public WOffScreenImage(Component c, int w, int h) {
	super(c, w, h);
    }

    public Graphics getGraphics() {
	Graphics g = new WGraphics(this);
	initGraphics(g);
	return g;
    }

    public DrawingSurfaceInfo getDrawingSurfaceInfo() {
	return new WDrawingSurfaceInfo(getImageRep());
    }
}
