/*
 * @(#)WPrintGraphics.java	1.9 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */
package sun.awt.windows;

import java.awt.*;


/**
 * WPrintGraphics is an object that encapsulates a print graphics context 
 * for a page. 
 * 
 * @version 
 */

public class WPrintGraphics extends WGraphics implements PrintGraphics {

    WPrintJob pjob;
    int pageNum = 0;
    boolean hasPageNum = false;

    WPrintGraphics(WGraphics g) {
        super(g);
    }

    public WPrintGraphics(WPrintJob pjob) {
        super(pjob);
	this.pjob = pjob;
    }

    public PrintJob getPrintJob() {
        return pjob;
    }

    /**
     * Create a new WPrintGraphics Object based on this one.
     */
    public Graphics create() {
	WPrintGraphics g = new WPrintGraphics(this);
	g.foreground = foreground;
	g.font = font;
	g.originX = originX;
	g.originY = originY;
	g.pjob = pjob;
	return g;
    }

    /**
     * Create a new WPrintGraphics Object based on this one.
     * The WPrintGraphics will be the master object for one page of the
     * document.
     */
    Graphics create(int pageNum) {
        WPrintGraphics g = (WPrintGraphics) create();
	g.hasPageNum = true;
	g.pageNum = pageNum;
	return g;
    }

    protected void disposeImpl() {
	if (hasPageNum && pjob != null) {
	    pjob.flushPage(pageNum);
	}
        super.disposeImpl();
    }
}
