/*
 * @(#)awt_Brush.h	1.5 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef AWT_BRUSH_H
#define AWT_BRUSH_H

#include "awt_GDIObject.h"
#include "Hashtable.h"

/*
 * An AwtBrush is a cached Windows brush.
 */
class AwtBrush : public AwtGDIObject {
public:
    /*
     * Get a GDI object from its respective cache.  If it doesn't exist
     * it gets created, otherwise its reference count gets bumped.
     * Release() must be called when the brush is no longer needed
     */
    static AwtBrush* Get(COLORREF color);

private:
    AwtBrush(COLORREF color);

    static Hashtable cache;

    HBRUSH SafeCreateSolidBrush(COLORREF cr);
};

#endif // AWT_BRUSH_H
