/*
 * @(#)awt_Button.h	1.7 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef AWT_BUTTON_H
#define AWT_BUTTON_H

#include "awt_Component.h"

#include "java_awt_Button.h"
#include "sun_awt_windows_WButtonPeer.h"

//
// Component class for system provided buttons
//
class AwtButton : public AwtComponent {
public:
    AwtButton();

    virtual const char* GetClassName();
    
    static AwtButton* Create(Hsun_awt_windows_WButtonPeer* self,
                             Hsun_awt_windows_WComponentPeer* hParent);

    // Return the associated AWT peer object.
    Hsun_awt_windows_WButtonPeer* GetPeer() { 
	return (Hsun_awt_windows_WButtonPeer*)m_peerObject; 
    }

    //////// Windows message handler functions

    MsgRouting WmNotify(UINT notifyCode);
    MsgRouting WmDrawItem(UINT ctrlId, DRAWITEMSTRUCT far& drawInfo);
    MsgRouting WmPaint(HDC hDC);
};

#endif // AWT_BUTTON_H
