/*
 * @(#)awt_Canvas.h	1.17 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef AWT_CANVAS_H
#define AWT_CANVAS_H

#include "awt_Component.h"

#include "java_awt_Canvas.h"
#include "sun_awt_windows_WCanvasPeer.h"

class AwtCanvas : public AwtComponent {
public:
    AwtCanvas();
    virtual ~AwtCanvas();

    virtual const char* GetClassName();
    
    static AwtCanvas* Create(Hsun_awt_windows_WCanvasPeer* self,
                             Hsun_awt_windows_WComponentPeer* hParent);

    // Return the associated AWT peer object.
    INLINE Hsun_awt_windows_WCanvasPeer* GetPeer() { 
	return (Hsun_awt_windows_WCanvasPeer*)m_peerObject; 
    }

    virtual MsgRouting WmEraseBkgnd(HDC hDC, BOOL& didErase);
    virtual MsgRouting WmPaint(HDC hDC);
    virtual MsgRouting WmMouseDown(UINT flags, int x, int y, int button);
    virtual MsgRouting WmMouseUp(UINT flags, int x, int y, int button);

protected:
    BOOL m_eraseBackground;
};

#endif // AWT_CANVAS_H
