/*
 * @(#)awt_Checkbox.h	1.12 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef AWT_CHECKBOX_H
#define AWT_CHECKBOX_H

#include "awt_Component.h"

#include "java_awt_Checkbox.h"
#include "java_awt_CheckboxGroup.h"
#include "sun_awt_windows_WCheckboxPeer.h"

//
// Component class for system provided Checkboxes
//
class AwtCheckbox : public AwtComponent {
public:
    AwtCheckbox();

    virtual const char* GetClassName();
    
    static AwtCheckbox* Create(Hsun_awt_windows_WCheckboxPeer* self,
                               Hsun_awt_windows_WComponentPeer* hParent);

    // Return the associated AWT peer object.
    INLINE Hsun_awt_windows_WCheckboxPeer* GetPeer() { 
	return (Hsun_awt_windows_WCheckboxPeer*)m_peerObject; 
    }

    //get state of multifont checkbox
    BOOL GetState();

    //get check mark size
    int GetCheckSize();

    //////// Windows message handler functions

    MsgRouting WmNotify(UINT notifyCode);
    MsgRouting WmDrawItem(UINT ctrlId, DRAWITEMSTRUCT far& drawInfo);
    MsgRouting WmPaint(HDC hDC);

#ifdef DEBUG
    virtual void VerifyState(); // verify checkbox and peer are in sync.
#endif

private:
    //for state of LButtonDown
    BOOL m_fLButtonDowned;
};

#endif // AWT_CHECKBOX_H
