/*
 * @(#)awt_Color.cpp	1.1 96/05/18 Thomas Ball
 *
 * Copyright (c) 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

#include "awt.h"
#include <java_awt_Color.h>
#include <sun_awt_windows_WColor.h>

Hjava_awt_Color* 
sun_awt_windows_WColor_getDefaultColor(Hsun_awt_windows_WColor*, long index)
{
    int iColor = 0;
    switch(index) {
      case sun_awt_windows_WColor_WINDOW_BKGND: 
        iColor = COLOR_WINDOW; 
        break;
      case sun_awt_windows_WColor_WINDOW_TEXT:
        iColor = COLOR_WINDOWTEXT; 
        break;
      case sun_awt_windows_WColor_FRAME:
        iColor = COLOR_WINDOWFRAME; 
        break;
      case sun_awt_windows_WColor_SCROLLBAR:
        iColor = COLOR_SCROLLBAR; 
        break;
      case sun_awt_windows_WColor_MENU_BKGND:
        iColor = COLOR_MENU; 
        break;
      case sun_awt_windows_WColor_MENU_TEXT:
        iColor = COLOR_MENUTEXT; 
        break;
      case sun_awt_windows_WColor_BUTTON_BKGND:
        iColor = (IS_NT) ? COLOR_BTNFACE : COLOR_3DFACE; 
        break;
      case sun_awt_windows_WColor_BUTTON_TEXT:
        iColor = COLOR_BTNTEXT; 
        break;
      case sun_awt_windows_WColor_HIGHLIGHT:
        iColor = COLOR_HIGHLIGHT; 
        break;

      default:
          return NULL;
    }
    DWORD c = ::GetSysColor(iColor);
    Hjava_awt_Color* hColor = (Hjava_awt_Color*)
        execute_java_constructor(EE(), "java/awt/Color", NULL, "(III)",
                                 GetRValue(c), GetGValue(c), GetBValue(c));
    ASSERT(!exceptionOccurred(EE()));
    ASSERT(hColor != NULL);
    return hColor;
}
