/*
 * @(#)awt_Dialog.h	1.11 98/07/09
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef AWT_DIALOG_H
#define AWT_DIALOG_H

#include "awt_Frame.h"

#include "java_awt_Dialog.h"
#include "sun_awt_windows_WDialogPeer.h"
#include <awt_image.h>

class AwtDialog : public AwtFrame {
public:
    AwtDialog();
    virtual ~AwtDialog();

    virtual const char* GetClassName();
    virtual void RegisterClass();
    virtual void SetResizable(BOOL isResizable);

    // Create a new AwtDialog.  This must be run on the main thread.
    static AwtDialog* Create(Hsun_awt_windows_WDialogPeer *self,
                            Hsun_awt_windows_WComponentPeer *hParent);

    // Return the associated AWT peer object.
    INLINE Hsun_awt_windows_WDialogPeer* GetPeer() { 
	return (Hsun_awt_windows_WDialogPeer*)m_peerObject; 
    }

    virtual MsgRouting WmShowModal();
    virtual MsgRouting WmEndModal();
    virtual MsgRouting WmStyleChanged(WORD wStyleType, LPSTYLESTRUCT lpss);
    virtual MsgRouting WmSize(int type, int w, int h);
    virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);

    // utility functions for application-modal dialogs
    static void ModalDisable(HWND hwndDlg);
    static void ModalEnable(HWND hwndDlg);
    static void ModalNextWindowToFront(HWND hwndDlg);

private:
    static int GetDisabledLevel(HWND hwnd);
    static void IncrementDisabledLevel(HWND hwnd, int increment);
    static void ResetDisabledLevel(HWND hwnd);
    static BOOL CALLBACK DisableTopLevelsCallback(HWND hWnd, LPARAM lParam);
    static BOOL CALLBACK EnableTopLevelsCallback(HWND hWnd, LPARAM lParam);
    static BOOL CALLBACK NextWindowToFrontCallback(HWND hWnd, LPARAM lParam);

    void UpdateSystemMenu();
    void UpdateDialogIcon();

    HWND  m_modalWnd;
};

#endif // AWT_DIALOG_H
