/*
 * @(#)awt_Menu.h	1.11 98/08/25
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef AWT_MENU_H
#define AWT_MENU_H

#include "awt_MenuItem.h"

#include <java_awt_MenuItem.h>
#include <sun_awt_windows_WMenuItemPeer.h>
#include <java_awt_Menu.h>
#include <sun_awt_windows_WMenuPeer.h>

class AwtMenuBar;

//
// Menu class for accessing an HMENU
//
class AwtMenu : public AwtMenuItem {
public:
    // id's for methods executed on toolkit thread
    enum {
	MENU_ADDSEPARATOR = MENUITEM_LAST+1,
	MENU_DELITEM,
	MENU_LAST
    };

    AwtMenu();
    virtual ~AwtMenu();
    virtual const char* GetClassName();

    // Create a new AwtMenu.  This must be run on the main thread.
    static AwtMenu* Create(Hsun_awt_windows_WMenuPeer* self,
                           AwtMenu* parentMenu);

    INLINE HMENU GetHMenu() { return m_hMenu; }
    INLINE void SetHMenu(HMENU hMenu) { m_hMenu = hMenu; }

    virtual AwtMenuBar* GetMenuBar();

    INLINE AwtMenu* GetParent() { return m_parentMenu; }
    INLINE void SetParentMenu(AwtMenu* parent) { m_parentMenu = parent; }

    void AddSeparator();
    virtual void AddItem(AwtMenuItem* item);
    virtual void DeleteItem(long index);
    virtual HWND GetOwnerHWnd();

    //for multifont menu
    BOOL IsTopMenu();
    virtual AwtMenuItem* GetItem(Hjava_awt_Menu* target, long index);
    virtual int CountItem(Hjava_awt_Menu* target);
    virtual void SendDrawItem(AwtMenuItem* awtMenuItem,
			      DRAWITEMSTRUCT far& drawInfo);
    virtual void SendMeasureItem(AwtMenuItem* awtMenuItem,
				 HDC hDC, MEASUREITEMSTRUCT far& measureInfo);
    void DrawItem(DRAWITEMSTRUCT far& drawInfo);
    void DrawItems(DRAWITEMSTRUCT far& drawInfo);
    void MeasureItem(HDC hDC, MEASUREITEMSTRUCT far& measureInfo);
    void MeasureItems(HDC hDC, MEASUREITEMSTRUCT far& measureInfo);

    virtual LONG WinThreadExecProc(ExecuteArgs * args);

protected:
    HMENU    m_hMenu;
    AwtMenu* m_parentMenu;	// can also be an AwtMenuBar
};

#endif // AWT_MENU_H
