/*
 * @(#)awt_MenuBar.h	1.12 98/08/25
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef AWT_MENUBAR_H
#define AWT_MENUBAR_H

#include "awt.h"
#include "awt_Menu.h"
#include <java_awt_MenuBar.h>
#include <sun_awt_windows_WMenuBarPeer.h>
#include <sun_awt_windows_WFramePeer.h>

class AwtFrame;

//
// Menubar class for accessing items in a HWND's menubar
//
class AwtMenuBar : public AwtMenu {
public:
    // id's for methods executed on toolkit thread
    enum MenuExecIds {
	MENUBAR_DELITEM = MENU_LAST+1
    };

    AwtMenuBar();
    virtual ~AwtMenuBar();
    virtual const char* GetClassName();

    // Create a new AwtMenuBar.  This must be run on the main thread.
    static AwtMenuBar* Create(Hsun_awt_windows_WMenuBarPeer* self,
                              Hsun_awt_windows_WFramePeer* hFramePeer);

    // Return the associated AWT peer object.
    INLINE Hsun_awt_windows_WMenuBarPeer* GetPeer() { 
	return (Hsun_awt_windows_WMenuBarPeer*)m_peerObject; 
    }

    virtual AwtMenuBar* GetMenuBar() { return this; }
    INLINE AwtFrame* GetFrame() { return m_frame; }

    virtual HWND GetOwnerHWnd();

    AwtMenuItem* GetItem(Hjava_awt_Menu* target, long index);
    int CountItem(Hjava_awt_Menu* target);
    void SendDrawItem(AwtMenuItem* awtMenuItem,
		      DRAWITEMSTRUCT far& drawInfo);
    void SendMeasureItem(AwtMenuItem* awtMenuItem,
			 HDC hDC, MEASUREITEMSTRUCT far& measureInfo);
    void DrawItem(DRAWITEMSTRUCT far& drawInfo);
    void MeasureItem(HDC hDC, MEASUREITEMSTRUCT far& measureInfo);

    void AddItem(AwtMenuItem* item);
    void DeleteItem(long index);

    virtual LONG WinThreadExecProc(ExecuteArgs * args);
protected:
    AwtFrame* m_frame;
};

#endif // AWT_MENUBAR_H
