/*
 * @(#)awt_PrintJob.cpp	1.5 98/03/17
 *
 * Copyright (c) 1996 Sun Microsystems, Inc. All Rights Reserved.
 *
 * Permission to use, copy, modify, and distribute this software
 * and its documentation for NON-COMMERCIAL purposes and without
 * fee is hereby granted provided that this copyright notice
 * appears in all copies. Please refer to the file "copyright.html"
 * for further important copyright and licensing information.
 *
 * SUN MAKES NO REPRESENTATIONS OR WARRANTIES ABOUT THE SUITABILITY OF
 * THE SOFTWARE, EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED
 * TO THE IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS FOR A
 * PARTICULAR PURPOSE, OR NON-INFRINGEMENT. SUN SHALL NOT BE LIABLE FOR
 * ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR
 * DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES.
 */

#include "awt.h"
#include "awt_Toolkit.h"
#include "awt_Component.h"
#include "awt_Graphics.h"
#include <sun_awt_windows_WPrintJob.h>

void sun_awt_windows_WPrintJob__flushPage(Hsun_awt_windows_WPrintJob *self)
{
    Hsun_awt_windows_WGraphics* hWGraphics = 
      (Hsun_awt_windows_WGraphics*)unhand(self)->graphics;
    CHECK_OBJ(hWGraphics);
    AwtMasterPrinterGraphics* pGraphics = 
        (AwtMasterPrinterGraphics*)unhand(hWGraphics)->pData;

    if (pGraphics != NULL) {
        // if there is currently no page in progress, EndPage is ignored
        pGraphics->EndPage();
    }
}   

void sun_awt_windows_WPrintJob_newPage(Hsun_awt_windows_WPrintJob *self)
{
    Hsun_awt_windows_WGraphics* hWGraphics = 
      (Hsun_awt_windows_WGraphics*)unhand(self)->graphics;
    CHECK_OBJ(hWGraphics);
    AwtMasterPrinterGraphics* pGraphics = 
        (AwtMasterPrinterGraphics*)unhand(hWGraphics)->pData;

    if (pGraphics != NULL) {
        // if there is currently no page in progress, EndPage is ignored
        pGraphics->EndPage();
        pGraphics->StartPage();
    }
}   

void sun_awt_windows_WPrintJob__end(Hsun_awt_windows_WPrintJob *self)
{
    Hsun_awt_windows_WGraphics* hWGraphics = 
      (Hsun_awt_windows_WGraphics*)unhand(self)->graphics;
    CHECK_OBJ(hWGraphics);
    AwtMasterPrinterGraphics* pGraphics = 
        (AwtMasterPrinterGraphics*)unhand(hWGraphics)->pData;

    if (pGraphics != NULL) {
        // End the final page and the document -- if they were already
        // ended, these commands will be ignored. Don't dispose of the
        // awt_Graphics object, though. That's done during finalization
        // of the WGraphics object.
        pGraphics->EndPage();
        pGraphics->EndPrintJob();
    }
}
