/*
 * @(#)awt_ScrollPane.h	1.12 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef AWT_SCROLLPANE_H
#define AWT_SCROLLPANE_H

#include "awt_Canvas.h"

#include "java_awt_ScrollPane.h"
#include "java_awt_Insets.h"
#include "sun_awt_windows_WScrollPanePeer.h"

//
// Component class for scrollable windows
//
class AwtScrollPane : public AwtCanvas {
public:
    AwtScrollPane();

    virtual const char* GetClassName();
    
    static AwtScrollPane* Create(Hsun_awt_windows_WScrollPanePeer* self,
                             Hsun_awt_windows_WComponentPeer* hParent);

    // Return the associated AWT peer object.
    INLINE Hsun_awt_windows_WScrollPanePeer* GetPeer() { 
	return (Hsun_awt_windows_WScrollPanePeer*)m_peerObject; 
    }

    // Return the associated AWT target object.
    INLINE Hjava_awt_ScrollPane* GetTarget() { 
	return (Hjava_awt_ScrollPane*)(unhand(m_peerObject)->target); 
    }

    void SetPageIncrement(int value, int orient);
    void SetInsets();
    void ScrollTo(int x, int y);
    int NewScrollPosition(UINT scrollCode, UINT orient, UINT pos,
                          UINT lineIncrement, UINT pageIncrement);
    void RecalcSizes(int parentWidth, int parentHeight, 
		     int childWidth, int childHeight);
    virtual void Show();
    virtual void Reshape(int x, int y, int w, int h);
    virtual void BeginValidate() {}
    virtual void EndValidate() {}

    //////// Windows message handler functions

    virtual MsgRouting WmHScroll(UINT scrollCode, UINT pos, HWND hScrollBar);
    virtual MsgRouting WmVScroll(UINT scrollCode, UINT pos, HWND hScrollBar);

#ifdef DEBUG
    virtual void VerifyState(); // verify target and peer are in sync.
#endif

private:
    void SetScrollInfo(int orient, int max, int page, BOOL disableNoScroll);
};

#endif // AWT_SCROLLPANE_H
