/*
 * @(#)awt_Scrollbar.h	1.11 98/07/11
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#ifndef AWT_SCROLLBAR_H
#define AWT_SCROLLBAR_H

#include "awt_Component.h"

#include "java_awt_Scrollbar.h"
#include "sun_awt_windows_WScrollbarPeer.h"

//
// Component class for system provided scrollbar controls
//
class AwtScrollbar : public AwtComponent {
public:
    AwtScrollbar();

    virtual const char* GetClassName();
    
    static AwtScrollbar* Create(Hsun_awt_windows_WScrollbarPeer* self,
                                Hsun_awt_windows_WComponentPeer* hParent);

    // Return the associated AWT peer object.
    INLINE Hsun_awt_windows_WScrollbarPeer* GetPeer() { 
	return (Hsun_awt_windows_WScrollbarPeer*)m_peerObject; 
    }

    void SetValue(int value);
    void SetValues(int value, int visible, int minimum, int maximum);
    void SetLineIncrement(int value) { m_lineIncr = value; }
    void SetPageIncrement(int value) { m_pageIncr = value; }

    //////// Windows message handler functions

    virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);

    virtual MsgRouting WmMouseDown(UINT flags, int x, int y, int button);
    virtual MsgRouting HandleEvent(MSG* msg);

    virtual MsgRouting WmSetFocus(HWND hWndLost);
    virtual MsgRouting WmKillFocus(HWND hWndGot);

    virtual MsgRouting WmHScroll(UINT scrollCode, UINT pos, HWND hScrollBar);
    virtual MsgRouting WmVScroll(UINT scrollCode, UINT pos, HWND hScrollBar);

private:
    UINT          m_orientation; // SB_HORZ or SB_VERT
    AwtComponent* m_hostWindow;  // if set, contains real hwnd we are riding on
    int           m_lineIncr;
    int           m_pageIncr;

    // 4063897: Workaround windows focus indicator bug
    BOOL m_ignoreFocusEvents;
    void UpdateFocusIndicator();

    // Don't do redundant callbacks
    const char *m_prevCallback;
    int m_prevCallbackPos;

    void DoScrollCallbackCoalesce(const char* methodName, int newPos);

    static const char * const SbNdragAbsolute;
    static const char * const SbNdragBegin;
    static const char * const SbNdragEnd;
    static const char * const SbNlineDown;
    static const char * const SbNlineUp;
    static const char * const SbNpageDown;
    static const char * const SbNpageUp;
};

#endif // AWT_SCROLLBAR_H
