/*
 * @(#)drawsurface.c	1.3 98/07/01
 *
 * Copyright 1995-1998 by Sun Microsystems, Inc.,
 * 901 San Antonio Road, Palo Alto, California, 94303, U.S.A.
 * All rights reserved.
 * 
 * This software is the confidential and proprietary information
 * of Sun Microsystems, Inc. ("Confidential Information").  You
 * shall not disclose such Confidential Information and shall use
 * it only in accordance with the terms of the license agreement
 * you entered into with Sun.
 */

#include "Win32DrawSurfaceTracker.h"

void
Win32DrawSurfaceTracker_draw(HWin32DrawSurfaceTracker *this,
			     long lWnd, long lBitmap, long lDC,
			     HArrayOfFloat *ctrlpts,
			     float red, float green, float blue)
{
    HDC hDC;
    POINT pts[4];
    HPEN hPen;
    int i;

    if (ctrlpts == 0) {
	SignalError(0, JAVAPKG "NullPointerException", 0);
	return;
    }
    if (obj_length(ctrlpts) < 8) {
	SignalError(0, JAVAPKG "ArrayIndexOutOfBoundsException", 0);
	return;
    }
    hDC = (HDC) lDC;
    for (i = 0; i < 4; i++) {
	pts[i].x = (long) unhand(ctrlpts)->body[i * 2 + 0];
	pts[i].y = (long) unhand(ctrlpts)->body[i * 2 + 1];
    }
    hPen = CreatePen(PS_SOLID, 0, RGB(((byte) (red * 255)),
				      ((byte) (green * 255)),
				      ((byte) (blue * 255))));
    SelectObject(hDC, hPen);
    PolyBezier(hDC, pts, 4);
    SelectObject(hDC, GetStockObject(NULL_PEN));
    DeleteObject(hPen);
}
