/*
	File : NetMan.java
	Date		Author		Change
	2001/10/11	Kim.K.C.	Created

Ŭ̾Ʈ Ʈ  ϱ  Ŭ
*/

package com.xce.xceman.client;

import java.io.*;
import javax.microedition.io.*;

import com.xce.xceman.common.*;

class NetMan extends Thread implements Protocol {
	
	GameCanvas gcanvas;
	
	StreamConnection con;
	DataInputStream in;
	DataOutputStream out;
	
	int id;	
	int[] packet = new int[MAX_LEN];
	
	NetMan(GameCanvas gcanvas) {
		this.gcanvas = gcanvas;
		this.start();
	}
	
	public void run() {
		while (true) {
			boolean connected = true;
			try {
				connect();
			} catch (IOException e) {
				connected = false;
			}
			
			if (connected) {
				try {
					while (true) {
						int type = in.readInt();
						process(type);
					}
				} catch (IOException ioe) {
					gcanvas.state = GameCanvas.FAIL_STATE;
				}
			} else {
				gcanvas.state = GameCanvas.FAIL_STATE;
			}		
			
			connected = false;
			if (id != -1) {
				ManInfo.remove(id);
				id = -1;
			}			
			gcanvas.repaintAll();
			
			synchronized (this) {
				try {
					this.wait();
				} catch (InterruptedException ie) {
				}
			}
		}
	}
	
	void process(int type) throws IOException {
		int id2;
		switch (type) {
			case CONNECT:
				id = in.readInt();
				gcanvas.state = GameCanvas.MAIN_STATE;
				gcanvas.repaintAll();				
				break;
			case MOVE:
				id2 = in.readInt();
				gcanvas.moveMan(id2, in.readInt(), in.readInt());
				break;
			case EXIT:
				id2 = in.readInt();
				if (id == id2) {
					gcanvas.state = GameCanvas.FAIL_STATE;
					ManInfo.removeAll();
					close();					
				} else {
					ManInfo.remove(id2);
				}
				gcanvas.repaintAll();
				break;
		}
	}
	
	void connect() throws IOException {
		/**
		 *  ּҿ Ʈ ȣ msd Ͽ о鿩 
		 * ̵  ٲ  ְ ϴ  Ϲ̴.
		 */ 
		//String host = midlet.getAppProperty("XCEMan-Host");
		//String port = midlet.getAppProperty("XCEMan-Port");
		//con = (StreamConnection)Connector.open("socket://" +
		//  host + ":" + port);		
		con = (StreamConnection)Connector.open("socket://211.210.77.120:7776");
		in = con.openDataInputStream();
		out = con.openDataOutputStream();
		
		out.writeInt(CONNECT);
		out.flush();
	}
	
	void send(int[] packet, int num) throws IOException {
		for (int i = 0; i < num; i++) {
			out.writeInt(packet[i]);
		}
		out.flush();
	}
	
	void move(int x, int y) {
		packet[0] = MOVE;
		packet[1] = x;
		packet[2] = y;
		try {
			send(packet, 3);
		} catch (Exception e) {
			gcanvas.state = GameCanvas.FAIL_STATE;
			gcanvas.repaintAll();
		}
	}
	
	void close() {
		if (in != null) {			
			try {
				in.close();
			} catch (Exception e) {}
		}
		
		if (out != null) {
			try {
				out.close();
			} catch (Exception e) {}
		}
		
		if (con != null) {
			try {
				con.close();
			} catch (Exception e) {}
		}
	}
}