/*
	File : Shadow.java
	Date		Author		Change
	2001/10/11	Kim.K.C.	Created
	2001/12/18	Kim.K.C.	CONNECT, EXIT õ  

Java Asynchronus Network   ʱ  Ϲ ϳ
Ŭ̾Ʈ ϳ 带 Ų. JDK 1.4 ʹ  ̶µ...
*/

package com.xce.xceman.server;

import java.io.*;
import java.net.*;
import java.util.*;

import com.xce.xceman.common.*;

class Shadow extends Thread implements Protocol {	
	static Shadow[] manList = new Shadow[MAX_MAN];
	
	private Socket socket;
	private DataInputStream in;
	private DataOutputStream out;	
	private int[] packet = new int[MAX_LEN];
	
	private int id;
	private int x;
	private int y;
	
	Shadow(Socket socket) throws IOException {
		this.socket = socket;
		in = new DataInputStream(socket.getInputStream());			
		out = new DataOutputStream(socket.getOutputStream());
		
		int slot = availSlot();
		if (slot != -1) {
			id = slot;
			manList[slot] = this;			
		} else {
			throw new IOException("REJECT");
		}				
		
		this.start();		
	}
	
	int availSlot() {
		for (int i = 0; i < manList.length; i++) {
			if (manList[i] == null) {
				return i;
			}
		}
		return -1;
	}
	
	
	public void run() {
		try {
			int type;
			while (true) {
				type = in.readInt();
				process(type);
			}
		} catch (IOException e) {
			System.out.println("Ʈ Դϴ");
		} catch (Exception e) {
			System.out.println("   Դϴ");
		} finally {
			System.out.println(id + " XCEMan ϴ");
			manList[id] = null;
			exit();
		}
	}
	
	void exit() {
		packet[0] = EXIT;
		packet[1] = id;
		broadcast(packet, 2);
	}
	
	void process(int type) throws IOException {
		System.out.println("Process Type: " + type);
		
		switch (type) {
			case CONNECT:
				packet[0] = CONNECT;
				packet[1] = id;
				send(packet, 2);
				
				x = 50;
				y = 50;
				
				broadcast();
				break;
			case MOVE:
				x = in.readInt();
				y = in.readInt();
				packet[0] = MOVE;
				packet[1] = id;
				packet[2] = x;
				packet[3] = y;
				broadcast(packet, 4);
				break;
			case EXIT:
				packet[0] = EXIT;
				packet[1] = id;
				broadcast(packet, 2);
				break;			
		}
	}
	
	synchronized void send(int[] packet, int num) throws IOException {
		for (int i = 0; i < num; i++) {
			out.writeInt(packet[i]);			
		}
		out.flush();
	}
	
	void broadcast() {
		// Phase 1 : ٸ  ġ Ѵ.
		int[] movePacket = new int[MAX_LEN];
		for (int i = 0; i < manList.length; i++) {
			Shadow man = manList[i];
			if (man != null) {
				movePacket[0] = MOVE;
				movePacket[1] = man.id;
				movePacket[2] = man.x;
				movePacket[3] = man.y;
				
				try {
					send(movePacket, 4);
				} catch (Exception e) {
				}
			}			
		}
		
		// Phase 2 : ڽ ġ 鿡 Ѵ.
		movePacket[1] = id;
		movePacket[2] = x;
		movePacket[3] = y;
		broadcast(movePacket, 4);		
	}
	
	static void broadcast(int[] packet, int num) {
		for (int i = 0; i < manList.length; i++) {
			Shadow man = manList[i];
			if (man != null) {
				try {
					man.send(packet, num);
				} catch (Exception e) {
				}
			}
		}
	}
}