package com.xce.xlcdui;

import java.io.IOException;

import javax.microedition.lcdui.*;

import com.xce.lcdui.*;
import com.xce.io.*;

/**
  * List Component ԵǾ  ư
  *  ư ؼ icon, label, position   ִ.
  * 
  * 2 ̻ ư  ڵ ޴ Ǿ  ϰ  ʴ.
  * 
  * <pre>
  * 
  * XSButton button = new XSButton(this, "", XSButton.RIGHT);
  * xslist.addRightButton(button);
  * 
  * </pre>
  * 
  * ߰ listener , canvas keypressed ؼ ̺Ʈ
  * captureؾ Ѵ.
  * 
  * XSProperties Ǵ پ ܵ ̿ؼ, 
  * ư    ִ.
  * 
  * @see XSProperties
  * @version 1.0 02/06/2002
  * @author Kim.W.G
  */
public class XSButton {

	private Image buttonImg = null;				// ư ̹
	private Image icon = null;					// button 
	
	private String label = null;				// label

	// width ũ ϸ, 120, 128 Ѵ.
	private int lcdType;

	private Canvas parent;

	private String leftImg = "/images/"+lcdType+"_menubutton.lbm";
	private String rightImg = "/images/"+lcdType+"_okbutton.lbm";

	public static final int LEFT = 1;
	public static final int RIGHT = 2;

	int mode = -1;
	
	/**
	 * Ŭ νϽ 
	 *
	 * @param	canvas	 ǰ ִ canvas
	 * @param	label	Button Label
	 */	
	public XSButton(Canvas canvas, String label) {
		parent = canvas;
		this.label = label;
		mode = LEFT;
		lcdType = (parent.getWidth() == 120) ? 120 : 128;
		leftImg = "/images/"+lcdType+"_menubutton.lbm";
		rightImg = "/images/"+lcdType+"_okbutton.lbm";

		try{
			buttonImg = Image.createImage(leftImg);
			icon = Image.createImage(XSProperties.ICON_BACK);
		} catch(IOException ioe) {
		}
	}

	/**
	 * Ŭ νϽ 
	 * ư ġ Ƿ    ִ.
	 *
	 * @param	canvas	 ǰ ִ canvas
	 * @param	label	Button Label
	 * @param	loc	ġ left, right 
	 */	
	public XSButton(Canvas canvas, String label, int loc) {
		parent = canvas;
		this.label = label;

		lcdType = (parent.getWidth() == 120) ? 120 : 128;
		leftImg = "/images/"+lcdType+"_menubutton.lbm";
		rightImg = "/images/"+lcdType+"_okbutton.lbm";

		if( loc == RIGHT ) {
			mode = RIGHT;
			try{
				buttonImg = Image.createImage(rightImg);
				icon = Image.createImage(XSProperties.ICON_OK);
			} catch(IOException ioe) {}
		}
		if( loc == LEFT ) {
			mode = LEFT; 
			try{
				buttonImg = Image.createImage(leftImg);
				icon = Image.createImage(XSProperties.ICON_BACK);
			} catch(IOException ioe) {}
		}// end if
	}

	/**
	 * ư label ٸ  üѴ.
	 *
	 * @param	lbl		ü label
	 */		
	public void setLabel(String lbl) {
		label = lbl;
	}

	/**
	 *  ư label ´.
	 *
	 * @return	 ư label
	 */		
	public String getLabel() {
		return label;
	}


	/**
	 * ִ ĵ ؼ ȭ鿡 ش.
	 *
	 * @param	g	Graphics ü
	 */		
	public void show(Graphics g) {
		// ش ư  ư̶, 
		if(mode == LEFT) {
			g.drawImage(buttonImg, 0, parent.getHeight(), g.TOP|g.LEFT);
			g.drawImage(icon, 1, parent.getHeight()+2, g.TOP|g.LEFT);
			g.drawString(label, 15, parent.getHeight()+2, g.TOP|g.LEFT);
		}
		// ش ư  ư̶, 
		if(mode == RIGHT) {
			g.drawImage(buttonImg, parent.getWidth(), parent.getHeight(), g.TOP|g.RIGHT);
			g.drawImage(icon, parent.getWidth()-1, parent.getHeight()+2, g.TOP|g.RIGHT);
			g.drawString(label, parent.getWidth()-15, parent.getHeight()+2, g.TOP|g.RIGHT);
		}
	}

	/**
	 * ȭ鿡 ÷̵ ư .
	 *
	 * @param	g	Graphics ü
	 */	
	public void hide(Graphics g) {
		parent.repaint(0, parent.getHeight(), parent.getWidth(), 16);
	}
}