package com.xce.xlcdui;

import java.io.IOException;

import javax.microedition.lcdui.*;

import com.xce.lcdui.*;
import com.xce.io.*;

/**
  * XSDialog alert confirm ΰ  Ʈ Ѵ.
  * alert confirm dialog box 
  * Ʈ ݿ  2α ȴ.
  * 
  * <pre>
  * XSDialog alert = new XSDialog(this, "ALERT TEST", XSDialog.ALERT);
  * ...
  * show(g);
  * 
  * // ޽ ٲ , 
  * alert.setMessage("replaced message.");
  * </pre>
  * 
  * confirm      ִ.
  * 
  * @version 1.0 02/05/2002
  * @author Kim.W.G
  */
public class XSDialog {

	/**
	 * Alert dialog box  
	 */
	public static final int ALERT = 1;
	/**
	 * Confirm dialog box  
	 */
	public static final int CONFIRM = 2;

	private Canvas parent;					// dialog box  ĵ
	private int type;						// ALERT, CONFIRM   

	private Image img_ok = null;			// DialogBox "Ȯ" ư
	private Image img_cancel = null;		// DialogBox "" ư

	private String okImg = "/images/d_okbutton.lbm";
	private String cancelImg = "/images/d_cancelbutton.lbm";

	private String message = null;				// Dialog Box ޽

	private int d_width;			// ,  margin 20
	private int d_height;								// height 60 fix
	private int startX;	//   ġ
	private int startY;

	private int insets = 2;					// DialogBox inset

	private int bgcolor = 0xffc6ff;			// , ȫ Ʈ 
	private int fgcolor = 0x002555;			// , ȸ 

	/**
	 * alert, confirm ݻ 2ٱ  ȴ.
	 * 2̻ ޽   κ õȴ.
	 */
	private Font default_font = Font.getDefaultFont();
	private String[] messages = null;
	private boolean multiLine = false;

	/**
	 * Ŭ νϽ 
	 *
	 * @param	canvas	 ϰ ְ, dialog object  canvas
	 * @param	type	ALERT, CONFIRM ΰ   
	 */	
	public XSDialog(Canvas canvas, String con, int type) {
		this.parent = canvas;
		this.type = type;

		d_width = parent.getWidth() - 10*2;			// ,  margin 20
		d_height = 60;								// height 60 fix
		startX = (parent.getWidth() - d_width) / 2;	//   ġ
		startY = (parent.getHeight() - d_height) / 2;


		if(con != null) message = con;
		else message = new String("Dialog Box!!");
		try{ 
			img_ok = Image.createImage(okImg);
			if(type == CONFIRM) img_cancel = Image.createImage(cancelImg);
		} catch(IOException ioe) {
		} // end try..
	}

	/**
	 *  Dialog ޽ üѴ. 
	 * 
	 * @param	m	ü ޼
	 */
	public void setMessage(String m) {
		message = m;
	}

	/**
	 * ִ ĵ ؼ ȭ鿡 ش.
	 * ڿ   ŸԿ  confirm, alert ޶.
	 *
	 * @param	g	Graphics ü
	 */		
	public void show(Graphics g) {
		int string_width = -1;
		int string_height = -1;
		//  ׵θ ׸.
		g.setColor(0x8d8d8d);
		g.fillRect(startX+2, startY+2, d_width, d_height);		// ׸
		g.setColor(bgcolor);
		g.fillRect(startX, startY, d_width, d_height);		// fill dialog area
		g.setColor(fgcolor);
		g.drawRect(startX, startY, d_width, d_height);		// draw dialog border

		// message  width, height Ѵ.
		string_width = default_font.stringWidth(message);
		string_height = default_font.getHeight();

		// Ʈ , 2 ̻    õȴ.
		if(string_width > d_width-insets*2) {
			multiLine = true;
			split(message);
		} // end if
		
		g.setClip(startX, startY, d_width, d_height);

		if(multiLine) {					// 2 
			g.setColor(fgcolor);
			g.drawString(messages[0], startX+insets+(d_width-default_font.stringWidth(messages[0]))/2, 
						startY+insets, g.TOP|g.LEFT);
			g.drawString(messages[1], startX+insets+(d_width-default_font.stringWidth(messages[1]))/2, 
						startY+2*insets+string_height, g.TOP|g.LEFT);
		} else {						// 1 
			g.setColor(fgcolor);
			g.drawString(message, startX+insets+(d_width-string_width)/2, 
						startY+(40-string_height)/2, g.TOP|g.LEFT);
		} // end if

		// type  ư ׷.
		if(type == CONFIRM) {				// confirm, ΰ ư
			g.drawImage(img_cancel, startX, startY+40+(20-img_ok.getHeight()), 
						g.TOP|g.LEFT);
			g.drawImage(img_ok, startX + (d_width-img_ok.getWidth()), 
						startY+40+(20-img_ok.getHeight()), g.TOP|g.LEFT);
		} else {
			g.drawImage(img_ok, startX + (d_width-img_ok.getWidth()), 
						startY+40+(20-img_ok.getHeight()), g.TOP|g.LEFT);
		} // end if
	}

	/**
	 * ȭ鿡 ÷̵ XSList .
	 *
	 * @param	g	Graphics ü
	 */	
	public void hide(Graphics g) {
		parent.repaint();
	}

	/**
	 * 2 ̻ ޽ ؼ  ´  ٸ
	 * ̾Ƴ. ٸ      
	 * XSDialog Ǿ ִ.
	 */
	private void split(String messasge) {
		int i = -1;
		char[] chars = message.toCharArray();
		messages = new String[2];

		i = 0;
		for(i = 0 ; i < chars.length ; i++) {
			if(d_width-2*insets > default_font.charsWidth(chars, 0, i+1)) {
				continue;
			}
			messages[0] = new String(chars, 0, i);
			break;
		} // end for

		if(chars.length == i)
			new String("");
		else {
			int offset = i;
			for( ; i < chars.length ; i++) {
				if(d_width-2*insets > default_font.charsWidth(chars, offset, (i-offset)+1))
					continue;
				break;
			} // end for

			messages[1] = new String(chars, offset, i-offset);
		} // end if
	}
}