package com.xce.xlcdui;

import java.util.*;
import java.io.IOException;

import javax.microedition.lcdui.*;
import com.xce.lcdui.*;
import com.xce.io.*;

/**
  * UI ǥ Ʈ  ϱ  ̵鷿
  * ExampleCanvas ؼ ش Ʈ 
  * 
  *  ׸ ý Ÿ  Ʈ  Ǹ, 
  * ٸ ̹ ϰ   icon variable ٸ ̹ ٲ
  * ν ϴ.
  *  LCD AREAκ LIST ׷ ڽ  Ŀ͸¡  ѵ, 
  * LCD κ ڽ area_margin, 
  * Ʈ ڽ  ׷  area_inset ϴ.
  * 
  * XSList  List, Popup    ִ.
  * 
  * List, Popup  ⺻ Ʋ ٰ  , 
  * area_margin, area_inset  ȭѼ  ٲܼ ִ.
  * 
  * <pre>
  *		// this -> canvas, items -> string array
  *		XSList list = new XSList(this, items, XSList.LIST);
  *		list.setTitle("Ʈ ");
  *		....
  *		list.show(g);
  * 
  * <pre>
  * 
  * list popup LCD margin ̿ؼ еȴ.
  * 
  * @version 1.0 02/01/2002
  * @author Kim.W.G
  */
public class XSList {

	//  ܸ  ũ⸦ Ѵ.
	private final int FONT_WIDTH = Font.getDefaultFont().charWidth('a');
	private final int FONT_HEIGHT = Font.getDefaultFont().getHeight();

	/**
	 * Ʈ  Ǹ, ڿ 
	 */		
	public final static int LIST = 1;
	/**
	 * ˾  Ǹ, ڿ 
	 */		
	public final static int POPUP = 2;

	private int icon_width = 13;		// icon width 13
	private int icon_height = 12;

	//  õǾ ׸ ε 
	private int currentIndex = -1;
	
	// ȭ  ù°  ε 
	private int first = -1;
	// ȭ    ε 
	private int last = -1;

	//  ȭ ִ  ũ
	private int max_show = -1;

	// LIST, POPUP Ÿ
	private int type = 1;
	
	/**
	 * XSList Class 
	 */		
	public int X_LIST = 1;

	private Canvas parent = null;
	private String items[] = null;
	private Vector vector = null;
	
	// title image, for List
	private Image imgTitle = null;
	// selection icon image
	private Image icon = null;
	// scroll down image
	private Image scroll_down = null;
	// scroll up image
	private Image scroll_up = null;
	// top border image, for popup
	private Image popup_border = null;
	// tab title, for popup
	private Image tab = null;

	/**
	 * XSList Ʈ ̾ƿ   Ѵ.
	 */
	// LCD Ʈ , x LCD, y ׳ ϴܺ 
	private int x_margin;
	private int y_margin;
	// Ʈڽ  ׷  μ
	private int area_inset;
	//  ׷ .. 
	private int avail_width;
	//  ׷ .. 
	private int avail_height;

	// Ʈ  κ  1 ..
	private int line_margin = 1;

	// ù° Ʈ ׸ ġ Ѵ.
	private int startx;
	private int starty;
	
	// 10*2 ܰ ϴ ڷ 
	private int line_length;

	// , 
	private int bgcolor = 0xffc6ff;
	private int fgcolor = 0x002555;

	//   ư
	private XSButton leftButton = null;
	private XSButton rightButton = null;

	/**
	 * Ʈ ŸƲ
	 */
	public String title = null;

	/**
	 * Ŭ νϽ 
	 *
	 * @param	canvas	 ϰ ְ, List object  canvas
	 * @param	type	LIST, POPUP ΰ   
	 */	
	public XSList(Canvas canvas, int type) {
		this.parent = canvas;
		// POPUP type    LIST 
		if(type == POPUP) 
			this.type = type;
		else type = LIST;

		currentIndex = 0;
		first = 0;
		vector = new Vector();

		// õ  Ÿ  
		try {
			if(type == LIST) {
				icon = Image.createImage(XSProperties.ICON_LARGE_LOCATION);				//  
				if(parent.getWidth() == 128)
					imgTitle = Image.createImage(XSProperties.TITLE_128);				// list title bar
				else 
					imgTitle = Image.createImage(XSProperties.TITLE_120);

				x_margin = 2;													// default margin value
				y_margin = imgTitle.getHeight() + x_margin;
				area_inset = 2;														// default inset value
			} else {
				icon = Image.createImage(XSProperties.ICON_SMALL_LOCATION);
				popup_border = Image.createImage(XSProperties.POPUP_MENUBAR);
				tab = Image.createImage(XSProperties.TAB);
				x_margin = 10;													// default margin value
				y_margin = 37;
				area_inset = 6;													// default inset value
			} // end if
			scroll_down = Image.createImage(XSProperties.ICON_SCROLL_DOWN);		// ũ ϴ
			scroll_up = Image.createImage(XSProperties.ICON_SCROLL_UP);			// ũ 
		} catch(IOException e) {
		}
		setLayoutValue();
	}

	/**
	 * Ŭ νϽ 
	 *
	 * @param	canvas	 ϰ ְ, List object  canvas
	 * @param	ls		ʱ  Ʈ ԽѾ  Ʈ
	 * @param	type	LIST, POPUP ΰ   
	 */	
	public XSList(Canvas canvas, String[] ls, int type) {
		this(canvas, type);
		for(int i = 0 ; i < ls.length ; i++) {
			vector.addElement(ls[i]);
		} // end for
		last = ((line_length > vector.size()) ? vector.size()-1: line_length-1);
	}

	// margin inset ִ  ٲش.
	private void setLayoutValue() {
		avail_width = parent.getWidth()-2*x_margin;
		if(type == LIST) {			// case list
			avail_height = parent.getHeight()-y_margin-2;
		} else {					// case popup
			avail_height = parent.getHeight()-y_margin*2;
		}
		startx = x_margin + area_inset;
		starty = y_margin;
		line_length = (avail_height) / (FONT_HEIGHT+line_margin);
	}

	public void setTitle(String title) {
		this.title = title;
	}
	
	/**
	 *  õ ε  ´.
	 *
	 * @return  õ ε 
	 */
	public int getCurrentIndex() {
		return currentIndex;
	}

	/**
	 *  Ʈ ׸ ߰
	 * 
	 * @param	str	߰ϰ ϴ Ʈ ׸
	 */	
	public void addItem(String str) {
		if(vector != null)	vector.addElement(str); // end if
		if( line_length >= vector.size() ) {
			last++;
		} // end if
	}

	/**
	 *   Ѵ.
	 * ù° ׸̶  ̵
	 * 
	 * @return	׸ ε Ѵ.
	 */
	public int next() {
		// ȭ ̰,   ϶ ó...
		if((currentIndex >= last) && (last == (vector.size()-1))) {
			currentIndex = 0;
			first = 0;
			last = first + ((line_length > vector.size()) ? vector.size()-1: line_length-1);
		//  ȭ ϰ츸, ȭ ÿ ĭ Ʒ ̵
		} else if((currentIndex >= last)) {
			currentIndex++;
			first++; last++;
		//  Ϲ  ׸
		} else {
			currentIndex++;
		} // end if

		parent.repaint();
		return currentIndex;
	}
	
	/**
	 *   Ѵ.
	 *  ׸̶ ó ̵
	 * 
	 * @return	׸ ε Ѵ.
	 */
	public int previous() {
		// ȭ ó̰, ù  
		if((currentIndex <= first) && (first <= 0)) {
			currentIndex = vector.size()-1;
			first = Math.max((vector.size() - line_length), 0);
			last = first + ((vector.size() > line_length) ? line_length-1: vector.size()-1);
		} else if(currentIndex <= first) {
			currentIndex--;
			first--;
			last--;
		} else {
			currentIndex--;
		} // end if
		parent.repaint();
		return currentIndex;
	}

	/**
	 * Ʈ  Ѵ.
	 *
	 * @return	Ʈ 
	 */	
	public int getBgcolor() {
		return bgcolor;
	}

	/**
	 * Ʈڽ ٱ  Ѵ.
	 *
	 * @param	bgcolor	 
	 */	
	public void setBgcolor(int bgcolor) {
		this.bgcolor = bgcolor;
	}

	/**
	 *  Ѵ.
	 *
	 * @return	
	 */	
	public int getFgcolor() {
		return fgcolor;
	}

	/**
	 *  Ѵ.
	 *
	 * @param	bgcolor	
	 */	
	public void setFgcolor(int bgcolor) {
		this.fgcolor = fgcolor;
	}

	/**
	 *  ġ ư ߰
	 *
	 * @param	button	 ߰ ư
	 */	
	public void addLeftButton(XSButton button) {
		if( button != null ) leftButton = button;
		return;
	}

	/**
	 *  ġ ư ߰
	 *
	 * @param	button	 ߰ ư
	 */	
	public void addRightButton(XSButton button) {
		if( button != null ) rightButton = button;
		return;
	}

	/**
	 *  ư .
	 */	
	public void removeLeftButton() {
		leftButton = null;
	}
	/**
	 *  ư .
	 */	
	public void removeRightButton() {
		rightButton = null;
	}

	/**
	 * ִ ĵ ؼ ȭ鿡 ش.
	 *
	 * @param	g	Graphics ü
	 */		
	public void show(Graphics g) {
		int sx = startx;
		int sy = starty;
		
		if( leftButton != null ) {				// draw left button
			leftButton.show(g);
		}
		if( rightButton != null) {				// draw right button
			rightButton.show(g);
		}

		if(type == LIST) {
			g.setColor(bgcolor);					// LCD bg color 
			g.fillRect(0, 0, parent.getWidth(), parent.getHeight());
			g.drawImage(imgTitle, 0, 0, g.TOP|g.LEFT);		// drawTitle bar
			g.setColor(fgcolor);
			g.setClip(0, 0, parent.getWidth(), imgTitle.getHeight());
			g.drawRect(1, 1, parent.getWidth()-2, parent.getHeight()-2);
			if(title == null) 
				g.drawString(" ּ", 
				(parent.getWidth()-Font.getDefaultFont().stringWidth(" ּ"))/2, 2, g.LEFT|g.TOP);
			else
				g.drawString(title, (parent.getWidth()-Font.getDefaultFont().stringWidth(title))/2, 
				2, g.LEFT|g.TOP);
		} // end if

		max_show = (line_length > vector.size()) ? vector.size(): line_length;
		g.setClip(0, 0, parent.getWidth(), parent.getHeight());
		if(type == POPUP) {					// case popup
			g.setColor(0x8d8d8d);
			g.fillRect(x_margin+2, y_margin+2, avail_width, avail_height);
		}
		g.setColor(bgcolor);				// LIST bg color 
		g.fillRect(x_margin, y_margin, avail_width, avail_height);		// list box
		g.setColor(fgcolor);				// fg color 
		g.drawRect(x_margin, y_margin, avail_width, avail_height);		// list border

		if(type == POPUP) {
			g.drawImage(popup_border, x_margin, y_margin, g.TOP|g.LEFT);
			if(title != null) {
				g.drawImage(tab, x_margin, y_margin, g.BOTTOM|g.LEFT);
				g.setClip(x_margin, y_margin-tab.getHeight(), tab.getWidth(), tab.getHeight());
				g.drawString(title, x_margin+2, y_margin-tab.getHeight()+2, g.TOP|g.LEFT);
			} // end if
			sy+=5;
		}
		g.setClip(x_margin, y_margin, avail_width, avail_height);

		// , ϴ ũ   
		if(first != 0) {
			g.drawImage(scroll_up, parent.getWidth()-x_margin-1, 
//					y_margin+2, g.TOP | g.RIGHT);
					sy+2, g.TOP | g.RIGHT);
		} // end if
		if(last != vector.size()-1) {
			g.drawImage(scroll_down, parent.getWidth()-x_margin-1, 
//					parent.getHeight()-4, g.RIGHT | g.BOTTOM);
					sy + avail_height - scroll_down.getHeight() - (tab == null ? 0 : tab.getHeight()-10), g.RIGHT | g.TOP);
		} // end if

		g.setColor(fgcolor);
		//  ۵ ׷.
		for(int i = first ; i < (first+max_show) ; i++) {
			if(i == currentIndex) {
				g.drawImage(icon, sx, sy+scroll_up.getHeight()+2, g.TOP | g.LEFT);
			} // end if
			g.drawString((String)vector.elementAt(i), sx+icon.getWidth()+5, sy+scroll_up.getHeight(), g.TOP|g.LEFT);
			sy += (FONT_HEIGHT + line_margin);
		} // end for
	}

	/**
	 * ȭ鿡 ÷̵ XSList .
	 *
	 * @param	g	Graphics ü
	 */	
	public void hide(Graphics g) {
		parent.repaint(0, 0, parent.getWidth(), parent.getHeight()+16);
	}
}