/*
	File : GameCanvas.java
	Date		Author		Change
	2001/09/19	Kim.K.C.	Created
*/

package com.xce.xceman;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import com.skt.m.*;
import com.xce.lcdui.*;

public class GameCanvas extends Canvas {
	public static final boolean IS_X350 = false;	
	
	private MIDlet midlet;
	private Image[] manImg = new Image[2];
	private int manWidth;
	private int manHeight;	
	
	/**
	 * SK-VM  ̹ εѴ.
	 */
	private Image titleImg = Toolkit.titleImg();
	private Image leftButtonImg = Toolkit.buttonBackLeftImg();
	private Image rightButtonImg = Toolkit.buttonBackRightImg();
	
	private int width = getWidth();
	private int height = getHeight() + 16;
	
	private int viewPortX = 0;
	private int viewPortY = titleImg.getHeight();
	private int viewPortWidth = width;
	private int viewPortHeight = getHeight() - 16;
	
	private int index;
	private int x = 0;
	private int y = viewPortY;
	
	/**
	 * α׷   ڵ.  Canvas ϳ  ȭ
	 *  ʿ伺 ִ  ̿  ũ Ѵ.
	 */
	int state = MAIN_STATE;
	static final int MAIN_STATE = 0;
	static final int HELP_STATE = 1;
	static final int RESUME_STATE = 2;
	
	private SoundMan sndMan = new SoundMan();
	
	GameCanvas(XCEMan midlet) {
		this.midlet = midlet;
	}
	
	void loadResource() {
		/**
		 *     ProgressBar   ִ.
		 *    ε ð ª  ʿ ⵵ ϴ. :-)
		 */	
		try {
			ProgressBar bar = new ProgressBar("XCEMan");
			bar.setMaxValue(3);
			manImg[0] = Image.createImage("/img/man0.png");
			bar.setValue(1);
			manImg[1] = Image.createImage("/img/man1.png");
			bar.setValue(2);
			sndMan.loadResource(); 
			bar.setValue(3);
			sndMan.start();
		
			manWidth = manImg[0].getWidth();
			manHeight = manImg[0].getHeight();
		} catch (Exception e) {
			midlet.notifyDestroyed();
		}
	}
	
	public void paint(Graphics g) {
		switch (state) {
			case MAIN_STATE:
				int clipY = g.getClipY();
		
				/**
				 * setClip() δ ս  ׸ ũ ʴ. Ʒ 
				 *  ƿ ʿ    ȣ  
				 *   ũ.
				 */
				if (clipY < 14) {
					paintTitle(g);
				}		
				if (clipY < getHeight()) {
					paintButton(g);
				}

				/**
				 *    ޼ҵ drawString() ̰ drawRect() drawImage()
				 *   ޼ҵ  .  ũ Ű  ʰ Clipping
				 * Area  ĳͰ ƴٴ  ü .
				 */
				g.setColor(Toolkit.white);
				g.fillRect(viewPortX, viewPortY, viewPortWidth, viewPortHeight);		
				g.drawImage(manImg[index], x, y, Graphics.TOP | Graphics.LEFT);
				break;
			case HELP_STATE:
				paintPopup(g, "", "ּ. :-)");
				break;
			case RESUME_STATE:
				paintPopup(g, "RESUME", "Ǿϴ!");
				break;
		}
	}
	
	void paintTitle(Graphics g) {
		g.drawImage(titleImg, 0, 0, Graphics.TOP | Graphics.LEFT);
		g.setColor(Toolkit.white);
		g.drawString("XCEMan", width >> 1, 1, Graphics.TOP | Graphics.HCENTER);	
	}
	
	void paintButton(Graphics g) {
		g.setColor(Toolkit.white);
		
		g.drawImage(leftButtonImg, 0, height, Graphics.BOTTOM | Graphics.LEFT);		
		g.drawString("", 2, height - 1, Graphics.BOTTOM | Graphics.LEFT);
		
		g.drawImage(rightButtonImg, width, height, Graphics.BOTTOM | Graphics.RIGHT);
		g.drawString("", width - 2, height - 1, Graphics.BOTTOM | Graphics.RIGHT);
	}	
	
	
	public void keyPressed(int keyCode) {
		if (state == HELP_STATE || state == RESUME_STATE) {
			state = MAIN_STATE;
			/**
			 * Ŀǵ  Ʈ ϱ ؼ repaint() ޼ҵ ſ
			 * Ʒ   Ʈ  ־߸ Ѵ.
			 */
			repaint(0, 0, width, height);
			
			/**
			 * serviceRepaints() ޼ҵ  ޼ҵ  ڵ ̹ repaint()
			 * û  paint() ޼ҵ尡 ȣǾٴ  Ѵ. Ӱ
			 *  ſ(!) ϰ Ǿ  ִ. ׷ X-350 
			 *  ־ ̺Ʈ ڵ鷯 ȣϴ keyPressed(), keyReleased()
			 * keyRepeated(), commandAction(), paint() ޼ҵ   
			 * . 
			 * 
			 * Ͻÿ IS_X350  true ̸ Ʈ ڵ忡 Ե ʱ 
			 * μ    ִ.  :-)
			 */
			if (!IS_X350) {
				serviceRepaints();
			}
			return;
		}
		
		switch (keyCode) {
			/**
			 * CommandListener ϵǾ   츸 KEY_COML, KEY_COMR
			 * Ѿ´. ÿ System.exit() ޼ҵ带  ȣϸ (!)
			 * ȵǰ notifyDestroyed() ޼ҵ带 ȣؾ Ѵ.
			 */
			case KEY_COML:
				midlet.notifyDestroyed();
				break;
			case KEY_COMR:
				state = HELP_STATE;
				repaint(0, 0, width, height);
				break;
			/**
			 * ĳ͸ ̴ Ű Է
			 */				
			case KEY_UP:
				moveUp();
				sndMan.play(SoundMan.SND_WALK);				
				break;
			case KEY_DOWN:
				moveDown();
				sndMan.play(SoundMan.SND_WALK);				
				break;
			case KEY_LEFT:
				moveLeft();
				sndMan.play(SoundMan.SND_WALK);				
				break;
			case KEY_RIGHT:				
				moveRight();
				sndMan.play(SoundMan.SND_WALK);				
				break;
			case KEY_FIRE:
				sndMan.play(SoundMan.SND_BELL);
				break;
		}
		if (!IS_X350) {
			serviceRepaints();
		}		
	}
	
	void moveUp() {
		incIndex();
		
		int oldY = y;
		y -= 5;
		if (y < viewPortY) {
			y = viewPortY;
		}
		
		if (y != oldY) {
			repaint(x, y, manWidth, manHeight + 5);
		}
	}
	
	void moveDown() {
		incIndex();
		
		int oldY = y;
		y += 5;
		if ((y + manHeight) > (height - 16)) {
			y = height - 16 - manHeight;
		}
		
		if (y != oldY) {
			repaint(x, y - 5, manWidth, manHeight + 5);
		}
	}
	
	void moveLeft() {
		incIndex();
		
		int oldX = x;
		x -= 5;
		if (x < viewPortX) {
			x = viewPortX;
		}
		
		if (x != oldX) {
			repaint(x, y, manWidth + 5, manHeight);
		}
	}
	
	void moveRight() {
		incIndex();
		
		int oldX = x;
		x += 5;
		if ((x + manWidth) > viewPortWidth) {
			x = viewPortWidth - manWidth;
		}
		
		if (x != oldX) {
			repaint(x - 5, y, manWidth + 5, manHeight);
		}		
	}
	
	void incIndex() {
		index++;
		if (index == 2) {
			index = 0;
		}
	}
	
	/**
	 * X-350   ޼ҵ尡 ȣ ʴ´.
	 */
	public void keyRepeated(int keyCode) {
		keyPressed(keyCode);
	}
	
	public void keyReleased(int keyCode) {
	}
	
	/**
	 *  ޼ҵ  ǥ ƴ Relative ǥ ؼ ְ ִ.
	 *  ػ󵵿 ߾ӿ ڰ  ô   
	 *  ԵǾ ִ. ̷   볳Ǵ  ˾ 츦
	 * ׸ ƾ  ѹ ȣǱ  ӵ ũ ΰ ʱ
	 * ̴.
	 */	
	void paintPopup(Graphics g, String msg1, String msg2) {
		boolean button = false;

		g.setColor(Toolkit.white);
		g.fillRect(0, 0, width, height);
		
		int maxWidth = 0;
		int maxHeight = 0;		
		final int boxSpace = 4;
		final int roundSpace = 3;

		final int msg1Width = msg1 == null ? 0 : Toolkit.DEFAULT_FONT.stringWidth(msg1);
		final int msg2Width = msg2 == null ? 0 : Toolkit.DEFAULT_FONT.stringWidth(msg2);
			
		final String str_yes = "";
		final String str_no = "ƴϿ";		
		final int yesWidth = Toolkit.DEFAULT_FONT.stringWidth(str_yes);
		final int noWidth = Toolkit.DEFAULT_FONT.stringWidth(str_no);
		final int buttonWidth = yesWidth > noWidth ? yesWidth+roundSpace * 2 : noWidth+roundSpace * 2;

		maxWidth = msg1Width > msg2Width ? msg1Width : msg2Width;
		if( button ){
			maxWidth = maxWidth > buttonWidth*2+boxSpace ? maxWidth : buttonWidth*2+boxSpace;
		}
			
		if( msg1 != null ) maxHeight += Toolkit.FONT_HEIGHT;
		if( msg2 != null ) maxHeight += Toolkit.FONT_HEIGHT;
		if( button ) maxHeight += Toolkit.FONT_HEIGHT*2 + roundSpace;
			
		int bwidth = maxWidth + boxSpace * 2;
		int bheight = maxHeight + boxSpace * 2;
		int bx = (width - bwidth) / 2;
		int by = (height - bheight) / 2;
			
		int tx = width / 2;
		int ty = by + boxSpace;

		g.setColor(Toolkit.white);
		g.fillRect(bx, by, bwidth, bheight); 
			
		g.setColor(Toolkit.black);
		g.drawRect(bx, by, bwidth, bheight);

			
		if (msg1 != null) {
			g.drawString(msg1, tx, ty, Graphics.TOP | Graphics.HCENTER);
			ty += Toolkit.FONT_HEIGHT;
		}
			
		if (msg2 != null) {
			g.drawString(msg2, tx, ty, Graphics.TOP | Graphics.HCENTER);
			ty += (Toolkit.FONT_HEIGHT);
		}
		ty += (Toolkit.FONT_HEIGHT * 3 / 4);
			
		if( button ){
			g.setColor(Toolkit.black);

			g.fillRoundRect(bx + boxSpace, ty - roundSpace,		// ƴϿ
							buttonWidth, 
							Toolkit.FONT_HEIGHT + roundSpace * 2, 3, 4);

			g.fillRoundRect(bx + bwidth -boxSpace - buttonWidth, ty - roundSpace,	// 
							buttonWidth, 
							Toolkit.FONT_HEIGHT + roundSpace * 2, 3, 4);							
			
			g.setColor(Toolkit.white);
			g.drawString(str_no, bx + boxSpace + buttonWidth / 2, ty, Graphics.HCENTER | Graphics.TOP);
			g.drawString(str_yes, bx + bwidth - boxSpace - buttonWidth/2, ty, Graphics.HCENTER | Graphics.TOP);
		}
	}	
}